/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('BiaozhunBianjiController', function($scope, $state, ionicMaterialInk, $ionicPopup, biaozhunService, chuchaService, $ionicActionSheet, userService, multimediaService) {

      const workId = $state.params.workid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.showLoading();

      $scope.mendianList = []
      $scope.qitaList = []
      biaozhunService.queryStandardWorkMain(workId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          $scope.fdays = Number($scope.fdays);
          document.querySelector('#dizhi').value = $scope.getLocString($scope.data)
          setTimeout(() => {
            $scope.selectBusinessTrip($scope.data.tbusinesstripid)
          }, 100);
          res.data.data[0].workmxlist.forEach(elem => {
            elem.imageData = []
            for (let ii = 0; ii < elem.fdocqty; ii++) {
              elem.imageData.push({
                url: '',
                show_url: '',
                postfix: '', 
                fdocument: '',
                createby: userService.getUserName(),
                createdate: getDateString(new Date()),
              })
            }              
            if (elem.ftype == '门店')
              $scope.mendianList.push(elem)
            else
              $scope.qitaList.push(elem)

            multimediaService.getImageList(elem.tworkmxid, 'tworkmx').then(res => {
              for (let i = 0; i < res.data.data.length && i < elem.fdocqty; i++) {
                elem.imageData[i].show_url = res.data.data[i].show_url
                elem.imageData[i].url = res.data.data[i].url
                elem.imageData[i].fdocument = res.data.data[i].fdocument
                elem.imageData[i].postfix = res.data.data[i].postfix
                elem.imageData[i].createby = res.data.data[i].createby
                elem.imageData[i].createdate = res.data.data[i].createdate
                elem.imageData[i].tattachmentid = res.data.data[i].tattachmentid
              }
            })
          });
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      function uploadImage(isMendian, idx, ii){
        let arr = isMendian ? $scope.mendianList : $scope.qitaList
        multimediaService.uploadPicture(arr[idx].imageData[ii].url, arr[idx].ftype, arr[idx].tworkmxid, 'tworkmx')
        .then(
          res => {},
          err => {
            $scope.showToast({title: err})
        })
      }

      $scope.removeImage = function(isMendian, idx, ii) {
        let arr = isMendian ? $scope.mendianList : $scope.qitaList
        if (arr[idx].tworkmxid)
          multimediaService.removeImage({ownertable: 'tworkmx', ownerid: arr[idx].tworkmxid, tattachmentid: arr[idx].imageData[ii].tattachmentid});
        arr[idx].imageData[ii].show_url = ''
      }

      function firstBlankIndex(isMendian, idx) {
        let arr = isMendian ? $scope.mendianList : $scope.qitaList
        for (var ii in arr[idx].imageData) {
          if (!arr[idx].imageData[ii].show_url)
            return ii
        }
        return 0
      }
      
      $scope.isFull = (isMendian, idx) => {
        let arr = isMendian ? $scope.mendianList : $scope.qitaList
        for (var ii in arr[idx].imageData) {
          if (!arr[idx].imageData[ii].show_url)
            return false
        }
        return true
      }

      $scope.isBlank = (isMendian, idx) => {
        let arr = isMendian ? $scope.mendianList : $scope.qitaList
        for (var ii in arr[idx].imageData) {
          if (arr[idx].imageData[ii].show_url)
            return false
        }
        return true
      }

      $scope.openCamera = function(isMendian, rowNum, idx) {
        multimediaService.openCamera()
          .then(function (imageURI) {
            let fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            let img = isMendian ? $scope.mendianList[rowNum].imageData[idx] : $scope.qitaList[rowNum].imageData[idx]
            img.url = imageURI
            img.show_url = imageURI
            img.postfix = fdocument.substring(fdocument.lastIndexOf('.') + 1)
            img.fdocument = fdocument
            img.createby = userService.getUserName()
            img.createdate = getDateString(new Date())
            uploadImage(isMendian, rowNum, idx)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      }

      $scope.openGallery = function(isMendian, rowNum, idx) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            let fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            let img = isMendian ? $scope.mendianList[rowNum].imageData[idx] : $scope.qitaList[rowNum].imageData[idx]
            img.url = imageURI
            img.show_url = imageURI
            img.postfix = fdocument.substring(fdocument.lastIndexOf('.') + 1)
            img.fdocument = fdocument
            img.createby = userService.getUserName()
            img.createdate = getDateString(new Date())
            uploadImage(isMendian, rowNum, idx)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      }

      $scope.openFileSelector = (isMendian, rowNum, idx) => {
        fileChooser.open(function(url) {
          let extIndex = url.indexOf('com.android.externalstorage.documents/document/')
          if (extIndex != -1) {
            url = 'file:///storage/' + decodeURIComponent(url.replace('%3A', '%2F').substr(extIndex + 47))
          }
          window.FilePath.resolveNativePath(url, finalPath => {
            var fdocument = finalPath.substr(finalPath.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            let img = isMendian ? $scope.mendianList[rowNum].imageData[idx] : $scope.qitaList[rowNum].imageData[idx]
            img.url = finalPath
            img.show_url = finalPath
            img.postfix = fdocument.substring(fdocument.lastIndexOf('.') + 1)
            img.fdocument = fdocument
            img.createby = userService.getUserName()
            img.createdate = getDateString(new Date())
            uploadImage(isMendian, rowNum, idx)
          });
        }, function(e){
        });
      }

      $scope.actionSheet = function(isMendian, rowNum, idx, fisimage = 1) {
        var buttonList = [
          {
            text: '拍照'
          },
          {
            text: '从相册选择'
          }]
        if (fisimage != 1) {
          buttonList.push({text:'选择文件'})
          idx = firstBlankIndex(isMendian, rowNum)
        }
        // Show the action sheet
				$ionicActionSheet.show({
					buttons: buttonList,
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera(isMendian, rowNum, idx);
							break;
							case 1: //从相册选择
                $scope.openGallery(isMendian, rowNum, idx);
							break;
              case 2: //选择文件
                $scope.openFileSelector(isMendian, rowNum, idx)                
							break;
							default:
							break;
						}
						return true;
					}
				});
      };

      $scope.isAllImageReady = function() {
        for (var idx in $scope.mendianList){
          if (!$scope.isFull(1, idx))
            return false
        }
        for (var idx in $scope.qitaList){
          if (!$scope.isFull(0, idx) && !$scope.isBlank(0, idx))
            return false
          if (!$scope.isBlank(0, idx) && $scope.qitaList[idx].fiseditnote && !$scope.qitaList[idx].fnotes)
            return false
        }
        return true;
      }

      $scope.modify = function() {
        if (!$scope.data.tstoreid){
          $scope.showToast({title: "请选择工作门店"})
          return;
        }

        if ($scope.data.fdays <= 0){
          $scope.showToast({title: "请填写工作天数。"})
          return;
        }
        
        $scope.data.fdate = getDateString(new Date());
        $scope.showLoading();
        $scope.data.datalog = [{
          "ftype": "修改",
          "flog": "修改内容", // TODO 修改内容
        }]
        
        $scope.data.workmx = $scope.data.workmxlist
        for (var i = 0; i < $scope.mendianList.length; i++){
          $scope.data.workmx[i].fnotes = $scope.mendianList[i].fnotes
        }
        for (var i = 0; i < $scope.qitaList.length; i++){
          $scope.data.workmx[i + $scope.mendianList.length].fnotes = $scope.qitaList[i].fnotes
        }
        
        biaozhunService.standardWorkInsertOrModify(workId, $scope.data)
        .then(function(res){
          if (res && res.data && res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      // Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        localStorage.setItem('businesstrip', '');
      });

      // BusinessTripSelector
      $scope.showBusinessTripSelector = function() {
        $state.go('app.selectbussinesstrip');
      }

      $scope.getBusinessTripData = function(businessTripId) {
        chuchaService.queryBusinessTripMain(businessTripId)
        .then(function(res){
          if (res.data.code === 1) {
            let businessTrip = res.data.data[0];
            $scope.data.fprovince = businessTrip.fprovince;
            $scope.data.fcity = businessTrip.fcity;
            $scope.data.fcounty = businessTrip.fcounty;
            $scope.data.tagentsid = businessTrip.tagentsid;

            $scope.agentStoreList = [];
            biaozhunService.queryAgentStoreList(businessTrip.tagentsid)
            .then(function(res){
              $scope.agentStoreList = res.data.data;
              for (var i = 0; i < res.data.data.length; i++) {
                if ($scope.data.fstorename == res.data.data[i].fstorename){
                  $scope.data.tstoreid = res.data.data[i].tstoreid;
                  break;
                }
              }
            });
          }
        });
      }

      $scope.selectBusinessTrip = function(tbusinesstripid) {
        var businessTrip = localStorage.getItem('businesstrip');
        if (!businessTrip) {
          $scope.getBusinessTripData(tbusinesstripid);
          return;
        }

        businessTrip = JSON.parse(businessTrip);
        if (businessTrip && businessTrip.tagentsid) {
          document.querySelector('#business-trip-id').value = businessTrip.tbusinesstripid;
          document.querySelector('#dizhi').value = $scope.getLocString(businessTrip);

          $scope.data.tbusinesstripid = businessTrip.tbusinesstripid;
          $scope.data.fprovince = businessTrip.fprovince;
          $scope.data.fcity = businessTrip.fcity;
          $scope.data.fcounty = businessTrip.fcounty;
          $scope.data.tagentsid = businessTrip.tagentsid;

          $scope.agentStoreList = [];
          biaozhunService.queryAgentStoreList(businessTrip.tagentsid)
          .then(function(res){
            $scope.agentStoreList = res.data.data;
            for (var i = 0; i < res.data.data.length; i++) {
              if ($scope.data.fstorename == res.data.data[i].fstorename){
                $scope.data.tstoreid = res.data.data[i].tstoreid;
                break;
              }
            }
          });
        }
      }

      // get keywords
      $scope.keywords = $scope.loadKeywords();

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentStoreSelectPanel = function() {
        $scope.selectModel = $scope.agentStoreList;
        $scope.selectKeyField = "tstoreid";
        $scope.selectValueField = "fstorename";
        $scope.selectModelName = "tstoreid";
        $scope.selected = $scope.data.tstoreid;

        $scope.showSelectPanel();
      }

		});
})();

