/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('BiaozhunXiangqingController', function($scope, $rootScope, $ionicPopup, $ionicPopover, $state, $stateParams, biaozhunService, $ionicActionSheet, multimediaService) {
      const workId = $stateParams.workid;

      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
			$scope.navIndex = 0;
      $rootScope.isDownloading = -1

			$scope.showSlide = function (num) {
				$scope.navIndex = num;
        $scope.$broadcast('scroll.refreshComplete');
      };

      const template = `
          <ion-popover-view class="fit" style="height:80px !important">
            <ion-content scroll="false">
              <div class="list">
                <ion-list>
                  <ion-item lines="none" detail="false" ng-click="showEdit()">
                    <div class="table-line">
                    <img src="img/bianji4.png" style="background-color: #666666; height: 18px; width: 18px; margin-right: 8px">
                      <span class="info-table-line-text">编辑</span>
                    </div>
                  </ion-item>
                  <ion-item lines="none" detail="false" ng-click="confirmDelete()">
                    <div class="table-line">
                    <img src="img/zhangdan1.png" style="height: 18px; width: 18px; margin-right: 8px">
                    <span class="info-table-line-text">删除</span>
                    </div>
                  </ion-item>
                </ion-list>
              </div>
            </ion-content>
          </ion-popover-view>`;

      $scope.popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
      })

      $scope.openPopover = ($event) => {
        $scope.popover.show($event);
      }

      $scope.closePopover = () => {
        $scope.popover.hide();
      }

      // Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.popover.remove();
      });

      // Execute action on hide popover
      $scope.$on('popover.hidden', function() {
        // Execute action
      });

      // Execute actioni on remove popover
      $scope.$on('popover.removed', function() {
        // Execute action
      });

      $scope.showEdit = () => {
        $scope.closePopover();
        $state.go('app.biaozhunbianji', {workid: workId});
      }

      $scope.confirmDelete = () => {
				let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">删除确认</span></div>',
					subTitle: '<div><span class="popup-content">确定要进行删除操作吗？</span></div>',
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
              biaozhunService.standardWorkDelete(workId)
                .then(
                  function(res){
                    if (res.data.code === 1) {
                      $scope.showToast({
                        title: "删除成功！"
                      });
                      $scope.goBack();
                    } else {
                      // $ionicPopup.alert({
                      // title: res.data.msg
                      // });
                    }
                    $scope.hideLoading();
                  },
                  function(err){
                    $scope.hideLoading();
                  });
              $scope.closePopover();
          }
				});
      }
      
      $scope.mendianList = []
      $scope.qitaList = []
      $scope.loadData = () => {
        biaozhunService.queryStandardWorkMain(workId)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
            $scope.data = $scope.setDefaults($scope.data);
            res.data.data[0].workmxlist.forEach(elem => {
              elem.imageData = []
              // if (elem.ftype == '门店')
                $scope.mendianList.push(elem)
              // else
              //   $scope.qitaList.push(elem)

              multimediaService.getImageList(elem.tworkmxid, 'tworkmx').then(res => {
                for (let i = 0; i < res.data.data.length; i++) {
                  elem.imageData.push({
                    show_url: res.data.data[i].show_url,
                    url: res.data.data[i].url,
                    fdocument: res.data.data[i].fdocument,
                    postfix: res.data.data[i].postfix,
                    createby: res.data.data[i].createby,
                    createdate: res.data.data[i].createdate,
                    tattachmentid: res.data.data[i].tattachmentid,
                  })
                }
              })
            });
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.showLoading();
      $scope.loadData();

    });
})();

