/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('BiaozhunXinzengController', function($scope, $state, ionicMaterialInk, biaozhunService, $ionicActionSheet, multimediaService, userService, $ionicPopup) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        tworkid: 0,
        tbusinesstripid: '',
        fdays: null,
        tagentsid: '',
        tstoreid: '',
        fdate: '',
        workmx: [],
      };

      $scope.mendianList = []
      $scope.qitaList = []
      $scope.showLoading();
      biaozhunService.queryStandardWorkTemplateList()
      .then(function(res){
        if (res.data.code === 1) {
          res.data.data.forEach(elem => {
            elem.tworkmxid = 0
            elem.imageData = []
            for (let ii = 0; ii < elem.fdocqty; ii++) {
              elem.imageData.push({
                url: '',
                postfix: '', 
                fdocument: '',
                createby: userService.getUserName(),
                createdate: getDateString(new Date()),
              })
            }              
            if (elem.ftype == '门店')
              $scope.mendianList.push(elem)
            else
              $scope.qitaList.push(elem)
          })
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      function uploadImages() {
        let arr = [$scope.mendianList, $scope.qitaList]
        for (let i in arr) {
          for (let j in arr[i]) {
            arr[i][j].imageData.forEach(element => {
              if (element.url)
                multimediaService.uploadPicture(element.url, arr[i][j].ftype, arr[i][j].tworkmxid, 'tworkmx')
                .then(
                  res => {},
                  err => {
                    $scope.showToast({title: err})
                })
            });
          }
        }
      }

      function firstBlankIndex(isMendian, idx) {
        let arr = isMendian ? $scope.mendianList : $scope.qitaList
        for (var ii in arr[idx].imageData) {
          if (!arr[idx].imageData[ii].url)
            return ii
        }
        return 0
      }

      $scope.isFull = (isMendian, idx) => {
        let arr = isMendian ? $scope.mendianList : $scope.qitaList
        for (var ii in arr[idx].imageData) {
          if (!arr[idx].imageData[ii].url)
            return false
        }
        return true
      }

      $scope.isBlank = (isMendian, idx) => {
        let arr = isMendian ? $scope.mendianList : $scope.qitaList
        for (var ii in arr[idx].imageData) {
          if (arr[idx].imageData[ii].url)
            return false
        }
        return true
      }

      $scope.openCamera = function(isMendian, rowNum, idx) {
        multimediaService.openCamera()
          .then(function (imageURI) {
            let fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            let img = {
              url: imageURI, 
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
            }
            if (isMendian)
              $scope.mendianList[rowNum].imageData[idx] = img;
            else
              $scope.qitaList[rowNum].imageData[idx] = img;
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      }

      $scope.openGallery = function(isMendian, rowNum, idx) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            let fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            let img = {
              url: imageURI, 
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
            }
            if (isMendian)
              $scope.mendianList[rowNum].imageData[idx] = img;
            else
              $scope.qitaList[rowNum].imageData[idx] = img;
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      }

      $scope.openFileSelector = (isMendian, rowNum, idx) => {
        fileChooser.open(function(url) {
          let extIndex = url.indexOf('com.android.externalstorage.documents/document/')
          if (extIndex != -1) {
            url = 'file:///storage/' + decodeURIComponent(url.replace('%3A', '%2F').substr(extIndex + 47))
          }
          window.FilePath.resolveNativePath(url, finalPath => {
            var fdocument = finalPath.substr(finalPath.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            let img = {
              url: finalPath, 
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
            }
            if (isMendian)
              $scope.mendianList[rowNum].imageData[idx] = img
            else
              $scope.qitaList[rowNum].imageData[idx] = img
          });
        }, function(e){
        });
      }

      $scope.actionSheet = function(isMendian, rowNum, idx, fisimage = 1) {
        var buttonList = [
          {
            text: '拍照'
          },
          {
            text: '从相册选择'
          }]
        if (fisimage != 1) {
          buttonList.push({text:'选择文件'})
          idx = firstBlankIndex(isMendian, rowNum)
        }
        // Show the action sheet
				$ionicActionSheet.show({
					buttons: buttonList,
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera(isMendian, rowNum, idx);
							break;
							case 1: //从相册选择
                $scope.openGallery(isMendian, rowNum, idx);
							break;
              case 2: //选择文件
                $scope.openFileSelector(isMendian, rowNum, idx)                
							break;
							default:
							break;
						}
						return true;
					}
				});
      };

      $scope.isAllImageReady = function() {
        for (var idx in $scope.mendianList){
          if (!$scope.isFull(1, idx))
            return false
        }
        for (var idx in $scope.qitaList){
          if (!$scope.isFull(0, idx) && !$scope.isBlank(0, idx))
            return false
          if (!$scope.isBlank(0, idx) && $scope.qitaList[idx].fiseditnote && !$scope.qitaList[idx].fnotes)
            return false
        }
        return true;
      }

      $scope.register = function() {
        if (!$scope.data.tstoreid){
          $scope.showToast({title: "请选择工作门店"})
          return;
        }

        if ($scope.data.fdays <= 0){
          $scope.showToast({title: "请填写工作天数。"})
          return;
        }
        
        $scope.showLoading();
        $scope.data.datalog = [
          {
            "ftype": "新增",
            "flog": "新增记录",
          }
        ]
        for (var i = 0; i < $scope.mendianList.length; i++){
          $scope.data.workmx.push({
            tworkmxid: $scope.mendianList[i].tworkmxid,
            ftype: $scope.mendianList[i].ftype,
            fworkname: $scope.mendianList[i].fworkname,
            fnotes: $scope.mendianList[i].fnotes,
            fdocqty: $scope.mendianList[i].fdocqty,
            fisimage: $scope.mendianList[i].fisimage,
            fiseditnote: $scope.mendianList[i].fiseditnote,
          })
        }
        for (var i = 0; i < $scope.qitaList.length; i++){
          $scope.data.workmx.push({
            tworkmxid: $scope.qitaList[i].tworkmxid,
            ftype: $scope.qitaList[i].ftype,
            fworkname: $scope.qitaList[i].fworkname,
            fnotes: $scope.qitaList[i].fnotes,
            fdocqty: $scope.qitaList[i].fdocqty,
            fisimage: $scope.qitaList[i].fisimage,
            fiseditnote: $scope.qitaList[i].fiseditnote,
          })
        }
        biaozhunService.standardWorkInsertOrModify(0, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            for(var i = 0; i < res.data.data[0].workmxlist.length; i++) {
              if (i < $scope.mendianList.length) {
                $scope.mendianList[i].tworkmxid = res.data.data[0].workmxlist[i].tworkmxid
              } else
                $scope.qitaList[i - $scope.mendianList.length].tworkmxid = res.data.data[0].workmxlist[i].tworkmxid
            }
            uploadImages()
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      // get keywords
      $scope.keywords = $scope.loadKeywords();

      // Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        localStorage.setItem('businesstrip', '');
      });

      // BusinessTripSelector
      $scope.showBusinessTripSelector = function() {
        $state.go('app.selectbussinesstrip');
      }

      $scope.selectBusinessTrip = function() {
        var businessTrip = localStorage.getItem('businesstrip');
        if (!businessTrip) {
          $scope.hideLoading();
          return;
        }
        businessTrip = JSON.parse(businessTrip);
        if (businessTrip && businessTrip.tagentsid) {
          document.querySelector('#business-trip-id').value = businessTrip.tbusinesstripid;
          document.querySelector('#dizhi').value = $scope.getLocString(businessTrip);

          $scope.data.tbusinesstripid = businessTrip.tbusinesstripid;
          $scope.data.fprovince = businessTrip.fprovince;
          $scope.data.fcity = businessTrip.fcity;
          $scope.data.fcounty = businessTrip.fcounty;
          $scope.data.tagentsid = businessTrip.tagentsid;

          $scope.showLoading();
          biaozhunService.queryAgentStoreList(businessTrip.tagentsid)
          .then(function(res){
            $scope.agentStoreList = res.data.data;
            $scope.hideLoading();
          },
          function(err){
            $scope.hideLoading();
          });
        }
      }

      $scope.selectBusinessTrip();

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentStoreSelectPanel = function() {
        $scope.selectModel = $scope.agentStoreList;
        $scope.selectKeyField = "tstoreid";
        $scope.selectValueField = "fstorename";
        $scope.selectModelName = "tstoreid";
        $scope.selected = $scope.data.tstoreid;

        $scope.showSelectPanel();
      }
      
		});
})();

