/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('ChuchaBianjiController', function($scope, $state, ionicMaterialInk, $ionicPopup, chuchaService) {

      const businessTripId = $state.params.businesstripid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.showLoading();
      $scope.data = [];
      var originData = {};
      var fieldArray = {
        'fbegdate': '到达日期',
        'fenddate': '返程日期',
        'fchannel': '来源渠道',
        'fcounty': '出差地址',
        'fnotes': '出差备注',
        'fothername': '随行人员',
        'fagentname': '考察经销商',
      }
      chuchaService.queryBusinessTripMain(businessTripId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          $scope.data.fbegdate = $scope.data.fbegdate ? $scope.data.fbegdate.substring(0, 10) : '';
          $scope.data.fenddate = $scope.data.fenddate ? $scope.data.fenddate.substring(0, 10) : '';
          if ($scope.agentList) {
            $scope.agentList.forEach(v => {
              if (v.tagentsid == $scope.data.tagentsid) {
                $scope.data.fagentname = v.fagentname;
              }
            });
          }
          originData = Object.assign({}, $scope.data)

          new Rolldate({
            el: '#fbegdate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fbegdate,
            confirm: function(date) {
              $scope.data.fbegdate = date;
              $scope.$apply($scope.data);
            },
          });
          new Rolldate({
            el: '#fenddate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fenddate,
            confirm: function(date) {
              $scope.data.fenddate = date;
              $scope.$apply($scope.data);
            },
          });
          new Rollarea({
            el: '#dizhi',
            format: 'province-city-county',
            value: {'fprovince': $scope.data.fprovince, 'fcity': $scope.data.fcity, 'fcounty': $scope.data.fcounty},
            confirm: function(area) {
              $scope.data.fprovince = area.fprovince;
              $scope.data.fcity = area.fcity;
              $scope.data.fcounty = area.fcounty;
            },
          });
        } else {
          
        }
      },
      function(err){
      });

      chuchaService.queryAgentList()
      .then(function(res){
        $scope.agentList = res.data.data;
        if ($scope.data.tagentsid) {
          $scope.agentList.forEach(v => {
            if (v.tagentsid == $scope.data.tagentsid) {
              $scope.data.fagentname = v.fagentname;
            }
          });
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      $scope.modify = function() {
        if ($scope.data.fbegdate > $scope.data.fenddate) {
          $scope.showToast({title: "返程日期应晚于到达时间"});
          return;
        }

        if ($("#dizhi").val() == '') {
          $scope.showToast({title: "请输入出差地址！"});
          return;
        }
        
        $scope.showLoading();
        var modified = ""
        for (var key in fieldArray) {
          if (originData[key] != $scope.data[key])
            modified += "," + fieldArray[key]
        }
        if (modified.substring(0, 1) == ",")
          modified = modified.substring(1)
        $scope.data.datalog = [
          {
              "ftype": "修改",
              "flog": "修改内容：" + modified, // TODO 修改内容
          }
        ],

        chuchaService.businessTripInsertOrModify(businessTripId, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentSelectPanel = function() {
        $scope.selectModel = $scope.agentList;
        $scope.selectKeyField = "tagentsid";
        $scope.selectValueField = "fagentname";
        $scope.selectModelName = "tagentsid";
        $scope.selected = $scope.data.tagentsid;

        $scope.showSelectPanel();
      }

		});
})();

