(function(){

	"use strict";
	angular.module('starter.services')

	.service('chuchaService', function (apiService, userService) {
		var self = this;

    // 出差行程列表查询
		self.queryBusinessTripList = function(fromdb, pageNumber, pageSize, sortDirection, condition, createdate) {
			var request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.businesstrip.businesstrip",
					"method": "query_businesstripList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {
						},
						"sort":"t1.changedate" + (sortDirection == ascending ? '' : ' desc'),
					}
				}
			};
			if (condition) {
        request.data.content.where.condition = condition;
      }
      if (createdate) {
        request.data.content.where.createdate = createdate;
      }

			return apiService.makeRequest(request);
		}

    // 出差行程主界面查询
		self.queryBusinessTripMain = function(businessTripId) {
			var request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.businesstrip.businesstrip",
					"method": "query_businesstripMain",
					"content": {
						"userid": userService.getUserId(),
						"tbusinesstripid": businessTripId,
					}
				}
			};

			return apiService.makeRequest(request);
    }

    // 出差行程新增，修改
    self.businessTripInsertOrModify = function(businessTripId, data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.businesstrip.businesstrip",
					"method": "businesstripInsertOrModify",
					"content": {
            "userid": userService.getUserId(),
            "tbusinesstripid": businessTripId,
            "tagentsid": data.tagentsid,
            "fbegdate": data.fbegdate,
            "fenddate": data.fenddate,
            "fprovince": data.fprovince,
            "fcity": data.fcity,
            "fcounty": data.fcounty,
            "fdays": (Date.parse(data.fenddate) - Date.parse(data.fbegdate)) / 86400000,//data.fdays,
            "fnotes": data.fnotes,
            "fothername": data.fothername,
						"datalog": data.datalog
						// [// TODO 修改记录，非必填项，可以为空
            //     {
            //         "ftype": "修改", // TODO 修改类型
            //         "flog": "修改字段及内容", // TODO 修改内容
            //     }
            // ],
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 出差行程删除
    self.businessTripDelete = function(businessTripId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.businesstrip.businesstrip",
					"method": "businesstripDelete",
					"content": {
            "userid": userService.getUserId(),
            "tbusinesstripid": businessTripId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 经销商选择列表查询
    self.queryAgentList = function() {
      let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.businesstrip.businesstrip",
					"method": "query_agentList",
					"content": {
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    }

    // 出差行程提交
    self.businessTripSubmit = function(businessTripId) {
      let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.businesstrip.businesstrip",
					"method": "businesstripSubmit",
					"content": {
            "userid": userService.getUserId(),
            "tbusinesstripid" : businessTripId,
					}
				}
      };

			return apiService.makeRequest(request);
    }
	})

})();
