/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('ChuchaXiangqingController', function($scope, $ionicPopup, $ionicPopover, $state, $stateParams, chuchaService, multimediaService) {
      const businessTripId = $stateParams.businesstripid;

      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
			$scope.navIndex = 0;

			$scope.showSlide = function (num) {
				$scope.navIndex = num;
        $scope.$broadcast('scroll.refreshComplete');
      };

      const template = `
          <ion-popover-view class="fit" style="height:{{data.fstatus=='已提交' ? '80px !important' : '120px !important'}} ">
            <ion-content scroll="false">
              <div class="list">
                <ion-list>
                  <ion-item lines="none" detail="false" ng-click="showEdit()">
                    <div class="table-line">
                    <img src="img/bianji4.png" style="background-color: #666666; height: 18px; width: 18px; margin-right: 8px">
                      <span class="info-table-line-text">编辑</span>
                    </div>
                  </ion-item>
                  <ion-item lines="none" detail="false" ng-click="confirmTijiao()" ng-if="data.fstatus!='已提交'">
                    <div class="table-line">
                      <img src="img/sucai.png" style="height: 18px; width: 18px; margin-right: 8px; filter: grayscale(100%);">
                      <span class="info-table-line-text">提交</span>
                    </div>
                  </ion-item>
                  <ion-item lines="none" detail="false" ng-click="confirmDelete()">
                    <div class="table-line">
                    <img src="img/zhangdan1.png" style="height: 18px; width: 18px; margin-right: 8px">
                    <span class="info-table-line-text">删除</span>
                    </div>
                  </ion-item>
                </ion-list>
              </div>
            </ion-content>
          </ion-popover-view>`;

      $scope.popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
      })

      $scope.openPopover = ($event) => {
        $scope.popover.show($event);
      }

      $scope.closePopover = () => {
        $scope.popover.hide();
      }

      // Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.popover.remove();
      });

      // Execute action on hide popover
      $scope.$on('popover.hidden', function() {
        // Execute action
      });

      // Execute actioni on remove popover
      $scope.$on('popover.removed', function() {
        // Execute action
      });

      $scope.showEdit = () => {
        $scope.closePopover();
        $state.go('app.chuchabianji', {businesstripid: businessTripId});
      }

      $scope.confirmTijiao = () => {
        let popTxt = '当前行程未填写工作，是否确定提交？'
        if (($scope.data.worklist_zx && $scope.data.worklist_zx.length > 0) || ($scope.data.worklist && $scope.data.worklist.length > 0)) {
          popTxt = '确定要进行提交操作吗？'
        }
        let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">提交确认</span></div>',
					subTitle: `<div><span class="popup-content">${popTxt}</span></div>`,
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
              chuchaService.businessTripSubmit(businessTripId)
                .then(
                  function(res){
                    if (res.data.code === 1) {
                      $scope.showToast({
                        title: "提交成功！"
                      });
                      $scope.goBack();
                    } else {
                      // $ionicPopup.alert({
                      // title: res.data.msg
                      // });
                    }
                    $scope.hideLoading();
                  },
                  function(err){
                    $scope.hideLoading();
                  });
              $scope.closePopover();
          }
				});
      }

      $scope.confirmDelete = () => {
				let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">删除确认</span></div>',
					subTitle: '<div><span class="popup-content">确定要进行删除操作吗？</span></div>',
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
              chuchaService.businessTripDelete(businessTripId)
                .then(
                  function(res){
                    if (res.data.code === 1) {
                      $scope.showToast({
                        title: "删除成功！"
                      });
                      $scope.goBack();
                    } else {
                      // $ionicPopup.alert({
                      // title: res.data.msg
                      // });
                    }
                    $scope.hideLoading();
                  },
                  function(err){
                    $scope.hideLoading();
                  });
              $scope.closePopover();
          }
				});
      }

      $scope.loadData = () => {
        chuchaService.queryBusinessTripMain(
          businessTripId,
        )
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
            $scope.data = $scope.setDefaults($scope.data);
            
            chuchaService.queryAgentList()
            .then(function(res){
              res.data.data.forEach(element => {
                if ($scope.data.tagentsid == element.tagentsid) {
                  $scope.data.fagentName = element.fagentname
                }
              });
            })
            
            $scope.data.datalog.forEach(element => {
              element['avatar'] = 'img/no-avatar.jpg';
              multimediaService.getImageList(element.tenterprise_userid, 'tenterprise_users')
              .then(function(rr){
                if (rr.data.code == 1 && rr.data.data.length > 0) {
                  element['avatar'] = rr.data.data[rr.data.data.length - 1].url;
                }
              })
            });
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.showLoading();
      $scope.loadData();
    });
})();

