/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('ChuchaXinzengController', function($scope, $state, ionicMaterialInk, chuchaService, $ionicPopup) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        tbusinesstripid: 0,
        fname: '',
        fbegdate: '',
        fenddate: '',
        fprovince: '',
        fcity: '',
        fcounty: '',
        fnotes: '',
        fothername: [],
      };

      $scope.showLoading();

      chuchaService.queryAgentList()
      .then(function(res){
        $scope.agentList = res.data.data;
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      $scope.register = function() {
        if ($scope.data.fbegdate > $scope.data.fenddate) {
          $scope.showToast({title: "返程日期应晚于到达时间"});
          return;
        }

        if ($("#dizhi").val() == '') {
          $scope.showToast({title: "请输入出差地址！"});
          return;
        }

        $scope.showLoading();
        $scope.data.datalog = [
          {
              "ftype": "新增",
              "flog": "新增记录",
          }
        ]

				chuchaService.businessTripInsertOrModify(0, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      new Rolldate({
        el: '#fbegdate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fbegdate,
        confirm: function(date) {
          $scope.data.fbegdate = date;
          $scope.$apply($scope.data);
        },
      });
      new Rolldate({
        el: '#fenddate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fenddate,
        confirm: function(date) {
          $scope.data.fenddate = date;
          $scope.$apply($scope.data);
        },
      });
      new Rollarea({
        el: '#dizhi',
        format: 'province-city-county',
        value: {'fprovince': $scope.data.fprovince, 'fcity': $scope.data.fcity, 'fcounty': $scope.data.fcounty},
        confirm: function(area) {
          $scope.data.fprovince = area.fprovince;
          $scope.data.fcity = area.fcity;
          $scope.data.fcounty = area.fcounty;
        },
      });

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentSelectPanel = function() {
        $scope.selectModel = $scope.agentList;
        $scope.selectKeyField = "tagentsid";
        $scope.selectValueField = "fagentname";
        $scope.selectModelName = "tagentsid";
        $scope.selected = $scope.data.tagentsid;

        $scope.showSelectPanel();
      }

		});
})();

