﻿(function(){

	"use strict";
	angular.module('starter.services')
		.service('apiService', function ($http, $q, $ionicHistory, $state, $ionicPopup) {
			var self = this;

			self.makeRequest = function (request) {

				var settings = getSettings(request);
				settings.headers = {
					"Accept": "application/json; charset=utf-8",
					"Content-Type": "application/json",
					"Cache-Control": "no-cache"
					// "Authorization": token.token_type + ' ' + token.access_token
				}

				/*if (settings.headers) {
					settings.headers["culture"] = "he-IL";
				}*/

				var deffered = $q.defer();

				// FIXME
				// console.log('------------- REQUEST ---------------');
				// console.log(JSON.stringify(settings));
				$http(settings)
					.then(function (response) {
						// FIXME
						// console.log('------------- RESPONSE --------------');
						// console.log(JSON.stringify(response));
						if (Number(response.data.errcode) == 5) {
							// var myPopup = $ionicPopup.show({title: response.data.msg});

							// setTimeout(function() {
							// 	myPopup.close();
							// }, 1500);
							//logout
							localStorage.clear();

							var token = localStorage.getItem(TOKEN_KEY);
							var request = {
								url: API_URL_V1 + "logout",
								data: {"accesstoken": token}
							};
							self.makeRequest(request);
							$ionicHistory.nextViewOptions({
								disableBack: true,
								historyRoot: true,
								disableAnimate: true
							});
					
							$ionicHistory.clearCache();
							$ionicHistory.clearHistory();
							$state.go('app.login', {type: 0}, {reload: true});
							deffered.reject(response.data.errcode);
						} else
							deffered.resolve(response);
					}, function (response) {
						deffered.reject(response);
					});

				return deffered.promise;
			};

			self.getByUrl = function (apiUrl) {
				var request = {
					method: 'GET', url: apiUrl
				};

				return self.makeRequest(request);
			};


			function getSettings(requestData) {
				var accesstoken = localStorage.getItem(TOKEN_KEY);
				if (accesstoken)
					requestData.data[TOKEN_KEY] = accesstoken;

				return {
					method: requestData.method || "POST",
					url: requestData.url,
					dataType: requestData.dataType || "json",
					data: requestData.data || {},
					params: requestData.params || {},
					cache: 'false',
					headers: requestData.headers || {
						"Accept": "application/json; charset=utf-8"
						, "Content-Type": "application/json"
						//, "_culture": "he-IL"
					},
					async: requestData.async || "false",
					cache: requestData.cache || "false",
					success: requestData.success || {},
					error: requestData.error || {},
					complete: requestData.complete || {},
					fail: requestData.fail || {}
				};
			}

		})

})();
