
angular.module('starter')
.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
  $ionicConfigProvider.backButton.previousTitleText(false).text('');
  $ionicConfigProvider.tabs.position('bottom');
  $ionicConfigProvider.views.swipeBackEnabled(false);

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider
  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/tabs.html',
    controller: 'AppCtrl'
  })

  .state('app.login', {
    url: '/login/:type',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/login/login.html',
        controller: 'LoginController'
      }
    }
  })

  .state('app.selectuser', {
    url: '/selectuser',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/login/selectuser.html',
        controller: 'SelectUserController'
      }
    }
  })

  .state('app.selectrole', {
    url: '/selectrole/:phone',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/login/selectrole.html',
        controller: 'SelectRoleController'
      }
    }
  })

  .state('app.registeragent', {
    url: '/registeragent/:phone',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/login/registeragent.html',
        controller: 'RegisterAgentController'
      }
    }
  })


  // Each tab has its own nav history stack:

  .state('app.dash', {
    url: '/dash',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/tab-dash.html',
        controller: 'DashController'
      }
    }
  })

  .state('app.wode', {
    url: '/wode',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/tab-account.html',
        controller: 'WodeController'
      }
    }
  })

  .state('app.edit-profile', {
    url: '/edit-profile',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/edit-profile.html',
        controller: 'EditProfileController'
      }
    }
  })

  .state('app.password', {
    url: '/password',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/password.html',
        controller: 'PasswordController'
      }
    }
  })

  .state('app.mendianliebiao', {
    url: '/mendianliebiao',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/mendianliebiao.html',
        controller: 'MendianLiebiaoController'
      }
    }
  })

  .state('app.mendianxiangqing', {
    url: '/mendianxiangqing/:storeid',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/mendianxiangqing.html',
        controller: 'MendianXiangqingController'
      }
    }
  })

  .state('app.zhanghuliebiao', {
    url: '/zhanghuliebiao',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/zhanghuliebiao.html',
        controller: 'ZhanghuLiebiaoController'
      }
    }
  })

  .state('app.zhanghubianji', {
    url: '/zhanghubianji/:enterpriseuserid',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/zhanghubianji.html',
        controller: 'ZhanghuBianjiController'
      }
    }
  })

  .state('app.zhanghuxinzeng', {
    url: '/zhanghuxinzeng',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/zhanghuxinzeng.html',
        controller: 'ZhanghuXinzengController'
      }
    }
  })

  .state('app.xiaoshouliebiao', {
    url: '/xiaoshouliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshou/xiaoshouliebiao.html',
        controller: 'XiaoshouLiebiaoController'
      }
    }
  })

  .state('app.xiaoshouxiangqing', {
    url: '/xiaoshouxiangqing/:receiptid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshou/xiaoshouxiangqing.html',
        controller: 'XiaoshouXiangqingController'
      }
    }
  })

  .state('app.xiaoshouxinzeng', {
    url: '/xiaoshouxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshou/xiaoshouxinzeng.html',
        controller: 'XiaoshouXinzengController'
      }
    }
  })

  .state('app.xiaoshoubianji', {
    url: '/xiaoshoubianji/:receiptid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshou/xiaoshoubianji.html',
        controller: 'XiaoshouBianjiController'
      }
    }
  })

  .state('app.xiaoshoujiluliebiao', {
    url: '/xiaoshoujiluliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoujilu/xiaoshoujiluliebiao.html',
        controller: 'XiaoshouJiluLiebiaoController'
      }
    }
  })

  .state('app.xiaoshoujiluxiangqing', {
    url: '/xiaoshoujiluxiangqing/:agentspurchaseid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoujilu/xiaoshoujiluxiangqing.html',
        controller: 'XiaoshouJiluXiangqingController'
      }
    }
  })

  .state('app.xiaoshoujiluxinzeng', {
    url: '/xiaoshoujiluxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoujilu/xiaoshoujiluxinzeng.html',
        controller: 'XiaoshouJiluXinzengController'
      }
    }
  })

  .state('app.xiaoshoujilubianji', {
    url: '/xiaoshoujilubianji/:agentspurchaseid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoujilu/xiaoshoujilubianji.html',
        controller: 'XiaoshouJiluBianjiController'
      }
    }
  })

  .state('app.jiedailiebiao', {
    url: '/jiedailiebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/jiedai/jiedailiebiao.html',
        controller: 'JiedaiLiebiaoController'
      }
    }
  })

  .state('app.jiedaixiangqing', {
    url: '/jiedaixiangqing/:receiptid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/jiedai/jiedaixiangqing.html',
        controller: 'JiedaiXiangqingController'
      }
    }
  })

  .state('app.jiedaixinzeng', {
    url: '/jiedaixinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/jiedai/jiedaixinzeng.html',
        controller: 'JiedaiXinzengController'
      }
    }
  })

  .state('app.jiedaibianji', {
    url: '/jiedaibianji/:receiptid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/jiedai/jiedaibianji.html',
        controller: 'JiedaiBianjiController'
      }
    }
  })

  .state('app.shijianliebiao', {
    url: '/shijianliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/shijian/shijianliebiao.html',
        controller: 'ShijianLiebiaoController'
      }
    }
  })

  .state('app.shijianxiangqing', {
    url: '/shijianxiangqing/:saleeventid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/shijian/shijianxiangqing.html',
        controller: 'ShijianXiangqingController'
      }
    }
  })

  .state('app.shijianxinzeng', {
    url: '/shijianxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/shijian/shijianxinzeng.html',
        controller: 'ShijianXinzengController'
      }
    }
  })

  .state('app.shijianbianji', {
    url: '/shijianbianji/:saleeventid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/shijian/shijianbianji.html',
        controller: 'ShijianBianjiController'
      }
    }
  })

  .state('app.feiyongliebiao', {
    url: '/feiyongliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/feiyong/feiyongliebiao.html',
        controller: 'FeiyongLiebiaoController'
      }
    }
  })

  .state('app.feiyongxiangqing', {
    url: '/feiyongxiangqing/:tagents_costid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/feiyong/feiyongxiangqing.html',
        controller: 'FeiyongXiangqingController'
      }
    }
  })

  .state('app.feiyongxinzeng', {
    url: '/feiyongxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/feiyong/feiyongxinzeng.html',
        controller: 'FeiyongXinzengController'
      }
    }
  })

  .state('app.feiyongbianji', {
    url: '/feiyongbianji/:tagents_costid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/feiyong/feiyongbianji.html',
        controller: 'FeiyongBianjiController'
      }
    }
  })

  .state('app.dianpuliebiao', {
    url: '/dianpuliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpu/dianpuliebiao.html',
        controller: 'DianpuLiebiaoController'
      }
    }
  })

  .state('app.dianpuxiangqing', {
    url: '/dianpuxiangqing/:agentsid?storeid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpu/dianpuxiangqing.html',
        controller: 'DianpuXiangqingController'
      }
    }
  })

  .state('app.dianpuxinzeng', {
    url: '/dianpuxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpu/dianpuxinzeng.html',
        controller: 'DianpuXinzengController'
      }
    }
  })

  .state('app.dianpugaijian', {
    url: '/dianpugaijian/:agentsid/:storeid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpu/dianpugaijian.html',
        controller: 'GaijianDianpuController'
      }
    }
  })

  .state('app.dianpubianji', {
    url: '/dianpubianji/:agentsid?storeid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpu/dianpubianji.html',
        controller: 'DianpuBianjiController'
      }
    }
  })

  .state('app.tibaojianguan', {
    url: '/tibaojianguan',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/jianguan/tibaojianguan.html',
        controller: 'TibaoJianguanController'
      }
    }
  })

  .state('app.yixiangkehuxitong', {
    url: '/yixiangkehuxitong',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/yixiangkehuxitong/shouye.html',
        controller: 'YixiangKehuXitongShouyeController'
      }
    }
  })

  .state('app.yixiangkehuxitong-kehulaiyuanfenxi', {
    url: '/yixiangkehuxitong-kehulaiyuanfenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/yixiangkehuxitong/kehulaiyuanfenxi.html',
        controller: 'KehuLaiyuanFenxiController'
      }
    }
  })

  .state('app.yixiangkehuxitong-xinzengyixiangkehufenxi', {
    url: '/yixiangkehuxitong-xinzengyixiangkehufenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/yixiangkehuxitong/xinzengyixiangkehufenxi.html',
        controller: 'XinzengYixiangKehuFenxiController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong', {
    url: '/xiaoshoufenxixitong',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/shouye.html',
        controller: 'XiaoshouFenxiXitongShouyeController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-xiaoshoudongzuofenxi', {
    url: '/xiaoshoufenxixitong-xiaoshoudongzuofenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/xiaoshoudongzuofenxi.html',
        controller: 'XiaoshouDongzuoFenxiController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-xiaoshouqudaofenxi', {
    url: '/xiaoshoufenxixitong-xiaoshouqudaofenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/xiaoshouqudaofenxi.html',
        controller: 'XiaoshouQudaoFenxiController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-chengjiaochanpinfenxi', {
    url: '/xiaoshoufenxixitong-chengjiaochanpinfenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/chengjiaochanpinfenxi.html',
        controller: 'ChengjiaoChanpinFenxiController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-kedanzhifenxi', {
    url: '/xiaoshoufenxixitong-kedanzhifenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/kedanzhifenxi.html',
        controller: 'KedanzhiFenxiController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-xiaoquzhanbifenxi', {
    url: '/xiaoshoufenxixitong-xiaoquzhanbifenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/xiaoquzhanbifenxi.html',
        controller: 'XiaoquZhanbiFenxiController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-tuidanlvfenxi', {
    url: '/xiaoshoufenxixitong-tuidanlvfenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/tuidanlvfenxi.html',
        controller: 'TuidanlvFenxiController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-xiaoshoushuju', {
    url: '/xiaoshoufenxixitong-xiaoshoushuju',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/xiaoshoushuju.html',
        controller: 'XiaoshouFenxiShujuController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-xiaoqukedanzhi', {
    url: '/xiaoshoufenxixitong-xiaoqukedanzhi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/xiaoqukedanzhi.html',
        controller: 'XiaoquKedanzhiController'
      }
    }
  })

  .state('app.xiaoshoufenxixitong-jiedaicishufenxi', {
    url: '/xiaoshoufenxixitong-jiedaicishufenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoufenxixitong/jiedaicishufenxi.html',
        controller: 'JiedaiCishuFenxiController'
      }
    }
  })

  .state('app.shijianfenxixitong', {
    url: '/shijianfenxixitong',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/shijianfenxixitong/shouye.html',
        controller: 'ShijianFenxiXitongShouyeController'
      }
    }
  })

  .state('app.jingyingfenxixitong', {
    url: '/jingyingfenxixitong',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/jingyingfenxixitong/shouye.html',
        controller: 'JingyingFenxiXitongShouyeController'
      }
    }
  })

  .state('app.jingyingfenxixitong-feiyongzhanbifenxi', {
    url: '/jingyingfenxixitong-feiyongzhanbifenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/jingyingfenxixitong/feiyongzhanbifenxi.html',
        controller: 'FeiyongZhanbiFenxiController'
      }
    }
  })

  .state('app.jingyingfenxixitong-yueduyingkuifenxi', {
    url: '/jingyingfenxixitong-yueduyingkuifenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/jingyingfenxixitong/yueduyingkuifenxi.html',
        controller: 'YueduYingkuiFenxiController'
      }
    }
  })

  .state('app.kehudanganfenxi', {
    url: '/kehudanganfenxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/kehudanganfenxi/shouye.html',
        controller: 'KehuDanganFenxiShouyeController'
      }
    }
  })

  .state('app.kehudanganfenxi-laokehuxinxi', {
    url: '/kehudanganfenxi-laokehuxinxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/kehudanganfenxi/laokehuxinxi.html',
        controller: 'LaokehuXinxiController'
      }
    }
  })

  .state('app.kehudanganfenxi-yixiangkehuxinxi', {
    url: '/kehudanganfenxi-yixiangkehuxinxi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/kehudanganfenxi/yixiangkehuxinxi.html',
        controller: 'YixiangKehuXinxiController'
      }
    }
  })


  .state('app.kehudanganfenxi-laokehugenjin', {
    url: '/kehudanganfenxi-laokehugenjin',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/kehudanganfenxi/laokehugenjin.html',
        controller: 'LaokehuGenjinController'
      }
    }
  })

  .state('app.kehudanganfenxi-yixiangkehugenjin', {
    url: '/kehudanganfenxi-yixiangkehugenjin',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/kehudanganfenxi/yixiangkehugenjin.html',
        controller: 'YixiangkehuGenjinController'
      }
    }
  })

  .state('app.sucailiebiao', {
    url: '/sucailiebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/sucai/sucailiebiao.html',
        controller: 'SucaiLiebiaoController'
      }
    }
  })

  .state('app.sucaixiangqing', {
    url: '/sucaixiangqing/:archivesid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/sucai/sucaixiangqing.html',
        controller: 'SucaiXiangqingController'
      }
    }
  })

  .state('app.sucaixinzeng', {
    url: '/sucaixinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/sucai/sucaixinzeng.html',
        controller: 'SucaiXinzengController'
      }
    }
  })

  .state('app.sucaibianji', {
    url: '/sucaibianji/:archivesid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/sucai/sucaibianji.html',
        controller: 'SucaiBianjiController'
      }
    }
  })

  .state('app.yingxiaozhiku', {
    url: '/yingxiaozhiku',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/yingxiaozhiku/yingxiaozhiku.html',
        controller: 'YingxiaoZhikuController'
      }
    }
  })

  .state('app.wuliaoxiangqing', {
    url: '/wuliaoxiangqing/:archivesid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/yingxiaozhiku/wuliaoxiangqing.html',
        controller: 'WuliaoXiangqingController'
      }
    }
  })

  .state('app.kechengliebiao', {
    url: '/kechengliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/kecheng/kechengliebiao.html',
        controller: 'KechengLiebiaoController'
      }
    }
  })

  .state('app.kechengxiangqing', {
    url: '/kechengxiangqing/:archivesid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/kecheng/kechengxiangqing.html',
        controller: 'KechengXiangqingController'
      }
    }
  })

  .state('app.xinxiaoxiliebiao', {
    url: '/xinxiaoxiliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xinxiaoxi/xinxiaoxiliebiao.html',
        controller: 'XinxiaoxiLiebiaoController'
      }
    }
  })

  .state('app.chuchaliebiao', {
    url: '/chuchaliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/chucha/chuchaliebiao.html',
        controller: 'ChuchaLiebiaoController'
      }
    }
  })

  .state('app.chuchaxiangqing', {
    url: '/chuchaxiangqing/:businesstripid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/chucha/chuchaxiangqing.html',
        controller: 'ChuchaXiangqingController'
      }
    }
  })

  .state('app.chuchaxinzeng', {
    url: '/chuchaxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/chucha/chuchaxinzeng.html',
        controller: 'ChuchaXinzengController'
      }
    }
  })

  .state('app.chuchabianji', {
    url: '/chuchabianji/:businesstripid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/chucha/chuchabianji.html',
        controller: 'ChuchaBianjiController'
      }
    }
  })

  .state('app.biaozhunliebiao', {
    url: '/biaozhunliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/biaozhun/biaozhunliebiao.html',
        controller: 'BiaozhunLiebiaoController'
      }
    }
  })

  .state('app.biaozhunxiangqing', {
    url: '/biaozhunxiangqing/:workid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/biaozhun/biaozhunxiangqing.html',
        controller: 'BiaozhunXiangqingController'
      }
    }
  })

  .state('app.biaozhunxinzeng', {
    url: '/biaozhunxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/biaozhun/biaozhunxinzeng.html',
        controller: 'BiaozhunXinzengController'
      }
    }
  })

  .state('app.selectbussinesstrip', {
    url: '/selectbussinesstrip',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/biaozhun/selectbussinesstrip.html',
        controller: 'SelectBussinesstripController'
      }
    }
  })

  .state('app.biaozhunbianji', {
    url: '/biaozhunbianji/:workid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/biaozhun/biaozhunbianji.html',
        controller: 'BiaozhunBianjiController'
      }
    }
  })

  .state('app.zixuanliebiao', {
    url: '/zixuanliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/zixuan/zixuanliebiao.html',
        controller: 'ZixuanLiebiaoController'
      }
    }
  })

  .state('app.zixuanxiangqing', {
    url: '/zixuanxiangqing/:workid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/zixuan/zixuanxiangqing.html',
        controller: 'ZixuanXiangqingController'
      }
    }
  })

  .state('app.zixuanxinzeng', {
    url: '/zixuanxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/zixuan/zixuanxinzeng.html',
        controller: 'ZixuanXinzengController'
      }
    }
  })

  .state('app.zixuanbianji', {
    url: '/zixuanbianji/:workid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/zixuan/zixuanbianji.html',
        controller: 'ZixuanBianjiController'
      }
    }
  })

  .state('app.gongzuoshuju', {
    url: '/gongzuoshuju',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/gongzuoshuju/shouye.html',
        controller: 'GongzuoShujuShouyeController'
      }
    }
  })

  .state('app.gongzuoshuju-gongzuojieguopingding', {
    url: '/gongzuoshuju-gongzuojieguopingding',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/gongzuoshuju/gongzuojieguopingding.html',
        controller: 'GongzuoJieguoPingdingController'
      }
    }
  })

  .state('app.gongzuoshuju-fangfashoujipaiming', {
    url: '/gongzuoshuju-fangfashoujipaiming',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/gongzuoshuju/fangfashoujipaiming.html',
        controller: 'FangfaShoujiPaimingController'
      }
    }
  })

  .state('app.xiaoshoushuju', {
    url: '/xiaoshoushuju',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoushuju/shouye.html',
        controller: 'XiaoshouShujuShouyeController'
      }
    }
  })

  .state('app.xiaoshoushuju-tongbizengfu', {
    url: '/xiaoshoushuju-tongbizengfu',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoushuju/tongbizengfu.html',
        controller: 'TongbiZengfuController'
      }
    }
  })

  .state('app.xiaoshoushuju-yuepingjunxiaoshou', {
    url: '/xiaoshoushuju-yuepingjunxiaoshou',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoushuju/yuepingjunxiaoshou.html',
        controller: 'YuepingjunXiaoshouController'
      }
    }
  })

  .state('app.xiaoshoushuju-xiaoshoushuju', {
    url: '/xiaoshoushuju-xiaoshoushuju',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/xiaoshoushuju/xiaoshoushuju.html',
        controller: 'XiaoshouShujuController'
      }
    }
  })

  .state('app.dianpushuju', {
    url: '/dianpushuju',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpushuju/shouye.html',
        controller: 'DianpuShujuShouyeController'
      }
    }
  })

  .state('app.dianpushuju-mianjizhanbi', {
    url: '/dianpushuju-mianjizhanbi',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpushuju/mianjizhanbi.html',
        controller: 'MianjiZhanbiController'
      }
    }
  })

  .state('app.dianpushuju-dianpugaijian', {
    url: '/dianpushuju-dianpugaijian',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpushuju/dianpugaijian.html',
        controller: 'DianpuGaijianController'
      }
    }
  })

  .state('app.dianpushuju-dianpumaichang', {
    url: '/dianpushuju-dianpumaichang',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpushuju/dianpumaichang.html',
        controller: 'DianpuMaichangController'
      }
    }
  })

  .state('app.dianpushuju-jingxiaoshangdangan', {
    url: '/dianpushuju-jingxiaoshangdangan',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/dianpushuju/jingxiaoshangdangan.html',
        controller: 'JingxiaoshangDanganController'
      }
    }
  })

  .state('app.zhongduandashuju', {
    url: '/zhongduandashuju',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/zhongduandashuju/shouye.html',
        controller: 'ZhongduanDashujuShouyeController'
      }
    }
  })

  .state('app.zongbiao', {
    url: '/zongbiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/zongbiao/shouye.html',
        controller: 'ZongbiaoShouyeController'
      }
    }
  })

  .state('app.xingdongli', {
    url: '/xingdongli',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/xingdongli.html',
        controller: 'XingdongliController'
      }
    }
  })

  .state('app.renwuzhongxin', {
    url: '/renwuzhongxin',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/renwuzhongxin.html',
        controller: 'RenwuZhongxinController'
      }
    }
  })

  .state('app.paihangbang', {
    url: '/paihangbang',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/paihangbang.html',
        controller: 'PaihangbangController'
      }
    }
  })

  .state('app.jinriqiandao', {
    url: '/jinriqiandao',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/jinriqiandao.html',
        controller: 'JinriQiandaoController'
      }
    }
  })

  .state('app.zhuanyeban', {
    url: '/zhuanyeban',
    cache: false,
    views: {
      'tab-account': {
        templateUrl: 'templates/geren/zhuanyeban.html',
        controller: 'ZhuanyebanController'
      }
    }
  })

  .state('app.tongxunlu', {
    url: '/tongxunlu',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/geren/tongxunlu.html',
        controller: 'TongxunluController'
      }
    }
  })

  .state('app.tonggaoliebiao', {
    url: '/tonggaoliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/tonggao/tonggaoliebiao.html',
        controller: 'TonggaoLiebiaoController'
      }
    }
  })

  .state('app.tonggaoxiangqing', {
    url: '/tonggaoxiangqing/:tonggaoid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/tonggao/tonggaoxiangqing.html',
        controller: 'TonggaoXiangqingController'
      }
    }
  })

  .state('app.tibaoliebiao', {
    url: '/tibaoliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/tibao/tibaoliebiao.html',
        controller: 'TibaoLiebiaoController'
      }
    }
  })

  .state('app.tibaoxiangqing', {
    url: '/tibaoxiangqing/:tibaoid/:type',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/tibao/tibaoxiangqing.html',
        controller: 'TibaoXiangqingController'
      }
    }
  })

  .state('app.tibaotianxie', {
    url: '/tibaotianxie/:tibaoid/:type',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/tibao/tibaotianxie.html',
        controller: 'TibaoTianxieController'
      }
    }
  })

  .state('app.tousu', {
    url: '/tousu',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/tousu/tousu.html',
        controller: 'TousuController'
      }
    }
  })

  // TODO
  .state('app.shujutongji', {
    url: '/shujutongji',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/temp/shujutongji.html',
        controller: 'ShujuTongjiController'
      }
    }
  })

  .state('app.xingdonglizhoubao', {
    url: '/xingdonglizhoubao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/temp/xingdonglizhoubao.html',
        controller: 'XingdongliZhoubaoController'
      }
    }
  })

  .state('app.zhifuliebiao', {
    url: '/zhifuliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/zhifu/zhifuliebiao.html',
        controller: 'ZhifuLiebiaoController'
      }
    }
  })

  .state('app.zhifuxinzeng', {
    url: '/zhifuxinzeng',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/zhifu/zhifuxinzeng.html',
        controller: 'ZhifuXinzengController'
      }
    }
  })

  .state('app.huodongliebiao', {
    url: '/huodongliebiao',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/huodong/huodongliebiao.html',
        controller: 'HuodongLiebiaoController'
      }
    }
  })

  .state('app.promotehuodong', {
    url: '/promotehuodong',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/huodong/promotehuodong.html',
        controller: 'PromoteHuodongController'
      }
    }
  })

  .state('app.huodongxiangqing', {
    url: '/huodongxiangqing/:tagentactivitiesid/:tenterprise_userid',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/huodong/huodongxiangqing.html',
        controller: 'HuodongXiangqingController'
      }
    }
  })

  .state('app.huodongxinzeng', {
    url: '/huodongxinzeng/:huodongid/:type',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/huodong/huodongxinzeng.html',
        controller: 'HuodongXinzengController'
      }
    }
  })

  .state('app.consulting', {
    url: '/consulting',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/tousu/consulting.html',
        controller: 'ConsultingController'
      }
    }
  })

  .state('app.wodetuiguangren', {
    url: '/wodetuiguangren',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/geren/wodetuiguangren.html',
        controller: 'WodetuiguangrenController'
      }
    }
  })

  .state('app.wodeshangjia', {
    url: '/wodeshangjia',
    cache: false,
    views: {
      'tab-dash': {
        templateUrl: 'templates/geren/wodeshangjia.html',
        controller: 'WodeShangjiaController'
      }
    }
  })

  var accesstoken = localStorage.getItem(TOKEN_KEY);
  if (accesstoken) {
    if (localStorage.getItem(ROLE) == '推广人')
      $urlRouterProvider.otherwise('/app/promotehuodong')
    else
      $urlRouterProvider.otherwise('/app/dash')
  }
  else
    $urlRouterProvider.otherwise('/app/login/0');

  // if none of the above states are matched, use this as the fallback

});
