angular.module('starter.controllers', ['ngCordova'])

.controller('AppCtrl', function($rootScope, $scope, $state, $ionicLoading, $ionicPopup, $ionicHistory, $window, userService, multimediaService, $sce, dashService, $ionicNavBarDelegate, IonicClosePopupService, $ionicSlideBoxDelegate, $ionicModal) {
  // Form data for the login modal
  $scope.loginData = {};
  $scope.isExpanded = false;
  $scope.hasHeaderFabLeft = false;
  $scope.hasHeaderFabRight = false;
  $scope.showFilter = false;
  $scope.lastKeyword = '';
  $scope.xiaoxiCount = 0;
  $scope.isV300 = true
  $scope.isV310 = false

  $scope.ipAddr = "0.0.0.0"
  setTimeout(() => {
    networkinterface.getWiFiIPAddress(address => {
      $scope.ipAddr = address.ip
    }, error => console.error(`Unable to get IP: ${error}`));
    networkinterface.getCarrierIPAddress(address => {
      $scope.ipAddr = address.ip
    }, err => console.log(err))
  }, 2000)

  function wechatPayment(accountInfo) {
    var paymentPopup = $ionicPopup.show({
      title: '<div class="table-line"><span class="popup-title">系统提示</span></div>',
      subTitle: '<div><span class="popup-content">该账号暂未支付使用年费，请前往支付！</span></div>',
      scope: $scope,
      buttons: [
        // {
        //   text: '暂不支付',
        //   type: 'button-left',
        //   onTap: function(e) {
        //     return 0;
        //   }
        // },
        {
          text: `￥${accountInfo.fpayamount} <strike>￥${accountInfo.fagentoldamount}</strike> 去支付`,
          type: 'button-pay button-pay background-red',
          onTap: function(e) {
            return 1;
          }
        },
      ]
    })
    paymentPopup.then(function(res) {
      if (res == 1) {
        userService.createAPPWechatOrder(accountInfo, $scope.ipAddr).then(res => {
          if (!res.data || !res.data.data.partnerid) {
            $state.go('app.login', {type: 0});
            return
          }
          var params = {
            partnerid: res.data.data.partnerid, // merchant id
            prepayid: res.data.data.prepayid, // prepay id
            noncestr: res.data.data.noncestr, // nonce
            timestamp: res.data.data.timestamp, // timestamp
            sign: res.data.data.sign, // signed string
          };
          
          Wechat.sendPaymentRequest(params, function () {
            $scope.showToast({title: '支付成功！'})
            $state.go('app.dash')
          }, function (reason) {
            $scope.showToast({title: '支付失败！' + reason})
            $state.go('app.login', {type: 0});
          });
        })
      } else {
        // $state.go('app.login', {type: 0});
      }
    });
    IonicClosePopupService.register(paymentPopup);
  }

  $scope.selectUser = (accountInfo, nextView = 'app.dash') => {
    $ionicHistory.nextViewOptions({
      disableBack: true,
      historyRoot: true,
    });
    // 微信支付
    if (accountInfo.fisneedpay > 0) {
      wechatPayment(accountInfo)
    } else
    {
      userService.selectUser(accountInfo);
      setTimeout(() => {
        $state.go(nextView);
      }, 100);
    }
  }

  $scope.swipe = function (direction) {
    if(direction == 'right') 
      $ionicNavBarDelegate.back();
  }
  
  $rootScope.$ionicGoBack = function() {
    if ($state.current.name == 'app.edit-profile' && $scope.isPromoterRole() && $ionicHistory.backView().url != '/app/wode')
      $state.go('app.promotehuodong')
    else
      $ionicNavBarDelegate.back();
  }

  $scope.getXiaoxiCount = function() {
    return $scope.xiaoxiCount > 0 ? $scope.xiaoxiCount : 0;
  }

  $scope.resetXiaoxiCount = function() {
    $scope.xiaoxiCount = 0;
  }

  $scope.incXiaoxiCount = function() {
    $scope.xiaoxiCount++;
  }

  $scope.decXiaoxiCount = function() {
    $scope.xiaoxiCount = $scope.xiaoxiCount > 0 ? $scope.xiaoxiCount - 1 : 0;
  }

  var navIcons = document.getElementsByClassName('ion-navicon');
  for (var i = 0; i < navIcons.length; i++) {
    navIcons.addEventListener('click', function() {
      this.classList.toggle('active');
    });
  }

  ////////////////////////////////////////
  // Layout Methods
  ////////////////////////////////////////

  $scope.hideNavBar = function() {
    document.getElementsByTagName('ion-nav-bar')[0].style.display = 'none';
  };

  $scope.showNavBar = function() {
    document.getElementsByTagName('ion-nav-bar')[0].style.display = 'block';
  };

  $scope.hideTabBar = function() {
    $(".tab-nav").hide();
    setTimeout(() => {
      $(".scroll-content").removeClass("has-tabs");
    }, 100);
  }

  $scope.showTabBar = function() {
    $(".tab-nav").show();
    setTimeout(() => {
      $(".scroll-content").addClass("has-tabs");
    }, 100);
  }

  $scope.noHeader = function() {
    var content = document.getElementsByTagName('ion-content');
    for (var i = 0; i < content.length; i++) {
      if (content[i].classList.contains('has-header')) {
        content[i].classList.toggle('has-header');
      }
    }
  };

  $scope.setExpanded = function(bool) {
    $scope.isExpanded = bool;
  };

  $scope.setHeaderFab = function(location) {
    var hasHeaderFabLeft = false;
    var hasHeaderFabRight = false;

    switch (location) {
      case 'left':
        hasHeaderFabLeft = true;
        break;
      case 'right':
        hasHeaderFabRight = true;
        break;
    }

    $scope.hasHeaderFabLeft = hasHeaderFabLeft;
    $scope.hasHeaderFabRight = hasHeaderFabRight;
  };

  $scope.hasHeader = function() {
    var content = document.getElementsByTagName('ion-content');
    for (var i = 0; i < content.length; i++) {
      if (!content[i].classList.contains('has-header')) {
        content[i].classList.toggle('has-header');
      }
    }
  };

  $scope.hideHeader = function() {
    $scope.hideNavBar();
    $scope.noHeader();
  };

  $scope.showHeader = function() {
    $scope.showNavBar();
    $scope.hasHeader();
  };

  $scope.clearFabs = function() {
    var fabs = document.getElementsByClassName('button-fab');
    if (fabs.length && fabs.length > 1) {
      fabs[0].remove();
    }
  };

  $scope.showLoading = function (text, duration) {
    if (text == undefined)
      text = ''
    if (!duration)
      duration = 30000
    if (duration == -1) {
      $ionicLoading.show({
        template: '<div ng-click="hideLoading()" style="margin:8px" class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg><span style="font-size:0.8em">' + text + '</span></div>',
        scope:$scope
      });
    } else
      $ionicLoading.show({
        template: '<div ng-click="hideLoading()" style="margin:8px" class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg><span style="font-size:0.8em">' + text + '</span></div>',
        duration : duration,
        scope:$scope
      });
  };

  $scope.hideLoading = function(){
    $ionicLoading.hide();
  };

  $scope.navigate = function(target) {
    $scope.showHeader()
    $state.go(target)
  }

  $scope.setShowSearchBar = function(v) {
    $scope.isSearchVisible = v;
  }

  $scope.toggleSearchBar = function(){
    $scope.isSearchVisible = !$scope.isSearchVisible;
  }

  $scope.hideSearchBar = function(){
    $scope.isSearchVisible = false;
  }

  $scope.switchFilter = function(){
    $scope.showFilter = !$scope.showFilter;
  }

  $scope.setShowFilter = function(v){
    $scope.showFilter = v;
    $scope.initFenxiPeriod();
  }

  $scope.getKeywordToSave = (oldKey, newKey) => {
    // console.log('old:' + oldKey + ' / new:' + newKey);

    if (!oldKey && newKey) return newKey;
    if (!oldKey || !newKey) return null;
    const oldKeyLen = oldKey.length;
    const newKeyLen = newKey.length;
    if (oldKeyLen == newKeyLen - 1) {
      if (oldKey == newKey.substring(0, oldKeyLen)) {
        return [oldKey, newKey];
      }
    } else if (oldKeyLen == newKeyLen + 1) {
      if (oldKey.substring(0, newKeyLen) == newKey) {
        return [oldKey, newKey];
      }
    }

    return newKey;
  }

  $scope.saveKeyword = (keyword) => {
    if (!keyword) {
      $scope.keyword = '';
      $scope.$broadcast('refresh');
      return;
    }

    $scope.keyword = keyword;
    $scope.$broadcast('refresh');

    // const newKeyword = $scope.getKeywordToSave($scope.lastKeyword, keyword);
    // if (!newKeyword) return;
    // let keyToDelete = '';
    // let keyToAdd = '';
    // if (Array.isArray(newKeyword)) {
    //   keyToDelete = newKeyword[0];
    //   keyToAdd = newKeyword[1];
    // } else if (typeof(newKeyword) === 'string') {
    //   keyToAdd = newKeyword;
    // } else {
    //   return;
    // }

    // $scope.lastKeyword = keyToAdd;

    // let keywordsString = localStorage.getItem(KEYWORDS);
    // let keywords;
    // if (!keywordsString || keywordsString == '[]') {
    //   keywords = new Array();
    // } else {
    //   keywords = JSON.parse(keywordsString);
    // }

    // if (keywords.includes(keyToDelete)) {
    //   const idx = keywords.indexOf(keyToDelete);
    //   keywords.splice(idx, 1);
    // }
    // if (keywords.includes(keyToAdd)) return;

    // keywords.push(keyToAdd);
    // localStorage.setItem(KEYWORDS, JSON.stringify(keywords));
  }

  $scope.loadKeywords = () => {
    // let keywordsString = localStorage.getItem(KEYWORDS);
    // let keywords;
    // if (!keywordsString || keywordsString == '[]') {
    //   keywords = new Array();
    // } else {
    //   keywords = JSON.parse(keywordsString);
    // }
    // return keywords;
  }

  $scope.clearKeywords = () => {
    localStorage.setItem(KEYWORDS, JSON.stringify(new Array()));
  }

  $scope.clearKeyword = () => {
    $scope.keyword = ''
  }

  $scope.getPeriodStart = () => {
    return $scope.periodStart;
  }

  $scope.setPeriodStart = (v) => {
    $scope.periodStart = v;
  }

  $scope.getPeriodEnd = () => {
    return $scope.periodEnd;
  }

  $scope.setPeriodEnd = (v) => {
    $scope.periodEnd = v;
    $scope.$broadcast('refresh');
  }

  $scope.getPeriodString = () => {
    if (!$scope.getPeriodStart() || !$scope.getPeriodEnd()) {
      return '';
    } else {
      return $scope.periodStart.getFullYear() + '-' + ("0" + ($scope.periodStart.getMonth() + 1)).slice(-2) + '-' + ("0" + $scope.periodStart.getDate()).slice(-2) + ' ~ ' +
          $scope.periodEnd.getFullYear() + '-' + ("0" + ($scope.periodEnd.getMonth() + 1)).slice(-2) + '-' + ("0" + $scope.periodEnd.getDate()).slice(-2);
    }
  }

  $scope.applyChartFilter = (filterType, value1, value2, value3) => {
    $scope.setShowFilter(false);

    value1 = Number(value1);
    if (filterType == 0) {
      value2 = Number(value2);
      $scope.fenxiPeriodStart = new Date(value1, value2, 1);
      $scope.fenxiPeriodEnd = new Date(value1, value2 + 1, 0);
      $scope.fenxiPeriodString = value1 + '年' + (value2 + 1) + '月';
    } else if (filterType == 1) {
      value2 = Number(value2);
      const chineseNumber = '一二三四';
      $scope.fenxiPeriodStart = new Date(value1, value2 * 3, 1);
      $scope.fenxiPeriodEnd = new Date(value1, value2 * 3 + 3, 0);
      $scope.fenxiPeriodString = value1 + '年 第' +
          chineseNumber.substring(value2, value2 + 1) + '季度';
    } else if (filterType == 2) {
      $scope.fenxiPeriodStart = new Date(value1, 0, 1);
      $scope.fenxiPeriodEnd = new Date(value1 + 1, 0, 0);
      $scope.fenxiPeriodString = value1 + '年';
    } else {
      $scope.fenxiPeriodStart = undefined;
      $scope.fenxiPeriodEnd = undefined;
    }

    $scope.$broadcast('refresh');
  }

  $scope.initFenxiPeriod = function() {
    $scope.fenxiPeriodStart = undefined;
    $scope.fenxiPeriodEnd = undefined;
    $scope.fenxiPeriodString = undefined;
  }

  $scope.setFenxiPeriodStart = v => {
    $scope.fenxiPeriodStart = v;
  }

  $scope.setFenxiPeriodEnd = v => {
    $scope.fenxiPeriodEnd = v;
  }

  $scope.setFenxiPeriodString = v => {
    $scope.fenxiPeriodString = v;
  }

  $scope.getCurrentMonthString = function() {
    return new Date().getFullYear() + '年' + ("0" + (new Date().getMonth() + 1)).slice(-2) + '月';
  }

  $scope.getCurrentYearString = function() {
    return new Date().getFullYear() + '年';
  }

  $scope.showToast = function(opt) {
    var myPopup = $ionicPopup.show(opt);

    setTimeout(function() {
      myPopup.close();
    }, 1500);
  }

  $scope.goBack = function() {
    $window.history.go(-1);
  }

  $scope.logout = function () {
    $scope.showLoading();

    userService.logout();

    $ionicHistory.nextViewOptions({
      disableBack: true,
      historyRoot: true,
      disableAnimate: true
    });

    $ionicHistory.clearCache();
    $ionicHistory.clearHistory();
    setTimeout(() => {
      $scope.hideLoading();
    }, 100);
    $state.go('app.login', {type: 0}, {reload: true});
  };

  $scope.max = (a, b) => {
    return Math.max(a, b);
  }

  $scope.checkPhone = function(phone) {
    if (!checkPhone(phone))
      $scope.showToast({
        title: '手机号码有误，请重填'
      });
  }

  $scope.checkMail = function(mail) {
    if (!checkMail(mail))
      $scope.showToast({
        title: '邮箱有误，请重填'
      });
  }

  $scope.refreshComplete = function() {
    $scope.hideLoading();
    $scope.$broadcast('scroll.refreshComplete')
    $scope.$broadcast('scroll.infiniteScrollComplete');
  }

  $scope.locationList = [];
  $.getJSON("areaData.json", function(json) {
    $scope.locationList = json;
  });

  $scope.getLocString = function(data, delimeter = "-"){
    if ($scope.locationList)
      if (data && data.fprovince && data.fcity && data.fcounty)
        return $scope.locationList['86'][data.fprovince] + delimeter + $scope.locationList[data.fprovince][data.fcity] + delimeter + ($scope.locationList[data.fcity][data.fcounty] ? $scope.locationList[data.fcity][data.fcounty] : ' ');
    return '';
  }

  $scope.setDefaults = function(data, type="") {
    if (!data) return data;
    switch(type) {
      case "":
        Object.keys(data).forEach(function(idx){
          if ((idx != 'fiscollection') && (!data[idx] || (data[idx].length == 0 && idx != 'worklist' && idx != 'worklist_zx' && idx != 'datalog')))
            data[idx] = '暂无';
        });
        break;
      default:
        break;
    }
    return data;
  }

  /**
 * 图表图片导出
 * @param chart chart 实例
 * @param name 图片名称，可选，默认名为 'G2Chart'
 */
  $scope.downloadImage = function(chart) {
    let myPopup = $ionicPopup.show({
      title: '<div class="table-line"><span class="popup-title">导图确认</span></div>',
      subTitle: '<div><span class="popup-content">是否保存统计图?</span></div>',
      scope: $scope,
      buttons: [
        {
          text: '取消',
          type: 'button-left',
          onTap: function(e) {
            return 0;
          }
        },
        {
          text: '确认',
          type: 'button-right background-red',
          onTap: function(e) {
            return 1;
          }
        },
      ]
    })
    .then(function(res) {
      if (res == 1) {
        $scope.showLoading();
        const link = document.createElement('a');
        const renderer = chart.renderer;
        let d = new Date();
        let filename = d.getFullYear() + ("0" + (d.getMonth() + 1)).slice(-2) + ("0" + d.getDate()).slice(-2) + "-" + d.getHours() + ("0" + (d.getMinutes() + 1)).slice(-2) + ("0" + d.getSeconds()).slice(-2);
        filename = `${filename}${renderer === 'svg' ? '.svg' : '.png'}`;
        const canvas = chart.getCanvas();
        canvas.get('timeline').stopAllAnimations();

        setTimeout(() => {
          const dataURL = toDataURL(chart);
          if (window.Blob && window.URL && renderer !== 'svg') {
            const arr = dataURL.split(',');
            const mime = arr[0].match(/:(.*?);/)[1];
            const bstr = atob(arr[1]);
            let n = bstr.length;
            const u8arr = new Uint8Array(n);
            while (n--) {
              u8arr[n] = bstr.charCodeAt(n);
            }
            const blobObj = new Blob([u8arr], { type: mime });
            let DOWNLOAD_DIR = cordova.file.externalCacheDirectory 
            let filePath = DOWNLOAD_DIR + filename;

            window.resolveLocalFileSystemURL(DOWNLOAD_DIR, entry => {
              entry.getFile(filename, { create: true, exclusive: false}, function (fileEntry) {
                fileEntry.createWriter(function (fileWriter) {
                  fileWriter.onwriteend = function() {
                    cordova.plugins.photoLibrary.saveImage(fileEntry.nativeURL, 'dsb', function (libraryItem) {
                      $ionicPopup.show({
                        title: '<div class="table-line"><span class="popup-title">下载成功</span></div>',
                        subTitle: `<div><span class="popup-content">文件已保存在相册</span></div>`,
                        scope: $scope,
                        buttons: [
                          {
                            text: '确认',
                            type: 'button-right background-red',
                            onTap: function(e) {
                              return 0;
                            }
                          },
                        ]
                      })
                    }, function (err) {
                      $scope.showToast({
                        title: `下载失败`
                      })
                    });
                    // $ionicPopup.show({
                    //   title: '<div class="table-line"><span class="popup-title">下载成功</span></div>',
                    //   subTitle: `<div><span class="popup-content">文件已保存在${filePath}</span></div>`,
                    //   scope: $scope,
                    //   buttons: [
                    //     {
                    //       text: '确认',
                    //       type: 'button-right background-red',
                    //       onTap: function(e) {
                    //         return 0;
                    //       }
                    //     },
                    //   ]
                    // })
                    $scope.hideLoading();
                  };

                  fileWriter.onerror = function (e) {
                    $scope.showToast({
                      title: `下载失败`
                    })
                    $scope.hideLoading();
                  };

                  fileWriter.write(blobObj);
                });
              });
              }, err => {
                $scope.showToast({
                  title: `下载失败`
                })
                $scope.hideLoading();
              });
          }
        }, 16);
      }
    });
  }

  $scope.createDownloadLog = function(v) {
    dashService.createDownloadLog(v).then(function(res){});
  }

  $rootScope.isDownloading = -1
  $rootScope.round_progress = 0
  $scope.downloadFile = function(uri, attachmentId = 0) {
    let myPopup = $ionicPopup.show({
      title: '<div class="table-line"><span class="popup-title">下载确认</span></div>',
      subTitle: '<div><span class="popup-content">是否下载文件?</span></div>',
      scope: $scope,
      buttons: [
        {
          text: '取消',
          type: 'button-left',
          onTap: function(e) {
            return 0;
          }
        },
        {
          text: '确认',
          type: 'button-right background-red',
          onTap: function(e) {
            return 1;
          }
        },
      ]
    })
    .then(function(res) {
      if (res == 1) {
        $rootScope.round_progress = 0
        $rootScope.isDownloading = attachmentId
        $scope.createDownloadLog(attachmentId);
        multimediaService.downloadFile(uri).then(function(res){
          let postfix = res.nativeURL.substring(res.nativeURL.lastIndexOf('.') + 1)
          let album = 'dsb'
          if ($scope.isPicture(postfix)) {
            cordova.plugins.photoLibrary.saveImage(res.nativeURL, album, function (libraryItem) {
              $rootScope.isDownloading = -1
              $ionicPopup.show({
                title: '<div class="table-line"><span class="popup-title">下载成功</span></div>',
                subTitle: `<div><span class="popup-content">文件已保存在相册</span></div>`,
                scope: $scope,
                buttons: [
                  {
                    text: '确认',
                    type: 'button-right background-red',
                    onTap: function(e) {
                      return 0;
                    }
                  },
                ]
              })
            }, function (err) {
              $rootScope.isDownloading = -1
              $scope.showToast({
                title: `下载失败`
              })
            });
          } else if($scope.isMovie(postfix)) {
            cordova.plugins.photoLibrary.saveVideo(res.nativeURL, album, function (cameraRollAssetId) {
              $rootScope.isDownloading = -1
              $ionicPopup.show({
                title: '<div class="table-line"><span class="popup-title">下载成功</span></div>',
                subTitle: `<div><span class="popup-content">文件已保存在相册</span></div>`,
                scope: $scope,
                buttons: [
                  {
                    text: '确认',
                    type: 'button-right background-red',
                    onTap: function(e) {
                      return 0;
                    }
                  },
                ]
              })
            }, function (err) {
              $rootScope.isDownloading = -1
              $scope.showToast({
                title: `下载失败`
              })
            });
          } else {
            $ionicPopup.show({
              title: '<div class="table-line"><span class="popup-title">下载成功</span></div>',
              subTitle: `<div><span class="popup-content">文件已保存在${res.nativeURL}</span></div>`,
              scope: $scope,
              buttons: [
                {
                  text: '确认',
                  type: 'button-right background-red',
                  onTap: function(e) {
                    return 0;
                  }
                },
              ]
            })            
          }
          $rootScope.isDownloading = -1
        }, function(err){
          $scope.showToast({
            title: `下载失败`
          })
          $rootScope.isDownloading = -1
        })
      }
    })
  }

  $scope.isPicture = function(ext) {
    if (!ext)
      return false

    if (ext.toUpperCase() == 'PNG' || ext.toUpperCase() == 'JPG' || ext.toUpperCase() == 'JPEG' || ext.toUpperCase() == 'BMP' || ext.toUpperCase() == 'GIF')
      return true;

    return false;
  }

  $scope.isPDF = function(ext) {
    if (!ext)
      return false

    if (ext.toUpperCase() == 'PDF')
      return true;

    return false;
  }

  $scope.isMovie = function(ext) {
    if (!ext)
      return false

    if (ext.toUpperCase() == 'MP4' || ext.toUpperCase() == 'MOV' || ext.toUpperCase() == 'AVI' || ext.toUpperCase() == '3GP')
      return true;

    return false;
  }
  
  $scope.getIsAdministrator = function() {
    return userService.getRole() == '经销商' ? Number(userService.getIsAdministrator()) == 1 : userService.getDataModify() == 1;
  }

  $scope.getDataModify = function() {
    return userService.getDataModify() == 1;
  }

  $scope.getIsProfessionalVersion = function() {
    return userService.getAppModel() == '专业版';
  }
  
  $scope.getIsUpgradedVersion = function() {
    return userService.getAppModel() == '标准升级版';
  }
  
  $scope.getIsBasicVersion = function() {
    return userService.getAppModel() == '标准版';
  }

  $scope.canReadAgentanalysis = function() {
    return Number(localStorage.getItem('fcanreadagentanalysis')) != 0
  }

  $scope.showFenxi = function() {
    if (userService.getRole() == '经销商') {
      $scope.navigate('app.zhongduandashuju');
    } else {
      $scope.navigate('app.zongbiao');
    }
  }

  $scope.getFenxiName = function() {
    if (userService.getRole() == '经销商') {
      return '销售分析';
    } else {
      return '营销分析';
    }
  }

  $scope.isJingxiaoshang = function() {
    return userService.getRole() == '经销商'
  }

  $scope.getGonggaoType = function (v) {
    if (v == '政策公告') {
      return 'zhengcegonggao';
    } else if (v == '销售装备') {
      return 'xiaoshouzhuangbei';
    } else if (v == '促销活动') {
      return 'cuxiaohuodong';
    } else if (v == '研发和改良') {
      return 'yanfahegailiang';
    } else if (v == '培训与学习') {
      return 'peixunyuxuexi';
    } else {
      return 'qita';
    }
  }

  $scope.isExpired = function(expirationDate) {
    return (new Date()) > (new Date(expirationDate));
  }

  $scope.getImageName = function(v) {
    var arr = ['avi', 'doc', 'gif', 'htm', 'jpg', 'mkv', 'mp3', 'mp4',
        'mpg', 'oth', 'pdf', 'png', 'ppt', 'psd', 'rmv', 'swf',
        'txt', 'xls', 'zip'];
    if (arr.indexOf(v) == -1) {
      return 'oth';
    }

    return v;
  }

  $scope.formatDate = function(date) {
    var d = new Date(date),
        month = '' + (d.getMonth() + 1),
        day = '' + d.getDate(),
        year = d.getFullYear();

    if (month.length < 2) 
      month = '0' + month;
    if (day.length < 2) 
      day = '0' + day;

    return [year, month, day].join('-');
  }

  $scope.getDateDiff = function(dateTimeStamp, isWodetuiguangren = false){
    var minute = 1000 * 60;
    var hour = minute * 60;
    var day = hour * 24;
    var halfamonth = day * 15;
    var month = day * 30;
    var year = day * 365;
    var now = new Date().getTime();
    var diffValue = now - new Date(dateTimeStamp);
    if (diffValue < 0) {
      return "刚刚";
      //若日期不符则弹出窗口告之
      //alert("结束日期不能小于开始日期！");
    }
    var yearC = diffValue / year;
    var monthC = diffValue / month;
    var weekC = diffValue / (7 * day);
    var dayC = diffValue / day;
    var hourC = diffValue / hour;
    var minC = diffValue / minute;
    if (yearC >= 1) {
      result = parseInt(yearC) + "年前";
    } else if (monthC >= 1) {
      result = parseInt(monthC) + "个月前";
    } else if (weekC >= 1) {
      if (isWodetuiguangren)
        result = parseInt(dayC) + "天";
      else
        result = parseInt(weekC) + "周前";
    } else if (dayC >= 1) {
      result = parseInt(dayC) + "天前";
    } else if (hourC >= 1) {
      result = parseInt(hourC) + "个小时前";
    } else if (minC >= 1) {
      result = parseInt(minC) + "分钟前";
    } else {
      result = "刚刚";
    }
  
    return result;
  }
  
  $scope.trustSrc = function(src) {
    return $sce.trustAsResourceUrl(src);
  }

  $scope.isAccountLogin = () => {
    return Number(localStorage.getItem('loginType')) == 1
  }

  $scope.isOnlySMSMode = () => {
    return Number(localStorage.getItem('floginmode')) == 1
  }

  $scope.playVideo = function(url) {
    // Play a video with callbacks
    var options = {
      successCallback: function() {
        // console.log("Video was closed without error.");
      },
      errorCallback: function(errMsg) {
        // console.log("Error! " + errMsg);
      },
      // orientation: 'landscape',
      shouldAutoClose: true,  // true(default)/false
      controls: true // true(default)/false. Used to hide controls on fullscreen
    };
    window.plugins.streamingMedia.playVideo(url, options);
  }

  $scope.previewFile = (url => {
    if (!url)
      return

    var fdocument = url.substr(url.lastIndexOf('/')+1)
    fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
    let postfix = fdocument.substr(fdocument.lastIndexOf('.') + 1)
    if ($scope.isMovie(postfix)) {
      $scope.playVideo(url)
      return
    }

    if (url.substr(url.lastIndexOf('.') + 1).toUpperCase() == 'PDF') {
      cordova.InAppBrowser.open(`https://www.gjtool.cn/pdfh5/pdf.html?file=${url}`, '_blank', 'hideurlbar=yes,toolbarcolor=#db0e2c,hidenavigationbuttons=yes,closebuttoncaption=关闭,closebuttoncolor=#ffffff')
      return
    }

    // if (url.substr(-3).toLowerCase() == "pdf") {
      $scope.showLoading()
      window.PreviewAnyFile.previewPath(
        win => {
          $scope.hideLoading()
        },
        error => {
          $scope.hideLoading()
        },
        url, {name : fdocument}
      );
    // }
  })


  $ionicModal.fromTemplateUrl('templates/partial/image-modal.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.imageModal = modal;
  });

  $scope.openModal = function() {
    $ionicSlideBoxDelegate.slide(0);
    $scope.imageModal.show();
  };

  $scope.closeModal = function() {
    $scope.imageModal.hide();
  };

  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.imageModal.remove();
  });
  // Execute action on hide modal
  $scope.$on('modal.hide', function() {
    // Execute action
  });
  // Execute action on remove modal
  $scope.$on('modal.removed', function() {
    // Execute action
  });
  $scope.$on('modal.shown', function() {
    console.log('Modal is shown!');
  });

  // Call this functions if you need to manually control the slides
  $scope.next = function() {
    $ionicSlideBoxDelegate.next();
  };

  $scope.previous = function() {
    $ionicSlideBoxDelegate.previous();
  };

  $scope.goToSlide = function(index, imageList) {
    $scope.imageData = imageList
    $scope.imageModal.show();
    $ionicSlideBoxDelegate.slide(index);
  }

  // Called each time the slide changes
  $scope.slideChanged = function(index) {
    $scope.slideIndex = index;
  };

  $scope.isAgentRole = function() {
    return localStorage.getItem('siteid') == "AGENTS"
  }

  $scope.isPromoterRole = function() {
    return userService.getRole() == '推广人'
    // return localStorage.getItem('siteid') == "PROMOTERS"
  }

})
