angular.module('starter')

.directive('hideTabs', function($rootScope) {
  return {
  restrict: 'A',
  link: function(scope, $el) {
		$rootScope.hideTabs = 'tabs-item-hide';
		scope.$on('$destroy', function() {
			$rootScope.hideTabs = '';
		});
  }
 };
})

.directive('searchBox', function($rootScope) {
	return {
		restrict: 'EA',
    replace: true,
    templateUrl: 'templates/partial/search-box.html',
    require: 'ngModel',
    scope: {
      keywords: '=keywords',
      saveKeyword: '&saveKeyword',
      clearKeywords: '&clearKeywords',
    },
    link: function (scope, element, attrs) {
      scope.setKeyword = (keyword) => {
				scope.keyword = keyword;
				scope.saveKeyword({'keyword': keyword});
      }

      scope.resetKeyword = () => {
				scope.keyword = '';
        scope.setKeyword('');
			}

			scope.clearKeywordList = () => {
				scope.clearKeywords();
				scope.keywords = null;
			}
    }
	};
})

.directive('searchBox1', function($rootScope) {
	return {
		restrict: 'EA',
    replace: true,
    templateUrl: 'templates/partial/search-box1.html',
    require: 'ngModel',
    scope: {
      keywords: '=keywords',
      saveKeyword: '&saveKeyword',
      clearKeywords: '&clearKeywords',
    },
    link: function (scope, element, attrs) {
      scope.setKeyword = (keyword) => {
				scope.keyword = keyword;
				scope.saveKeyword({'keyword': keyword});
      }

      scope.resetKeyword = () => {
				scope.keyword = '';
        scope.setKeyword('');
			}

			scope.clearKeywordList = () => {
				scope.clearKeywords();
				scope.keywords = null;
			}
    }
	};
})

.directive('searchBox2', function($rootScope) {
	return {
		restrict: 'EA',
    replace: true,
    templateUrl: 'templates/partial/search-box2.html',
    require: 'ngModel',
    scope: {
      keywords: '=keywords',
      saveKeyword: '&saveKeyword',
      clearKeywords: '&clearKeywords',
    },
    link: function (scope, element, attrs) {
      scope.setKeyword = (keyword) => {
				scope.keyword = keyword;
				scope.saveKeyword({'keyword': keyword});
      }

      scope.resetKeyword = () => {
				scope.keyword = '';
        scope.setKeyword('');
			}

			scope.clearKeywordList = () => {
				scope.clearKeywords();
				scope.keywords = null;
			}
    }
	};
})

.directive('filterBox', function($rootScope) {
	return {
		restrict: 'EA',
		replace: true,
		templateUrl: 'templates/partial/filter-box.html',
		scope: {
      getPeriodString: '&getPeriodString',
      setPeriodStart: '&setPeriodStart',
      setPeriodEnd: '&setPeriodEnd',
      setShowFilter: '&setShowFilter',
    },
		link: function (scope, element, attrs, ctrl) {
			scope.selected_index = -1;
			scope.selectChanged = i => {
				if (scope.selected_index == i) return; else scope.selected_index = i;
        scope.itemSelection = [false, false, false, false, false, false];
        if (i < 6 && i >= 0) {
					scope.itemSelection[i] = true;

					let start, end;
					if (i == 0) {
						// 今天
						start = new Date();
						end = new Date();
					} else if (i == 1) {
						// 昨天
						let d = new Date();
						d.setDate(d.getDate() - 1);
						start = d;
						end = d;
					} else if (i == 2) {
						// 本周
						let d = new Date();
						let firstday = d.getDate() - d.getDay();
						let lastday = d.getDate() - d.getDay() + 6;
						start = new Date(d.setDate(firstday));
						end = new Date(d.setDate(lastday));
					} else if (i == 3) {
						// 上周
						let d = new Date();
						let firstday = d.getDate() - d.getDay() - 7;
						let lastday = d.getDate() - d.getDay() - 1;
						start = new Date(d.setDate(firstday));
						end = new Date(d.setDate(lastday));
					} else if (i == 4) {
						// 本月
						let date = new Date();
						start = new Date(date.getFullYear(), date.getMonth(), 1);
						end = new Date(date.getFullYear(), date.getMonth() + 1, 0);
					} else if (i == 5) {
						// 上月
						let date = new Date();
						start = new Date(date.getFullYear(), date.getMonth() - 1, 1);
						end = new Date(date.getFullYear(), date.getMonth(), 0);
					}

					$('#select-period-1').data('dateRangePicker').setDateRange(
						start.getFullYear() + '-' + ("0" + (start.getMonth() + 1)).slice(-2) + '-' + ("0" + start.getDate()).slice(-2),
						end.getFullYear() + '-' + ("0" + (end.getMonth() + 1)).slice(-2) + '-' + ("0" + end.getDate()).slice(-2)
					);
        }
      }

      scope.applyFilter = () => {
				scope.setShowFilter({'v': false});
			}

			scope.createDateRangePicker = () => {
				$('#select-period-1').dateRangePicker(
					{
						// autoClose: true,
						showShortcuts: false,
						monthSelect: true,
						yearSelect: true,
						language: 'cn',
						inline: true,
						container: '#select-period-1',
            alwaysOpen: true,
            customArrowPrevSymbol: '<ion-icon name="caret-back-outline"></ion-icon>',
            customArrowNextSymbol: '<ion-icon name="caret-forward-outline"></ion-icon>',
					})
					.on('datepicker-first-date-selected', function(event, obj)
					{
						/* This event will be triggered when first date is selected */
						// obj will be something like this:
						// {
						// 		date1: (Date object of the earlier date)
						// }
					})
					.on('datepicker-change',function(event,obj)
					{
						/* This event will be triggered when second date is selected */
						// obj will be something like this:
						// {
						// 		date1: (Date object of the earlier date),
						// 		date2: (Date object of the later date),
						//	 	value: "2013-06-05 to 2013-06-07"
						// }
						scope.setPeriodStart({'v': obj.date1});
						scope.setPeriodEnd({'v': obj.date2});
					})
					.on('datepicker-apply',function(event,obj)
					{
						/* This event will be triggered when user clicks on the apply button */
						scope.selectChanged(-1);
						scope.$apply();
					})
					.on('datepicker-close',function()
					{
						/* This event will be triggered before date range picker close animation */
					})
					.on('datepicker-closed',function()
					{
						/* This event will be triggered after date range picker close animation */
					})
					.on('datepicker-open',function()
					{
						/* This event will be triggered before date range picker open animation */
					})
					.on('datepicker-opened',function()
					{
						/* This event will be triggered after date range picker open animation */
					});
			}

      scope.resetFilter = () => {
				scope.selectChanged(-1);
				// $('#select-period').data('dateRangePicker').clear();
				$('#select-period-1').data('dateRangePicker').clear();
				scope.setPeriodStart({'v': undefined});
				scope.setPeriodEnd({'v': undefined});
      }

			scope.createDateRangePicker();
			scope.resetFilter();

			// ----------------------------------------
			scope.showCalendar = function() {
        $('.rolldate-container .rolldate-panel').css('height', '320px');
        $('div.drp_top-bar').css('display', 'none');
				// $('.rolldate-container header').css('border-bottom', 'unset');
        $('.rolldate-container header').css('line-height', '40px');
        $('.date-picker-wrapper').css('border', 'unset');
				$('.date-picker-wrapper').css('padding', 'unset');
				$('.month-wrapper').css('width', 'unset');
				$('.month-wrapper').css('border', 'unset');
        $('.month-wrapper table').css('width', '100%');
        $('.date-picker-wrapper .footer').css('display', 'none');

				scope.isShowCalendar = true;
			}

			scope.hideCalendar = function() {
				scope.isShowCalendar = false;
			}

			scope.isShowCalendar = false;
		}
	};
})

.directive('filterBox2', function($rootScope) {
	return {
		restrict: 'EA',
		replace: true,
		templateUrl: 'templates/partial/filter-box2.html',
		scope: {
			applyChartFilter: '&applyChartFilter',
      setShowFilter: '&setShowFilter',
    },
		link: function (scope, element, attrs, ctrl) {
      scope.subFilterIndex = 0;
      scope.tabClick = false;

      // 按月选择
      var ul = '';
          itemClass = '';
          domMndex = 0;
      ul += '<div id="filter-2-date-selector-panel-1-year"><ul class="wheel-scroll">';
      for (var j = 2016; j <= 2050; j++) {
        itemClass = j == new Date().getFullYear() ? 'active' : '';

        ul += '<li class="wheel-item ' + itemClass + '" data-index="' + domMndex + '">' + j + '年' + '</li>';
        domMndex++;
      }
      ul += '</ul></div>';
      domMndex = 0;
      ul += '<div id="filter-2-date-selector-panel-1-month"><ul class="wheel-scroll">';
      for (var k = 1; k <= 12; k++) {
        itemClass = k == new Date().getMonth() + 1 ? 'active' : '';

        ul += '<li class="wheel-item ' + itemClass + '" data-index="' + domMndex + '">' + (k < 10 ? '0' + k : k) + '月' + '</li>';
        domMndex++;
      }
      ul += '</ul></div>';
      $('#date-selector-panel-1').html('<div class="rolldate-container"><div class="rolldate-dim mask-top"></div><div class="rolldate-dim mask-bottom"></div><div class="rolldate-wrapper">' + ul + '</div></div>');

      scope.scroll_1_1 = new bscroll_min('#filter-2-date-selector-panel-1-year', {
        wheel: {
          selectedIndex: 111,
        }
      });
      scope.scroll_1_1.wheelTo($('#filter-2-date-selector-panel-1-year .active') ? $('#filter-2-date-selector-panel-1-year .active').attr('data-index') : 0);
      scope.scroll_1_1.on('scrollEnd', function () {});

      scope.scroll_1_2 = new bscroll_min('#filter-2-date-selector-panel-1-month', {
        wheel: {
          selectedIndex: 0,
        }
      });
      scope.scroll_1_2.wheelTo($('#filter-2-date-selector-panel-1-month .active') ? $('#filter-2-date-selector-panel-1-month .active').attr('data-index') : 0);
      scope.scroll_1_2.on('scrollEnd', function () {});

      // 按季选泽
      setTimeout(function() {
        ul = '';
        itemClass = '';
        domMndex = 0;
        ul += '<div id="filter-2-date-selector-panel-2-year"><ul class="wheel-scroll">';
        for (var j = 2016; j <= 2050; j++) {
          itemClass = j == new Date().getFullYear() ? 'active' : '';

          ul += '<li class="wheel-item ' + itemClass + '" data-index="' + domMndex + '">' + j + '年' + '</li>';
          domMndex++;
        }
        ul += '</ul></div>';
        domMndex = 0;
        ul += '<div id="filter-2-date-selector-panel-2-quarter"><ul class="wheel-scroll">';
        var chineseNumber = "一二三四";
        for (var q = 1; q <= 4; q++) {
          itemClass = ((q - 1) * 3 <= new Date().getMonth() && q * 3 > new Date().getMonth()) ? 'active' : '';

          ul += '<li class="wheel-item ' + itemClass + '" data-index="' + domMndex + '">' + '第' + chineseNumber.substring(q - 1, q) + '季度' + '</li>';
          domMndex++;
        }
        ul += '</ul></div>';
        $('#date-selector-panel-2').html('<div class="rolldate-container"><div class="rolldate-dim mask-top"></div><div class="rolldate-dim mask-bottom"></div><div class="rolldate-wrapper">' + ul + '</div></div>');

        scope.scroll_2_1 = new bscroll_min('#filter-2-date-selector-panel-2-year', {
          wheel: {
            selectedIndex: 0,
          }
        });
        scope.scroll_2_1.wheelTo($('#filter-2-date-selector-panel-2-year .active') ? $('#filter-2-date-selector-panel-2-year .active').attr('data-index') : 0);
        scope.scroll_2_1.on('scrollEnd', function () {});

        scope.scroll_2_2 = new bscroll_min('#filter-2-date-selector-panel-2-quarter', {
          wheel: {
            selectedIndex: 0,
          }
        });
        scope.scroll_2_2.wheelTo($('#filter-2-date-selector-panel-2-quarter .active') ? $('#filter-2-date-selector-panel-2-quarter .active').attr('data-index') : 0);
        scope.scroll_2_2.on('scrollEnd', function () {});
      }, 100);

      // 按年选择
      setTimeout(function() {
        ul = '';
        itemClass = '';
        domMndex = 0;
        ul += '<div id="filter-2-date-selector-panel-3-year"><ul class="wheel-scroll">';
        for (var j = 2016; j <= 2050; j++) {
          itemClass = j == new Date().getFullYear() ? 'active' : '';

          ul += '<li class="wheel-item ' + itemClass + '" data-index="' + domMndex + '">' + j + '年' + '</li>';
          domMndex++;
        }
        ul += '</ul></div>';
        $('#date-selector-panel-3').html('<div class="rolldate-container"><div class="rolldate-dim mask-top"></div><div class="rolldate-dim mask-bottom"></div><div class="rolldate-wrapper">' + ul + '</div></div>');

        scope.scroll_3_1 = new bscroll_min('#filter-2-date-selector-panel-3-year', {
          wheel: {
            selectedIndex: 0,
          }
        });
        scope.scroll_3_1.wheelTo($('#filter-2-date-selector-panel-3-year .active') ? $('#filter-2-date-selector-panel-3-year .active').attr('data-index') : 0);
        scope.scroll_3_1.on('scrollEnd', function () {});
      }, 200);
		}
	};
})

.directive('filterBox3', function($rootScope) {
	return {
		restrict: 'EA',
		replace: true,
		templateUrl: 'templates/partial/filter-box3.html',
		scope: {
			applyChartFilter: '&applyChartFilter',
      setShowFilter: '&setShowFilter',
    },
		link: function (scope, element, attrs, ctrl) {
			// 按年选择
      ul = '';
      itemClass = '';
      domMndex = 0;
      ul += '<div id="filter-2-date-selector-panel-3-year"><ul class="wheel-scroll">';
      for (var j = 2016; j <= 2050; j++) {
        itemClass = j == new Date().getFullYear() ? 'active' : '';

        ul += '<li class="wheel-item ' + itemClass + '" data-index="' + domMndex + '">' + j + '年' + '</li>';
        domMndex++;
      }
      ul += '</ul></div>';
      $('#date-selector-panel').html('<div class="rolldate-container"><div class="rolldate-dim mask-top"></div><div class="rolldate-dim mask-bottom"></div><div class="rolldate-wrapper">' + ul + '</div></div>');

      scope.scroll_3_1 = new bscroll_min('#filter-2-date-selector-panel-3-year', {
        wheel: {
          selectedIndex: 0,
        }
      });
      scope.scroll_3_1.wheelTo($('#filter-2-date-selector-panel-3-year .active') ? $('#filter-2-date-selector-panel-3-year .active').attr('data-index') : 0);
      scope.scroll_3_1.on('scrollEnd', function () {});
		}
	};
})

.directive('filterBox4', function($rootScope) {
	return {
		restrict: 'EA',
		replace: true,
		templateUrl: 'templates/partial/filter-box4.html',
		scope: {
			applyFilterValue: '&applyFilterValue',
			model: '=model',
    },
		link: function (scope, element, attrs, ctrl) {
			scope.applyFilter = () => {
				$('#select-period').data('dateRangePicker').destroy();
				scope.applyFilterValue({v: scope.model});
				scope.isShow = false;
			}

			scope.resetFilter = () => {
				$('#select-period').data('dateRangePicker').clear();
        scope.model = [];
        document.querySelector('#dizhi').innerHTML = '选择地点';
      }

			// DateRangePicker
			scope.createDateRangePicker = () => {
				$('#select-period').dateRangePicker(
					{
						showShortcuts: false,
						monthSelect: true,
						yearSelect: true,
						language: 'cn',
						inline: true,
						container: '#select-period',
						alwaysOpen: true,
            customArrowPrevSymbol: '<ion-icon name="caret-back-outline"></ion-icon>',
            customArrowNextSymbol: '<ion-icon name="caret-forward-outline"></ion-icon>',
					})
					.on('datepicker-first-date-selected', function(event, obj)
					{
						/* This event will be triggered when first date is selected */
						// obj will be something like this:
						// {
						// 		date1: (Date object of the earlier date)
						// }
					})
					.on('datepicker-change',function(event,obj)
					{
						/* This event will be triggered when second date is selected */
						// obj will be something like this:
						// {
						// 		date1: (Date object of the earlier date),
						// 		date2: (Date object of the later date),
						//	 	value: "2013-06-05 to 2013-06-07"
						// }
						scope.model.periodStart = getDateString(obj.date1);
						scope.model.periodEnd = getDateString(obj.date2);
					})
					.on('datepicker-apply',function(event,obj)
					{
						/* This event will be triggered when user clicks on the apply button */
						scope.$apply();
					})
					.on('datepicker-close',function()
					{
						/* This event will be triggered before date range picker close animation */
					})
					.on('datepicker-closed',function()
					{
						/* This event will be triggered after date range picker close animation */
					})
					.on('datepicker-open',function()
					{
						/* This event will be triggered before date range picker open animation */
					})
					.on('datepicker-opened',function()
					{
						/* This event will be triggered after date range picker open animation */
					});

				if (scope.model.periodStart && scope.model.periodEnd) {
					$('#select-period').data('dateRangePicker').setDateRange(scope.model.periodStart, scope.model.periodEnd, true);
				}
			}

			scope.getPeriodString = function() {
				if (scope.model.periodStart && scope.model.periodEnd) {
					return scope.model.periodStart + ' ~ ' + scope.model.periodEnd;
				} else {
					return undefined;
				}
			}

      scope.createDateRangePicker();

			scope.showCalendar = function() {
        $('.rolldate-container .rolldate-panel').css('height', '320px');
        $('div.drp_top-bar').css('display', 'none');
				// $('.rolldate-container header').css('border-bottom', 'unset');
        $('.rolldate-container header').css('line-height', '40px');
        $('.date-picker-wrapper').css('border', 'unset');
				$('.date-picker-wrapper').css('padding', 'unset');
				$('.month-wrapper').css('width', 'unset');
				$('.month-wrapper').css('border', 'unset');
        $('.month-wrapper table').css('width', '100%');
        $('.date-picker-wrapper .footer').css('display', 'none');

				scope.isShowCalendar = true;
			}

			scope.hideCalendar = function() {
				scope.isShowCalendar = false;
			}

      scope.isShowCalendar = false;

      new Rollarea({
        el: '#dizhi',
        format: 'province-city-county',
        value: {'fprovince': scope.model.fprovince, 'fcity': scope.model.fcity, 'fcounty': scope.model.fcounty},
        confirm: function(area) {
          scope.model.fprovince = area.fprovince;
          scope.model.fcity = area.fcity;
          scope.model.fcounty = area.fcounty;
        },
      });
		}
	};
})

.directive('selectPanel', function() {
  return {
    restrict: 'EA',
    replace: true,
    templateUrl: 'templates/partial/select-panel.html',
    scope: {
      selectOne: '&selectOne',
      hideSelectPanel: '&hideSelectPanel',
      model: '=selectModel',
      key: '=selectKeyField',
      value: '=selectValueField',
      selected: '=selected',
    },
		link: function (scope) {
			scope._selected = scope.selected;

      scope.select = function(v) {
        scope._selected = v;
			}
			
			scope.model.forEach(function(item){
				if ((scope.key && item[scope.key] == scope._selected) || (item == scope._selected)) {
					scope.select(item);
				}
			});
    }
  }
})

.directive('onLongPress', function($timeout) {
	return {
		restrict: 'A',
		link: function($scope, $elm, $attrs) {
			$elm.bind('touchstart', function(evt) {
				// Locally scoped variable that will keep track of the long press
				$scope.longPress = true;

				// We'll set a timeout for 600 ms for a long press
				$timeout(function() {
					if ($scope.longPress) {
						// If the touchend event hasn't fired,
						// apply the function given in on the element's on-long-press attribute
						$scope.$apply(function() {
							$scope.$eval($attrs.onLongPress)
						});
					}
				}, 2000);
			});

			$elm.bind('touchend', function(evt) {
				// Prevent the onLongPress event from firing
				$scope.longPress = false;
				// If there is an on-touch-end function attached to this element, apply it
				if ($attrs.onTouchEnd) {
					$scope.$apply(function() {
						$scope.$eval($attrs.onTouchEnd)
					});
				}
			});
		}
	};
})
