(function(){

	"use strict";
	angular.module('starter.services')

	.service('fenxiService', function (apiService, userService) {
		let self = this;

    // 客户来源分析
		self.queryChannelOfCustomers = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "channelofcustomers",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 新增意向客户分析
    self.queryNewCustomers = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "newcustomers",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 销售动作分析
    self.queryCustomerAction = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "customeraction",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 销售渠道分析
    self.queryChannelOfOrders = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "channeloforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 成交产品分析
    self.queryProductOfOrders = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "productoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 客单值分析
    self.queryAmountOfOrders = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "amountoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 小区占比分析
    self.queryCommunityOfOrders = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "communityoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 退单率分析
    self.queryReturnCountOfOrders = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "returncountoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 销售情况分析表
    self.queryCustomerOfOrders = function(
      pageNumber = 1,
      pageSize = 20,
      sortDirection = descending,
      periodStart = new Date(),
      periodEnd = new Date(),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "customeroforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "pageNumber": pageNumber,
            "pageSize": pageSize,
            "sort": "t1.fdate " + sortDirection == ascending ? "asc" : "desc",
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 接待次数与首单成交分析
    self.queryReceptionTimesOfFirstOrder = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "receptiontimesoffirstorder",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 事件订单占比分析
    self.queryEventOfOrders = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "eventoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 月度杂项费用分析
    self.queryCostNameOfMonth = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "costnameofmonth",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 月度盈亏分析
    self.queryCostAndOrdersOfMonth = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "costandordersofmonth",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 老客户信息查询
    self.queryOldCustomer = function(
      pageNumber = 1,
      pageSize = 20,
      periodStart = new Date(),
      periodEnd = new Date(),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "oldcustomer",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "pageNumber": pageNumber,
            "pageSize": pageSize,
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 意向客户信息查询
    self.queryNewCustomer = function(
      pageNumber = 1,
      pageSize = 20,
      periodStart = new Date(),
      periodEnd = new Date(),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "newcustomer",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "pageNumber": pageNumber,
            "pageSize": pageSize,
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 小区深度分析
    self.queryCommunityDepthOfOrders = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "communitydepthoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "fbegmonth": periodStart.getFullYear() + '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2),
            "fendmonth": periodEnd.getFullYear() + '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 意向客户跟进系统
    self.queryNewCustomerTrack = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "newcustomertrack",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 老客户维护系统系统_生日提醒
    self.queryOldCustomerBless = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "oldcustomerbless",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 老客户维护系统系统_购买周年
    self.queryOldCustomerCycle = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.data.analysis",
					"method": "oldcustomercycle",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

	})

})();
