(function(){

	"use strict";
	angular.module('starter.services')

	.service('qiyeShujuService', function (apiService, userService) {
    let self = this;

    // 工作数据_工作结果评定
    self.businessTripGrade = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "businesstripGrade",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 工作数据_方法收集排名
    self.businessTripGetKnowledge = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "businesstripGetKnowledge",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 销售数据_同比增幅分析
    self.saleAmountGrowthRateAnalysis = function(periodStart = new Date(), periodEnd = new Date()) {
      let month_array = [];
      for (let i = periodStart.getMonth() + 1; i < periodEnd.getMonth() + 2; i++) {
        month_array.push(i);
      }
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "saleAmountGrowthRateAnalysis",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "fyear": periodStart.getFullYear(),
            "fmonth": month_array.join(','),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 销售数据_月销售平均分析
    self.saleAmountAverageAnalysis = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "saleAmountAverageAnalysis",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "fyear": periodStart.getFullYear(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 销售数据_销售数据分析
    self.saleAmountAnalysis = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "saleAmountAnalysis",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "fyear": periodStart.getFullYear(),
            "fmonth": periodStart.getMonth() + 1,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 店铺数据_店铺面积占比分析
    self.storeAreaAnalysis = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "storeAreaAnalysis",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 店铺数据_改建分析
    self.storeRebuildAnalysis = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "storeRebuildAnalysis",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 店铺数据_店铺卖场分析
    self.storeMarketAnalysis = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "storeMarketAnalysis",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 店铺数据_经销商档案列表
    self.agentList = function(pageNumber, pageSize) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "agentList",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "pageNumber": pageNumber,
            "pageSize": pageSize,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 店铺数据_经销商档案门店列表
    self.agentStoreList = function(agentsId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "agentStoreList",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "tagentsid": agentsId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 终端大数据_意向客户分析_客户来源分析
		self.queryChannelOfCustomers = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "channelofcustomers",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_意向客户分析_新增意向客户分析
    self.queryNewCustomers = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "newcustomers",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_销售系统分析_销售动作分析
    self.queryCustomerAction = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "customeraction",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_销售系统分析_销售渠道分析
    self.queryChannelOfOrders = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "channeloforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_销售系统分析_成交产品分析
    self.queryProductOfOrders = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "productoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_销售系统分析_客单值分析
    self.queryAmountOfOrders = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "amountoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_销售系统分析_小区占比分析
    self.queryCommunityOfOrders = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "communityoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_销售系统分析_退单率分析
    self.queryReturnCountOfOrders = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "returncountoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_销售系统分析_销售情况分析表
    self.queryCustomerOfOrders = function(
      pageNumber = 1,
      pageSize = 20,
      sortDirection = descending,
      periodStart = new Date(),
      periodEnd = new Date(),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "customeroforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "pageNumber": pageNumber,
            "pageSize": pageSize,
            "sort": "t1.fdate " + sortDirection == ascending ? "asc" : "desc",
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_接待次数与首单成交分析
    self.queryReceptionTimesOfFirstOrder = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "receptiontimesoffirstorder",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_事件分析_事件订单占比分析
    self.queryEventOfOrders = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "eventoforders",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_月度费用分析_月度杂项费用分析
    self.queryCostNameOfMonth = function(periodStart = new Date(), periodEnd = new Date()) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "costnameofmonth",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_月度费用分析_月度盈亏分析
    self.queryCostAndOrdersOfMonth = function(
      periodStart = new Date(new Date().getFullYear(), 0, 1),
      periodEnd = new Date(new Date().getFullYear() + 1, 0, 0),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "costandordersofmonth",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_客户档案分析_老客户信息查询
    self.queryOldCustomer = function(
      pageNumber = 1,
      pageSize = 100,
      periodStart = new Date(),
      periodEnd = new Date(),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "oldcustomer",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "pageNumber": pageNumber,
            "pageSize": pageSize,
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 终端大数据_客户档案分析_意向客户信息查询
    self.queryNewCustomer = function(
      pageNumber = 1,
      pageSize = 20,
      periodStart = new Date(),
      periodEnd = new Date(),
    ) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.data.analysis",
					"method": "newcustomer",
					"content": {
            "getdatafromdbanyway": false,
            "userid": userService.getUserId(),
            "pageNumber": pageNumber,
            "pageSize": pageSize,
					}
				}
      };

      if (periodStart) {
        request.data.content.fbegmonth = periodStart.getFullYear() +
            '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2);
      }
      if (periodEnd) {
        request.data.content.fendmonth = periodEnd.getFullYear() +
            '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2);
      }

			return apiService.makeRequest(request);
    };

	})

})();
