(function(){

	"use strict";
	angular.module('starter.services')
		
	.service('userService', function (apiService) {
		var self = this;

		// 短信验证码登陆并获取token & 账号登陆并获取token
		self.login = function(phone, password, loginType = 0) {
			var request = {
				url: API_URL_V1 + (loginType == 0 ? "login" : "loginbyaccount"),
				data: {"phonenumber": phone, "accountno": phone, "password": CryptoJS.MD5(password).toString()}
			};
			localStorage.setItem("loginType", loginType);

			return apiService.makeRequest(request);
		}

		self.getToken = function() {
			return localStorage.getItem(TOKEN_KEY);
		}

		self.getRole = function() {
			return localStorage.getItem(ROLE);
		}

		self.getUserId = function() {
			return localStorage.getItem(USER_ID);
		}

		self.getUserName = function() {
			return localStorage.getItem('fname');
		}

		self.getDataModify = function() {
			return localStorage.getItem('fdatamodify');
		}

		self.getIsAdministrator = function() {
			return localStorage.getItem('fisadministrator');
		}

		self.getAppModel = function() {
			return localStorage.getItem('fappmodel');
		}

		self.getPayAmount = function() {
			return localStorage.getItem('fpayamount');
		}

		self.getSiteId = function() {
			return localStorage.getItem('siteid');
		}

		self.getPassword = function(phonenumber) {
			var request = {
				url: API_URL_V1 + "getpassword",
				data: {"phonenumber": phonenumber}
			};

			return apiService.makeRequest(request);
		}

		self.selectUser = function(accountInfo) {
			localStorage.setItem(TOKEN_KEY, accountInfo.token);
			localStorage.setItem(ROLE, accountInfo.fusertype);
			localStorage.setItem(USER_ID, accountInfo.userid);

			localStorage.setItem('fname', accountInfo.fname);
			localStorage.setItem('fcompname', accountInfo.fcompname);
			localStorage.setItem('frole', accountInfo.frole);
			localStorage.setItem('fisadministrator', accountInfo.fisadministrator);
			localStorage.setItem('fdatamodify', accountInfo.fdatamodify);
			// localStorage.setItem('fphonenumber', phone);
			localStorage.setItem('fappmodel', accountInfo.fappmodel);
			localStorage.setItem('fpayamount', accountInfo.fpayamount);
			localStorage.setItem('floginmode', accountInfo.floginmode);
			localStorage.setItem('siteid', accountInfo.siteid);
			localStorage.setItem('fcanreadagentanalysis', accountInfo.fcanreadagentanalysis);
			// localStorage.setItem('password', CryptoJS.MD5(password).toString());
		}

		// 注销登陆
		self.logout = function() {
			localStorage.clear();

			var token = localStorage.getItem(TOKEN_KEY);
			var request = {
				url: API_URL_V1 + "logout",
				data: {"accesstoken": token}
			};

			return apiService.makeRequest(request);
		}

		self.reLogin = function() {
			var fphonenumber = localStorage.getItem('fphonenumber');
			var password = localStorage.getItem('password');
			var request = {
				url: API_URL_V1 + "login",
				data: {"phonenumber": fphonenumber,"password": password}
			};

			return apiService.makeRequest(request);
		}

		// 生成微信支付预订单
		self.createAPPWechatOrder = function(accountInfo, ipAddr) {
			let request = {
				url: API_URL_V1,
				data: {
		  		"classname": "system.payment.payment",
					"method": "createAPPWechatOrder",
					"accesstoken": accountInfo.token,
					"content": {
						"userid": accountInfo.userid,
						"famount": accountInfo.fpayamount * 100,
						"custip": ipAddr
					}
				}
			};

			if (accountInfo.fappmodel)
				request.data.content.fappmodel = accountInfo.fappmodel

			return apiService.makeRequest(request);
		};

		// 账户余额查询
		self.queryAccountBalance = function() {
			let request = {
				url: API_URL_V1,
				data: {
		  		"classname": "agentclient.usercenter.account.account",
					"method": "query_accountbalance",
					"accesstoken": self.getToken(),
					"content": {
						"userid": self.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 账户收支明细查询
		self.queryAccountdetails = function() {
			let request = {
				url: API_URL_V1,
				data: {
		  		"classname": "agentclient.usercenter.account.account",
					"method": "query_accountdetails",
					"accesstoken": self.getToken(),
					"content": {
						"getdatafromdbanyway": true,
						"userid": self.getUserId()
					}
				}
			};

			return apiService.makeRequest(request);
		};

		//获取微信调用参数
		self.getWechatDock = function(url='https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.htm') {
			let request = {
				url: API_URL_V1,
				data: {
		  		"classname": "system.wechatdock.wechatdock",
					"method": "getWechatDock",
					"accesstoken": self.getToken(),
					"content": {
						"userid": self.getUserId(),
						"url": url
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 用户密码修改
		self.changePassWord = function(newPwd) {
			let request = {
				url: API_URL_V1,
				data: {
		  		"classname": "system.users.Users",
					"method": "changePassWord",
					"content": {
						"userid": self.getUserId(),
						"password": localStorage.getItem('password'),
						"newpassword": CryptoJS.MD5(newPwd).toString(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		self.isValidPassword = (password) => {
			return CryptoJS.MD5(password).toString() == localStorage.getItem('password')
		}

	})

})();
