(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('DashController', function($rootScope, $state, $scope, userService, gerenService, dashService, xinxiaoxiService, tonggaoService, multimediaService, $interval, $timeout, $ionicPopup) {
      $scope.showHeader();
      $scope.showTabBar();

      $scope.slideImages = []
      $scope.slideImages.push ({id: 1, img: "img/lft1.png"})
      $scope.slideImages.push ({id: 2, img: "img/lft2.png"})
      $scope.firstTonggaoCover = undefined;

      function animateContent(direction) {  
        var animationOffset = $('.slide-page-wrapper').height() - $('.carousel3').height();
        if (direction == 'up') {
          animationOffset = 0;
        }
    
        // console.log("animationOffset:"+animationOffset);
        $('.carousel3').animate({ "marginTop": (animationOffset)+ "px" }, direction == 'up' ? 1000 : 2000 * ($scope.zuixinFangwenData.length - 5));
      }

      function up(){
        animateContent("up")
      }
      function down(){
        animateContent("down")
      }
      
      function start(){
        setTimeout(function () {
          down();
        }, 1000);
        setTimeout(function () {
          up();
        }, 1000);
      }

      $scope.doRefresh = function() {
        $scope.messageList = [];
        async.parallel([
          function(callback) {
            xinxiaoxiService.queryMessage(false, 1, 100, '素材')
            .then(function(res) {
              if (res && res.data && res.data.code === 1) {
                callback(null, res.data.data)
              }
            });
          },
          function(callback) {
            xinxiaoxiService.queryMessage(false, 1, 100, '系统')
            .then(function(res) {
              if (res && res.data && res.data.code === 1) {
                callback(null, res.data.data)
              }
            });
          }
        ], function(err, results){
          if (!err) {
            $scope.messageList = [];
            $scope.resetXiaoxiCount()
            for (var i in results) {
              for (var j in results[i]) {
                if (results[i][j].fisread == 0) {
                  $scope.incXiaoxiCount()
                }
                $scope.messageList.push(results[i][j]);
              }
            }
            $scope.messageList.sort(((a, b) => (a.createdate > b.createdate) ? -1 : 1));
            if ($scope.messageList.length > 2) {
              $scope.recentMessages = $scope.messageList.slice(0, 3);
            } else {
              $scope.recentMessages = $scope.messageList;
            }
          }
        });

        $scope.navigateDongtai = function(item) {
          switch(item.ftype) {
            case '接待':
              $state.go('app.jiedaixiangqing', {receiptid: item.tcustomer_receptid});
              break;
            case '销售':
              $state.go('app.xiaoshouxiangqing', {receiptid: item.tcustomer_receptid});
              break;
            default:
              break;
          }
        }

        if (!$scope.isAgentRole())
        {
          gerenService.queryUserMsg().then(function(res){
            if (res.data.errcode == "005")
              $scope.logout();
          });
          // 通告列表
          tonggaoService.queryNoticeList(
            1, // pageNumber
            3, // pageSize
            '', // condition
          )
          .then(function(res){
            if (res.data.code === 1) {
              $scope.tonggaoList = res.data.data;
              if (res.data.data.length > 0) {
                multimediaService.getImageList(res.data.data[0].tnoticeid, 'tnotice').then(res => {
                  for (let i = 0; i < res.data.data.length; i++) {
                    if (res.data.data[i].ftype == 'cover') {
                      $scope.firstTonggaoCover = res.data.data[i].show_url;
                      break;
                    }
                  }
                });
              }
            }
          },
          function(err){
          });
        }
          

        $scope.role = userService.getRole();

        

        // 首页简报
        $scope.briefDate = new Date();

        $scope.getNextDayButtonVisible = function(date) {
          var today = new Date();
          var todayString = today.getFullYear() + '-' + ("0" + (today.getMonth() + 1)).slice(-2) + '-' + ("0" + (today.getDate())).slice(-2);
          var dateString = date.getFullYear() + '-' + ("0" + (date.getMonth() + 1)).slice(-2) + '-' + ("0" + (date.getDate())).slice(-2);
          return (dateString != todayString);
        }

        $scope.getPrevDayBriefData = function() {
          $scope.briefDate.setDate($scope.briefDate.getDate() - 1);
          $scope.getBriefData($scope.briefDate);
        }

        $scope.getNextDayBriefData = function() {
          $scope.briefDate.setDate($scope.briefDate.getDate() + 1);
          $scope.getBriefData($scope.briefDate);
        }

        $scope.getBriefData = function(date) {
          $scope.briefData = {};
          dashService.queryBriefReport(date).then(function(res){
            if (res.data.code === 1) {
              $scope.briefData = res.data.data;
            }
          });
        }

        $scope.getBriefData($scope.briefDate);

        // 行动力
        gerenService.queryXingdongli()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.xingdongli = res.data.data;
          } else{
          }
        },
        function(err){
        });

        // 最新消息
        $scope.showMessage = 0;
        $interval(function() {
          if ($scope.recentMessages && $scope.recentMessages.length > 0) {
            $scope.showMessage = ($scope.showMessage + 1) % $scope.recentMessages.length;
          }
        }, 12000);

        // 最新访问
        $scope.zuixinFangwenData = [];
        dashService.queryLatestVisit().then(function(res){
          if (res.data.code === 1) {
            $scope.zuixinFangwenData = res.data.data;
            if ($scope.zuixinFangwenData.length > 5) {
              setInterval(function () {
                start();
              }, 3000);
            }
            // $scope.zuixinFangwenData = chunkArray($scope.zuixinFangwenData, 5);
            // console.log($scope.zuixinFangwenData);
          }
        });
        
        // $scope.zuixinFangwenData = [
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶1", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶2", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶3", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶4", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶5", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶6", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶7", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶8", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶9", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶10", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶11", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶12", fprovince: "330000"},
        //   {fcity: "330400", fcounty: "330402", flastrequestdate: "2020-12-25 16:41:03.367", fname: "夏晶13", fprovince: "330000"},
        // ];
        // $scope.zuixinFangwenData = chunkArray($scope.zuixinFangwenData, 5);

        // 应用请求次数增加
        $scope.addRequestTimes = function(v) {
          dashService.addRequestTimes(v).then(function(res){
          });
        }

        if ($scope.role == '企业' && !$scope.isAgentRole()) {
          $scope.noEntryForThreeDaysData = [];
          // 三天未录入销售经销商列表查询
          dashService.queryNoEntryForThreeDays().then(function(res){
            if (res.data.code === 1) {
              $scope.noEntryForThreeDaysData = chunkArray(res.data.data, 5);
              // $scope.noEntryForThreeDaysData = res.data.data;
            }
          });

          $scope.noEntryForSevenDaysData = [];
          // 七天未录入销售经销商列表查询
          dashService.queryNoEntryForSevenDays().then(function(res){
            if (res.data.code === 1) {
              $scope.noEntryForSevenDaysData = chunkArray(res.data.data, 5);
              // $scope.noEntryForSevenDaysData = res.data.data;
            }
          });
        } else {
          $scope.newCustMsgData = [];
          // 今日动态
          dashService.queryNewCustMsg().then(function(res){
            if (res.data.code === 1) {
              $scope.newCustMsgData = chunkArray(res.data.data, 5);
              // $scope.newCustMsgData = res.data.data;
            }
          });
        }

        $scope.showImageIndex = 0;

        $scope.fcompname = localStorage.getItem(FCOMPNAME);

        $scope.refreshComplete();
      }

      $scope.doRefresh();

      $(function() {
        $('ion-nav-bar.nav-bar-container')[0].style.display = 'none';
        // $('.tab-nav.tabs > a')[1].style.display = 'none';
        // $('.tab-nav.tabs > a')[2].style.display = 'block';
        // $('.tab-nav.tabs > a')[3].style.display = 'block';
        // $('.tab-nav.tabs > a')[4].style.display = 'block';
        // $('.tab-nav.tabs > a')[5].style.display = 'block';

        var checkContent4 = $interval(function() {
          if ($('.slide-page-content4')) {
            $('.slide-page-content4').scroll(function() {
              $scope.stopAutoSlide();
              autoSlide = $interval(function() {
                if ($('.slide-page-content4')) {
                  $('.slide-page-content4').css('scroll-snap-type', 'unset');
                  $('.slide-page4').css('scroll-snap-align', 'unset');
                  $timeout(function(){}, 100);
                  $('.slide-page-content4').animate({scrollLeft: (($scope.showImageIndex + 1) % 3) * $('.slide-page4').width()}, 200);
                  $('.slide-page-content4').css('scroll-snap-type', 'x mandatory');
                  $('.slide-page4').css('scroll-snap-align', 'start');
                  $scope.showImageIndex = ($scope.showImageIndex + 1) % 3;
                } else {
                  $scope.stopAutoSlide();
                }
              }, 5000);

              var scrollLeft = document.querySelector('.slide-page-content4').scrollLeft;
              var offsetWidth = document.querySelector('.slide-page4').offsetWidth;
              $scope.showImageIndex = Math.round(scrollLeft / offsetWidth);
              $scope.$apply($scope.showImageIndex);
            });

            var autoSlide = $interval(function() {
              if ($('.slide-page-content4')) {
                $('.slide-page-content4').css('scroll-snap-type', 'unset');
                $('.slide-page4').css('scroll-snap-align', 'unset');
                $timeout(function(){}, 100);
                $('.slide-page-content4').animate({scrollLeft: (($scope.showImageIndex + 1) % 3) * $('.slide-page4').width()}, 200);
                $('.slide-page-content4').css('scroll-snap-type', 'x mandatory');
                $('.slide-page4').css('scroll-snap-align', 'start');
                $scope.showImageIndex = ($scope.showImageIndex + 1) % 3;
              } else {
                $scope.stopAutoSlide();
              }
            }, 5000);

            $scope.stopAutoSlide = function() {
              $interval.cancel(autoSlide);
            }

            $scope.stopCheckContent4();
          }
        }, 100);

        $scope.stopCheckContent4 = function() {
          $interval.cancel(checkContent4);
        }

        if ($scope.role == '企业') {
          var checkContent1 = $interval(function() {
            if ($('.slide-page-content1')) {
              $('.slide-page-content1').scroll(function() {
                var scrollLeft = document.querySelector('.slide-page-content1').scrollLeft;
                var offsetWidth = document.querySelector('.slide-page1').offsetWidth;
                if (scrollLeft % offsetWidth == 0) {
                  $scope.noEntryForThreeDaysPageNumber = Math.round(scrollLeft / offsetWidth) + 1;
                  $scope.$apply($scope.noEntryForThreeDaysPageNumber);
                }
              });
              $scope.stopCheckContent1();
            }
          }, 100);

          $scope.stopCheckContent1 = function() {
            $interval.cancel(checkContent1);
          }

          var checkContent2 = $interval(function() {
            if ($('.slide-page-content2')) {
              $('.slide-page-content2').scroll(function() {
                var scrollLeft = document.querySelector('.slide-page-content2').scrollLeft;
                var offsetWidth = document.querySelector('.slide-page2').offsetWidth;
                if (scrollLeft % offsetWidth == 0) {
                  $scope.noEntryForSevenDaysPageNumber = Math.round(scrollLeft / offsetWidth) + 1;
                  $scope.$apply($scope.noEntryForSevenDaysPageNumber);
                }
              });
              $scope.stopCheckContent2();
            }
          }, 100);

          $scope.stopCheckContent2 = function() {
            $interval.cancel(checkContent2);
          }
        } else {
          var checkContent3 = $interval(function() {
            if ($('.slide-page-content3')) {
              $('.slide-page-content3').scroll(function() {
                var scrollLeft = document.querySelector('.slide-page-content3').scrollLeft;
                var offsetWidth = document.querySelector('.slide-page3').offsetWidth;
                if (scrollLeft % offsetWidth == 0) {
                  $scope.newCustMsgPageNumber = Math.round(scrollLeft / offsetWidth) + 1;
                  $scope.$apply($scope.newCustMsgPageNumber);
                }
              });
              $scope.stopCheckContent3();
            }
          }, 100);

          $scope.stopCheckContent3 = function() {
            $interval.cancel(checkContent3);
          }
        } 

      });

      $scope.changeRole = () => {
        let accounts = JSON.parse(localStorage.getItem('accounts'))
        if (accounts.length > 1) {
          $state.go('app.selectuser')
        }
      }

      $scope.pcVersionURL = "https://www.cnd3b.com/dsb1/"
      $scope.showPCURL = () => {
        let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">更多精彩功能请前往电脑端</span></div>',
					subTitle: `<div><span class="popup-content">地址：${$scope.pcVersionURL}</span></div>`,
          scope: $scope,
					buttons: [
						{
              text: '知道了',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '复制',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            cordova.plugins.clipboard.copy($scope.pcVersionURL,
              function () {
                $scope.showToast({title: "链接已复制到剪贴板"})
              }, function () {
            });
            $scope.closePopover();
          }
        });
      }

    });
})();

