(function(){

	"use strict";
	angular.module('starter.services')

	.service('dashService', function (apiService, userService) {
		let self = this;

    // 首页简报
		self.queryBriefReport = function(date = new Date()) {
			var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
					"classname": role=='经销商' ? "agentclient.mainpage.mainpage" : "salerclient.mainpage.mainpage",
					"method": "query_briefreport",
					"content": {
						"getdatafromdbanyway": true,
            "userid": userService.getUserId(),
            "fdate": date.getFullYear() +
								'-' + ("0" + (date.getMonth() + 1)).slice(-2) +
								'-' + ("0" + (date.getDate())).slice(-2),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 今日动态（经销商）
    self.queryNewCustMsg = function(pageNumber = 1, pageSize = 100) {
			let date = new Date();
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.mainpage",
					"method": "query_newcustmsg",
					"content": {
						"getdatafromdbanyway": true,
            "userid": userService.getUserId(),
            "fdate": date.getFullYear() +
								'-' + ("0" + (date.getMonth() + 1)).slice(-2) +
								'-' + ("0" + (date.getDate())).slice(-2),
						"pageNumber": pageNumber,
						"pageSize": pageSize,
					}
				}
      };

			return apiService.makeRequest(request);
		};

		// 三天未录入销售经销商列表查询（企业）
    self.queryNoEntryForThreeDays = function(pageNumber = 1, pageSize = 100) {
			let date = new Date();
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.mainpage",
					"method": "query_noentryforthreedays",
					"content": {
						"getdatafromdbanyway": true,
            "userid": userService.getUserId(),
						"pageNumber": pageNumber,
						"pageSize": pageSize,
					}
				}
      };

			return apiService.makeRequest(request);
		};

		// 七天未录入销售经销商列表查询（企业）
    self.queryNoEntryForSevenDays = function(pageNumber = 1, pageSize = 100) {
			let date = new Date();
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.mainpage",
					"method": "query_noentryforsevendays",
					"content": {
						"getdatafromdbanyway": true,
            "userid": userService.getUserId(),
						"pageNumber": pageNumber,
						"pageSize": pageSize,
					}
				}
      };

			return apiService.makeRequest(request);
		};
		
		// 最新访问
		self.queryLatestVisit = function() {
			var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
					"classname": role=='经销商' ? "agentclient.mainpage.mainpage" : "salerclient.mainpage.mainpage",
					"method": "query_latestvisit",
					"content": {
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
		};
		
		// 应用请求次数增加
		self.addRequestTimes = function(name) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "system.system.getCallMethodStatistics",
					"method": "addRequestTimes",
					"content": {
						"userid": userService.getUserId(),
						"fappname": name,
					}
				}
      };

			return apiService.makeRequest(request);
		};

		// 创建附件下载记录
		self.createDownloadLog = function(tattachmentid) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "system.system.docManage",
					"method": "createdownloadlog",
					"content": {
						"userid": userService.getUserId(),
						"tattachmentid": tattachmentid,
					}
				}
      };

			return apiService.makeRequest(request);
		};

	})

})();
