(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('DianpuBianjiController', function($scope, $stateParams, ionicMaterialInk, $ionicPopup, dianpuService, $ionicActionSheet, multimediaService) {

      const agentsId = $stateParams.agentsid;
      const storeId = $stateParams.storeid;

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        fdate: null,
        ftype: '改建',
        farea: 0,
        fnotes: '改建',
      };

      dianpuService.queryStoreMain(
        storeId,
        agentsId
      )
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          $scope.data.fphonenumber = Number($scope.data.fphonenumber);

          // new Rolldate({
          //   el: '#fbirthdate',
          //   format: 'YYYY-MM-DD',
          //   value: $scope.data.fbirthdate,
          //   confirm: function(date) {
          //     $scope.data.fbirthdate = date;
          //   },
          // });
          new Rolldate({
            el: '#fstartdate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fstartdate,
            confirm: function(date) {
              $scope.data.fstartdate = date;
              $scope.$apply($scope.data);
            },
          });
          setTimeout(function() {
            new Rollarea({
              el: '#dizhi',
              format: 'province-city-county',
              value: {'fprovince': $scope.data.fprovince, 'fcity': $scope.data.fcity, 'fcounty': $scope.data.fcounty},
              confirm: function(area) {
                $scope.data.fprovince = area.fprovince;
                $scope.data.fcity = area.fcity;
                $scope.data.fcounty = area.fcounty;
              },
            });
          }, 100);
        } else{
          
        }
        $scope.refreshComplete();
      },
      function(err){
        $scope.refreshComplete();
      });
      dianpuService.queryAgentList()
      .then(function(res){
        $scope.agentList = res.data.data;
      },
      function(err){
      });

      dianpuService.queryStoreTypeList()
      .then(function(res){
        $scope.storeTypeList = res.data.data;
      },
      function(err){
      });

      dianpuService.queryMarketList()
      .then(function(res){
        $scope.marketList = res.data.data;
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });
      $scope.imageData = [];
      $scope.imageData['doorhead'] = [
        {
          ftype: 'doorhead',
          url: ''
        },
        {
          ftype: 'doorhead',
          url: ''
        },
        {
          ftype: 'doorhead',
          url: ''
        }
      ]
      $scope.imageData['negotiationarea'] = [
        {
          ftype: 'negotiationarea',
          url: ''
        },
        {
          ftype: 'negotiationarea',
          url: ''
        },
        {
          ftype: 'negotiationarea',
          url: ''
        }
      ]
      $scope.imageData['designarea'] = [
        {
          ftype: 'designarea',
          url: ''
        },
        {
          ftype: 'designarea',
          url: ''
        },
        {
          ftype: 'designarea',
          url: ''
        }
      ]
      $scope.imageData['showarea'] = [
        {
          ftype: 'showarea',
          url: ''
        },
        {
          ftype: 'showarea',
          url: ''
        },
        {
          ftype: 'showarea',
          url: ''
        }
      ]
      $scope.imageData['experiencearea'] = [
        {
          ftype: 'experiencearea',
          url: ''
        },
        {
          ftype: 'experiencearea',
          url: ''
        },
        {
          ftype: 'experiencearea',
          url: ''
        }
      ]
      $scope.imageData['overallview'] = [
        {
          ftype: 'overallview',
          url: ''
        }
      ]
      multimediaService.getImageList(storeId)
      .then(function(res) {
        var data = groupBy(res.data.data, 'ftype');
        Object.keys(data).forEach(outer => {
          data[outer].forEach((elem, index) => {
            $scope.imageData[outer][index] = elem
          })
        })
      })

      $scope.removeImage = function(ftype, idx) {
        $scope.imageData[ftype][idx].url = '';
        multimediaService.removeImage($scope.imageData[ftype][idx]);
      }

      $scope.selectedActions = new Array();

      $scope.changeAction = (selected, action) => {
        // selected = !selected;
        if (selected) {
          const index = $scope.selectedActions.indexOf(action);
          if (index == -1) {
            $scope.selectedActions.push(action);
          }
        } else {
          const index = $scope.selectedActions.indexOf(action);
          if (index > -1) {
            $scope.selectedActions.splice(index, 1);
          }
        }
      }

      function uploadAvatar(url, ftype, idx) {
        multimediaService.uploadPicture(url, ftype, storeId)
        .then(res => {
          res = res.data//JSON.parse(res.response)
          if (res.code == 1 && res.data.length > 0) {
            $scope.imageData[ftype][idx] = res.data[res.data.length - 1];
          } else
            $scope.showToast({title: '头像上传失败！'});
        }, err => {
          $scope.showToast({title: err});
        })
      }

      $scope.openGallery = function(ftype, idx) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            uploadAvatar(imageURI, ftype, idx);
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openCamera = function(ftype, idx) {
        multimediaService.openCamera()
          .then(function (imageURI) {
            uploadAvatar(imageURI, ftype, idx);
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.actionSheet = function(ftype, idx) {
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: [
						{
							text: '拍照'
						},
						{
							text: '从相册选择'
						}],
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera(ftype, idx);
							break;
							case 1: //从相册选择
                $scope.openGallery(ftype, idx);
							break;
							default:

							break;
						}
						return true;
					}
				});
      };

      $scope.modify = function() {
        if (!checkPhone($scope.data.fphonenumber)){
          $scope.showToast({title: '手机号码有误，请重填'});
          return;
        }

        if (!$scope.data.fstoretype) {
          $scope.showToast({title: '请选择代理模式'});
          return;
        }

        $scope.showLoading();
        $scope.data.fcustaction = $scope.selectedActions.join('|');
        $scope.data.datalog = [
          {
              "ftype": "修改",
              "flog": "修改内容", // TODO 修改内容
          }
        ],
        dianpuService.storeInsertOrModify($scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentSelectPanel = function() {
        $scope.selectModel = $scope.agentList;
        $scope.selectKeyField = "tagentsid";
        $scope.selectValueField = "fagentname";
        $scope.selectModelName = "tagentsid";
        $scope.selected = $scope.data.tagentsid;

        $scope.showSelectPanel();
      }

      $scope.showMarketSelectPanel = function() {
        $scope.selectModel = $scope.marketList;
        $scope.selectKeyField = "fchannel";
        $scope.selectValueField = "fchannel";
        $scope.selectModelName = "fmarket";
        $scope.selected = $scope.data.fmarket;

        $scope.showSelectPanel();
      }

		});
})();

