(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('GaijianDianpuController', function($scope, $stateParams, ionicMaterialInk, $ionicPopup, $ionicActionSheet, dianpuService, multimediaService) {

      const agentsId = $stateParams.agentsid;
      const storeId = $stateParams.storeid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        fdate: null,
        ftype: '改建',
        farea: 0,
        fnotes: '',
      };

      $scope.modify = function() {
        $scope.showLoading();

        dianpuService.storeRebuild(agentsId, storeId, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.removeImage = function(ftype, idx) {
        $scope.imageData[ftype][idx].url = '';
        multimediaService.removeImage($scope.imageData[ftype][idx]);
      }
      
      multimediaService.getImageList(storeId)
      .then(function(res) {
        $scope.imageData = [];
        $scope.imageData['doorhead'] = [];
        $scope.imageData['negotiationarea'] = [];
        $scope.imageData['designarea'] = [];
        $scope.imageData['showarea'] = [];
        $scope.imageData['experiencearea'] = [];
        $scope.imageData['overallview'] = [];
        
        for (var i = res.data.data.length - 1; i >= 0; i--){
          $scope.imageData[res.data.data[i].ftype].push(res.data.data[i]);
        }
      })

      function uploadAvatar(uri, ftype, idx) {
        multimediaService.uploadPicture(uri, ftype, storeId)
        .then(res => {
          res = res.data//JSON.parse(res.response)
          if (res.code == 1 && res.data.length > 0) {
            $scope.imageData[ftype][idx] = res.data[res.data.length - 1];
          } else
            $scope.showToast({title: '头像上传失败！'});
        }, err => {
          $scope.showToast({title: err})
        })
      }

      $scope.openGallery = function(ftype, idx) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            uploadAvatar(imageURI, ftype, idx);
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openCamera = function(ftype, idx) {
        multimediaService.openCamera()
          .then(function (imageURI) {
            uploadAvatar(imageURI, ftype, idx);
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.actionSheet = function(ftype, idx) {
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: [
						{
							text: '拍照'
						}, 
						{
							text: '从相册选择'
						}],
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera(ftype, idx);                          
							break; 
							case 1: //从相册选择
                $scope.openGallery(ftype, idx);                          
							break;
							default:
												
							break;
						}
						return true;
					}
				});
      };

      new Rolldate({
        el: '#fdate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fdate,
        confirm: function(date) {
          $scope.data.fdate = date;
          $scope.$apply($scope.data);
        },
      });
      
		});
})();

