/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('DianpuLiebiaoController', function($scope, dianpuService, $ionicPopup, $ionicHistory)
    {
      $scope.dataList = [];
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 10;
      $scope.fromdb = $ionicHistory.forwardView() != null
      
      $scope.$on('$destroy', function() {
        $scope.clearKeyword()
      });

      $scope.loadData = () => {
        dianpuService.queryStoreList(
          $scope.fromdb,
          $scope.pageNumber, // pageNumber
          $scope.pageSize, // pageSize
          $scope.keyword, // keyword
        )
        .then(function (res) {
          if (res.data.code === 1) {
            $scope.dataList = $scope.dataList.concat(res.data.data);
            $scope.pageTotal = res.data.pageTotal;
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function (err) {
          $scope.refreshComplete();
        });
      }

			$scope.doRefresh = function () {
				$scope.pageNumber = 1
        $scope.dataList = [];
        $scope.loadData();
      };
      $scope.showLoading();
      $scope.doRefresh();
      
      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      // get keywords
      $scope.keywords = $scope.loadKeywords();

      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });

      $scope.setShowSearchBar(false);
    })
})();
