(function(){

	"use strict";
	angular.module('starter.services')

	.service('dianpuService', function (apiService, userService) {
		let self = this;

    // 经销商门店列表查询
		self.queryStoreList = function(fromdb, pageNumber, pageSize, condition) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "query_storeList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {},
					}
				}
      };
      if (condition) request.data.content.where.condition = condition;

			return apiService.makeRequest(request);
    };

    // 经销商门店主界面查询
    self.queryStoreMain = function(storeId, agentsId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "query_storeMain",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
            "tagentsid": agentsId,
            "tstoreid": storeId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 经销商门店新增，修改
    self.storeInsertOrModify = function(data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "storeInsertOrModify",
					"content": {
            "userid": userService.getUserId(),
            "tagentsid": data.tagentsid,
            "tstoreid": data.tstoreid,
            "fstorenum": data.fstorenum,
            "fstorename": data.fstorename,
            "farea": data.farea,
            "fstoretype": data.fstoretype,
            "fmarket": data.fmarket,
            "fstartdate": data.fstartdate ? data.fstartdate : '',
            // "fstartdate": data.fstartdate.getFullYear() +
            //     '-' + ("0" + (data.fstartdate.getMonth() + 1)).slice(-2) +
						//     '-' + ("0" + data.fstartdate.getDate()).slice(-2),
            "fstatus": data.fstatus,
            "fprovince": data.fprovince,
            "fcity": data.fcity,
            "fcounty": data.fcounty,
            "faddress": data.faddress,
            "fcontact": data.fcontact,
            "fphonenumber": data.fphonenumber,
            "femail": data.femail,
            "fwechatno": data.fwechatno,
						"datalog": data.datalog
						// [
            //   {
            //     "ftype": "修改",
            //     "flog": "修改字段及内容"
            //   }
            // ]
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 经销商门店删除
    self.storeDelete = function(agentsId, storeId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "storeDelete",
					"content": {
            "userid": userService.getUserId(),
            "tagentsid": agentsId,
            "tstoreid": storeId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 经销商选择列表查询
    self.queryAgentList = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "query_agentList",
					"content": {
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 归属卖场列表查询
    self.queryMarketList = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "query_marketList",
					"content": {
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 门店类型列表查询（代理模式）
    self.queryStoreTypeList = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "query_storetypeList",
					"content": {
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 门店状态类表查询
    self.queryStoreStatusList = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "query_storestatusList",
					"content": {
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 店铺改建
    self.storeRebuild = function(agentsId, storeId, data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.storeinput.storeinput",
					"method": "storeRebuild",
					"content": {
            "userid": userService.getUserId(),
            "tagentsid": agentsId,
						"tstoreid": storeId,
						"fdate": data.fdate ? data.fdate : '',
            // "fdate": data.fdate.getFullYear() +
            //     '-' + ("0" + (data.fdate.getMonth() + 1)).slice(-2) +
            //     '-' + ("0" + data.fdate.getDate()).slice(-2),
            "ftype": data.ftype,
            "farea": data.farea,
            "fnotes": data.fnotes,
					}
				}
      };

			return apiService.makeRequest(request);
		};		

	})

})();

