(function(){
	"use strict";
  angular.module('starter.controllers')
		.controller('DianpuXiangqingController', function($scope, $rootScope, $ionicPopup, $ionicPopover, $state, $stateParams, $ionicActionSheet, dianpuService, multimediaService) {
      const agentsId = $stateParams.agentsid;
      const storeId = $stateParams.storeid;

      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
			$scope.navIndex = 0;
      $rootScope.isDownloading = -1

      const template = `
          <ion-popover-view class="fit" style="height:120px !important;">
            <ion-content scroll="false">
              <div class="list">
                <ion-list>
                <ion-item lines="none" detail="false" ng-click="showEdit()">
                  <div class="table-line">
                  <img src="img/bianji4.png" style="background-color: #666666; height: 18px; width: 18px; margin-right: 8px">
                    <span class="info-table-line-text">编辑</span>
                  </div>
                </ion-item>
                <ion-item lines="none" detail="false" ng-click="showGaijian()">
                  <div class="table-line">
                    <img src="img/sucai.png" style="height: 18px; width: 18px; margin-right: 8px; filter: grayscale(100%);">
                    <span class="info-table-line-text">改建</span>
                  </div>
                </ion-item>
                  <ion-item lines="none" detail="false" ng-click="confirmDelete()">
                    <div class="table-line">
                    <img src="img/zhangdan1.png" style="height: 18px; width: 18px; margin-right: 8px">
                    <span class="info-table-line-text">删除</span>
                    </div>
                  </ion-item>
                </ion-list>
              </div>
            </ion-content>
          </ion-popover-view>`;

      $scope.popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
      })

      $scope.openPopover = ($event) => {
        $scope.popover.show($event);
      }

      $scope.closePopover = () => {
        $scope.popover.hide();
      }

      // Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.popover.remove();
      });

      // Execute action on hide popover
      $scope.$on('popover.hidden', function() {
        // Execute action
      });

      // Execute actioni on remove popover
      $scope.$on('popover.removed', function() {
        // Execute action
      });

      $scope.showEdit = () => {
        $scope.closePopover();
        $state.go('app.dianpubianji', {agentsid: agentsId, storeid: storeId});
      }

      $scope.showGaijian = () => {
        $scope.closePopover();
        $state.go('app.dianpugaijian', {agentsid: agentsId, storeid: storeId});
      }

      $scope.confirmDelete = () => {
				let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">删除确认</span></div>',
					subTitle: '<div><span class="popup-content">确定要进行删除操作吗？</span></div>',
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
            dianpuService.storeDelete(agentsId, storeId)
            .then(
              function(res){
                if (res.data.code === 1) {
                  $scope.showToast({
                    title: "删除成功！"
                  });
                  $scope.goBack();
                } else {
                  $ionicPopup.alert({
                    title: res.data.msg
                  });
                }
                $scope.hideLoading();
              },
              function(err){
                $scope.hideLoading();
              });
            $scope.closePopover();
          }
        });
      }

      $scope.loadData = () => {
        dianpuService.queryStoreMain(
          storeId,
          agentsId
        )
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
            $scope.data = $scope.setDefaults($scope.data);
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.showLoading();
      $scope.loadData();

      multimediaService.getImageList(storeId)
      .then(function(res) {
        $scope.imageData = groupBy(res.data.data, 'ftype');
      })

		});
})();

