(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('DianpuXinzengController', function($scope, ionicMaterialInk, $ionicPopup, dianpuService, $ionicActionSheet, multimediaService) {

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        tagentsid: 0,
        tstoreid: 0,
        fstorenum: "",
        fstorename: "",
        farea: 0,
        fstoretype: null,
        fmarket: "",
        fstartdate: "",
        fstatus: "",
        fprovince: "",
        fcity: "",
        fcounty: "",
        faddress: "",
        fcontact: "",
        fphonenumber: "",
        femail: "",
        fwechatno: "",
        piclist: [],
      };

      $scope.imageData = [];
      $scope.imageData['doorhead'] = [
        {
          ftype: 'doorhead',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'doorhead',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'doorhead',
          postfix: '', 
          fdocument: '',
          uri: ''
        }
      ]
      $scope.imageData['negotiationarea'] = [
        {
          ftype: 'negotiationarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'negotiationarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'negotiationarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        }
      ]
      $scope.imageData['designarea'] = [
        {
          ftype: 'designarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'designarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'designarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        }
      ]
      $scope.imageData['showarea'] = [
        {
          ftype: 'showarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'showarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'showarea',
          postfix: '', 
          fdocument: '',
          uri: ''
        }
      ]
      $scope.imageData['experiencearea'] = [
        {
          ftype: 'experiencearea',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'experiencearea',
          postfix: '', 
          fdocument: '',
          uri: ''
        },
        {
          ftype: 'experiencearea',
          postfix: '', 
          fdocument: '',
          uri: ''
        }
      ]
      $scope.imageData['overallview'] = [
        {
          ftype: 'overallview',
          postfix: '', 
          fdocument: '',
          uri: ''
        }
      ]

      $scope.showLoading();

      dianpuService.queryAgentList()
      .then(function(res){
        $scope.agentList = res.data.data;
      },
      function(err){
      });

      dianpuService.queryStoreTypeList()
      .then(function(res){
        $scope.storeTypeList = res.data.data;
      },
      function(err){
      });

      dianpuService.queryMarketList()
      .then(function(res){
        $scope.marketList = res.data.data;
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      $scope.selectedActions = new Array();

      $scope.changeAction = (selected, action) => {
        // selected = !selected;
        if (selected) {
          const index = $scope.selectedActions.indexOf(action);
          if (index == -1) {
            $scope.selectedActions.push(action);
          }
        } else {
          const index = $scope.selectedActions.indexOf(action);
          if (index > -1) {
            $scope.selectedActions.splice(index, 1);
          }
        }
      }

      function uploadImages(storeId) {
        $scope.imageData['doorhead'].forEach(element => {
          if (element.uri.length > 0)
            multimediaService.uploadPicture(element.uri, element.ftype, storeId)
            .then(
              res => {},
              err => {
                $scope.showToast({title: err})
            })
        });
        $scope.imageData['negotiationarea'].forEach(element => {
          if (element.uri.length > 0)
            multimediaService.uploadPicture(element.uri, element.ftype, storeId)
            .then(
              res => {},
              err => {
                $scope.showToast({title: err})
            })
        });
        $scope.imageData['designarea'].forEach(element => {
          if (element.uri.length > 0)
            multimediaService.uploadPicture(element.uri, element.ftype, storeId)
            .then(
              res => {},
              err => {
                $scope.showToast({title: err})
            })
        });
        $scope.imageData['showarea'].forEach(element => {
          if (element.uri.length > 0)
            multimediaService.uploadPicture(element.uri, element.ftype, storeId)
            .then(
              res => {},
              err => {
                $scope.showToast({title: err})
            })
        });
        $scope.imageData['experiencearea'].forEach(element => {
          if (element.uri.length > 0)
            multimediaService.uploadPicture(element.uri, element.ftype, storeId)
            .then(
              res => {},
              err => {
                $scope.showToast({title: err})
            })
        });
        if ($scope.imageData['overallview'][0].uri.length > 0)
          multimediaService.uploadPicture($scope.imageData['overallview'][0].uri, 'overallview', storeId)
          .then(
            res => {},
            err => {
              $scope.showToast({title: err})
          })
      }

      $scope.openGallery = function(type, idx) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            let fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            $scope.imageData[type][idx].uri = imageURI;
            $scope.imageData[type][idx].postfix = fdocument.substring(fdocument.lastIndexOf('.') + 1) 
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openCamera = function(type, idx) {
        multimediaService.openCamera()
          .then(function (imageURI) {
            let fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            $scope.imageData[type][idx].uri = imageURI;
            $scope.imageData[type][idx].postfix = fdocument.substring(fdocument.lastIndexOf('.') + 1) 
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.actionSheet = function(type, idx) {
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: [
						{
							text: '拍照'
						},
						{
							text: '从相册选择'
						}],
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera(type, idx);
							break;
							case 1: //从相册选择
                $scope.openGallery(type, idx);
							break;
							default:

							break;
						}
						return true;
					}
				});
      };

      $scope.register = function() {
        if (!checkPhone($scope.data.fphonenumber)){
          $scope.showToast({title: '手机号码有误，请重填'});
          return;
        }

        if (!$scope.data.fstoretype) {
          $scope.showToast({title: '请选择代理模式'});
          return;
        }

        $scope.data.fcustaction = $scope.selectedActions.join('|');
        $scope.data.tstoreid = 0;
        $scope.data.datalog = [
          {
              "ftype": "新增",
              "flog": "新增记录",
          }
        ]
        $scope.showLoading();

				dianpuService.storeInsertOrModify($scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            uploadImages(res.data.data[0].tstoreid)
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      // new Rolldate({
      //   el: '#fbirthdate',
      //   format: 'YYYY-MM-DD',
      //   value: $scope.data.fbirthdate,
      //   confirm: function(date) {
      //     $scope.data.fbirthdate = date;
      //   },
      // });
      new Rolldate({
        el: '#fstartdate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fstartdate,
        confirm: function(date) {
          $scope.data.fstartdate = date;
          $scope.$apply($scope.data);
        },
      });
      setTimeout(function() {
        new Rollarea({
          el: '#dizhi',
          format: 'province-city-county',
          value: {'fprovince': $scope.data.fprovince, 'fcity': $scope.data.fcity, 'fcounty': $scope.data.fcounty},
          confirm: function(area) {
            $scope.data.fprovince = area.fprovince;
            $scope.data.fcity = area.fcity;
            $scope.data.fcounty = area.fcounty;
          },
        });
      }, 100);

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentSelectPanel = function() {
        $scope.selectModel = $scope.agentList;
        $scope.selectKeyField = "tagentsid";
        $scope.selectValueField = "fagentname";
        $scope.selectModelName = "tagentsid";
        $scope.selected = $scope.data.tagentsid;

        $scope.showSelectPanel();
      }

      $scope.showMarketSelectPanel = function() {
        $scope.selectModel = $scope.marketList;
        $scope.selectKeyField = "fchannel";
        $scope.selectValueField = "fchannel";
        $scope.selectModelName = "fmarket";
        $scope.selected = $scope.data.fmarket;

        $scope.showSelectPanel();
      }
		});
})();

