(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('DianpuShujuShouyeController', function($rootScope, $scope, $location, $anchorScroll, $ionicPopup, qiyeShujuService, $timeout) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.scrollTo = function(target){
        $location.hash(target); // set the location hash
        $anchorScroll();
      };

      $scope.selectTab = function(idx){
        $scope.navIndex = idx;
        $scope.$broadcast('scroll.refreshComplete');
      }

      $scope.showLoading();

      let chartArray = []
      $scope.$on('$destroy', function() {
        chartArray.forEach(chart => {
          chart.clear()
          if (!chart.destroyed)
            chart.destroy()
        })
      });

      setTimeout(function() {
        // 店铺数据_店铺面积占比分析
        $scope.hideChart1 = false;
        qiyeShujuService.storeAreaAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.data.length == 0) {
            $scope.hideChart1 = true;
          } else if (res.data.code === 1 && res.data.data.data.length > 0) {
            var data = [];

            var sum = 0;
            res.data.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart1 = true;
            }
            $scope.avgArea = parseFloat(res.data.data.favgarea.toFixed(2));
            let chart = new G2.Chart({
              container: 'dianpushuju-shouye-chart-1',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '家';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fclass')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fclass}\n${obj.fcount}家\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});
            chart.render();

            $scope.detailList3 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;

              if (state === 'selected') {
                const data = element.getData();
                if (stateStatus) {
                  $scope.detailList3 = data.fdata.slice(0, 10);
                  $scope.$apply($scope.detailList3);
                } else {
                  $scope.detailList3 = [];
                  $scope.$apply($scope.detailList3);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }
        },
        function(err) {
          $scope.hideChart1 = true;
        });

        // 店铺数据_改建分析
        $scope.hideChart2 = false;
        qiyeShujuService.storeRebuildAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.data.length == 0) {
            $scope.hideChart2 = true;
          } else if (res.data.code === 1 && res.data.data.data.length > 0) {
            var data = [];

            var sum = 0;
            res.data.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart2 = true;
            }
            $scope.avgIntervalTime = res.data.data.favgintervaltime;
            let chart = new G2.Chart({
              container: 'dianpushuju-shouye-chart-2',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '家';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fclass')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fclass}\n${obj.fcount}家\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});
            chart.render();

            $scope.detailList2 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;

              if (state === 'selected') {
                const data = element.getData();
                if (stateStatus) {
                  $scope.detailList2 = data.fdata.slice(0, 10);
                  $scope.$apply($scope.detailList2);
                } else {
                  $scope.detailList2 = [];
                  $scope.$apply($scope.detailList2);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart2 = true;
          }
        },
        function(err) {
          $scope.hideChart2 = true;
        });

        // 店铺数据_店铺卖场分析
        $scope.hideChart3 = false;
        qiyeShujuService.storeMarketAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart3 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart3 = true;
            }
            let chart = new G2.Chart({
              container: 'dianpushuju-shouye-chart-3',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '家';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fclass')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fclass}\n${obj.fcount}家\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});
            chart.render();

            $scope.detailList1 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;

              if (state === 'selected') {
                const data = element.getData();
                if (stateStatus) {
                  $scope.detailList1 = data.fdata.slice(0, 10);
                  $scope.$apply($scope.detailList1);
                } else {
                  $scope.detailList1 = [];
                  $scope.$apply($scope.detailList1);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart3 = true;
          }
        },
        function(err) {
          $scope.hideChart3 = true;
        });

        // 店铺数据_经销商档案列表
        $scope.agentList = [];
        qiyeShujuService.agentList(1, 10)
        .then(function(res) {
        if (res.data.code === 1) {
          $scope.agentList = res.data.data;
          $scope.agentList.forEach(function(item) {
            if (item.fprovince && item.fcity && item.fcounty
                && !isNaN(Number(item.fprovince))
                && !isNaN(Number(item.fcity))
                && !isNaN(Number(item.fcounty))) {
              item.fcounty = $scope.locationList[item.fcity][item.fcounty];
              item.fcity = $scope.locationList[item.fprovince][item.fcity];
              item.fprovince = $scope.locationList['86'][item.fprovince];
            }
          })
        } else {
          
        }

        $scope.hideLoading();
      },
      function(err) {
        $scope.hideLoading();
      });
      }, 500);

      $scope.setFavButtonInvisible = () => {
        $timeout.cancel($scope.timer);
        $scope.timer = $timeout(function() {
          $scope.show1 = false;
          $scope.show2 = false;
          $scope.show3 = false;
          $scope.show4 = false;
        }, 1500);
      }

      $(function() {
        $('ion-content').scroll(function(ev) {
          if ($('div.shuju-topmenu-panel').length) {
            if ($('ion-content').scrollTop() >= 20 ||
                (ev.target.scrollTop && ev.target.scrollTop >= 20) ||
                (ev.originalEvent.detail && ev.originalEvent.detail.scrollTop >= 20)) {
              $('div.tabs-top div.shuju-topmenu-panel').addClass('fixed-header');
              $('ion-content.dianpushuju').css("top", "107px");
              $('.shuju-topmenu-panel').css('height', '63px');
              $('ul:not(.wheel-scroll)').removeClass('display-flex').removeClass('flex-wrap-wrap').addClass('scrolling-wrapper');
            } else {
              $('div.tabs-top div.shuju-topmenu-panel').removeClass('fixed-header');
              $('ion-content.dianpushuju').css("top", "170px");
              $('.shuju-topmenu-panel').css('height', '126px');
              $('ul:not(.wheel-scroll)').removeClass('scrolling-wrapper').addClass('display-flex').addClass('flex-wrap-wrap');
            }
          }
        });
      });

      $('ion-content.dianpushuju').css("top", "170px");
      $('.shuju-topmenu-panel').css('height', '126px');

      $scope.selectedItem = 1;

    });
})();

