(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('FeiyongBianjiController', function($scope, $state, ionicMaterialInk, feiyongService, $ionicPopup) {
      const tagents_costid = $state.params.tagents_costid;

			ionicMaterialInk.displayEffect();
			$scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
      
      $scope.showLoading();
      $scope.modified = [];
      
      var originData = {};

      feiyongService.queryCostMain(tagents_costid)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          originData = Object.assign({}, $scope.data)

          new Rolldate({
            el: '#fdate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fdate,
            confirm: function(date) {
              $scope.data.fdate = date;
              $scope.$apply($scope.data);
            },
          });
        }
          
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      var modified = ''
      $scope.addModifiedList = function(item) {
        var isAdded = false;
        for(var i = 0; i < $scope.modified.length; i++) {
          if ($scope.modified[i].fcostname == item.fcostname) {
            isAdded = true;
            break;
          }
        }
        if (!isAdded) {
          $scope.modified.push(item);
          modified += ',' + item.fcostname
        }
      }
      
      $scope.modify = function() {
        if (!$scope.data.fdate) {
					$scope.showToast({title: "请输入日期!"});
					return;
				}

				var sum = 0;
				for (var i = 0; i < $scope.data.costlist.length; i++){
					if (!$scope.data.costlist[i].famount)
						$scope.data.costlist[i].famount = 0;
					sum += $scope.data.costlist[i].famount;
				}

				if (sum == 0) {
					$scope.showToast({title: "请输入至少一个项目的金额!"});
					return;
        }
        
        $scope.showLoading();
        if (originData[fdate] != $scope.data[fdate])
          modified = ",日期"
        if (modified.substring(0, 1) == ",")
          modified = modified.substring(1)
        $scope.datalog = [
          {
              "ftype": "修改",
              "flog": "修改内容：" + modified, // TODO 修改内容
          }
        ],
        feiyongService.queryCostInsertOrModify(tagents_costid, $scope.data.fdate.substr(0, 10), $scope.modified, $scope.datalog)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
				    $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
        },
        function(err){
        });

        $scope.hideLoading();
      }
			
		});
})();
