/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('FeiyongLiebiaoController', function($scope, $rootScope, feiyongService, $ionicPopup, $ionicHistory)
    {
      $scope.dataList = [];
      $scope.hideTabBar();
      $scope.pageNumber = 1;
      $scope.pageSize = 10;
      $scope.fromdb = $ionicHistory.forwardView() != null
      
      $scope.$on('$destroy', function() {
        $scope.clearKeyword()
      });

      $scope.loadData = () => {
        var i, j;
        feiyongService.queryCostList(
          $scope.fromdb,
          $scope.pageNumber,
          $scope.pageSize,
          $scope.sortDirection, // sort
          $scope.keyword, // keyword
          $scope.periodStart, // begindate
          $scope.periodEnd, // enddate
        )
        .then(function(res){
          if (res.data.code === 1) {
            $scope.dataList = $scope.dataList.concat(res.data.data);
            $scope.pageTotal = res.data.pageTotal;
          } else
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.refreshComplete();            
        },
        function(err){
          $scope.refreshComplete();
        });
      }

			$scope.doRefresh = function () {
        $scope.showLoading();
				$scope.pageNumber = 1
        $scope.dataList = [];
        $scope.loadData();
      };
      $scope.doRefresh();
      
      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      // get keywords
      $scope.keywords = $scope.loadKeywords();

      $rootScope.sort = v => {
        $scope.sortDirection = v;
        $scope.dataList.sort(getSortOrder('updatedAt', v));
      }

      $scope.sortDirection = descending; // 默认值为反序
      // $scope.dataList.sort(getSortOrder('updatedAt', $scope.sortDirection));

      $scope.changeSortDirection = () => {
        $scope.sortDirection = 1 - $scope.sortDirection;
        $scope.doRefresh();
      };

      $scope.setShowFilter(false);
      $scope.setShowSearchBar(false);
      $scope.initFenxiPeriod();
    })
})();
