(function(){

	"use strict";
	angular.module('starter.services')

	.service('feiyongService', function (apiService, userService) {
		var self = this;

    // 费用记录列表查询
		self.queryCostList = function(fromdb, pageNumber, pageSize, sortDirection, condition, periodStart, periodEnd) {
			var request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.costinput.costinput",
					"method": "query_costList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {

						},
						"sort":"t1.fdate" + (sortDirection == ascending ? '' : ' desc'),
					}
				}
			};
      if (condition) request.data.content.where.condition = condition;
			if (periodStart) {
        request.data.content.where.begdate = periodStart.getFullYear()
          + '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodStart.getDate()).slice(-2);
      }
      if (periodEnd) {
        request.data.content.where.enddate = periodEnd.getFullYear()
          + '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodEnd.getDate()).slice(-2);
      }

			return apiService.makeRequest(request);
		}

    // 费用记录主界面查询
		self.queryCostMain = function(tagents_costid) {
			var request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.costinput.costinput",
					"method": "query_costMain",
					"content": {
						"userid": userService.getUserId(),
						"tagents_costid": tagents_costid,
					}
				}
			};

			return apiService.makeRequest(request);
		}

    // 费用记录新增，修改
		self.queryCostInsertOrModify = function(tagents_costid, fdate, costList, dataLog) {
			var request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.costinput.costinput",
					"method": "costInsertOrModify",
					"content": {
						"userid": userService.getUserId(),
						"tagents_costid": tagents_costid,
						"fdate": fdate ? fdate : '',
						"costlist": costList,
						"datalog": dataLog
					}
				}
			};

			return apiService.makeRequest(request);
		}

    // 费用记录删除
		self.queryCostDelete = function(tagents_costid) {
			var request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.costinput.costinput",
					"method": "costDelete",
					"content": {
						"userid": userService.getUserId(),
						"tagents_costid": tagents_costid
					}
				}
			};

			return apiService.makeRequest(request);
		}
	})

})();
