/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  angular.module('starter.controllers')
		.controller('FeiyongXiangqingController', function($scope, $ionicPopup, feiyongService, $state, $ionicPopover, multimediaService) {
      const tagents_costid = $state.params.tagents_costid;

      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
      $scope.navIndex = 0;

      $scope.showSlide = function (num) {
				$scope.navIndex = num;
        $scope.$broadcast('scroll.refreshComplete');
      };

      const template = `
      <ion-popover-view class="fit" style="height:80px !important">
        <ion-content scroll="false">
          <div class="list">
            <ion-list>
              <ion-item lines="none" detail="false" ng-click="showEdit()">
                <div class="table-line">
                <img src="img/bianji4.png" style="background-color: #666666; height: 18px; width: 18px; margin-right: 8px">
                  <span class="info-table-line-text">编辑</span>
                </div>
              </ion-item>
              <ion-item lines="none" detail="false" ng-click="confirmDelete()">
                <div class="table-line">
                <img src="img/zhangdan1.png" style="height: 18px; width: 18px; margin-right: 8px">
                <span class="info-table-line-text">删除</span>
                </div>
              </ion-item>
            </ion-list>
          </div>
        </ion-content>
      </ion-popover-view>`;

      $scope.popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
      })

      $scope.openPopover = ($event) => {
        $scope.popover.show($event);
      }

      $scope.closePopover = () => {
        $scope.popover.hide();
      }

      // Execute action on hide popover
      $scope.$on('popover.hidden', function() {
        // Execute action
      });

      // Execute actioni on remove popover
      $scope.$on('popover.removed', function() {
        // Execute action
      });

      // Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.popover.remove();
      });

      $scope.showEdit = () => {
        $scope.closePopover();
			  $state.go('app.feiyongbianji', {tagents_costid: tagents_costid})
      }

      $scope.confirmDelete = () => {
				var myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">删除确认</span></div>',
					subTitle: '<div><span class="popup-content">确定要进行删除操作吗？</span></div>',
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
            feiyongService.queryCostDelete(tagents_costid)
            .then(function(res){
              if (res.data.code === 1) {
                $scope.showToast({
                  title: "删除成功！"
                });
                $scope.goBack();
              } else
                $ionicPopup.alert({
                  title: res.data.msg
                });
              $scope.hideLoading();
            },
            function(err){
              $scope.hideLoading();
            });
            $scope.closePopover();
          }
				});
      }

      $scope.loadData = () => {
        feiyongService.queryCostMain(tagents_costid)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
            $scope.data = $scope.setDefaults($scope.data);
            $scope.data.datalog.forEach(element => {
              element['avatar'] = 'img/no-avatar.jpg';
              multimediaService.getImageList(element.tenterprise_userid, 'tenterprise_users')
              .then(function(rr){
                if (rr.data.code == 1 && rr.data.data.length > 0) {
                  element['avatar'] = rr.data.data[rr.data.data.length - 1].url;
                }
              })
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.showLoading();
      
      $scope.loadData();

		});
})();
