(function(){
	'use strict';
	angular.module('starter.controllers')
		.controller('EditProfileController', function($scope, $ionicActionSheet, gerenService, multimediaService, $ionicPopup, userService) {
      $scope.$parent.showHeader();
			$scope.hideTabBar();

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
      
      $scope.loadData = () => {
        gerenService.queryUserMsg()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
            $scope.data.fbirthdate = $scope.data.fbirthdate ? $scope.data.fbirthdate.substring(0, 10) : '';
            $scope.data.fphonenumber = $scope.data.fphonenumber ? Number($scope.data.fphonenumber) : null;

            new Rolldate({
              el: '#fbirthdate',
              format: 'YYYY-MM-DD',
              value: $scope.data.fbirthdate,
              confirm: function(date) {
                $scope.data.fbirthdate = date;
                $scope.$apply($scope.data);
              },
            });

            new Rollarea({
              el: '#dizhi',
              format: 'province-city-county',
              value: {'fprovince': $scope.data.fprovince, 'fcity': $scope.data.fcity, 'fcounty': $scope.data.fcounty},
              confirm: function(area) {
                $scope.data.fprovince = area.fprovince;
                $scope.data.fcity = area.fcity;
                $scope.data.fcounty = area.fcounty;
              },
            });
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.showLoading();

      $scope.loadData();

      $scope.genderlist = ['男', '女'];

      $scope.modify = function() {
        if (!checkMail($scope.data.femail)){
          $scope.showToast({title: '邮箱有误，请重填'});
          return;
        }

        if (!checkPhone($scope.data.fphonenumber)){
          $scope.showToast({title: '手机号码有误，请重填'});
          return;
        }

        $scope.showLoading();

        gerenService.updateUserInfo($scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.avatar = 'img/no-avatar.jpg';
      multimediaService.getImageList(userService.getUserId(), 'tenterprise_users')
      .then(function(res){
        if (res.data.code == 1 && res.data.data.length > 0) {
          $scope.avatar = res.data.data[res.data.data.length - 1].url;
        }
      })

      function uploadAvatar(uri) {
        multimediaService.getImageList(userService.getUserId(), 'tenterprise_users')
        .then(function(res){
          if (res.data.code == 1 && res.data.data.length > 0) {            
            res.data.data.forEach(element => {
              multimediaService.removeImage(element)
            });
          }
        })
        
        setTimeout(() => {
          multimediaService.uploadPicture(uri, 'headportrait', userService.getUserId(), "tenterprise_users")
          .then(res => {
            res = res.data//JSON.parse(res.response)
            if (res.code == 1 && res.data.length > 0) {
              $scope.avatar = res.data[res.data.length - 1].url;
            } else
              $scope.showToast({title: '头像上传失败！'});
          }, err => {
            $scope.showToast({title: err})
          })
        }, 1000);
      }

      $scope.openGallery = function() {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            uploadAvatar(imageURI);
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openCamera = function() {
        multimediaService.openCamera()
          .then(function (imageURI) {
            uploadAvatar(imageURI);
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.actionSheet = function(form) {
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: [
						{
							text: '拍照'
						},
						{
							text: '从相册选择'
						}],
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera();
							break;
							case 1: //从相册选择
                $scope.openGallery();
							break;
							default:

							break;
						}
						return true;
					}
				});
			};

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showGenderSelectPanel = function() {
        $scope.selectModel = $scope.genderlist;
        $scope.selectKeyField = "";
        $scope.selectValueField = "";
        $scope.selectModelName = "fsex";
        $scope.selected = $scope.data.fsex;

        $scope.showSelectPanel();
      }

    });
})();

