(function(){

	"use strict";
	angular.module('starter.services')

	.service('gerenService', function (apiService, userService) {
		let self = this;

    // 个人信息查询
		self.queryUserMsg = function(userId = '') {
      var role = userService.getRole();

			let request = {
				url: API_URL_V1,
				data: {
					"classname": role=='经销商' ? "agentclient.usercenter.usermsg.usermsg" : "salerclient.usercenter.usermsg.usermsg",
					"method": "query_usermsg",
					"content": {
						"userid": userId == '' ? userService.getUserId() : userId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 个人信息修改
    self.updateUserInfo = function(data) {
      var role = userService.getRole();

			let request = {
				url: API_URL_V1,
				data: {
					"classname": role=='经销商' ? "agentclient.usercenter.usermsg.usermsg" : "salerclient.usercenter.usermsg.usermsg",
					"method": "update_usermsg",
					"content": {
            "userid": userService.getUserId(),
            "fname": data.fname,
            "fsex": data.fsex,
            "fbirthdate": data.fbirthdate,
            "femail": data.femail,
            "fwechatno": data.fwechatno,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 门店信息列表查询
    self.queryStoreList = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.usercenter.storemsg.storemsg",
					"method": "query_storeList",
					"content": {
            "getdatafromdbanyway": true,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 门店信息主界面查询
    self.queryStoreMain = function(tstoreid) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.usercenter.storemsg.storemsg",
					"method": "query_storeMain",
					"content": {
            "userid": userService.getUserId(),
            "tstoreid": tstoreid,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 账户列表查询
    self.queryUserList = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.usercenter.teammsg.teammsg",
					"method": "query_userList",
					"content": {
            "getdatafromdbanyway": true,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 账户信息修改
    self.updateUserMsg = function(enterpriseUserId, data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.usercenter.teammsg.teammsg",
					"method": "update_userMsg",
					"content": {
            "userid": userService.getUserId(),
            "tenterprise_userid": enterpriseUserId,
            "fname": data.fname,
            "tstoreid": data.tstoreid,
            "frole": data.frole,
            "fphonenumber": data.fphonenumber,
						"subusers": data.subusers
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 账户绑定门店选择
    self.selectStore = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.usercenter.teammsg.teammsg",
					"method": "selectStore",
					"content": {
            "getdatafromdbanyway": true,
            "userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 通讯录查询
    self.queryPhonebook = function(pageNumber, pageSize, condition) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.phonebook.phonebook" : "salerclient.mainpage.phonebook.phonebook",
					"method": "query",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"pageNumber": pageNumber,
            "pageSize": pageSize,
            "where": {
						},
					}
				}
			};

			if (condition) {
				request.data.content.where.condition = condition;
			}

			return apiService.makeRequest(request);
    };

    // 行动力总值查询
    self.queryXingdongli = function() {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.usercenter.actionscore.ActionScore" : "salerclient.usercenter.actionscore.ActionScore",
					"method": "query_total",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
    };

    // 行动力收支明细查询
    self.queryXingdongliLog = function(pageNumber, pageSize, actionscoreId, ftypemx) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.usercenter.actionscore.ActionScore" : "salerclient.usercenter.actionscore.ActionScore",
					"method": "query_scorelog",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"pageNumber": pageNumber,
            "pageSize": pageSize,
            "tactionscoreid": actionscoreId,
            "ftypemx": ftypemx,
					}
				}
			};

			return apiService.makeRequest(request);
    };

    // 任务完成情况查询
    self.queryRenwuWancheng = function() {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.usercenter.actionscore.ActionScore" : "salerclient.usercenter.actionscore.ActionScore",
					"method": "query_taskstatus",
					"content": {
						"userid": userService.getUserId()
					}
				}
			};

			return apiService.makeRequest(request);
		};
		
    // 每日签到
    self.querySignin = function() {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.usercenter.signin.SignIn" : "salerclient.usercenter.signin.SignIn",
					"method": "signin",
					"content": {
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
    };

    // 签到日志查询
    self.querySigninLog = function() {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.usercenter.signin.SignIn" : "salerclient.usercenter.signin.SignIn",
					"method": "query_signinlog",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};
		
		// 经销商行动力排行榜查询
		self.queryRankingList = function(pageNumber, pageSize) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.usercenter.actionscore.ActionScore" : 'salerclient.usercenter.actionscore.ActionScore',
					"method": "query_rankinglist",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"pageNumber": pageNumber,
						"pageSize": pageSize,
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 个人行动力排名查询
		self.queryRank = function() {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "agentclient.usercenter.actionscore.ActionScore",
					"method": "query_rank",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// APP咨询ID获取
		self.getCustomerserviceid = function() {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "system.customerservice.Customerservice",
					"method": "getCustomerserviceid",
					"content": {
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};
		
		// APP咨询
		self.customerServiceSubmit = function(tcustomerserviceid, fmessage) {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "system.customerservice.Customerservice",
					"method": "submit",
					"content": {
						"userid": userService.getUserId(),
						"fmessage": fmessage,
						"fsysfrom": "手机APP",
						"tcustomerserviceid": tcustomerserviceid
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 独立经销商角色创建
		self.registerAgents = function(data) {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "publicmethod.users.Users",
					"accesstoken": '',
					"method": "register_agents",
					"content": {
						"fname": data.fname ? data.fname : '',
						"fphonenumber": data.fphonenumber ? data.fphonenumber : '',
						"fagentname": data.fagentname ? data.fagentname : '',
						"faddress": data.faddress ? data.faddress : '',
						"fprovince": data.fprovince ? data.fprovince : '',
						"fcity": data.fcity ? data.fcity : '',
						"fcounty": data.fcounty ? data.fcounty : '',
						"fsex": data.fsex ? data.fsex : '',
						"fbirthdate": data.fbirthdate ? data.fbirthdate : '',
						"femail": data.femail ? data.femail : '',
						"fwechatno": data.fwechatno ? data.fwechatno : ''
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 二级推广人角色创建
		self.registerPromoters = function(data) {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "publicmethod.users.Users",
					"accesstoken": '',
					"method": "register_promoters",
					"content": {
						"fname": data.fname ? data.fname : '',
						"fphonenumber": data.fphonenumber ? data.fphonenumber : '',
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 根据简码（推广码）获取用户信息
		self.getUserMsgByShortCode = function(fshortcode) {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "publicmethod.users.Users",
					"method": "getUserMsgByShortCode",
					"content": {
						"fshortcode": fshortcode
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 二级推广人查询
		self.queryPromoterList = function(data) {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "agentclient.usercenter.promoters.promoters",
					"accesstoken": '',
					"method": "query_promoterList",
					"content": {
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 根据简码（推广码）获取用户信息
		self.getUserMsgByShortCode = function(fshortcode) {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "publicmethod.users.Users",
					"accesstoken": '',
					"method": "getUserMsgByShortCode",
					"content": {
						"fshortcode": fshortcode,
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 二级推广人合作商家查询
		self.queryAgentList = function(data) {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "agentclient.usercenter.promoters.promoters",
					"accesstoken": '',
					"method": "query_agentList",
					"content": {
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 二级推广人增加合作商家
		self.cooperation = function(fshortcode) {
			let request = {
				url: API_URL_V1,
				data: {
          "classname": "agentclient.usercenter.promoters.promoters",
					"accesstoken": '',
					"method": "cooperation",
					"content": {
						"userid": userService.getUserId(),
						"fshortcode":fshortcode
					}
				}
			};

			return apiService.makeRequest(request);
		};

	})

})();
