(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('JinriQiandaoController', function($scope, $state, ionicMaterialInk, $ionicPopup, gerenService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.checked = false;
      $scope.data = [];

      $scope.getMonth = function() {
        return (new Date().getFullYear()) + '年' + (new Date().getMonth() + 1) + '月';
      }

      let start = new Date();
      let end = new Date();
      start.setDate(1);
      start.setDate(start.getDate() - start.getDay());
      end.setDate(7);
      end.setMonth(end.getMonth() + 1);
      end.setDate(end.getDate() - end.getDay() - 1);
      
      function getDaysArray(start, end) {
        for(var arr=[],dt=new Date(start); dt<=end; dt.setDate(dt.getDate()+1)){
            arr.push(new Date(dt));
        }
        return arr;
      };

      $scope.dateList = getDaysArray(start, end);
      
      $scope.setChecked = function () {
        gerenService.querySignin()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.checked = true;
            $scope.data.push($scope.formatDate(new Date()));
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.loadData = () => {
        gerenService.querySigninLog()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data;
            $scope.checked = $scope.getIsChecked(new Date());
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.showLoading();

      $scope.loadData();

      $scope.getIsToday = (v) => {
        return ($scope.formatDate(new Date()) == $scope.formatDate(v));
      }

      $scope.getIsThisMonth = (v) => {
        return ($scope.formatDate(new Date()).substring(0, 7) == $scope.formatDate(v).substring(0, 7));
      }

      $scope.getIsChecked = (v) => {
        return ($scope.data.indexOf($scope.formatDate(v)) != -1);
      }

      $(function() {
        // $('.tab-nav.tabs > a')[1].style.display = 'block';
        // $('.tab-nav.tabs > a')[2].style.display = 'none';
        // $('.tab-nav.tabs > a')[3].style.display = 'none';
        // $('.tab-nav.tabs > a')[4].style.display = 'none';
        // $('.tab-nav.tabs > a')[5].style.display = 'none';
        // $('#xiaoxiCount')[0].style.display = 'none';
      });
		});
})();
