(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('PaihangbangController', function($scope, $state, multimediaService, $ionicPopup, gerenService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 20;

      $scope.slideImages = []
      $scope.slideImages.push ({id: 1, img: "img/lft1.png"})
      $scope.slideImages.push ({id: 2, img: "img/lft2.png"})

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });

      $scope.loadData = () => {
        gerenService.queryRankingList(
          $scope.pageNumber, // pageNumber
          $scope.pageSize, // pageSize
        )
        .then(function(res){
          if (res.data.code === 1) {
            $scope.dataList = $scope.dataList.concat(res.data.data);
            $scope.dataList.forEach(element => {
              element['avatar'] = 'img/no-avatar.jpg';
              multimediaService.getImageList(element.tenterprise_userid, 'tenterprise_users')
              .then(function(rr){
                if (rr.data.code == 1 && rr.data.data.length > 0) {
                  element['avatar'] = rr.data.data[rr.data.data.length - 1].url;
                }
              })
            });
            $scope.pageTotal = res.data.pageTotal;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });

        gerenService.queryRank()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.rank = res.data.data[0];
            $scope.rank.avatar = 'img/no-avatar.jpg';
            if ($scope.rank.tenterprise_userid) {
              multimediaService.getImageList($scope.rank.tenterprise_userid, 'tenterprise_users')
              .then(function(rr){
                if (rr.data.code == 1 && rr.data.data.length > 0) {
                  $scope.rank.avatar = rr.data.data[rr.data.data.length - 1].url;
                }
              })
            }
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
        },
        function(err){
        });
      }

      $scope.doRefresh = function () {
        $scope.pageNumber = 1;
        $scope.dataList = [];
        $scope.loadData();
      };

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      $scope.showLoading();
      $scope.doRefresh();
		});
})();
