(function(){
	'use strict';
	angular.module('starter.controllers')
		.controller('PasswordController', function($scope, $ionicActionSheet, $ionicPopup, userService) {
      $scope.$parent.showHeader();
      $scope.hideTabBar();
      
      $scope.modify = function() {
        if ($("#current").val() === undefined || $("#current").val() === '') {
          $scope.showToast({
            title: "请输入原密码"
          });
          return;
        }

        if (!userService.isValidPassword($("#current").val())) {
          $scope.showToast({
            title: "原密码不正确！"
          });
          return;
        }

        if ($("#new").val() === undefined || $("#new").val() === '' || $("#new").val().length < 6 || $("#new").val().length > 20) {
          $scope.showToast({
            title: "请设置6-20位新的登录密码"
          });
          return;
        }

        if ($("#new").val() != $("#confirm").val()) {
          $scope.showToast({
            title: "请再次输入新的登录密码"
          });
          return;
        }
        $scope.showLoading();

        userService.changePassWord($("#new").val())
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '已修改！'});
            $scope.goBack();
          } else {
            $ionicPopup.alert({
              title: res.data.msg
            });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }
    });
})();

