/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('WodeShangjiaController', function($scope, gerenService, $ionicPopup)
    {
      $scope.dataList = [];
      $scope.hideTabBar();

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
			
      $scope.registerCooperation = function() {
				$ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">请输入邀请码</span></div>',
					template: `<div><input class="promotenumber" id="promotenumber"/></div>`,
					scope: $scope,
					buttons: [
						{
						  text: '暂不加入',
						  type: 'button-left',
						  onTap: function(e) {
						    return 0;
						  }
						},
						{
							text: '确定',
							type: 'button-right background-red',
							onTap: function(e) {
								return 1;
							}
						},
					]
				}).then(function(res) {
					if (res == 1) {
						let promoteNumber = $("#promotenumber").val()
						$scope.showLoading();
						gerenService.cooperation(promoteNumber).then(res => {
							if (res.data.code === 1) {
								$scope.hideLoading();
							} else {
								$ionicPopup.alert({
									title: res.data.msg
								});
								$scope.hideLoading();
							}
						},
						function(err){
							$scope.hideLoading();
						});
					} else {}
				});
			};

      $scope.loadData = () => {
        gerenService.queryAgentList()
        .then(function(res){
          if (res.data.code === 1) {
            $scope.dataList = res.data.data;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.showLoading();

      $scope.loadData();

    })
})();
