/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('WodetuiguangrenController', function($scope, gerenService, $ionicPopup, $ionicHistory)
  {
    $scope.dataList = [];
    $scope.hideTabBar();  
    $scope.navIndex = 0;

    $scope.$on('$ionicView.beforeEnter', function (e,config) {
      config.enableBack = true;
    });
    
    $scope.showSlide = function (num) {
      $scope.navIndex = num;
      $scope.$broadcast('scroll.refreshComplete');
    };
    
    gerenService.queryUserMsg()
    .then(function(res){
      if (res.data.code === 1) {
        $scope.fshortcode = res.data.data[0].fshortcode
        $('canvas').remove();
        $('#qr-code').qrcode({width: 200,height: 200,text: `https://www.cnd3b.com/index?type=miniApp&id=${$scope.fshortcode}`});
      }
    });

    $scope.loadData = () => {
      gerenService.queryPromoterList().then(function(res){
        if (res.data.code === 1) {
          $scope.dataList = res.data.data;
        } else{
          $ionicPopup.alert({
            title: res.data.msg
          });
        }
        $scope.refreshComplete();            	
      },
      function(err){
        $scope.refreshComplete();            		
      });
    }

    $scope.showLoading();
    $scope.doRefresh = function () {
      // $scope.dataList = [];
      $scope.loadData();
    };
    $scope.doRefresh();

    $scope.isQRDownloading = false
    $scope.downloadQR = () => {
      $scope.isQRDownloading = true
      let d = new Date();
      let filename = d.getFullYear() + ("0" + (d.getMonth() + 1)).slice(-2) + ("0" + d.getDate()).slice(-2) + "-" + d.getHours() + ("0" + (d.getMinutes() + 1)).slice(-2) + ("0" + d.getSeconds()).slice(-2);
      filename = `${filename}.jpg`;
      const canvas = document.getElementsByTagName('canvas')[0];
      // canvas.get('timeline').stopAllAnimations();

      setTimeout(() => {
        var dataURL = canvas.toDataURL("image/jpg");
        if (window.Blob && window.URL) {
          const arr = dataURL.split(',');
          const mime = arr[0].match(/:(.*?);/)[1];
          const bstr = atob(arr[1]);
          let n = bstr.length;
          const u8arr = new Uint8Array(n);
          while (n--) {
            u8arr[n] = bstr.charCodeAt(n);
          }
          const blobObj = new Blob([u8arr], { type: mime });
          let DOWNLOAD_DIR = cordova.file.externalCacheDirectory 
          let filePath = DOWNLOAD_DIR + filename;

          window.resolveLocalFileSystemURL(DOWNLOAD_DIR, entry => {
            entry.getFile(filename, { create: true, exclusive: false}, function (fileEntry) {
              fileEntry.createWriter(function (fileWriter) {
                fileWriter.onwriteend = function() {
                  cordova.plugins.photoLibrary.saveImage(fileEntry.nativeURL, 'dsb', function (libraryItem) {
                    $ionicPopup.show({
                      title: '<div class="table-line"><span class="popup-title">下载成功</span></div>',
                      subTitle: `<div><span class="popup-content">文件已保存在相册</span></div>`,
                      scope: $scope,
                      buttons: [
                        {
                          text: '确认',
                          type: 'button-right background-red',
                          onTap: function(e) {
                            return 0;
                          }
                        },
                      ]
                    })
                  }, function (err) {
                    $scope.showToast({
                      title: `下载失败`
                    })
                  });
                  $scope.isQRDownloading = false
                };

                fileWriter.onerror = function (e) {
                  $scope.showToast({
                    title: `下载失败`
                  })
                  $scope.isQRDownloading = false
                };

                fileWriter.write(blobObj);
              });
            });
            }, err => {
              $scope.showToast({
                title: `下载失败`
              })
              $scope.isQRDownloading = false
            });
        }
      }, 16);
    }
    
  })
})();
