(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('HuodongLiebiaoController', function($scope, $state, ionicMaterialInk, $ionicPopup, huodongService, gerenService, userService, multimediaService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 5;
      $scope.condition = '';

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });

      huodongService.queryAnalysis().then(res => {
        if (res.data.code === 1) {
          $scope.headerData = res.data.data[0]
        }
      })
      
      $scope.loadData = () => {
        huodongService.queryAgentactivitiesList(
          $scope.pageNumber, // pageNumber
          $scope.pageSize // pageSize
        )
        .then(function(res){
          // console.log(res);
          if (res.data.code === 1) {
            $scope.dataList = $scope.dataList.concat(res.data.data)
            $scope.dataList.forEach(element => {
              multimediaService.getImageList(element.tagentactivitiesid, 'tagentactivities').then(res => {
                for (let i = 0; i < res.data.data.length; i++) {
                  if (res.data.data[i].ftype == 'cover')
                    element.cover = res.data.data[i].url
                }
              })
              element.avatar = 'img/no-avatar.jpg';
              multimediaService.getImageList(element.tenterprise_userid, 'tenterprise_users')
              .then(function(rr){
                if (rr.data.code == 1 && rr.data.data.length > 0) {
                  element.avatar = rr.data.data[rr.data.data.length - 1].url;
                }
              })
              gerenService.queryUserMsg(element.tenterprise_userid).then(query => {
                if (query.data.code === 1 && query.data.data.length > 0) {
                  element.userName = query.data.data[0].fname
                  if (userService.getUserId() == element.tenterprise_userid)
                    element.userName = element.userName + '（我）'
                }
              })
            });
            $scope.pageTotal = res.data.pageTotal;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.showLoading();
			$scope.doRefresh = function () {
        $scope.pageNumber = 1;
        $scope.dataList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }
		});
})();

