(function(){

	"use strict";
	angular.module('starter.services')

	.service('huodongService', function (apiService, userService) {
		let self = this;

		// 数据统计，简报
		self.queryAnalysis = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage." + (userService.getRole() == '推广人' ? "promotersactivities.promotersactivities" : "tagentactivities.agentactivities"),
					"method": "query_analysis",
					"content": {
						"getdatafromdbanyway": true,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 活动列表查询
		self.queryAgentactivitiesList = function(pageNumber, pageSize) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage." + (userService.getRole() == '推广人' ? "promotersactivities.promotersactivities" : "tagentactivities.agentactivities"),
					"method": "query_agentactivitiesList",
					"content": {
						"getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"pageNumber": pageNumber,
						"pageSize": pageSize,
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 活动主界面表头查询
		self.queryAgentactivitiesMain = function(tagentactivitiesid, tenterprise_userid) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage." + (userService.getRole() == '推广人' ? "promotersactivities.promotersactivities" : "tagentactivities.agentactivities"),
					"method": "query_agentactivitiesMain",
					"content": {
						"tagentactivitiesid": tagentactivitiesid,
						"tenterprise_userid": tenterprise_userid,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};
		
		// 活动主界面表体拉新统计
		self.queryAgentactivitiesCustList = function(pageNumber, pageSize, tagentactivitiesid, tenterprise_userid) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage." + (userService.getRole() == '推广人' ? "promotersactivities.promotersactivities" : "tagentactivities.agentactivities"),
					"method": "query_agentactivitiesCustList",
					"content": {
						"getdatafromdbanyway": true, 
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"tagentactivitiesid": tagentactivitiesid,
						"tenterprise_userid": tenterprise_userid,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 活动主界面表体线索统计
		self.queryAgentactivitiesFormList = function(pageNumber, pageSize, tagentactivitiesid, tenterprise_userid) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage." + (userService.getRole() == '推广人' ? "promotersactivities.promotersactivities" : "tagentactivities.agentactivities"),
					"method": "query_agentactivitiesFormList",
					"content": {
						"getdatafromdbanyway": true, 
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"tagentactivitiesid": tagentactivitiesid,
						"tenterprise_userid": tenterprise_userid,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 活动新增修改
		self.agentactivitiesInsertOrModify = function(data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage." + (userService.getRole() == '推广人' ? "promotersactivities.promotersactivities" : "tagentactivities.agentactivities"),
					"method": "agentactivitiesInsertOrModify",
					"content": {
						"tagentactivitiesid": data.tagentactivitiesid,
						"ftitle": data.ftitle,
						"fbegdate": data.fbegdate,
						"fenddate": data.fenddate,
						"fsaler1rewardamount1": data.fsaler1rewardamount1,
						"fsaler1rewardamount2": data.fsaler1rewardamount2,
						"fsaler2rewardamount1": data.fsaler2rewardamount1,
						"fsaler2rewardamount2": data.fsaler2rewardamount2,
						"fupperlimitamount": data.fupperlimitamount,
						"fnotes": data.fnotes,
						"fphonenumber": data.fphonenumber,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

		// 活动分享
		self.agentactivitiesShare = function(tagentactivitiesid) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage." + (userService.getRole() == '推广人' ? "promotersactivities.promotersactivities" : "tagentactivities.agentactivities"),
					"method": "agentactivitiesShare",
					"content": {
						"tagentactivitiesid": tagentactivitiesid,
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		};

	})

})();
