(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('HuodongXiangqingController', function($scope, $rootScope, $stateParams, multimediaService, huodongService, userService) {
      $scope.showHeader();
      $scope.hideTabBar();
      $rootScope.isDownloading = -1
      $scope.pageSize = 8
      $scope.pageTotal = 1
      
      $scope.tagentactivitiesid = $stateParams.tagentactivitiesid;
      $scope.tenterprise_userid = $stateParams.tenterprise_userid;
      $scope.isMine = userService.getUserId() == $scope.tenterprise_userid
      
      $scope.imageData = []

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
      
      $scope.mainData = {
        ftitle: '',
        fbegdate: '',
        fenddate: '',
        fstatus: '',
        fsaler1rewardamount1: 0,
        fsaler1rewardamount2: 0,
        fremuneration: 0,
        fsharecount: 0,
        fcustcount: 0,
        fformcount: 0,
        cover: ''
      }
      huodongService.queryAgentactivitiesMain($scope.tagentactivitiesid, $scope.tenterprise_userid).then(res => {
        if (res.data.code == 1 && res.data.data.length > 0) {
          $scope.mainData = res.data.data[0]
          if (!$scope.isPromoterRole())
            multimediaService.getImageList($scope.tagentactivitiesid, 'tagentactivities').then(res => {
              for (let i = 0; i < res.data.data.length; i++) {
                if (res.data.data[i].ftype == 'cover')
                  $scope.mainData.cover = res.data.data[i].url
                else {
                  $scope.imageData.push(
                    {
                      url: res.data.data[i].url,
                      postfix: res.data.data[i].postfix,
                      show_url: res.data.data[i].show_url,
                      fdocument: res.data.data[i].fdocument
                    }
                  )
                }
              }
            })
          $scope.showTab(0)
        }
      })

      $scope.loadData = () => {
        $scope.showLoading()
        $scope.formList = []
        $scope.custList = []
        if ($scope.tabIndex == 0) {
          huodongService.queryAgentactivitiesCustList($scope.pageNumber, $scope.pageSize, $scope.tagentactivitiesid, $scope.tenterprise_userid).then(res => {
            if (res.data.code == 1) {
              $scope.custList = res.data.data
              $scope.pageTotal = res.data.pageTotal;
            }
            $scope.hideLoading()
          }, err => $scope.hideLoading())
        } else {
          huodongService.queryAgentactivitiesFormList($scope.pageNumber, $scope.pageSize, $scope.tagentactivitiesid, $scope.tenterprise_userid).then(res => {
            if (res.data.code == 1) {
              $scope.formList = res.data.data
              $scope.pageTotal = res.data.pageTotal;
            }
            $scope.hideLoading()
          }, err => $scope.hideLoading())
        }
      }

      $scope.showTab = (idx) => {
        $scope.tabIndex = idx
        $scope.pageNumber = 1
        $scope.loadData()
      }

      $scope.nextPage = () => {
        $scope.pageNumber = $scope.pageNumber < $scope.pageTotal ? $scope.pageNumber + 1 : $scope.pageTotal
        $scope.loadData()
      }

      $scope.prevPage = () => {
        $scope.pageNumber = $scope.pageNumber > 1 ? $scope.pageNumber - 1 : 1
        $scope.loadData()
      }

      $scope.isShowSharing = false
      
      $scope.showSucaiLeixing = function() {
        document.querySelector('.rolldate-container .rolldate-panel').style.setProperty('height', '33%');
        $scope.isShowSharing = true;
      }

      $scope.hideSucaiLeixing = function() {
        $scope.isShowSharing = false;
      }

      $scope.selectSucaiLeixing = function(type) {
        huodongService.agentactivitiesShare($scope.tagentactivitiesid).then(res => {
          if (res.data.code != 1)
            return
          let version = isDevServer ? "test" : "product"
          let wxShareUrl = `https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx45f99fca9b087ae6&redirect_uri=${encodeURIComponent(`https://test.cnd3b.com/dsb/activity.html?userid=${userService.getUserId()}&archivesid=${res.data.data.tagentactivities_shareid}&siteid=${userService.getSiteId()}&version=${version}&wechatname=a`)}&response_type=code&scope=snsapi_userinfo&state=123&connect_redirect=1#wechat_redirect`
          $scope.showLoading()
          setTimeout(() => {
            $scope.hideLoading()
          }, 3000);
          switch (type) {
            case '微信好友':
            case '微信群聊':
              Wechat.share({
                message:{
                  title: $scope.mainData.ftitle == null ? "" : $scope.mainData.ftitle,
                  description: $scope.mainData.fnotes == null ? "" : $scope.mainData.fnotes,
                  thumb: $scope.mainData.cover == null ? "" : $scope.mainData.cover,
                  media: {
                    type: Wechat.Type.WEBPAGE,
                    webpageUrl: wxShareUrl
                  }
                },
                scene: Wechat.Scene.SESSION  
              }, function () {
                huodongService.agentactivitiesShare($scope.tagentactivitiesid, type, '_ad')
                $scope.hideSucaiLeixing();
              }, function (reason) {
                $scope.hideSucaiLeixing();
              });
            break;
            case '微信朋友圈':
              Wechat.share({
                message:{
                  title: $scope.mainData.ftitle == null ? "" : $scope.mainData.ftitle,
                  description: $scope.mainData.fnotes == null ? "" : $scope.mainData.fnotes,
                  thumb: $scope.mainData.cover == null ? "" : $scope.mainData.cover,
                  media: {
                    type: Wechat.Type.WEBPAGE,
                    webpageUrl: wxShareUrl
                  }
                },
                scene: Wechat.Scene.TIMELINE  
              }, function () {
                huodongService.agentactivitiesShare($scope.tagentactivitiesid)
                $scope.hideSucaiLeixing();
              }, function (reason) {
                $scope.hideSucaiLeixing();
              });
              break;
            case 'weibo':
              WeiboSDK.ssoLogin(function (ssolArg) {
                var args = {};
                args.url = `https://www.cnd3b.com/dsb/sucai.html?userid=${userService.getUserId()}&archivesid=${res.data.data.tagentactivities_shareid}&siteid=${userService.getSiteId()}&version=${version}&wechatname=a`
                // args.url = `https://api.weibo.com/oauth2/authorize?client_id=570804165&response_type=code&redirect_uri=https://www.cnd3b.com`
                args.title = $scope.mainData.ftitle == null ? "" : $scope.mainData.ftitle
                args.description = $scope.mainData.fnotes == null ? "" : $scope.mainData.fnotes
                args.image = $scope.mainData.cover == null ? "" : $scope.mainData.cover
                WeiboSDK.shareToWeibo(function () {
                  huodongService.agentactivitiesShare($scope.tagentactivitiesid)
                }, function (failReason) {
                  // alert(failReason);
                }, args);
              }, function (failReason) {
                // alert(failReason);
              });
              $scope.hideSucaiLeixing();
              break;
            default:
              $scope.hideSucaiLeixing();
              break;
          }
        })
      }

		});
})();

