/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('HuodongXinzengController', function($scope, $state, ionicMaterialInk, huodongService, $ionicPopup, $ionicActionSheet, multimediaService, userService) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.hideTabBar();
      $scope.step = 1

      $scope.next = () => {
        $scope.step = 2
      }

      $scope.prev = () => {
        $scope.step = 1
        setTimeout(() => {
          new Rolldate({
            el: '#fbegdate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fbegdate,
            confirm: function(date) {
              $scope.data.fbegdate = date;
              $scope.$apply($scope.data);
            },
          });
    
          new Rolldate({
            el: '#fenddate',
            format: 'YYYY-MM-DD',
            value: $scope.fenddate,
            confirm: function(date) {
              $scope.data.fenddate = date;
              $scope.$apply($scope.data);
            },
          });
        }, 100);
      }

      $scope.data = {
        tagentactivitiesid: 0,
        ftitle: '',
        fbegdate: null,// 活动开始日期 如：2020-04-01
        fenddate: null,// 活动结束日期 如：2020-04-31
        fsaler1rewardamount1: '',// 一级推广人流量奖励(单位分)，界面显示转化成元
        fsaler1rewardamount2: '',// 一级推广人线索奖励(单位分)，界面显示转化成元
        fsaler2rewardamount1: '',// 二级推广人流量奖励(单位分)，界面显示转化成元
        fsaler2rewardamount2: '',// 二级推广人线索奖励(单位分)，界面显示转化成元
        fupperlimitamount: 0,// 活动预算，(单位分)，界面显示转化成元
        fnotes: '',
        fphonenumber: '',
      };
      
      setTimeout(() => {
        new Rolldate({
          el: '#fbegdate',
          format: 'YYYY-MM-DD',
          value: $scope.data.fbegdate,
          confirm: function(date) {
            $scope.data.fbegdate = date;
            $scope.$apply($scope.data);
          },
        });
  
        new Rolldate({
          el: '#fenddate',
          format: 'YYYY-MM-DD',
          value: $scope.fenddate,
          confirm: function(date) {
            $scope.data.fenddate = date;
            $scope.$apply($scope.data);
          },
        });
      }, 100);

      $scope.coverImage = {
        url: '', 
        show_url: '', 
        postfix: '', 
        fdocument: '',
        createby: userService.getUserName(),
        createdate: ''
      }
      $scope.imageData = [];
      function uploadImages(tarchivesid) {
        multimediaService.uploadPicture($scope.coverImage.url, "cover", tarchivesid, 'tagentactivities')
        .then(
          res => {},
          err => {
            $scope.showToast({title: err})
        })
        $scope.imageData.forEach(element => {
          multimediaService.uploadPicture(element.url, "default", tarchivesid, 'tagentactivities')
          .then(
            res => {},
            err => {
              $scope.showToast({title: err})
          })
        });
      }

      function pushImage(uri, isCover) {
        var fdocument = uri.substr(uri.lastIndexOf('/')+1)
        fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
        let postfix = fdocument.substring(fdocument.lastIndexOf('.') + 1)
        if (!$scope.isPicture(postfix) && !$scope.isMovie(postfix)) {
          $scope.showToast({title: '只能上传视频或图片!'})
          return
        }
        if (isCover) {
          $scope.coverImage.url = uri
          $scope.coverImage.show_url = uri
          $scope.coverImage.postfix = fdocument.substring(fdocument.lastIndexOf('.') + 1)
          $scope.coverImage.fdocument = fdocument
          $scope.coverImage.createdate = getDateString(new Date())
        } else {
          $scope.imageData.push({
            url: uri, 
            show_url: $scope.isMovie(postfix) ? `img/${$scope.getImageName(postfix.toLowerCase().substr(0, 3))}.png` : uri, 
            postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
            fdocument: fdocument,
            createby: userService.getUserName(),
            createdate: getDateString(new Date())
          });
        }
        setTimeout(() => {
          $scope.$apply();
        }, 100);
      }

      $scope.removeImageData = function(idx) {
        $scope.imageData.splice(idx, 1)
      }

      $scope.openGallery = function(isCover) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            pushImage(imageURI, isCover)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openCamera = function(isCover) {
        multimediaService.openCamera()
          .then(function (imageURI) {
            pushImage(imageURI, isCover)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.actionSheet = function(isCover = false) {
        var buttons = [
          {
            text: '拍照'
          }, 
          {
            text: '从相册选择'
          }]
          // buttons.push({text: '选择文件'})
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: buttons,
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera(isCover);
							break; 
							case 1: //从相册选择
                $scope.openGallery(isCover);
							break;
						}
						return true;
					}
				});
      };

      $scope.fabu = function() {
        if (!$scope.data.ftitle) {
          $scope.showToast({title: '请输入项目名称！'})
          return
        }
        if ($scope.coverImage.show_url == '') {
          $scope.showToast({title: '请选择项目封面！'})
          return
        }
        if ($scope.imageData.length == 0) {
          $scope.showToast({title: '请选择宣传图或者视频！'})
          return
        }
        // if (!$scope.data.fphonenumber) {
        //   $scope.showToast({title: '请输入联系方式'})
        //   return
        // }
                
        let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">发布确认</span></div>',
					subTitle: `<div><span class="popup-content">是否确认发布项目？确认后将冻结账户资金${$scope.data.fupperlimitamount}元</span></div>`,
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
            $scope.data.fsaler1rewardamount1 = $scope.data.fsaler1rewardamount1 * 100
            $scope.data.fsaler1rewardamount2 = $scope.data.fsaler1rewardamount2 * 100
            $scope.data.fsaler2rewardamount1 = $scope.data.fsaler2rewardamount1 * 100
            $scope.data.fsaler2rewardamount2 = $scope.data.fsaler2rewardamount2 * 100
            $scope.data.fupperlimitamount = $scope.data.fupperlimitamount * 100
            huodongService.agentactivitiesInsertOrModify($scope.data)
            .then(function(res){
              if (res.data.code === 1) {
                uploadImages(res.data.data[0].tagentactivitiesid)
                $state.go('app.huodongliebiao');
              } else {
                $ionicPopup.alert({
                  title: '账户可用余额不足，请重新编辑'//res.data.msg
                });
              }
              $scope.hideLoading();
            },
            function(err){
              $scope.hideLoading();
            });
          }
        });			
      }

      $scope.data.fsaler1rewardamount1 = 0
      $scope.data.fsaler1rewardamount2 = 0
      $scope.data.fsaler2rewardamount1 = 0
      $scope.data.fsaler2rewardamount2 = 0
      // $scope.data.fupperlimitamount = 0
      // $scope.arg11 = $scope.arg12 = $scope.arg21 = $scope.arg22 = $scope.rg31 = $scope.arg32 = $scope.arg41 = $scope.arg42 = 0
      $scope.args = [
        ['', '', ''],
        ['', '', ''],
        ['', '', ''],
        ['', '', ''],
      ]
      $scope.changeSum = (row, args) => {
        args[row][2] = args[row][0] * args[row][1]
        switch (row) {
          case 0:
            $scope.data.fsaler1rewardamount1 = args[row][0]
            break;
          case 1:
            $scope.data.fsaler1rewardamount2 = args[row][0]
            break;
          case 2:
            $scope.data.fsaler2rewardamount1 = args[row][0]
            break;
          case 3:
            $scope.data.fsaler2rewardamount2 = args[row][0]
            break;
          default:
            break;
        }
        $scope.data.fupperlimitamount = Number(args[0][2]) + Number(args[1][2]) + Number(args[2][2]) + Number(args[3][2])
      }

		});
})();

