(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('PromoteHuodongController', function($scope, $interval, $ionicPopup, xinxiaoxiService, huodongService, gerenService, userService, multimediaService) {
      $scope.showHeader();
      $scope.showTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 5;
      $scope.condition = '';

      huodongService.queryAnalysis().then(res => {
        if (res.data.code === 1) {
          $scope.headerData = res.data.data[0]
        }
      })

      $scope.fcompname = localStorage.getItem(FCOMPNAME);
      
      $scope.messageList = [];
      async.parallel([
        function(callback) {
          xinxiaoxiService.queryMessage(false, 1, 100, '素材')
          .then(function(res) {
            if (res && res.data && res.data.code === 1) {
              callback(null, res.data.data)
            }
          });
        },
        function(callback) {
          xinxiaoxiService.queryMessage(false, 1, 100, '系统')
          .then(function(res) {
            if (res && res.data && res.data.code === 1) {
              callback(null, res.data.data)
            }
          });
        }
      ], function(err, results){
        if (!err) {
          $scope.messageList = [];
          $scope.resetXiaoxiCount()
          for (var i in results) {
            for (var j in results[i]) {
              if (results[i][j].fisread == 0) {
                $scope.incXiaoxiCount()
              }
              $scope.messageList.push(results[i][j]);
            }
          }
          $scope.messageList.sort(((a, b) => (a.createdate > b.createdate) ? -1 : 1));
          if ($scope.messageList.length > 2) {
            $scope.recentMessages = $scope.messageList.slice(0, 3);
          } else {
            $scope.recentMessages = $scope.messageList;
          }
        }
      });

      // 最新消息
      $scope.showMessage = 0;
      $interval(function() {
        if ($scope.recentMessages && $scope.recentMessages.length > 0) {
          $scope.showMessage = ($scope.showMessage + 1) % $scope.recentMessages.length;
        }
      }, 12000);

      $scope.loadData = () => {
        huodongService.queryAgentactivitiesList(
          $scope.pageNumber, // pageNumber
          $scope.pageSize // pageSize
        )
        .then(function(res){
          // console.log(res);
          if (res.data.code === 1) {
            $scope.dataList = $scope.dataList.concat(res.data.data)
            $scope.dataList.forEach(element => {
              element.avatar = 'img/no-avatar.jpg';
              multimediaService.getImageList(element.tenterprise_userid, 'tenterprise_users')
              .then(function(rr){
                if (rr.data.code == 1 && rr.data.data.length > 0) {
                  element.avatar = rr.data.data[rr.data.data.length - 1].url;
                }
              })
              gerenService.queryUserMsg(element.tenterprise_userid).then(query => {
                if (query.data.code === 1 && query.data.data.length > 0) {
                  element.userName = query.data.data[0].fname
                  if (userService.getUserId() == element.tenterprise_userid)
                    element.userName = element.userName + '（我）'
                }
              })
            });
            $scope.pageTotal = res.data.pageTotal;
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.showLoading();
			$scope.doRefresh = function () {
        $scope.pageNumber = 1;
        $scope.dataList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      
      $scope.pcVersionURL = "https://www.cnd3b.com/dsb/1"
      $scope.showPCURL = () => {
        let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">更多精彩功能请前往电脑端</span></div>',
					subTitle: `<div><span class="popup-content">地址：${$scope.pcVersionURL}</span></div>`,
          scope: $scope,
					buttons: [
						{
              text: '知道了',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '复制',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            if (cordova && cordova.plugins.clipboard)
              cordova.plugins.clipboard.copy($scope.pcVersionURL,
                function () {
                  $scope.showToast({title: "链接已复制到剪贴板"})
                }, function () {
              });
            $scope.closePopover();
          }
        });
      }

      $(function() {
        $('ion-nav-bar.nav-bar-container')[0].style.display = 'none';
      })
		});
})();

