(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('JiedaiBianjiController', function($scope, $state, ionicMaterialInk, $ionicPopup, jiedaiService) {

      const receiptId = $state.params.receiptid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.showLoading();

      var originData = {};
      var fieldArray = {
        'fname': '客户姓名',
        'fphonenumber': '手机号码',
        'fchannel': '来源渠道',
        'fcommunity': '小区名称',
        'fnumber': '幢/单元/室',
        'frenovationplandate': '计划装修时间',
        'fdate': '接待日期',
        'fnotes': '接待情况',
      }
      jiedaiService.queryReceptionMain(receiptId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          $scope.data.frenovationplandate = $scope.data.frenovationplandate ? $scope.data.frenovationplandate.substring(0, 10) : '';
          $scope.data.fdate = $scope.data.fdate ? $scope.data.fdate.substring(0, 10) : '';
          $scope.data.fphonenumber = $scope.data.fphonenumber ? Number($scope.data.fphonenumber) : null;
          originData = Object.assign({}, $scope.data)
          new Rolldate({
            el: '#frenovationplandate',
            format: 'YYYY-MM-DD',
            value: $scope.data.frenovationplandate,
            confirm: function(date) {
              $scope.data.frenovationplandate = date;
              $scope.$apply($scope.data);
            },
          });

          new Rolldate({
            el: '#fdate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fdate,
            confirm: function(date) {
              $scope.data.fdate = date;
              $scope.$apply($scope.data);
            },
          });
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      jiedaiService.querySelectChannel()
      .then(function(res){
        $scope.channels = res.data;
      },
      function(err){
      });

      jiedaiService.querySelectStore()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.stores = res.data.data;
        } else {
          
        }
      },
      function(err){
      });

      jiedaiService.querySelectCustomerAction()
      .then(function(res){
        $scope.customerActions = res.data;
      },
      function(err){
      });

      $scope.selectedActions = new Array();

      $scope.changeAction = (selected, action) => {
        // selected = !selected;
        if (selected) {
          const index = $scope.selectedActions.indexOf(action);
          if (index == -1) {
            $scope.selectedActions.push(action);
          }
        } else {
          const index = $scope.selectedActions.indexOf(action);
          if (index > -1) {
            $scope.selectedActions.splice(index, 1);
          }
        }
      }

      $scope.modify = function() {
        if (!checkPhone($scope.data.fphonenumber)){
          $scope.showToast({title: '手机号码有误，请重填'});
          return;
        }

        $scope.data.fcustaction = $scope.selectedActions.join('|');

        var modified = ""
        for (var key in fieldArray) {
          if (originData[key] != $scope.data[key])
            modified += "," + fieldArray[key]
        }
        if (modified.substring(0, 1) == ",")
          modified = modified.substring(1)
        $scope.data.datalog = [
          {
              "ftype": "修改",
              "flog": "修改内容：" + modified, // TODO 修改内容
          }
        ],
        $scope.showLoading();

        jiedaiService.receptionInsertOrModify(receiptId, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showChannelSelectPanel = function() {
        $scope.selectModel = $scope.channels;
        $scope.selectKeyField = "";
        $scope.selectValueField = "";
        $scope.selectModelName = "fchannel";
        $scope.selected = $scope.data.fchannel;

        $scope.showSelectPanel();
      }

		});
})();

