(function(){

	"use strict";
	angular.module('starter.services')

	.service('jiedaiService', function (apiService, userService) {
		let self = this;

    // 接待记录列表查询
		self.queryReceptionList = function(fromdb, pageNumber, pageSize, sortDirection, condition, periodStart, periodEnd) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.receptioninput.receptioninput",
					"method": "query_receptionList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {

						},
						"sort":"t1.changedate" + (sortDirection == ascending ? '' : ' desc'),
					}
				}
      };
      if (condition) request.data.content.where.condition = condition;
      if (periodStart) {
        request.data.content.where.begdate = periodStart.getFullYear()
          + '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodStart.getDate()).slice(-2);
      }
      if (periodEnd) {
        request.data.content.where.enddate = periodEnd.getFullYear()
          + '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodEnd.getDate()).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 接待记录主界面查询
    self.queryReceptionMain = function(customerReceiptId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.receptioninput.receptioninput",
					"method": "query_receptionMain",
					"content": {
						"userid": userService.getUserId(),
						"tcustomer_receptid": customerReceiptId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 接待记录新增，修改(customerReceiptId=0:新增)
    self.receptionInsertOrModify = function(customerReceiptId, data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.receptioninput.receptioninput",
					"method": "receptionInsertOrModify",
					"content": {
            "userid": userService.getUserId(), //用户登陆时选择的唯一账号id，必填项
            "tcustomer_receptid": customerReceiptId, //接待记录唯一ID，如果是新增记录，则该值直接赋值为“0”.如果当前记录为修改，则为查询时获取到的接待记录唯一ID
            "fname": data.fname, //客户姓名
            "fphonenumber": data.fphonenumber, //客户联系方式，手机号
            "fchannel": data.fchannel, //来源渠道
            "fcommunity": data.fcommunity, //小区
						"fnumber": data.fnumber, //幢单元室
						"frenovationplandate": data.frenovationplandate ? data.frenovationplandate : '',
            // "frenovationplandate": (!data.frenovationplandate) ? '' : data.frenovationplandate.getFullYear()
            //     + '-' + ("0" + (data.frenovationplandate.getMonth() + 1)).slice(-2)
            //     + '-' + ("0" + data.frenovationplandate.getDate()).slice(-2) + " 00:00:00.0", //计划装修日期
						"tstoreid": data.tstoreid, //门店ID
						"fdate": data.fdate ? data.fdate + ' 00:00:00.0' : '',
            // "fdate": data.fdate.getFullYear()
            //     + '-' + ("0" + (data.fdate.getMonth() + 1)).slice(-2)
            //     + '-' + ("0" + data.fdate.getDate()).slice(-2) + " 00:00:00.0", //接待日期
            "freception_address": data.freception_address, //接待地点：卖场、外勤
            "fcustaction": data.fcustaction, //客户动作
            "fnotes": data.fnotes, //接待记录
						"datalog": data.datalog
						// [ //修改记录，非必填项，可以为空
            //   {
            //     "ftype": "修改", // TODO 修改类型
            //     "flog": "修改字段及内容" // TODO 修改内容
            //   }
            // ]
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 接待记录删除
    self.queryReceptionDelete = function(customerReceiptId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.receptioninput.receptioninput",
					"method": "receptionDelete",
					"content": {
            "userid": userService.getUserId(),
            "tcustomer_receptid": customerReceiptId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 来源渠道选择
    self.querySelectChannel = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.receptioninput.receptioninput",
					"method": "selectChannel",
					"content": {
						"getdatafromdbanyway": false,
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 接待门店选择
    self.querySelectStore = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.receptioninput.receptioninput",
					"method": "selectStore",
					"content": {
						"getdatafromdbanyway": false,
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 销售动作选择
    self.querySelectCustomerAction = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.receptioninput.receptioninput",
					"method": "selectCustaction",
					"content": {
						"getdatafromdbanyway": false,
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
		};
		
		// 手机号查询客户档案
		self.queryCustomerByPhoneNumber = function(phone) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.receptioninput.receptioninput",
					"method": "queryCustomerByPhoneNumber",
					"content": {
						"getdatafromdbanyway": false,
						"userid": userService.getUserId(),
						"fphonenumber": phone
					}
				}
      };

			return apiService.makeRequest(request);
		};

	})

})();
