(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('JiedaiXinzengController', function($scope, $state, ionicMaterialInk, $ionicPopup, jiedaiService) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        fphonenumber: '',
        fname: '',
        fchannel: '',
        fcommunity: '',
        fnumber: '',
        frenovationplandate: null,
        freception_address: '卖场',
        fdate: null,
        tstoreid: '',
        fcustaction: '',
        fnotes: '',
      };

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
      
      $scope.showLoading();

      jiedaiService.querySelectChannel()
      .then(function(res){
        $scope.channels = res.data;
      },
      function(err){
      });

      jiedaiService.querySelectStore()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.stores = res.data.data;
        } else {
          
        }
      },
      function(err){
      });

      jiedaiService.querySelectCustomerAction()
      .then(function(res){
        $scope.customerActions = res.data;
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      $scope.selectedActions = new Array();

      $scope.changeAction = (selected, action) => {
        // selected = !selected;
        if (selected) {
          const index = $scope.selectedActions.indexOf(action);
          if (index == -1) {
            $scope.selectedActions.push(action);
          }
        } else {
          const index = $scope.selectedActions.indexOf(action);
          if (index > -1) {
            $scope.selectedActions.splice(index, 1);
          }
        }
      }

      $scope.register = function() {
        if (!checkPhone($('#AsyncData').val())){
          $scope.showToast({title: '手机号码有误，请重填'});
          return;
        }

        $scope.data.fphonenumber = $('#AsyncData').val();

        $scope.data.fcustaction = $scope.selectedActions.join('|');
        $scope.data.datalog = [
          {
              "ftype": "新增",
              "flog": "新增记录",
          }
        ]
        $scope.showLoading();

				jiedaiService.receptionInsertOrModify(0, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.getDataFromPhone = function(phone) {
        if (!phone || phone.toString().length < 7) {
          $scope.$root.$broadcast($scope.autocompleteInputAsync.ID);
          return;
        }

        jiedaiService.queryCustomerByPhoneNumber(phone)
        .then(function(res){
            $scope.autocompleteInputAsync.searchlist = res.data.data;
            $scope.$root.$broadcast($scope.autocompleteInputAsync.ID);
        }, function () {
            $scope.autocompleteInputAsync.searchlist = undefined;
            $scope.$root.$broadcast($scope.autocompleteInputAsync.ID);
        });
      }

      $scope.setModelAsync = function (item) {
        if (item.fname && item.fphonenumber){
          $scope.data.fname = item.fname;
          $scope.data.fcommunity = item.fcommunity;
          $scope.data.fnumber = item.fnumber;
          $scope.data.frenovationplandate = item.frenovationplandate;
          $scope.data.fbirthdate = item.fbirthdate;
          $scope.data.fwechatno = item.fwechatno;
          $scope.data.fchannel = item.fchannel;
          $scope.data.freceptiontimes = item.freceptiontimes;
          $('#AsyncData').val(item.fphonenumber)
        }
      };

      $scope.autocompleteInputAsync = {
          'propNameToDisplay': 'fphonenumber',
          'isAsyncSearch': true,
          'ID':'AsyncData',
          'placeholder': '点击填写',
          'listClass': ['list-border-energized'],
          'labelContainerClass': ['item item-input', 'info-table-line-text', 'no-border'],
          'textBoxClass': ['text-right', 'ng-pristine', 'ng-untouched', 'ng-empty', 'ng-invalid', 'ng-invalid-required']
      };

      $scope.autocompleteInputAsync.itemSelectCallback = $scope.setModelAsync;
      $scope.autocompleteInputAsync.asyncHttpCall = $scope.getDataFromPhone;

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showChannelSelectPanel = function() {
        $scope.selectModel = $scope.channels;
        $scope.selectKeyField = "";
        $scope.selectValueField = "";
        $scope.selectModelName = "fchannel";
        $scope.selected = $scope.data.fchannel;

        $scope.showSelectPanel();
      }

      $scope.showStoreSelectPanel = function() {
        $scope.selectModel = $scope.stores;
        $scope.selectKeyField = "tstoreid";
        $scope.selectValueField = "fstorename";
        $scope.selectModelName = "tstoreid";
        $scope.selected = $scope.data.tstoreid;

        $scope.showSelectPanel();
      }

      new Rolldate({
        el: '#frenovationplandate',
        format: 'YYYY-MM-DD',
        value: $scope.data.frenovationplandate,
        confirm: function(date) {
          $scope.data.frenovationplandate = date;
          $scope.$apply($scope.data);
        },
      });

      new Rolldate({
        el: '#fdate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fdate,
        confirm: function(date) {
          $scope.data.fdate = date;
          $scope.$apply($scope.data);
        },
      });

		});
})();

