(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('JingyingFenxiXitongShouyeController', function($rootScope, $scope, $location, $anchorScroll, $ionicPopup, userService, fenxiService, qiyeShujuService, $timeout) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.scrollTo = function(target){
        $location.hash(target); // set the location hash
        $anchorScroll();
      };

      $scope.selectTab = function(idx){
        $scope.navIndex = idx;
        $scope.$broadcast('scroll.refreshComplete');
      }

      $scope.showLoading();

      let chartArray = []
      $scope.$on('$destroy', function() {
        chartArray.forEach(chart => {
          chart.clear()
          if (!chart.destroyed)
            chart.destroy()
        })
      });

      setTimeout(function() {
        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCostNameOfMonth()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            $scope.tips1 = res.data.tips;
            var data = [];

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.famount != 0) {
                sum += v.famount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart1 = true;
            }
            let chart = new G2.Chart({
              container: 'jingyingfenxixitong-shouye-chart-1',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('famount', {
              formatter: function(val){
                val = '￥' + parseFloat(val.toFixed(2));
                return val;
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });

            chart
              .interval()
              .adjust('stack')
              .position('famount')
              .color('fcostname')
              .label('famount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fcostname}\n￥${parseFloat(obj.famount.toFixed(2))}\n${parseFloat((obj.famount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-active');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }
        },
        function(err) {
          $scope.hideChart1 = true;
        });

        $scope.hideChart2 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCostAndOrdersOfMonth()
        .then(function(res) {
        if (res.data.code === 1 && res.data.data.length == 0) {
          $scope.hideChart2 = true;
        } else if (res.data.code === 1 && res.data.data.length > 0) {
          $scope.tips2 = res.data.tips;
          const data = res.data.data;
          const chart = new G2.Chart({
            container: 'jingyingfenxixitong-shouye-chart-2',
            autoFit: true,
            height: 300,
          });

          chartArray.push(chart)
          chart.data(data);
          chart.scale({
            fmonth: {
              formatter: function(val) {
                if (val.length >= 2) {
                  return Number(val.slice(-2)) + '月';
                } else {
                  return val;
                }
              }
            },
            famount: {
              range: [0, 0.9],
              nice: true,
              formatter: function(val){
                if (Math.abs(val) >= 1000) {
                  val = parseFloat((val / 1000).toFixed(2)) + 'K';
                }
                return '￥' + val;
              },
            },
          });

          chart.tooltip({
            showTitle: false,
          });

          chart.line().position('fmonth*famount')
          .label('famount', function(val){
            if (Math.abs(val) >= 1000) {
              val = parseFloat((val / 1000).toFixed(2)) + 'K';
            } else {
              val = parseFloat(val.toFixed(2));
            }
            return {content: '￥' + val}
          })
          .tooltip('fmonth*famount', function(fmonth, famount) {
            if (Math.abs(famount) >= 1000) {
              famount = parseFloat((famount / 1000).toFixed(2)) + 'K';
            } else {
              famount = parseFloat(famount.toFixed(2));
            }
            return {
              name: fmonth + ' 月度盈亏', value: '￥' + famount
            }
          });
          chart.point().position('fmonth*famount')
          .tooltip('fmonth*famount', function(fmonth, famount) {
            if (Math.abs(famount) >= 1000) {
              famount = parseFloat((famount / 1000).toFixed(2)) + 'K';
            } else {
              famount = parseFloat(famount.toFixed(2));
            }
            return {
              name: fmonth + ' 月度盈亏', value: '￥' + famount
            }
          });

          chart.render();
        } else {
          
          $scope.hideChart2 = true;
        }

        $scope.hideLoading();
      },
      function(err) {
        $scope.hideChart2 = true;
        $scope.hideLoading();
      });
      }, 500);

      $scope.setFavButtonInvisible = () => {
        $timeout.cancel($scope.timer);
        $scope.timer = $timeout(function() {
          $scope.show1 = false;
          $scope.show2 = false;
        }, 1500);
      }

      $('.shuju-topmenu-panel').css('height', '63px');
      $('ion-content.jingyingfenxixitong').css("top", "107px");

      $scope.showTip1 = false;
      $scope.showTip2 = false;

      $scope.toggleTip1 = function() {
        $scope.showTip1 = !$scope.showTip1;
      }

      $scope.toggleTip2 = function() {
        $scope.showTip2 = !$scope.showTip2;
      }

    });
})();

