(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('YueduYingkuiFenxiController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      const chart = new G2.Chart({
        container: 'jingyingfenxixitong-yueduyingkuifenxi-chart',
        autoFit: true,
        height: 300,
      });
      $scope.$on('$destroy', function() {
        chart.clear()
        if (!chart.destroyed)
          chart.destroy()
      });
      
      $scope.loadData = () => {
        $scope.showLoading();

        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date(new Date().getFullYear(), 0, 1));
          $scope.setFenxiPeriodEnd(new Date(new Date().getFullYear() + 1, 0, 0));
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年');
        }

        // Draw charts
        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCostAndOrdersOfMonth($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
            $scope.tips = ''
          } else if (res.data.code === 1) {
            const data = res.data.data;
            $scope.tips = isRangeDate($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd) ? res.data.tips : '';

            chart.data(data);
            chart.scale({
              fmonth: {
                formatter: function(val) {
                  if (val.length >= 2) {
                    return Number(val.slice(-2)) + '月';
                  } else {
                    return val;
                  }
                }
              },
              famount: {
                range: [0, 0.9],
                nice: true,
                formatter: function(val){
                  if (Math.abs(val) >= 1000) {
                    val = parseFloat((val / 1000).toFixed(2)) + 'K';
                  }
                  return '￥' + val;
                },
              },
            });

            chart.tooltip({
              showTitle: false,
            });

            chart.line().position('fmonth*famount')
            .label('famount', function(val){
              if (Math.abs(val) >= 1000) {
                val = parseFloat((val / 1000).toFixed(2)) + 'K';
              } else {
                val = parseFloat(val.toFixed(2));
              }
              return {content: '￥' + val}
            })
            .tooltip('fmonth*famount', function(fmonth, famount) {
              if (Math.abs(famount) >= 1000) {
                famount = parseFloat((famount / 1000).toFixed(2)) + 'K';
              } else {
                famount = parseFloat(famount.toFixed(2));
              }
              return {
                name: fmonth + ' 月度盈亏', value: '￥' + famount
              }
            });
            chart.point().position('fmonth*famount')
            .tooltip('fmonth*famount', function(fmonth, famount) {
              if (Math.abs(famount) >= 1000) {
                famount = parseFloat((famount / 1000).toFixed(2)) + 'K';
              } else {
                famount = parseFloat(famount.toFixed(2));
              }
              return {
                name: fmonth + ' 月度盈亏', value: '￥' + famount
              }
            });

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart1 = true;
          $scope.hideLoading();
        });
      }

      $scope.loadData();

      $scope.$on('refresh', function(ev) {
        $scope.loadData();
      });

      $scope.itemOnLongPress = function() {
        $scope.downloadImage(chart);
      }

    });
})();

