/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('KechengLiebiaoController', function($scope, $rootScope, $ionicPopup, sucaiService, multimediaService)
  {
    $scope.dataList = [];
    $scope.hideTabBar();

    $scope.$on('$ionicView.beforeEnter', function (e,config) {
      config.enableBack = true;
    });

    $scope.pageNumber = 1;
    $scope.pageSize = 10;
    $scope.sortDirection = 'submitdate desc'; // 默认值为反序
    $scope.fromdb = true//$ionicHistory.forwardView() != null;
    
    $scope.fclass2List = [];
    
    $scope.reloadTabVariables = function() {
      $scope.fclass1 = localStorage.getItem('kechengliebiao.fclass1_' + $scope.tabIndex);
      $scope.fclass2 = localStorage.getItem('kechengliebiao.fclass2_' + $scope.tabIndex);
    }

    $scope.reloadTabVariables();
    
    $scope.$on('$destroy', function() {
      $scope.clearKeyword()
    });

    $scope.loadData = () => {
      sucaiService.queryArchivesList(
        $scope.fromdb,
        $scope.pageNumber, // pageNumber
        $scope.pageSize, // pageSize
        $scope.sortDirection, // sort
        $scope.fmycollection, // fmycollection
        $scope.fmyarchives, // fmyarchives
        $scope.keyword, // keyword
        $scope.fclass1, // fclass1
        $scope.fclass2, // fclass2
        '_sc'
      )
      .then(function(res){
        if (res.data.code === 1) {
          $scope.dataList = $scope.dataList.concat(res.data.data);
          res.data.data.forEach(item => {
            multimediaService.getImageList(item.tarchives_scid, 'tarchives_sc')
            .then(function(imgs) {
              for (let i in imgs.data.data) {
                if (imgs.data.data[i].ftype == 'cover') {
                  item.show_url = imgs.data.data[i].show_url ? imgs.data.data[i].show_url : 'img/' + $scope.getImageName(imgs.data.data[i].postfix.toLowerCase().substr(0, 3)) + '.png';
                }
              }
            })
          })
          $scope.pageTotal = res.data.pageTotal;
        } else{
          
        }
        $scope.refreshComplete();
      },
      function(err){
        $scope.refreshComplete();
      });
    }

    $scope.showLoading();

    // 素材类型选择
    sucaiService.getArchivesClass("_sc")
    .then(function(res){
      if (res.data.code === 1) {
        $scope.archivesClassList = res.data.data;

        if ($scope.fclass1 == '') {
          $scope.fclass2List = [];
        } else {
          $scope.archivesClassList.forEach(function(c) {
            if (c.fclass1 == $scope.fclass1)
              $scope.fclass2List = c.fclass2;
          });
        }
      } else{
        //$ionicPopup.alert({
        //  title: res.data.msg
        //});
      }
    },
    function(err){
    });

    $scope.doRefresh = function () {
      $scope.pageNumber = 1;
      $scope.dataList = [];
      $scope.loadData();
    };
    // $scope.doRefresh();

    $scope.loadMore = function() {
      $scope.pageNumber += 1;
      $scope.loadData();
    }

    // get keywords
    $scope.keywords = $scope.loadKeywords();

    $scope.changeSortDirection = () => {
      var border = $(".back").outerWidth()-$(".back").innerWidth();
        if ($(".front").position().left > 1){
            $(".front").css("left",0);
            $(".mark-on").css("color", "#db0e2c");
            $(".mark-off").css("color", "#999");
            $scope.sortDirection = 'submitdate desc';
          } else {
            $(".front").css("left",($(".back").outerWidth()-$(".front").outerWidth()) + "px");
            $(".mark-off").css("color", "#db0e2c");
            $(".mark-on").css("color", "#999");
            $scope.sortDirection = 'fvisitors desc';
        }
      $scope.doRefresh();
    };

    $scope.$on('refresh', function(ev) {
      $scope.doRefresh();
    });

    $scope.setShowFilter(false);
    $scope.setShowSearchBar(false);
    $scope.initFenxiPeriod();

    $scope.showSucaiku = function() {
      $scope.tabIndex = 0;
      localStorage.setItem('kechengliebiao.tabindex', $scope.tabIndex);

      $scope.fmyarchives = 0;
      $scope.fmycollection = 0;

      var fclass1 = localStorage.getItem('kechengliebiao.fclass1_' + $scope.tabIndex);
      var fclass2 = localStorage.getItem('kechengliebiao.fclass2_' + $scope.tabIndex);
      $scope.setfclass1(fclass1);
      $scope.setfclass2(fclass2);

      $scope.showLoading();
      $scope.doRefresh();
    }

    $scope.showWodeSucai = function() {
      $scope.showToast({title: '暂未开放'})
      // $scope.tabIndex = 1;
      // localStorage.setItem('kechengliebiao.tabindex', $scope.tabIndex);

      // $scope.fmyarchives = 1;
      // $scope.fmycollection = 0;

      // $scope.showLoading();
      // $scope.doRefresh();
    }

    $scope.archivesClassList = []
    $scope.setfclass1 = function(v) {
      $scope.fclass1 = v;
      localStorage.setItem('kechengliebiao.fclass1_' + $scope.tabIndex, v);
      $scope.fclass2 = '';
      localStorage.setItem('kechengliebiao.fclass2_' + $scope.tabIndex, '');
      if (v == '') {
        $scope.fclass2List = [];
      } else {
        $scope.archivesClassList.forEach(function(c) {
          if (c.fclass1 == v)
            $scope.fclass2List = c.fclass2;
        });
      }
    }

    $scope.setfclass2 = function(v) {
      $scope.fclass2 = v;
      localStorage.setItem('kechengliebiao.fclass2_' + $scope.tabIndex, v);
      // $scope.doRefresh();
    }

    $scope.tabIndex = localStorage.getItem('kechengliebiao.tabindex');
    switch(Number($scope.tabIndex)) {
      case 1:
        $scope.showWodeSucai()
        break;
      default:
        $scope.tabIndex = 0;
        $scope.showSucaiku()
        break;
    }

    $scope.confirmDelete = () => {
      $ionicPopup.show({
        title: '<div class="table-line"><span class="popup-title">删除确认</span></div>',
        subTitle: '<div><span class="popup-content">确认要删除该素材：' + $scope.selectedSucaiTitle + '？</span></div>',
        scope: $scope,
        buttons: [
          {
            text: '取消',
            type: 'button-left',
            onTap: function(e) {
              return 0;
            }
          },
          {
            text: '确认',
            type: 'button-right background-red',
            onTap: function(e) {
              return 1;
            }
          },
        ]
      })
      .then(function(res) {
        if (res == 1) {
          sucaiService.archiveDelete($scope.selectedArchivesId)
          .then(function(res){
            if (res.data.code === 1) {
              $scope.showToast({title: '删除成功！'});
            } else{
             //$ionicPopup.alert({
             //   title: res.data.msg
             // });
            }
          },
          function(err){
          });
          $scope.hideControlPanel();
        }
      });
    }

    $scope.isShowControlPanel = false;

    $scope.showControlPanel = function(archivesId) {
      $scope.selectedArchivesId = archivesId;
      $scope.dataList.forEach(function(data) {
        if (data.tarchives_adid == archivesId) {
          $scope.selectedSucaiTitle = data.ftitle;
        }
      });

      $scope.isShowControlPanel = true;
      document.querySelector('.rolldate-panel.fadeIn').style.setProperty('height', '150px');
    }

    $scope.hideControlPanel = function() {
      $scope.isShowControlPanel = false;
    }

    document.querySelector('.tabs-striped .tabs').style.setProperty('border', 'none');
    document.querySelector('.tabs-striped .tabs').style.setProperty('box-shadow', 'unset');

    $scope.showFilter = false
    $scope.toggleShowFilter = () => {
      $scope.showFilter = !$scope.showFilter
    }
  })
})();
