/* global angular, document, window, LANG */
(function(){
	"use strict";

	angular.module('starter.controllers')
		.controller('LoginController', function($scope, ionicMaterialInk, userService, $stateParams, $state, $ionicHistory) {
			ionicMaterialInk.displayEffect();

			$scope.hideHeader();
			$scope.hideTabBar();
			$scope.type = Number($stateParams.type);
			
			$scope.changeUI = () => {
				$scope.type = $scope.type == 0 ? 1 : 0
			}

			let id = '', pwd = ''
			$scope.login = function() {
				switch ($scope.type) {
					case 0:
						if ($("#phonenumber").val() === undefined || $("#phonenumber").val() === '' || !checkPhone($("#phonenumber").val())) {
							$scope.showToast({
								title: "手机号码有误，请重填"
							});
							return;
						}
						if ($("#password").val() === undefined || $("#password").val() === '') {
							$scope.showToast({
								title: "请输入验证码！"
							});
							return;
						}
						id = $("#phonenumber").val()
						pwd = $("#password").val()
						break;
					case 1:
						if ($("#zhanghao").val() === undefined || $("#zhanghao").val() === '') {
							$scope.showToast({
								title: "请输入账号"
							});
							return;
						}
						if ($("#mima").val() === undefined || $("#mima").val() === '') {
							$scope.showToast({
								title: "请输入密码！"
							});
							return;
						}
						id = $("#zhanghao").val()
						pwd = $("#mima").val()
						break;
				}
				
				$scope.showLoading();
		
				userService.login(id, pwd, $scope.type)
				.then(
					function(res) {
						if (res.data.code === 1) {
							localStorage.setItem('fphonenumber', id)
							localStorage.setItem('password', CryptoJS.MD5(pwd).toString())
							localStorage.setItem('accounts', JSON.stringify(res.data.account_list))
							if (res.data.account_list.length == 1) {
								let nextView = res.data.account_list[0].fusertype == '推广人' ? 'app.promotehuodong' : 'app.dash'
								$scope.selectUser(res.data.account_list[0], nextView);
							} else if (res.data.account_list.length == 0) {
								$state.go('app.selectrole', {phone: id});
							} else {
								$state.go('app.selectuser');
							}
							$scope.hideLoading();
						} else 
							$scope.showToast({
								title: res.data.msg
							});
						setTimeout(function() {
							$scope.hideLoading();
						}, 1000);
					},
					function(err){
						setTimeout(function() {
							$scope.hideLoading();
						}, 1000);
				});
			};

			let isCounting = false
			let timer
			$scope.getPassword = function() {
				if (isCounting)
					return

				if (!checkPhone($("#phonenumber").val())){
					$scope.showToast({
						title: "手机号码有误，请重填"
					});
					return;
				}

				$scope.showLoading();
				userService.getPassword($("#phonenumber").val())
				.then(function(res){
					let tm = 60
					isCounting = true
					$(".yanzhengma-span").css('color', '#999')
					timer = setInterval(() => {
						tm--
						$(".yanzhengma-span")[0].innerText = tm + 's'
						if (tm < 1) {
							isCounting = false
							$(".yanzhengma-span").css('color', 'rgba(219,14,44,1)')
							$(".yanzhengma-span")[0].innerText = '获取验证码'
							clearInterval(timer)
						}
					}, 1000)
					
					$scope.showToast({
						title: res.data.msg
					});
					$scope.hideLoading();
				}, function(err){
					$scope.hideLoading();
				})
			}
			
      $scope.$on('$destroy', function() {
				clearInterval(timer)
      });

		});
})();
