/* global angular, document, window, LANG */
(function(){
	"use strict";

	angular.module('starter.controllers')
		.controller('SelectRoleController', function($scope, $ionicPopup, ionicMaterialInk, $ionicHistory, $state, gerenService) {
			ionicMaterialInk.displayEffect();
			$scope.showHeader();
			$scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = false;
      });
			let phone = $state.params.phone;
			$scope.accountList = JSON.parse(localStorage.getItem('accounts'));

			$scope.registerAgent = function() {
				$state.go('app.registeragent', {phone});
			};

			$scope.registerPromoter = function() {
				$ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">请输入邀请码</span></div>',
					template: `<div><input class="promotenumber" id="promotenumber"/></div>`,
					scope: $scope,
					buttons: [
						{
						  text: '暂不加入',
						  type: 'button-left',
						  onTap: function(e) {
						    return 0;
						  }
						},
						{
							text: '确定',
							type: 'button-right background-red',
							onTap: function(e) {
								return 1;
							}
						},
					]
				}).then(function(res) {
					if (res == 1) {
						let promoteNumber = $("#promotenumber").val()
						$scope.showLoading();
						gerenService.getUserMsgByShortCode(promoteNumber).then(res => {
							if (res.data.code === 1) {
								gerenService.registerPromoters({fname: '', fphonenumber: phone})
								.then(function(res){
									if (res.data.code === 1) {
										$scope.selectUser(res.data.account_list[0], 'app.edit-profile');
									} else {
										//$ionicPopup.alert({
										//	title: res.data.msg
										//});
									}
									$scope.hideLoading();
								},
								function(err){
									$scope.hideLoading();
								});
							} else {
								//$ionicPopup.alert({
								//	title: res.data.msg
								//});
								$scope.hideLoading();
							}
						},
						function(err){
							$scope.hideLoading();
						});
					} else {}
				});
			};

			$scope.confirmBack = () => {
				let backView = $ionicHistory.backView()
				if (backView && (backView.stateId == 'app.dash' || backView.stateName == 'app.dash')) {
					$scope.goBack()
					return
				}
				$ionicPopup.show({
					subTitle: '<div><span class="popup-content">是否退出登录？</span></div>',
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
						$scope.goBack();
          }
				});
			}

		});
})();
