(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('ShijianBianjiController', function($scope, $state, ionicMaterialInk, shijianService, $ionicPopup) {

      const saleEventId = $state.params.saleeventid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
      
      $scope.showLoading();

      var originData = {};
      var fieldArray = {
        'fsaleevent': '事件标题',
        'fbegdate': '执行日期',
        'fenddate': '完成日期',
      }

      shijianService.querySaleEventMain(saleEventId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          $scope.data.fbegdate = $scope.data.fbegdate ? $scope.data.fbegdate.substring(0, 10) : '';
          $scope.data.fenddate = $scope.data.fenddate ? $scope.data.fenddate.substring(0, 10) : '';
          originData = Object.assign({}, $scope.data)

          new Rolldate({
            el: '#fbegdate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fbegdate,
            confirm: function(date) {
              $scope.data.fbegdate = date;
              $scope.$apply($scope.data);
            },
          });

          new Rolldate({
            el: '#fenddate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fenddate,
            confirm: function(date) {
              $scope.data.fenddate = date;
              $scope.$apply($scope.data);
            },
          });
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      $scope.modify = function() {
        $scope.showLoading();
        var modified = ""
        for (var key in fieldArray) {
          if (originData[key] != $scope.data[key])
            modified += "," + fieldArray[key]
        }
        if (modified.substring(0, 1) == ",")
          modified = modified.substring(1)
        $scope.data.datalog = [
          {
              "ftype": "修改",
              "flog": "修改内容：" + modified, // TODO 修改内容
          }
        ],
        shijianService.querySaleEventInsertOrModify(saleEventId, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

		});
})();

