(function(){

	"use strict";
	angular.module('starter.services')

	.service('shijianService', function (apiService, userService) {
		let self = this;

    // 营销事件列表查询
		self.querySaleEventList = function(fromdb, pageNumber, pageSize, sortDirection, condition, periodStart, periodEnd) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.saleeventinput.saleeventinput",
					"method": "query_saleEventList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {

						},
						"sort":"t1.changedate" + (sortDirection == ascending ? '' : ' desc'),
					}
				}
      };
      if (condition) request.data.content.where.condition = condition;
      if (periodStart) {
        request.data.content.where.begdate = periodStart.getFullYear()
          + '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodStart.getDate()).slice(-2) + ' 00:00:00.0';
      }
      if (periodEnd) {
        request.data.content.where.enddate = periodEnd.getFullYear()
          + '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodEnd.getDate()).slice(-2) + ' 00:00:00.0';
      }

			return apiService.makeRequest(request);
    };

    // 营销事件主界面查询
    self.querySaleEventMain = function(saleEventId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.saleeventinput.saleeventinput",
					"method": "query_saleEventMain",
					"content": {
						"userid": userService.getUserId(),
						"tsaleeventid": saleEventId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 营销事件新增，修改(saleeventid=0:新增)
    self.querySaleEventInsertOrModify = function(saleEventId, data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.saleeventinput.saleeventinput",
					"method": "saleEventInsertOrModify",
					"content": {
            "userid": userService.getUserId(), //用户登陆时选择的唯一账号id，必填项
            "tsaleeventid": saleEventId,
						"fsaleevent": data.fsaleevent,
						"fbegdate": data.fbegdate ? data.fbegdate + ' 00:00:00.0' : '',
            // "fbegdate": data.fbegdate.getFullYear()
            //     + '-' + ("0" + (data.fbegdate.getMonth() + 1)).slice(-2)
						//     + '-' + ("0" + data.fbegdate.getDate()).slice(-2) + " 00:00:00.0",
						"fenddate": data.fenddate ? data.fenddate + ' 00:00:00.0' : '',
            // "fenddate": data.fenddate.getFullYear()
            //     + '-' + ("0" + (data.fenddate.getMonth() + 1)).slice(-2)
            //     + '-' + ("0" + data.fenddate.getDate()).slice(-2) + " 00:00:00.0",
						"datalog": data.datalog
						// [ //修改记录，非必填项，可以为空
            //   {
            //     "ftype": "修改", // TODO 修改类型
            //     "flog": "修改字段及内容" // TODO 修改内容
            //   }
            // ]
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 营销事件删除
    self.querySaleEventDelete = function(saleEventId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.saleeventinput.saleeventinput",
					"method": "saleEventDelete",
					"content": {
            "userid": userService.getUserId(),
            "tsaleeventid": saleEventId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

	})

})();
