/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('SucaiBianjiController', function($scope, $state, ionicMaterialInk, $ionicPopup, sucaiService, $ionicActionSheet, multimediaService) {

      const archivesId = $state.params.archivesid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.showLoading();

      sucaiService.queryArchivesMain(archivesId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          document.querySelector('#sucai-leixing-selector').value = $scope.data.fclass1 + '/' + $scope.data.fclass2;
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });
      
      // 素材类型选择
      sucaiService.getArchivesClass('_ad')
      .then(function(res){
        if (res.data.code === 1) {
          $scope.archivesClassList = res.data.data;
        } else{
          
        }

        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      function uploadImages(imageURI) {
        multimediaService.uploadPicture(imageURI, "default", archivesId, 'tarchives').then(res => {
          res = res.data//JSON.parse(res.response)
          if (res.code == 1){
            $scope.imageData = res.data;
          }
        }, err => {
          $scope.showToast({title: err})
        })
      }

      multimediaService.getImageList(archivesId, 'tarchives')
      .then(function(res) {
        $scope.imageData = res.data.data;
      })

      $scope.removeImageData = function(idx, item) {
        $scope.imageData.splice(idx, 1);
        multimediaService.removeImage(item);
      }

      $scope.openGallery = function(rowNum, idx) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            uploadImages(imageURI)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openCamera = function() {
        multimediaService.openCamera()
          .then(function (imageURI) {
            uploadImages(imageURI)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.actionSheet = function() {
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: [
						{text: '拍照'}, 
						{text: '从相册选择'},
            {text: '选择文件'}],
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera();                          
							break; 
							case 1: //从相册选择
                $scope.openGallery();                          
              break;
              case 2: //选择文件
                fileChooser.open(function(uri) {
                  let extIndex = uri.indexOf('com.android.externalstorage.documents/document/')
                  if (extIndex != -1) {
                    uri = 'file:///storage/' + decodeURIComponent(uri.replace('%3A', '%2F').substr(extIndex + 47))
                  }
                  window.FilePath.resolveNativePath(uri, finalPath => {
                    uploadImages(finalPath)
                  });
                }, function(e){
                });
                break;
							default:
												
							break;
						}
						return true;
					}
				});
      };

      $scope.modify = function() {
        $scope.showLoading();

        sucaiService.archivesInsertOrModify($scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }
      
      $scope.tijiao = function() {
        let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">提交确认</span></div>',
					subTitle: '<div><span class="popup-content">是否确认提交素材？</span></div>',
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
            sucaiService.archivesInsertOrModify($scope.data)
            .then(function(res){
              if (res.data.code === 1) {
                sucaiService.archivesSubmit(archivesId)
                .then(function(res){
                  if (res.data.code === 1) {
                    $scope.showToast({title: '提交成功！'});
                    $scope.goBack();
                  } else {
                    //$ionicPopup.alert({
                    //  title: res.data.msg
                    //});
                  }

                  $scope.hideLoading();
                },
                function(err){
                  $scope.hideLoading();
                });
              } else {
                //$ionicPopup.alert({
                //  title: res.data.msg
                //});
              }
            },
            function(err){
              $scope.hideLoading();
            });
          }
        });	
      }

      $scope.isShowSucaiLeixing = false;

      $scope.showSucaiLeixing = function() {
        let $html = '<div id="fclass1"><ul class="wheel-scroll">';
        let index = 0;
        let fclass1_index = -1;

        $scope.archivesClassList.forEach(function(v) {
          let active_class = '';
          if (v.fclass1 == $scope.data.fclass1) {
            fclass1_index = index;
            active_class = 'active';
          }
          $html += '<li class="wheel-item ' + active_class + '" data-index="' + index + '">' + v.fclass1 + '</li>';
          index++;
        });
        $html += '</ul></div>';
        $html += '<div id="fclass2"><ul class="wheel-scroll">';
        index = 0;
        $scope.archivesClassList[Math.max(fclass1_index, 0)].fclass2.forEach(function(v) {
          let active_class = '';
          if (v == $scope.data.fclass2) {
            active_class = 'active';
          }
          $html += '<li class="wheel-item ' + active_class + '" data-index="' + index + '">' + v + '</li>';
          index++;
        });
        $html += '</ul></div>';

        document.querySelector('.rolldate-wrapper').innerHTML = $html;

        $scope.fclass1_bscroll_min = new bscroll_min('#fclass1', {wheel: {selectedIndex: 0}});
        let active = document.querySelector('#fclass1 .active');
        if (active) {
          $scope.fclass1_bscroll_min.wheelTo(active.getAttribute('data-index'));
          $scope.fclass1_bscroll_min.refresh();
        }

        $scope.fclass1_bscroll_min.on('scrollEnd', function () {
          index = 0;
          $scope.archivesClassList.forEach(function(v) {
            if (index == $scope.fclass1_bscroll_min.getSelectedIndex()) {
              let li = '';
              v.fclass2.forEach(function(v2) {
                li += '<li class="wheel-item">' + v2 + '</li>';
              });
              document.querySelector('#fclass2 ul').innerHTML = li;
              $scope.fclass2_bscroll_min.refresh();
            }
            index++;
          });
        });

        $scope.fclass2_bscroll_min = new bscroll_min('#fclass2', {wheel: {selectedIndex: 0}});
        active = document.querySelector('#fclass2 .active');
        if (active) {
          $scope.fclass2_bscroll_min.wheelTo(active.getAttribute('data-index'));
          $scope.fclass2_bscroll_min.refresh();
        }

        document.querySelector('.rolldate-container .rolldate-panel').style.setProperty('height', '322px');

        $scope.isShowSucaiLeixing = true;
      }

      $scope.hideSucaiLeixing = function() {
        $scope.isShowSucaiLeixing = false;
        $scope.fclass1_bscroll_min.destroy();
        $scope.fclass2_bscroll_min.destroy();
      }

      $scope.selectSucaiLeixing = function() {
        $scope.data.fclass1 = document.querySelectorAll('#fclass1 li')[$scope.fclass1_bscroll_min.getSelectedIndex()].innerHTML;
        $scope.data.fclass2 = document.querySelectorAll('#fclass2 li')[$scope.fclass2_bscroll_min.getSelectedIndex()].innerHTML;

        document.querySelector('#sucai-leixing-selector').value = $scope.data.fclass1 + '/' + $scope.data.fclass2;
        $scope.hideSucaiLeixing();
      }

		});
})();

