/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('SucaiLiebiaoController', function($scope, $rootScope, $ionicPopup, sucaiService, multimediaService, userService, apiService)
  {
    $scope.dataList = [];
    $scope.hideTabBar();

    $scope.$on('$ionicView.beforeEnter', function (e,config) {
      config.enableBack = true;
    });

    $scope.pageNumber = 1;
    $scope.pageSize = 20;
    $scope.sortDirection = 'submitdate desc'; // 默认值为反序
    $scope.fromdb = true//$ionicHistory.forwardView() != null;
    
    $scope.fclass2List = [];
    
    $scope.reloadTabVariables = function() {
      $scope.fclass1 = localStorage.getItem('sucailiebiao.fclass1_' + $scope.tabIndex);
      $scope.fclass2 = localStorage.getItem('sucailiebiao.fclass2_' + $scope.tabIndex);
    }

    $scope.reloadTabVariables();
    
    $scope.$on('$destroy', function() {
      $scope.clearKeyword()
    });

    $scope.loadData = () => {
      sucaiService.queryArchivesList(
        $scope.fromdb,
        $scope.pageNumber, // pageNumber
        $scope.pageSize, // pageSize
        $scope.sortDirection, // sort
        $scope.fmycollection, // fmycollection
        $scope.fmyarchives, // fmyarchives
        $scope.keyword, // keyword
        $scope.fclass1, // fclass1
        $scope.fclass2, // fclass2
        '_ad'
      )
      .then(function(res){
        if (res.data.code === 1) {
          $scope.dataList = $scope.dataList.concat(res.data.data);
          res.data.data.forEach(item => {
            multimediaService.getImageList(item.tarchives_adid, 'tarchives_ad')
            .then(function(imgs) {
              if (imgs.data.data.length > 0) {
                item.show_url = imgs.data.data[0].show_url ? imgs.data.data[0].show_url : 'img/' + $scope.getImageName(imgs.data.data[0].postfix.toLowerCase().substr(0, 3)) + '.png';
                item.url = imgs.data.data[0].url
              }
            })
          })
          $scope.pageTotal = res.data.pageTotal;
        } else{
          
        }
        $scope.refreshComplete();
      },
      function(err){
        $scope.refreshComplete();
      });
    }

    $scope.showLoading();

    // 素材类型选择
    sucaiService.getArchivesClass("_ad")
    .then(function(res){
      if (res.data.code === 1) {
        $scope.archivesClassList = res.data.data;

        if ($scope.fclass1 == '') {
          $scope.fclass2List = [];
        } else {
          $scope.archivesClassList.forEach(function(c) {
            if (c.fclass1 == $scope.fclass1)
              $scope.fclass2List = c.fclass2;
          });
        }
      } else{
        $ionicPopup.alert({
          title: res.data.msg
        });
      }
    },
    function(err){
    });

    $scope.doRefresh = function () {
      $scope.pageNumber = 1;
      $scope.dataList = [];
      $scope.loadData();
    };
    // $scope.doRefresh();

    $scope.loadMore = function() {
      $scope.pageNumber += 1;
      $scope.loadData();
    }

    // get keywords
    $scope.keywords = $scope.loadKeywords();

    $scope.changeSortDirection = () => {
      
      var border = $(".back").outerWidth()-$(".back").innerWidth();
        if ($(".front").position().left > 1){
            $(".front").css("left",0);
            $(".mark-on").css("color", "#db0e2c");
            $(".mark-off").css("color", "#999");
            $scope.sortDirection = 'submitdate desc';
        } else {
            $(".front").css("left",($(".back").outerWidth()-$(".front").outerWidth()) + "px");
            $(".mark-off").css("color", "#db0e2c");
            $(".mark-on").css("color", "#999");
            $scope.sortDirection = 'fvisitors desc';
        }
      $scope.doRefresh();
    };

    $scope.$on('refresh', function(ev) {
      $scope.doRefresh();
    });


    $scope.showSucaiku = function() {
      $scope.tabIndex = 0;
      localStorage.setItem('sucailiebiao.tabindex', $scope.tabIndex);

      $scope.fmyarchives = 0;
      $scope.fmycollection = 0;

      var fclass1 = localStorage.getItem('sucailiebiao.fclass1_' + $scope.tabIndex);
      var fclass2 = localStorage.getItem('sucailiebiao.fclass2_' + $scope.tabIndex);
      $scope.setfclass1(fclass1);
      $scope.setfclass2(fclass2);

      $scope.showLoading();
      $scope.doRefresh();
    }

    $scope.showWodeSucai = function() {
      $scope.tabIndex = 1;
      localStorage.setItem('sucailiebiao.tabindex', $scope.tabIndex);

      $scope.fmyarchives = 1;
      $scope.fmycollection = 0;

      $scope.showLoading();
      $scope.doRefresh();
    }

    $scope.showLaxinqigndan = function() {
      $scope.tabIndex = 2;
      localStorage.setItem('sucailiebiao.tabindex', $scope.tabIndex);

      $scope.showLoading();
      
      $scope.laxinDataList = []
      sucaiService.shareStatistics(
        $scope.fromdb,
        1, // pageNumber
        100, // pageSize
        $scope.keyword, // keyword
        "changedate desc", // sort
        '_ad'
      )
      .then(function(res){
        if (res.data.code === 1) {
          $scope.laxinDataList = res.data.data
          setTimeout(() => {
            $scope.$apply($scope.laxinDataList)
          }, 100);
        } else{
        }
        $scope.refreshComplete();
      },
      function(err){
        $scope.refreshComplete();
      });
    }

    $scope.archivesClassList = []
    $scope.setfclass1 = function(v) {
      $scope.fclass1 = v;
      localStorage.setItem('sucailiebiao.fclass1_' + $scope.tabIndex, v);
      $scope.fclass2 = '';
      localStorage.setItem('sucailiebiao.fclass2_' + $scope.tabIndex, '');
      if (v == '') {
        $scope.fclass2List = [];
      } else {
        $scope.archivesClassList.forEach(function(c) {
          if (c.fclass1 == v)
            $scope.fclass2List = c.fclass2;
        });
      }
    }

    $scope.showFilter = false
    $scope.toggleShowFilter = () => {
      $scope.showFilter = !$scope.showFilter
    }

    $scope.setfclass2 = function(v) {
      $scope.fclass2 = v;
      localStorage.setItem('sucailiebiao.fclass2_' + $scope.tabIndex, v);
      // $scope.doRefresh();
    }

    $scope.tabIndex = localStorage.getItem('sucailiebiao.tabindex');
    switch(Number($scope.tabIndex)) {
      case 1:
        $scope.showWodeSucai()
        break;
      case 2:
        $scope.showLaxinqigndan()
        break;
      default:
        $scope.tabIndex = 0;
        $scope.showSucaiku()
        break;
    }

    document.querySelector('.tabs-striped .tabs').style.setProperty('border', 'none');
    document.querySelector('.tabs-striped .tabs').style.setProperty('box-shadow', 'unset');

    $scope.isShowSharing = false
    $scope.selectedSucai = null
      
    $scope.showSharing = function(item) {
      document.querySelector('.rolldate-container .rolldate-panel').style.setProperty('height', '33%');
      $scope.isShowSharing = true;
      $scope.selectedSucai = item
    }

    $scope.hideSharing = function() {
      $scope.isShowSharing = false;
    }

    $scope.selectShareType = function(type) {
      let version = isDevServer ? "test" : "product"
      let wxShareUrl = `https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx45f99fca9b087ae6&redirect_uri=${encodeURIComponent(`https://www.cnd3b.com/dsb/sucai.html?fchannel=${type}&userid=${userService.getUserId()}&archivesid=${$scope.selectedSucai.tarchives_adid}&siteid=${userService.getSiteId()}&version=${version}`)}&response_type=code&scope=snsapi_userinfo&state=123&connect_redirect=1#wechat_redirect`
      $scope.showLoading()
      setTimeout(() => {
        $scope.hideLoading()
      }, 3000);

      switch (type) {
        case '微信好友':
        case '微信群聊':
          Wechat.share({
            message:{
              title: $scope.selectedSucai.ftitle == null ? "" : $scope.selectedSucai.ftitle,
              description: $scope.selectedSucai.fnotes == null ? "" : $scope.selectedSucai.fnotes,
              thumb: $scope.selectedSucai.show_url == null ? "" : $scope.selectedSucai.show_url,
              media: {
                type: Wechat.Type.WEBPAGE,
                webpageUrl: wxShareUrl
              }
            },
            scene: Wechat.Scene.SESSION  
          }, function () {
            sucaiService.archiveShare($scope.selectedSucai.tarchives_adid, type, '_ad')
            $scope.hideSharing();
          }, function (reason) {
            $scope.hideSharing();
          });
          break;
        case '微信朋友圈':
          Wechat.share({
            message:{
              title: $scope.selectedSucai.ftitle == null ? "" : $scope.selectedSucai.ftitle,
              description: $scope.selectedSucai.fnotes == null ? "" : $scope.selectedSucai.fnotes,
              thumb: $scope.selectedSucai.show_url == null ? "" : $scope.selectedSucai.show_url,
              media: {
                type: Wechat.Type.WEBPAGE,
                webpageUrl: wxShareUrl
              }
            },
            scene: Wechat.Scene.TIMELINE  
          }, function () {
            sucaiService.archiveShare($scope.selectedSucai.tarchives_adid, type, '_ad')
            $scope.hideSharing();
          }, function (reason) {
            $scope.hideSharing();
          });
          break;
        case 'weibo':
          WeiboSDK.ssoLogin(function (ssolArg) {

            var args = {};
            args.url = `https://www.cnd3b.com/dsb/sucai.html?userid=${userService.getUserId()}&archivesid=${$scope.selectedSucai.tarchives_adid}&siteid=${userService.getSiteId()}&version=${version}`
            // args.url = `https://api.weibo.com/oauth2/authorize?client_id=570804165&response_type=code&redirect_uri=https://www.baidu.com`
            args.title = $scope.selectedSucai.ftitle == null ? "" : $scope.selectedSucai.ftitle
            args.description = $scope.selectedSucai.fnotes == null ? "" : $scope.selectedSucai.fnotes
            args.image = $scope.selectedSucai.url == null ? "" : $scope.selectedSucai.show_url
            WeiboSDK.shareToWeibo(function () {
              sucaiService.archiveShare($scope.selectedSucai.tarchives_adid, type, '_ad')
            }, function (failReason) {
              $scope.showToast({title: failReason})
            }, args);

            // alert(ssolArg.userId)
            // alert(ssolArg.access_token)

            apiService.getByUrl(`https://api.weibo.com/2/users/show.json?uid=${ssolArg.userId}&access_token=${ssolArg.access_token}`).then(res => {
              alert(res)
            })
          }, function (failReason) {
            $scope.showToast({title: failReason})
          });
          $scope.hideSharing();
          break;
        default:
          $scope.hideSharing();
          break;
      }
    }
  })
})();
