(function(){

	"use strict";
	angular.module('starter.services')

	.service('sucaiService', function (apiService, userService) {
		let self = this;


		// 素材库列表查询(fmycollection: 我的收藏, fmyarchives: 我的素材)
		self.queryArchivesList = function(fromdb, pageNumber, pageSize, sortDirection, fmycollection, fmyarchives, condition, fclass1, fclass2, postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "query_archivesList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {

						},
						// "sort":"t1.submitdate" + (sortDirection == ascending ? '' : ' desc'),
						"sort":"t1." + sortDirection
					}
				}
			};
			if (condition != undefined && condition != 'null' && condition != '') request.data.content.where.condition = condition;
			if (fclass1 != undefined && fclass1 != 'null' && fclass1 != '') request.data.content.where.fclass1 = fclass1;
			if (fclass2 != undefined && fclass2 != 'null' && fclass2 != '') request.data.content.where.fclass2 = fclass2;
			if (fmycollection != undefined && fmycollection != 'null' && fmycollection != '') request.data.content.where.fmycollection = 1;
			if (fmyarchives != undefined && fmyarchives != 'null' && fmyarchives != '') request.data.content.where.fmyarchives = 1;

			return apiService.makeRequest(request);
		};

		// 素材主界面查询
		self.queryArchivesMain = function(archivesId, postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "query_archivesMain",
					"content": {
						"userid": userService.getUserId(),
					}
				}
			};
			request.data.content["tarchives" + postfix + 'id'] = archivesId

			return apiService.makeRequest(request);
		};

		// 素材收藏
		self.archivesCollection = function(archivesId, isCollection, postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "archivesCollection",
					"content": {
						"userid": userService.getUserId(),
						"iscollection": isCollection,
					}
				}
			};
			request.data.content["tarchives" + postfix + 'id'] = archivesId

			return apiService.makeRequest(request);
		};

		// 素材新增或修改
		self.archivesInsertOrModify = function(data, postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "archivesInsertOrModify",
					"content": {
				"userid": userService.getUserId(),
				"fclass1": data.fclass1,
				"fclass2": data.fclass2,
				"ftitle": data.ftitle,
				"fnotes": data.fnotes,
						tag: data.tag
					}
				}
			};
			request.data.content["tarchives" + postfix + 'id'] = data.tarchivesid

			return apiService.makeRequest(request);
		};

		// 素材提交
		self.archivesSubmit = function(archivesId, postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "archivesSubmit",
					"content": {
						"userid": userService.getUserId(),
					}
				}
	  	};
			request.data.content["tarchives" + postfix + 'id'] = archivesId

			return apiService.makeRequest(request);
		};

		// 素材类型选择
		self.getArchivesClass = function(postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "getArchivesClass",
					"content": {
						"userid": userService.getUserId(),
					}
				}
	  	};

			return apiService.makeRequest(request);
		};

		//素材删除
		self.archiveDelete = function(archivesId, postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "archiveDelete",
					"content": {
						"userid": userService.getUserId(),
					}
				}
			};
			request.data.content["tarchives" + postfix + 'id'] = archivesId

			return apiService.makeRequest(request);
		}
		
		//推广素材分享记录
		self.archiveShare = function(archivesId, channel, postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "archiveShare",
					"content": {
						"userid": userService.getUserId(),
						"fchannel": channel,
					}
				}
			};
			request.data.content["tarchives" + postfix + 'id'] = archivesId

			return apiService.makeRequest(request);
		}

		//推广素材系统标签查询
		self.queryTagList = function(postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "query_tagList",
					"content": {
						"userid": userService.getUserId(),
					}
				}
			};

			return apiService.makeRequest(request);
		}

		// 素材库列表查询(fmycollection: 我的收藏, fmyarchives: 我的素材)
		self.shareStatistics = function(fromdb, pageNumber, pageSize, condition, sortDirection, postfix = '') {
			let prefString = userService.getRole() == '企业' ? 'saler' : 'agent';
			let request = {
				url: API_URL_V1,
				data: {
					"classname": prefString + "client.mainpage.archives.archives" + postfix,
					"method": "shareStatistics_custlist",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {

						},
						// "sort":"t1.submitdate" + (sortDirection == ascending ? '' : ' desc'),
						"sort":"t1." + sortDirection
					}
				}
			};
			if (condition != undefined && condition != 'null' && condition != '') request.data.content.where.condition = condition;

			return apiService.makeRequest(request);
		};

	})
})();
