(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('SucaiXiangqingController', function($scope, $rootScope, $ionicPopup, $stateParams, sucaiService, multimediaService, userService) {
      $scope.archivesId = $stateParams.archivesid;

      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();
      $rootScope.isDownloading = -1

      $scope.loadData = () => {
        sucaiService.queryArchivesMain($scope.archivesId, '_ad')
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
            $scope.data.fmycollection = $scope.data.fmycollection ? Number($scope.data.fmycollection) : 0;
            // $scope.data = $scope.setDefaults($scope.data);
            if ($scope.data.fmycollection == '暂无') {
              $scope.data.fmycollection = 0;
            } else {
              $scope.data.fmycollection = 1;
            }
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.showLoading();

      $scope.loadData();

      $scope.avatar = 'img/no-avatar.jpg';
      multimediaService.getImageList(userService.getUserId(), 'tenterprise_users')
      .then(function(res){
        if (res.data.code == 1 && res.data.data.length > 0) {
          $scope.avatar = res.data.data[res.data.data.length - 1].url;
        }
      })
      
      multimediaService.getImageList($scope.archivesId, 'tarchives_ad')
      .then(function(res) {
        $scope.imageData = res.data.data;
      })

      $scope.isShowSharing = false
      
      $scope.showSucaiLeixing = function() {
        document.querySelector('.rolldate-container .rolldate-panel').style.setProperty('height', '33%');
        $scope.isShowSharing = true;
      }

      $scope.hideSucaiLeixing = function() {
        $scope.isShowSharing = false;
      }

      $scope.selectSucaiLeixing = function(type) {
        let version = isDevServer ? "test" : "product"
        let wxShareUrl = `https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx45f99fca9b087ae6&redirect_uri=${encodeURIComponent(`https://www.cnd3b.com/dsb/sucai.html?fchannel=${type}&userid=${userService.getUserId()}&archivesid=${$scope.archivesId}&siteid=${userService.getSiteId()}&version=${version}`)}&response_type=code&scope=snsapi_userinfo&state=123&connect_redirect=1#wechat_redirect`
        $scope.showLoading()
        setTimeout(() => {
          $scope.hideLoading()
        }, 3000);
        switch (type) {
          case '微信好友':
          case '微信群聊':
            Wechat.share({
              message:{
                title: $scope.data.ftitle == null ? "" : $scope.data.ftitle,
                description: $scope.data.fnotes == null ? "" : $scope.data.fnotes,
                thumb: $scope.imageData[0].show_url == null ? "" : $scope.imageData[0].show_url,
                media: {
                  type: Wechat.Type.WEBPAGE,
                  webpageUrl: wxShareUrl
                }
              },
              scene: Wechat.Scene.SESSION  
            }, function () {
              sucaiService.archiveShare($scope.archivesId, type, '_ad')
              $scope.hideSucaiLeixing();
            }, function (reason) {
              $scope.hideSucaiLeixing();
            });
          break;
          case '微信朋友圈':
            Wechat.share({
              message:{
                title: $scope.data.ftitle == null ? "" : $scope.data.ftitle,
                description: $scope.data.fnotes == null ? "" : $scope.data.fnotes,
                thumb: $scope.imageData[0].show_url == null ? "" : $scope.imageData[0].show_url,
                media: {
                  type: Wechat.Type.WEBPAGE,
                  webpageUrl: wxShareUrl
                }
              },
              scene: Wechat.Scene.TIMELINE  
            }, function () {
              sucaiService.archiveShare($scope.archivesId, type, '_ad')
              $scope.hideSucaiLeixing();
            }, function (reason) {
              $scope.hideSucaiLeixing();
            });
            break;
          case 'weibo':
            WeiboSDK.ssoLogin(function (ssolArg) {
              var args = {};
              args.url = `https://www.cnd3b.com/dsb/sucai.html?userid=${userService.getUserId()}&archivesid=${$scope.archivesId}&siteid=${userService.getSiteId()}&version=${version}`
              // args.url = `https://api.weibo.com/oauth2/authorize?client_id=570804165&response_type=code&redirect_uri=https://www.cnd3b.com`
              args.title = $scope.data.ftitle == null ? "" : $scope.data.ftitle
              args.description = $scope.data.fnotes == null ? "" : $scope.data.fnotes
              args.image = $scope.imageData[0].show_url == null ? "" : $scope.imageData[0].show_url
              WeiboSDK.shareToWeibo(function () {
                sucaiService.archiveShare($scope.archivesId, type, '_ad')
              }, function (failReason) {
                // alert(failReason);
              }, args);
            }, function (failReason) {
              // alert(failReason);
            });
            $scope.hideSucaiLeixing();
            break;
          default:
            $scope.hideSucaiLeixing();
            break;
        }
      }

		});
})();

