/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('SucaiXinzengController', function($scope, $state, ionicMaterialInk, sucaiService, $ionicPopup, $ionicActionSheet, multimediaService, userService) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.hideTabBar();
      $scope.archivesId = 0;
      
      $scope.data = {
        tarchivesid: 0,
        fclass1: '',
        fclass2: '',
        ftitle: '',
        fnotes: '',
      };

      $scope.showLoading();

      // 素材类型选择
      sucaiService.getArchivesClass('_ad')
      .then(function(res){
        if (res.data.code === 1) {
          $scope.archivesClassList = res.data.data;
        } else {
          
        }

        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });
  
      $scope.isShowSucaiLeixing = false;

      $scope.showSucaiLeixing = function() {
        let $html = '<div id="fclass1"><ul class="wheel-scroll">';
        let index = 0;
        let fclass1_index = -1;

        $scope.archivesClassList.forEach(function(v) {
          let active_class = '';
          if (v.fclass1 == $scope.data.fclass1) {
            fclass1_index = index;
            active_class = 'active';
          }
          $html += '<li class="wheel-item ' + active_class + '" data-index="' + index + '">' + v.fclass1 + '</li>';
          index++;
        });
        $html += '</ul></div>';
        $html += '<div id="fclass2"><ul class="wheel-scroll">';
        index = 0;
        $scope.archivesClassList[Math.max(fclass1_index, 0)].fclass2.forEach(function(v) {
          let active_class = '';
          if (v == $scope.data.fclass2) {
            active_class = 'active';
          }
          $html += '<li class="wheel-item ' + active_class + '" data-index="' + index + '">' + v + '</li>';
          index++;
        });
        $html += '</ul></div>';
        
        document.querySelector('.rolldate-wrapper').innerHTML = $html;

        $scope.fclass1_bscroll_min = new bscroll_min('#fclass1', {wheel: {selectedIndex: 0}});
        let active = document.querySelector('#fclass1 .active');
        if (active) {
          $scope.fclass1_bscroll_min.wheelTo(active.getAttribute('data-index'));
          $scope.fclass1_bscroll_min.refresh();
        }

        $scope.fclass1_bscroll_min.on('scrollEnd', function () {
          index = 0;
          $scope.archivesClassList.forEach(function(v) {
            if (index == $scope.fclass1_bscroll_min.getSelectedIndex()) {
              let li = '';
              v.fclass2.forEach(function(v2) {
                li += '<li class="wheel-item">' + v2 + '</li>';
              });
              document.querySelector('#fclass2 ul').innerHTML = li;
              $scope.fclass2_bscroll_min.refresh();
            }
            index++;
          });
        });

        $scope.fclass2_bscroll_min = new bscroll_min('#fclass2', {wheel: {selectedIndex: 0}});
        active = document.querySelector('#fclass2 .active');
        if (active) {
          $scope.fclass2_bscroll_min.wheelTo(active.getAttribute('data-index'));
          $scope.fclass2_bscroll_min.refresh();
        }

        document.querySelector('.rolldate-container .rolldate-panel').style.setProperty('height', '322px');

        $scope.isShowSucaiLeixing = true;
      }

      sucaiService.queryTagList('_ad').then(res => {
        if (res.data.code === 1) {
          $scope.tagsList = res.data.data
          $scope.tagsList.forEach(elem => elem['selected'] = false)
        }
      })

      $scope.hideSucaiLeixing = function() {
        $scope.isShowSucaiLeixing = false;
        $scope.fclass1_bscroll_min.destroy();
        $scope.fclass2_bscroll_min.destroy();
      }

      $scope.selectSucaiLeixing = function() {
        $scope.data.fclass1 = document.querySelectorAll('#fclass1 li')[$scope.fclass1_bscroll_min.getSelectedIndex()].innerHTML;
        $scope.data.fclass2 = document.querySelectorAll('#fclass2 li')[$scope.fclass2_bscroll_min.getSelectedIndex()].innerHTML;

        document.querySelector('#sucai-leixing-selector').value = $scope.data.fclass1 + '/' + $scope.data.fclass2;
        $scope.hideSucaiLeixing();
      }

      $scope.imageData = [];
      function uploadImages(tarchivesid) {
        $scope.imageData.forEach(element => {
          multimediaService.uploadPicture(element.url, "default", tarchivesid, 'tarchives_ad')
          .then(
            res => {},
            err => {
              $scope.showToast({title: err})
          })
        });
      }

      function pushImage(uri) {
        var fdocument = uri.substr(uri.lastIndexOf('/')+1)
        fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
        let postfix = fdocument.substring(fdocument.lastIndexOf('.') + 1)
        if (!$scope.isPicture(postfix) && !$scope.isMovie(postfix)) {
          $scope.showToast({title: '只能上传视频或图片!'})
          return
        }
        
        $scope.imageData.push({
          url: uri, 
          show_url: uri, 
          postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
          fdocument: fdocument,
          createby: userService.getUserName(),
          createdate: getDateString(new Date())
        });
        setTimeout(() => {
          $scope.$apply();
        }, 100);
      }

      $scope.removeImageData = function(idx) {
        $scope.imageData.splice(idx, 1)
      }

      $scope.openGallery = function(rowNum, idx) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            pushImage(imageURI)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openCamera = function() {
        multimediaService.openCamera()
          .then(function (imageURI) {
            pushImage(imageURI)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.actionSheet = function(isShoujifangfa = false) {
        var buttons = [
          {
            text: '拍照'
          }, 
          {
            text: '从相册选择'
          }]
          // buttons.push({text: '选择文件'})
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: buttons,
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera();
							break; 
							case 1: //从相册选择
                $scope.openGallery();
							break;
							case 2: //选择文件
                fileChooser.open(function(uri) {
                  let extIndex = uri.indexOf('com.android.externalstorage.documents/document/')
                  if (extIndex != -1) {
                    uri = 'file:///storage/' + decodeURIComponent(uri.replace('%3A', '%2F').substr(extIndex + 47))
                  }
                  window.FilePath.resolveNativePath(uri, finalPath => {
                    pushImage(finalPath)
                  });
                }, function(e){
                });
							break;
							default:
												
							break;
						}
						return true;
					}
				});
      };

      $scope.tijiao = function() {
        if (!$scope.data.ftitle) {
          $scope.showToast({title: '请输入素材标题！'})
          return
        }
        if (!$scope.data.fclass1 || !$scope.data.fclass2) {
          $scope.showToast({title: '请选择素材分类！'})
          return
        }
        // if (!$scope.data.tag || $scope.data.tag.length == 0) {
        //   $scope.showToast({title: '请选择标签！'})
        //   return
        // }
        if ($scope.imageData.length == 0) {
          $scope.showToast({title: '请上传附件！'})
          return
        }
        
        let myPopup = $ionicPopup.show({
					title: '<div class="table-line"><span class="popup-title">发布确认</span></div>',
					subTitle: '<div><span class="popup-content">是否确认发布素材？</span></div>',
          scope: $scope,
					buttons: [
						{
              text: '取消',
              type: 'button-left',
              onTap: function(e) {
                return 0;
              }
						},
						{
							text: '确认',
							type: 'button-right background-red',
							onTap: function(e) {
                return 1;
							}
						},
					]
        })
        .then(function(res) {
          if (res == 1) {
            $scope.showLoading();
            sucaiService.archivesInsertOrModify($scope.data, '_ad')
            .then(function(res){
              if (res.data.code === 1) {
                uploadImages(res.data.data[0].tarchives_adid)
                $scope.archivesId = res.data.data[0].tarchives_adid
                sucaiService.archivesSubmit($scope.archivesId, '_ad')
                .then(function(res){
                  if (res.data.code === 1) {
                    $scope.showToast({title: '发布成功！'});
                    // $scope.goBack();
                    $state.go('app.sucailiebiao');
                  } else {
                    //$ionicPopup.alert({
                    //  title: res.data.msg
                    //});
                  }

                  $scope.hideLoading();
                },
                function(err){
                  $scope.hideLoading();
                });
              } else {
                //$ionicPopup.alert({
                //  title: res.data.msg
                //});
              }
            },
            function(err){
              $scope.hideLoading();
            });
          }
        });			
      }

      $scope.isShowTags = false
      
      $scope.showTags = function() {
        $('#tagSelector').css('height', '200px');
        $scope.isShowTags = true;
      }

      $scope.hideTags = function() {
        $scope.isShowTags = false;
      }

      $scope.data.tag = []
      $scope.selectTag = function(tag) {
        tag.selected = !tag.selected

        $scope.data.tag = []

        for (let i in $scope.tagsList) {
          if ($scope.tagsList[i].selected)
            $scope.data.tag.push($scope.tagsList[i].flable)
        }

        $("#sucai-tag-selector").val($scope.data.tag.join(', '))
      }

		});
})();

