(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('TibaoTianxieController', function($scope, $rootScope, $stateParams, multimediaService, $ionicPopup, $ionicActionSheet, tibaoService, userService) {
      $scope.showHeader();
			$scope.hideTabBar();
      $rootScope.isDownloading = -1

			$scope.data = [];

      const tibaoId = $stateParams.tibaoid;
      const type = $stateParams.type;
      let tsubmiteditid = ''
      $scope.webFujian = []
      $scope.mobileFujian = []

      $scope.loadData = () => {
        if (type == 0) {
          tibaoService.querySubmiteditModelMain(
            tibaoId,
          )
          .then(function(res){
            // console.log(res);
            if (res.data.code === 1) {
              $scope.data = res.data.data[0];
              tsubmiteditid = $scope.data.tsubmiteditid
              multimediaService.getImageList(tsubmiteditid, 'tsubmitedit').then(res => {
                $scope.mobileFujian = res.data.data
              });
            } else{
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
            $scope.refreshComplete();
          },
          function(err){
            $scope.refreshComplete();
          });
        } else {
          tibaoService.querySubSubmiteditModelMain(
            tibaoId,
          )
          .then(function(res){
            // console.log(res);
            if (res.data.code === 1) {
              $scope.data = res.data.data[0];
              // tsubmiteditid = $scope.data.tsubmiteditid
              // multimediaService.getImageList(tsubmiteditid, 'tsubsubmitedit').then(res => {
              //   $scope.fujianList = res.data.data;
              //   console.log($scope.fujianList);
              // });
            } else{
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
            $scope.refreshComplete();
          },
          function(err){
            $scope.refreshComplete();
          });
        }

        multimediaService.getImageList(tibaoId, 'tsubmiteditmodel').then(res => {
          $scope.webFujian = res.data.data
        });
      }

      $scope.showLoading();
      $scope.loadData();

      $scope.removeImageData = (idx) => {
        multimediaService.removeImage($scope.mobileFujian[idx])
        $scope.mobileFujian.splice(idx, 1)
      }

      $scope.actionSheet = function() {
        var buttons = [
          {
            text: '拍照'
          }, 
          {
            text: '从相册选择'
          }, 
          {
            text: '选择文件'
          }]
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: buttons,
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
              case 0: // 拍照
                multimediaService.openCamera()
                .then(function (imageURI) {
                  var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
                  fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                  $scope.mobileFujian.push({
                    url: imageURI,
                    show_url: imageURI,
                    postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                    fdocument: fdocument,
                    createby: userService.getUserName(),
                    createdate: getDateString(new Date()),
                    tattachmentid: 0,
                  })
                  multimediaService.uploadPicture(imageURI, "default", tsubmiteditid, 'tsubmitedit').then(res => {
                    $scope.hideLoading()
                    // $scope.fujianList = res.data.data
                  },err => {
                    $scope.showToast({title: err})
                    $scope.hideLoading()
                  })            
                }, function (err) {
                  $scope.showToast({title: '没有选择照片！'})
                });
							break; 
              case 1: //从相册选择
                multimediaService.getImageFromGallery()
                .then(function (imageURI) {
                  var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
                  fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                  $scope.mobileFujian.push({
                    url: imageURI,
                    show_url: imageURI,
                    postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                    fdocument: fdocument,
                    createby: userService.getUserName(),
                    createdate: getDateString(new Date())
                  })
                  multimediaService.uploadPicture(imageURI, "default", tsubmiteditid, 'tsubmitedit').then(res => {
                    $scope.hideLoading()
                    // $scope.fujianList = res.data.data
                  },err => {
                    $scope.showToast({title: err})
                    $scope.hideLoading()
                  })
                }, function (err) {
                  $scope.showToast({title: '没有选择照片！'})
                });
							break;
              case 2: //选择文件
                fileChooser.open(function(url) {
                  let extIndex = url.indexOf('com.android.externalstorage.documents/document/')
                  if (extIndex != -1) {
                    url = 'file:///storage/' + decodeURIComponent(url.replace('%3A', '%2F').substr(extIndex + 47))
                  }
                  window.FilePath.resolveNativePath(url, finalPath => {
                    var fdocument = finalPath.substr(finalPath.lastIndexOf('/')+1)
                    fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                    $scope.mobileFujian.push({
                      url: finalPath,
                      show_url: finalPath,
                      postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                      fdocument: fdocument,
                      createby: userService.getUserName(),
                      createdate: getDateString(new Date())
                    })
                    multimediaService.uploadPicture(finalPath, "default", tsubmiteditid, 'tsubmitedit').then(res => {
                      $scope.hideLoading()
                      // $scope.fujianList = res.data.data
                    },err => {
                      $scope.showToast({title: err})
                      $scope.hideLoading()
                    })
                  });
                });
							break;
							default:
												
							break;
						}
						return true;
					}
				});
      };

			$scope.saveEdit = function () {
        if (Number($scope.data.fistextrequired) == 1 && !$scope.data.fcontent) {
          $scope.showToast({title: "请输入提报内容！"})
          return;
        }
        if (Number($scope.data.fisattrequired) == 1 && $scope.mobileFujian.length == 0) {
          $scope.showToast({title: "请上传附件！"})
          return;
        }
        $scope.showLoading();

				tibaoService.querySaveedit(tibaoId, $scope.data.fcontent)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.submitEdit = function () {
        if (Number($scope.data.fistextrequired) == 1 && !$scope.data.fcontent) {
          $scope.showToast({title: "请输入提报内容！"})
          return;
        }
        if (Number($scope.data.fisattrequired) == 1 && $scope.mobileFujian.length == 0) {
          $scope.showToast({title: "请上传附件！"})
          return;
        }
        $scope.showLoading();

				tibaoService.querySubmitedit(tibaoId, $scope.data.fcontent)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '提交成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

		});
})();

