(function(){

	"use strict";
	angular.module('starter.services')

	.service('tonggaoService', function (apiService, userService) {
		let self = this;

    // 公告列表查询
    self.queryNoticeList = function(pageNumber, pageSize, condition) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.notice.notice" : "salerclient.mainpage.notice.notice",
					"method": "query_noticeList",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"pageNumber": pageNumber,
            "pageSize": pageSize,
            "where": {
						},
					}
				}
			};

			if (condition) {
				request.data.content.where.condition = condition;
			}

			return apiService.makeRequest(request);
    };

    // 公告主界面查询
    self.queryNoticeMain = function(noticeId) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.notice.notice" : "salerclient.mainpage.notice.notice",
					"method": "query_noticeMain",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
						"tnoticeid": noticeId,
					}
				}
			};

			return apiService.makeRequest(request);
    };

    // 公告评分留言
    self.queryNoticeReturnMessage = function(noticeId, leaveMessage, score) {
      var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.notice.notice" : "salerclient.mainpage.notice.notice",
					"method": "notice_returnMessage",
					"content": {
            "getdatafromdbanyway": true,
						"userid": userService.getUserId(),
            "tnoticeid": noticeId,
            "fleavemessage": leaveMessage,
            "fscore": score
					}
				}
			};

			return apiService.makeRequest(request);
		};
		
		// 公告主界面退出
		self.queryNoticeExit = function(noticeId) {
			var role = userService.getRole();
			let request = {
				url: API_URL_V1,
				data: {
          "classname": role=='经销商' ? "agentclient.mainpage.notice.notice" : "salerclient.mainpage.notice.notice",
					"method": "noticeexit",
					"content": {
						"userid": userService.getUserId(),
            "tnoticeid": noticeId,
					}
				}
			};

			return apiService.makeRequest(request);
		}

	})

})();
