(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('TonggaoXiangqingController', function($scope, $rootScope, $stateParams, $sce, $ionicPopup, tonggaoService, multimediaService) {
      $scope.showHeader();
      $scope.hideTabBar();
      $rootScope.isDownloading = -1

      const tonggaoId = $stateParams.tonggaoid;
      const reviewText = ['非常不满意', '不满意', '一般', '满意', '非常满意'];

      $scope.$on('$destroy', function() {
        tonggaoService.queryNoticeExit(tonggaoId);
      });

      $scope.reviewStars = 0;
      $scope.reviewStarsBack = 0;
      $scope.setReviewStarsTemp = function (v) {
        if ($scope.reviewStarsFromServer > 0) return;
        
        if (v == 0) {
          $scope.reviewStars = $scope.reviewStarsBack;
          $scope.reviewString = $scope.reviewStringBack;
        } else {
          $scope.reviewStars = v;
          $scope.reviewString = reviewText[$scope.reviewStars - 1];
        }
      }

      $scope.setReviewStars = function (v) {
        if ($scope.reviewStarsFromServer > 0) return;
        $scope.reviewStars = v;
        $scope.reviewString = reviewText[$scope.reviewStars - 1];

        $scope.reviewStarsBack = v;
        $scope.reviewStringBack = reviewText[$scope.reviewStars - 1];
      }

      $scope.commitReview = function () {
        if ($scope.reviewStarsBack == 0) {
          $scope.showToast({title: '请先给出您的评价！'});
          return;
        }
        $scope.showLoading();

				tonggaoService.queryNoticeReturnMessage(tonggaoId, $scope.data.fleavemessage, $scope.reviewStarsBack * 20)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.reviewStarsFromServer = $scope.reviewStarsBack;
            // $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.setReviewStarsTemp(0);
      $scope.reviewString = '';
      $scope.reviewStringBack = '';

      $scope.loadData = () => {
        tonggaoService.queryNoticeMain(
          tonggaoId,
        )
        .then(function(res){
          if (res.data.code === 1) {
            $scope.data = res.data.data[0];
            $scope.data.fcontent =  $sce.trustAsHtml($scope.data.fcontent)
            // console.log($scope.data);
            $scope.reviewStarsFromServer = $scope.data.fscore / 20;
            $scope.reviewStars = $scope.reviewStarsFromServer;
            $scope.reviewStarsBack = $scope.reviewStars;
            $scope.reviewString = reviewText[$scope.reviewStars - 1];
          } else{
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err){
          $scope.refreshComplete();
        });
      }

      $scope.showLoading();
      $scope.loadData();

      $scope.fujianList = []
      $scope.videoList = []
      $scope.coverList = []
      multimediaService.getImageList(tonggaoId, 'tnotice').then(res => {
        for (let i = 0; i < res.data.data.length; i++) {
          switch (res.data.data[i].ftype) {
            case 'default':
              $scope.fujianList.push(res.data.data[i])
              break;
            case 'video':
              $scope.videoList.push(res.data.data[i])
              break;
            case 'cover':
              $scope.coverList.push(res.data.data[i])
              break;
          }
        }
      });

      $scope.preview = function(img, index = 0) {
        if ($scope.isPicture(img.postfix))
        {
          $scope.goToSlide(index, $scope.fujianList);
        } else if ($scope.isPDF(img.postfix)) {
          $scope.previewFile(img.url)
        } else if ($scope.isMovie(img.postfix)) {
          $scope.playVideo(img.url)
        }
      }

		});
})();

