(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('ConsultingController', function($scope, $state, multimediaService, $ionicActionSheet, $ionicPopup, gerenService, userService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
      
      $scope.tijiao = function(fmessage) {
        if (!$('#fmessage').val()){
          $scope.showToast({title: '请输入您的问题'})
          return
        }

        // if ($scope.fujianList.length == 0){
        //   $scope.showToast({title: '请上传附件'})
        //   return
        // }
        
        $scope.showLoading();
        gerenService.getCustomerserviceid().then(res => {
          if (res.data.code == 1)
          {
            gerenService.customerServiceSubmit(res.data.data, fmessage).then(rr => {
              if(rr.data.code == 1) {
                $scope.fmessage = ''
                $('#fmessage').val('')
                $scope.showToast({title: '您的反馈小多已经收到！我们将24小时内联系您！'})
                $scope.fujianList.forEach(element => {
                  multimediaService.uploadPicture(element.url, "default", res.data.data, 'tcustomerservice')
                  .then(
                    res => {},
                    err => {
                      $scope.showToast({title: err})
                  })
                });
              }
              $scope.hideLoading();
            })
          }
        })
      }

      $scope.fujianList = []
      $scope.actionSheet = function() {
        var buttons = [
          {
            text: '拍照'
          }, 
          {
            text: '从相册选择'
          }, 
          {
            text: '选择文件'
          }]
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: buttons,
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
              case 0: // 拍照
                multimediaService.openCamera()
                .then(function (imageURI) {
                  var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
                  fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                  $scope.fujianList.push({
                    url: imageURI,
                    show_url: imageURI,
                    postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                    fdocument: fdocument,
                    createby: userService.getUserName(),
                    createdate: getDateString(new Date())
                  })
                }, function (err) {
                  $scope.showToast({title: '没有选择照片！'})
                });
							break; 
              case 1: //从相册选择
                multimediaService.getImageFromGallery()
                .then(function (imageURI) {
                  var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
                  fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                  $scope.fujianList.push({
                    url: imageURI,
                    show_url: imageURI,
                    postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                    fdocument: fdocument,
                    createby: userService.getUserName(),
                    createdate: getDateString(new Date())
                  })
                }, function (err) {
                  $scope.showToast({title: '没有选择照片！'})
                });
							break;
              case 2: //选择文件
                fileChooser.open(function(url) {
                  let extIndex = url.indexOf('com.android.externalstorage.documents/document/')
                  if (extIndex != -1) {
                    url = 'file:///storage/' + decodeURIComponent(url.replace('%3A', '%2F').substr(extIndex + 47))
                  }
                  window.FilePath.resolveNativePath(url, finalPath => {
                    var fdocument = finalPath.substr(finalPath.lastIndexOf('/')+1)
                    fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                    $scope.fujianList.push({
                      url: finalPath,
                      show_url: finalPath,
                      postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                      fdocument: fdocument,
                      createby: userService.getUserName(),
                      createdate: getDateString(new Date())
                    })
                  });
                });
							break;
							default:
												
							break;
						}
						return true;
					}
				});
      };      
		});
})();

