(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('TousuController', function($scope, $state, multimediaService, $ionicActionSheet, $ionicPopup, tousuService, userService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.data = [];

      $scope.showLoading();
      $scope.tousuArea = [];
      tousuService.queryTypeList()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.tousuArea = res.data.data;
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      $scope.setTousuArea = function(v) {
        $scope.currArea = v;
      }

      $scope.commitComplaint = function() {
        // ng-disabled="tousu.$invalid || currArea==-1" 
        if ($scope.currArea == undefined){
          $scope.showToast({title: '请选择投诉版块'})
          return
        }
        if (!$scope.data.ftitle){
          $scope.showToast({title: '请输入标题'})
          return
        }
        if (!$scope.data.fcontent){
          $scope.showToast({title: '请输入内容文字'})
          return
        }
        
        $scope.showLoading();

				tousuService.insertComplaint($scope.tousuArea[$scope.currArea].ftype, $scope.data.ftitle, $scope.data.fcontent)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            if (res.data.data && res.data.data.length > 0 && res.data.data[0].tcomplaintid)
              $scope.uploadFile(res.data.data[0].tcomplaintid)
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.fujianList = []

      $scope.actionSheet = function() {
        var buttons = [
          {
            text: '拍照'
          }, 
          {
            text: '从相册选择'
          }, 
          {
            text: '选择文件'
          }]
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: buttons,
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
              case 0: // 拍照
                multimediaService.openCamera()
                .then(function (imageURI) {
                  var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
                  fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                  $scope.fujianList.push({
                    url: imageURI,
                    postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                    fdocument: fdocument,
                    createby: userService.getUserName(),
                    createdate: getDateString(new Date())
                  })
                }, function (err) {
                  $scope.showToast({title: '没有选择照片！'})
                });
							break; 
              case 1: //从相册选择
                multimediaService.getImageFromGallery()
                .then(function (imageURI) {
                  var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
                  fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                  $scope.fujianList.push({
                    url: imageURI,
                    postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                    fdocument: fdocument,
                    createby: userService.getUserName(),
                    createdate: getDateString(new Date())
                  })
                }, function (err) {
                  $scope.showToast({title: '没有选择照片！'})
                });
							break;
              case 2: //选择文件
                fileChooser.open(function(url) {
                  let extIndex = url.indexOf('com.android.externalstorage.documents/document/')
                  if (extIndex != -1) {
                    url = 'file:///storage/' + decodeURIComponent(url.replace('%3A', '%2F').substr(extIndex + 47))
                  }
                  window.FilePath.resolveNativePath(url, finalPath => {
                    var fdocument = finalPath.substr(finalPath.lastIndexOf('/')+1)
                    fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
                    $scope.fujianList.push({
                      url: finalPath,
                      postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
                      fdocument: fdocument,
                      createby: userService.getUserName(),
                      createdate: getDateString(new Date())
                    })
                  });
                });
							break;
							default:
												
							break;
						}
						return true;
					}
				});
      };

      $scope.uploadFile = tcomplaintid => {
        $scope.fujianList.forEach(element => {
          multimediaService.uploadPicture(element.url, "default", tcomplaintid, 'tcomplaint')
          .then(
            res => {},
            err => {
              $scope.showToast({title: err})
          })
        });
      }
      
		});
})();

