/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('XiaoshouBianjiController', function($scope, $state, ionicMaterialInk, $ionicPopup, xiaoshouService, shijianService) {

      const receiptId = $state.params.receiptid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.showLoading();

      var originData = {};
      var fieldArray = {
        'fname': '客户姓名',
        'fphonenumber': '手机号码',
        'fchannel': '来源渠道',
        'fcommunity': '小区名称',
        'fnumber': '幢/单元/室',
        'frenovationplandate': '计划装修时间',
        'fbirthdate': '生日',
        'fwechatno': '微信号',
        'fstorename': '销售门店',
        'fdate': '下单日期',
        'finstalldate': '安装日期',
        'fsaleevent': '营销事件',
        'fdepositamount': '定金',
        'freceivedamount': '已收尾款',
        'orderlist': '销售订单',
      }

      $scope.gotOrderMain = false;
      $scope.gotSaleEvent = false;

      xiaoshouService.queryOrderMain(receiptId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          $scope.data.frenovationplandate = $scope.data.frenovationplandate ? $scope.data.frenovationplandate.substring(0, 10) : '';
          $scope.data.fbirthdate = $scope.data.fbirthdate ? $scope.data.fbirthdate.substring(0, 10) : '';
          $scope.data.fdate = $scope.data.fdate ? $scope.data.fdate.substring(0, 10) : '';
          $scope.data.finstalldate = $scope.data.finstalldate ? $scope.data.finstalldate.substring(0, 10) : '';
          $scope.data.fphonenumber = $scope.data.fphonenumber ? Number($scope.data.fphonenumber) : null;
          $scope.data.freceivablesamount = Number($scope.data.freceivablesamount);
          $scope.data.freceivedamount = Number($scope.data.freceivedamount);
          $scope.data.forderamount = Number($scope.data.forderamount);
          $scope.data.fdepositamount = Number($scope.data.fdepositamount);
          $scope.data.orderlist.forEach((order) => {
            order.fqty = Number(order.fqty);
            order.famount = Number(order.famount);
            order.fprice = Number(order.fprice);
          });
          originData = Object.assign({}, $scope.data)

          $scope.gotOrderMain = true;

          if ($scope.gotOrderMain === true && $scope.gotSaleEvent === true) {
            $scope.eventSelectable = false;
            $scope.selectableEventList = [];
            if ($scope.eventList) {
              $scope.eventList.forEach(function(e) {
                if ($scope.data.fdate >= e.fbegdate && $scope.data.fdate <= e.fenddate) {
                  $scope.eventSelectable = true;
                  $scope.selectableEventList.push(e);
                }
              });
              if (!$scope.eventSelectable) {
                $scope.data.tsaleeventid = undefined;
                $scope.data.fsaleevent = '暂无可关联事件';
              } else {
                if (!$scope.data.tsaleeventid) {
                  $scope.data.fsaleevent = '';
                }
              }
            }
          }

          new Rolldate({
            el: '#frenovationplandate',
            format: 'YYYY-MM-DD',
            value: $scope.data.frenovationplandate,
            confirm: function(date) {
              $scope.data.frenovationplandate = date;
              $scope.$apply($scope.data);
            },
          });
          new Rolldate({
            el: '#fbirthdate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fbirthdate,
            confirm: function(date) {
              $scope.data.fbirthdate = date;
              $scope.$apply($scope.data);
            },
          });
          new Rolldate({
            el: '#fdate',
            format: 'YYYY-MM-DD',
            value: $scope.data.fdate,
            confirm: function(date) {
              $scope.data.fdate = date;

              $scope.eventSelectable = false;
              $scope.selectableEventList = [];
              $scope.eventList.forEach(function(e) {
                if (date >= e.fbegdate && date <= e.fenddate) {
                  $scope.eventSelectable = true;
                  $scope.selectableEventList.push(e);
                }
              });
              if (!$scope.eventSelectable) {
                $scope.data.tsaleeventid = undefined;
                $scope.data.fsaleevent = '暂无可关联事件';
              } else {
                if (!$scope.data.tsaleeventid) {
                  $scope.data.fsaleevent = '';
                }
              }
              $scope.$apply($scope.data);
              $scope.$apply($scope.eventSelectable);
              $scope.$apply($scope.selectableEventList);
            },
          });
          new Rolldate({
            el: '#finstalldate',
            format: 'YYYY-MM-DD',
            value: $scope.data.finstalldate,
            confirm: function(date) {
              $scope.data.finstalldate = date;
              $scope.$apply($scope.data);
            },
          });
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      xiaoshouService.querySelectChannel()
      .then(function(res){
        $scope.channels = res.data;
      },
      function(err){
      });

      xiaoshouService.querySelectStore()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.stores = res.data.data;
        } else {
          
        }
      },
      function(err){
      });

      xiaoshouService.querySelectSaleevent()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.events = res.data.data;
          $scope.eventList = [];
          $scope.events.forEach(function(v) {
            shijianService.querySaleEventMain(v.tsaleeventid)
            .then(function(r){
              if (r.data.code === 1) {
                $scope.eventList[v.tsaleeventid] = r.data.data[0];

                $scope.gotSaleEvent = true;

                if ($scope.gotOrderMain === true && $scope.gotSaleEvent === true) {
                  $scope.eventSelectable = false;
                  $scope.selectableEventList = [];
                  if ($scope.eventList) {
                    $scope.eventList.forEach(function(e) {
                      if ($scope.data.fdate >= e.fbegdate && $scope.data.fdate <= e.fenddate) {
                        $scope.eventSelectable = true;
                        $scope.selectableEventList.push(e);
                      }
                    });
                    if (!$scope.eventSelectable) {
                      $scope.data.tsaleeventid = undefined;
                      $scope.data.fsaleevent = '暂无可关联事件';
                    } else {
                      if (!$scope.data.tsaleeventid) {
                        $scope.data.fsaleevent = '';
                      }
                    }
                  }
                }
              }
            });
          })
        } else {
          
        }
      },
      function(err){
      });

      $scope.removeRow = function(i) {
        if ($scope.data.orderlist.length == 1) {
          return;
        }

        $scope.data.orderlist.splice(i, 1);
      }

      $scope.modify = function() {
        if (!checkPhone($scope.data.fphonenumber)){
          $scope.showToast({title: '手机号码有误，请重填'});
          return;
        }

        $scope.data.fsaleevent = $scope.data.tsaleeventid ? $scope.data.fsaleevent : '';
        $scope.data.freceivablesamount = $scope.data.forderamount - $scope.data.fdepositamount - $scope.data.freceivedamount
        $scope.showLoading();

        var modified = ""
        for (var key in fieldArray) {
          if (originData[key] != $scope.data[key])
            modified += "," + fieldArray[key]
        }
        if (modified.substring(0, 1) == ",")
          modified = modified.substring(1)
        $scope.data.datalog = [
          {
              "ftype": "修改",
              "flog": "修改内容：" + modified, // TODO 修改内容
          }
        ],
        xiaoshouService.queryOrderInsertOrModify(receiptId, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.getTotalCount = () => {
        if (!$scope.data) {
          return 0;
        }
        let totalCount = 0;
        $scope.data.orderlist.forEach(
          order => totalCount = totalCount + parseInt(order.fqty)
        );
        return totalCount;
      }

      $scope.getTotalAmount = () => {
        if (!$scope.data) {
          return 0;
        }
        let totalAmount = 0;
        $scope.data.orderlist.forEach(
          order => totalAmount = totalAmount + parseInt(order.fqty) * parseFloat(order.fprice)
        );
        return totalAmount;
      }

      $scope.eventSelectable = true;

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showChannelSelectPanel = function() {
        $scope.selectModel = $scope.channels;
        $scope.selectKeyField = "";
        $scope.selectValueField = "";
        $scope.selectModelName = "fchannel";
        $scope.selected = $scope.data.fchannel;

        $scope.showSelectPanel();
      }

      $scope.showStoreSelectPanel = function() {
        $scope.selectModel = $scope.stores;
        $scope.selectKeyField = "tstoreid";
        $scope.selectValueField = "fstorename";
        $scope.selectModelName = "tstoreid";
        $scope.selected = $scope.data.tstoreid;

        $scope.showSelectPanel();
      }

      $scope.showEventSelectPanel = function() {
        $scope.selectModel = $scope.selectableEventList;
        $scope.selectKeyField = "tsaleeventid";
        $scope.selectValueField = "fsaleevent";
        $scope.selectModelName = "tsaleeventid";
        $scope.selected = $scope.data.tsaleeventid;

        $scope.showSelectPanel();
      }

		});
})();

