(function(){

	"use strict";
	angular.module('starter.services')

	.service('xiaoshouService', function (apiService, userService) {
		let self = this;

    // 销售记录列表查询
    self.queryOrderList = function(fromdb, pageNumber, pageSize, sortDirection, condition, periodStart, periodEnd) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "query_orderList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {

						},
						"sort":"t1.changedate" + (sortDirection == ascending ? '' : ' desc'),
					}
				}
      };
      if (condition) request.data.content.where.condition = condition;
      if (periodStart) {
        request.data.content.where.begdate = periodStart.getFullYear()
          + '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodStart.getDate()).slice(-2);
      }
      if (periodEnd) {
        request.data.content.where.enddate = periodEnd.getFullYear()
          + '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodEnd.getDate()).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 销售记录主界面查询
    self.queryOrderMain = function(customerReceiptId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "query_orderMain",
					"content": {
						"userid": userService.getUserId(),
						"tcustomer_receptid": customerReceiptId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 销售记录新增，修改
    self.queryOrderInsertOrModify = function(customerReceiptId, data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "orderInsertOrModify",
					"content": {
            "userid": userService.getUserId(),//用户登陆时选择的唯一账号id，必填项
            "tcustomer_receptid": customerReceiptId,//销售记录唯一ID，如果是新增记录，则该值直接赋值为“0”.如果当前记录为修改，则为查询时获取到的销售记录唯一ID
            "fname": data.fname,//客户姓名
            "fphonenumber": data.fphonenumber,//客户联系方式，手机号
            "fchannel": data.fchannel,//来源渠道
            "fcommunity": data.fcommunity,//小区
            "fnumber": data.fnumber,//幢单元室
            "frenovationplandate": data.frenovationplandate + ' 00:00:00.0' ? data.frenovationplandate : '',
            // "frenovationplandate": (!data.frenovationplandate) ? '' : data.frenovationplandate.getFullYear()
            //     + '-' + ("0" + (data.frenovationplandate.getMonth() + 1)).slice(-2)
            //     + '-' + ("0" + data.frenovationplandate.getDate()).slice(-2) + " 00:00:00.0",//计划装修日期
            "fbirthdate": data.fbirthdate ? data.fbirthdate + ' 00:00:00.0' : '',
            // "fbirthdate": (!data.fbirthdate) ? '' : data.fbirthdate.getFullYear()
            //     + '-' + ("0" + (data.fbirthdate.getMonth() + 1)).slice(-2)
            //     + '-' + ("0" + data.fbirthdate.getDate()).slice(-2) + " 00:00:00.0",//客户生日
            "fwechatno": data.fwechatno,//客户微信号
            "tstoreid": data.tstoreid,//门店ID
            "fdate": data.fdate ? data.fdate + ' 00:00:00.0' : '',
            // "fdate": data.fdate.getFullYear()
            //     + '-' + ("0" + (data.fdate.getMonth() + 1)).slice(-2)
            //     + '-' + ("0" + data.fdate.getDate()).slice(-2) + " 00:00:00.0",//下单日期
            "finstalldate": data.finstalldate ? data.finstalldate + ' 00:00:00.0' : '',
            // "finstalldate": (!data.finstalldate) ? '' : data.finstalldate.getFullYear()
            //     + '-' + ("0" + (data.finstalldate.getMonth() + 1)).slice(-2)
            //     + '-' + ("0" + data.finstalldate.getDate()).slice(-2) + " 00:00:00.0",//安装日期
            "tsaleeventid": data.tsaleeventid ? data.tsaleeventid : '',// 营销事件ID
            "fsaleevent": data.fsaleevent,// 营销事件
            "forderamount": data.forderamount,// 订单金额
            "fdepositamount": data.fdepositamount,// 定金
            "freceivedamount": data.freceivedamount,// 已收尾款
            "freceivablesamount": data.freceivablesamount,// 应收款
            "datalog": data.datalog
						// [// TODO 修改记录，非必填项，可以为空
            //     {
            //         "ftype": "修改", // TODO 修改类型
            //         "flog": "修改字段及内容", // TODO 修改内容
            //     }
            // ],
					}
				}
      };

      request.data.content.orderlist = data.orderlist;
      request.data.content.orderlist.forEach((order) => {
        order.fqty = order.fqty.toString();
        order.famount = order.famount.toString();
        order.fprice = order.fprice.toString();
        order.tcustomer_orderid = (!order.tcustomer_orderid) ? '0' : order.tcustomer_orderid;
      });

			return apiService.makeRequest(request);
    };

    // 销售记录删除
    self.queryOrderDelete = function(customerReceiptId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "orderDelete",
					"content": {
            "userid": userService.getUserId(),
            "tcustomer_receptid": customerReceiptId,
					}
				}
      };

			return apiService.makeRequest(request);
		};
			
		// 销售退单
		self.queryOrderClose = function(customerReceiptId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "orderClose",
					"content": {
						"userid": userService.getUserId(),
						"tcustomer_receptid": customerReceiptId,
					}
				}
			};

			return apiService.makeRequest(request);
		};

    // 来源渠道选择
    self.querySelectChannel = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "selectChannel",
					"content": {
						"getdatafromdbanyway": false,
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 接待门店选择
    self.querySelectStore = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "selectStore",
					"content": {
						"getdatafromdbanyway": false,
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 营销事件选择
    self.querySelectSaleevent = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "selectSaleevent",
					"content": {
						"getdatafromdbanyway": false,
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

		// 手机号查询客户档案
		self.queryCustomerByPhoneNumber = function(phone) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "agentclient.mainpage.action.orderinput.orderinput",
					"method": "queryCustomerByPhoneNumber",
					"content": {
						"getdatafromdbanyway": false,
						"userid": userService.getUserId(),
						"fphonenumber": phone
					}
				}
      };

			return apiService.makeRequest(request);
    };
    
	})

})();
