/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('XiaoshouXinzengController', function($scope, $state, ionicMaterialInk, xiaoshouService, shijianService, $ionicPopup) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
      
      $scope.data = {
        fname: '',
        fphonenumber: '',
        fchannel: '',
        fcommunity: '',
        fnumber: '',
        frenovationplandate: null,
        fbirthdate: null,
        fwechatno: '',
        tstoreid: '',
        fdate: null,
        finstalldate: null,
        tsaleeventid: '',
        fsaleevent: '',
        forderamount: 0,
        fdepositamount: 0,
        freceivedamount: 0,
        freceivablesamount: 0,
        orderlist: [
          {
            tcustomer_orderid: '0',
            fprodname: '',
            fqty: '',
            fprice: '',
            famount: 0,
          }
        ],
      };

      $scope.showLoading();

      xiaoshouService.querySelectChannel()
      .then(function(res){
        $scope.channels = res.data;
      },
      function(err){
      });

      xiaoshouService.querySelectStore()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.stores = res.data.data;
        } else {
          
        }
      },
      function(err){
      });

      xiaoshouService.querySelectSaleevent()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.events = res.data.data;
          $scope.eventList = [];
          $scope.events.forEach(function(v) {
            shijianService.querySaleEventMain(v.tsaleeventid)
            .then(function(r){
              if (r.data.code === 1) {
                $scope.eventList[v.tsaleeventid] = r.data.data[0];
              }
            });
          })
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      $scope.removeRow = function(i) {
        if ($scope.data.orderlist.length == 1) {
          return;
        }

        $scope.data.orderlist.splice(i, 1);
      }

      $scope.register = function() {
        if (!checkPhone($('#AsyncData').val())){
          $scope.showToast({title: '手机号码有误，请重填'});
          return;
        }

        $scope.data.fphonenumber = $('#AsyncData').val();
        $scope.data.datalog = [
          {
              "ftype": "新增",
              "flog": "新增记录",
          }
        ];
        $scope.data.fsaleevent = $scope.data.tsaleeventid ? $scope.data.fsaleevent : '';
        $scope.data.freceivablesamount = $scope.data.forderamount - $scope.data.fdepositamount - $scope.data.freceivedamount
        $scope.showLoading();

				xiaoshouService.queryOrderInsertOrModify(0, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.forderamount = 0;

      $scope.changeSum = function() {
        $scope.data.forderamount = 0;
        for (var i = 0; i < $scope.data.orderlist.length; i++) {
          $scope.data.forderamount += $scope.data.orderlist[i].fprice * $scope.data.orderlist[i].fqty
        }
      }

      $scope.getDataFromPhone = function(phone) {
        if (!phone || phone.toString().length < 7) {
          $scope.$root.$broadcast($scope.autocompleteInputAsync.ID);
          return;
        }

        xiaoshouService.queryCustomerByPhoneNumber(phone)
        .then(function(res){
            $scope.autocompleteInputAsync.searchlist = res.data.data;
            $scope.$root.$broadcast($scope.autocompleteInputAsync.ID);
        }, function () {
            $scope.autocompleteInputAsync.searchlist = undefined;
            $scope.$root.$broadcast($scope.autocompleteInputAsync.ID);
        });
      }

      $scope.setModelAsync = function (item) {
        if (item.fname && item.fphonenumber) {
          $scope.data.fname = item.fname;
          $scope.data.fcommunity = item.fcommunity;
          $scope.data.fnumber = item.fnumber;
          $scope.data.frenovationplandate = item.frenovationplandate;
          $scope.data.fbirthdate = item.fbirthdate;
          $scope.data.fwechatno = item.fwechatno;
          $scope.data.fchannel = item.fchannel;
          $('#AsyncData').val(item.fphonenumber)
        }
      };

      $scope.autocompleteInputAsync = {
          'propNameToDisplay': 'fphonenumber',
          'isAsyncSearch': true,
          'ID':'AsyncData',
          'placeholder': '点击填写',
          'listClass': ['list-border-energized'],
          'labelContainerClass': ['item item-input', 'info-table-line-text', 'no-border'],
          'textBoxClass': ['text-right', 'ng-pristine', 'ng-untouched', 'ng-empty', 'ng-invalid', 'ng-invalid-required']
      };

      $scope.autocompleteInputAsync.itemSelectCallback = $scope.setModelAsync;
      $scope.autocompleteInputAsync.asyncHttpCall = $scope.getDataFromPhone;

      new Rolldate({
        el: '#frenovationplandate',
        format: 'YYYY-MM-DD',
        value: $scope.data.frenovationplandate,
        confirm: function(date) {
          $scope.data.frenovationplandate = date;
          $scope.$apply($scope.data);
        },
      });
      new Rolldate({
        el: '#fbirthdate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fbirthdate,
        confirm: function(date) {
          $scope.data.fbirthdate = date;
          $scope.$apply($scope.data);
        },
      });
      new Rolldate({
        el: '#fdate',
        format: 'YYYY-MM-DD',
        value: $scope.data.fdate,
        confirm: function(date) {
          $scope.data.fdate = date;

          $scope.eventSelectable = false;
          $scope.selectableEventList = [];
          $scope.eventList.forEach(function(e) {
            if (date >= e.fbegdate && date <= e.fenddate) {
              $scope.eventSelectable = true;
              $scope.selectableEventList.push(e);
            }
          });
          if (!$scope.eventSelectable) {
            $scope.data.tsaleeventid = undefined;
            $scope.data.fsaleevent = '暂无可关联事件';
          } else {
            if (!$scope.data.tsaleeventid) {
              $scope.data.fsaleevent = '';
            }
          }
          $scope.$apply($scope.data);
          $scope.$apply($scope.eventSelectable);
          $scope.$apply($scope.selectableEventList);
        },
      });
      new Rolldate({
        el: '#finstalldate',
        format: 'YYYY-MM-DD',
        value: $scope.data.finstalldate,
        confirm: function(date) {
          $scope.data.finstalldate = date;
          $scope.$apply($scope.data);
        },
      });

      $scope.eventSelectable = false;

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showChannelSelectPanel = function() {
        $scope.selectModel = $scope.channels;
        $scope.selectKeyField = "";
        $scope.selectValueField = "";
        $scope.selectModelName = "fchannel";
        $scope.selected = $scope.data.fchannel;

        $scope.showSelectPanel();
      }

      $scope.showStoreSelectPanel = function() {
        $scope.selectModel = $scope.stores;
        $scope.selectKeyField = "tstoreid";
        $scope.selectValueField = "fstorename";
        $scope.selectModelName = "tstoreid";
        $scope.selected = $scope.data.tstoreid;

        $scope.showSelectPanel();
      }

      $scope.showEventSelectPanel = function() {
        $scope.selectModel = $scope.selectableEventList;
        $scope.selectKeyField = "tsaleeventid";
        $scope.selectValueField = "fsaleevent";
        $scope.selectModelName = "tsaleeventid";
        $scope.selected = $scope.data.tsaleeventid;

        $scope.showSelectPanel();
      }

		});
})();

