(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('ChengjiaoChanpinFenxiController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      $scope.chartOption1 = 0;
      $scope.changeChartOption1 = () => {
        $scope.chartOption1 = 1 - $scope.chartOption1;
        $scope.loadData();
      }

      const chart = new G2.Chart({
        container: 'xiaoshoufenxixitong-chengjiaochanpinfenxi-chart',
        autoFit: true,
        height: 300,
      });
      $scope.$on('$destroy', function() {
        chart.clear()
        if (!chart.destroyed)
          chart.destroy()
      });
      $scope.loadData = () => {
        $scope.showLoading();

        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date());
          $scope.setFenxiPeriodEnd(new Date());
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年' + ("0" + ($scope.fenxiPeriodStart.getMonth() + 1)).slice(-2) + '月');
        }

        // Draw charts
        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryProductOfOrders($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
            $scope.tips = ''
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            const data = res.data.data;
            $scope.tips = isRangeDate($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd) ? res.data.tips : '';

            chart.clear();
            chart.data(data);
            if ($scope.chartOption1 == 0) {
              chart.scale('fqty', {
                range: [0, 0.9],
                formatter: function(val){
                  val = val + '件';
                  return val;
                },
              });
            } else {
              chart.scale('famount', {
                range: [0, 0.9],
                formatter: function(val){
                  if (val >= 1000) {
                    val = parseFloat((val / 1000).toFixed(2)) + 'K';
                  }
                  return '￥' + val;
                },
              });
            }

            chart.tooltip({
              showTitle: false,
              showMarkers: false
            });
            chart.interaction('active-region');
            chart.legend({flipPage: false});

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            if ($scope.chartOption1 == 0) {
              chart
              .interval()
              .position('fprodname*fqty')
              .color('fprodname')
              .label('fqty', function(val){return {content: val + '件', offsetY: val == 0 ? -20 : 0}});
            } else {
              chart
              .interval()
              .position('fprodname*famount')
              .color('fprodname')
              .label('famount', function(val){
                if (val >= 1000) {
                  val = parseFloat((val / 1000).toFixed(2)) + 'K';
                }
                return {content: '￥' + val, offsetY: val == 0 ? -20 : 0};
              });
            }

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideLoading();
        });
      }

      $scope.loadData();

      $scope.$on('refresh', function(ev) {
        $scope.loadData();
      });

      $scope.itemOnLongPress = function() {
        $scope.downloadImage(chart);
      }

    });
})();

