(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('JiedaiCishuFenxiController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      let chart = new G2.Chart({
        container: 'xiaoshoufenxixitong-jiedaicishufenxi-chart',
        autoFit: true,
        height: 300,
      });
      $scope.$on('$destroy', function() {
        chart.clear()
        if (!chart.destroyed)
          chart.destroy()
      });
      
      $scope.loadData = () => {
        $scope.showLoading();

        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date());
          $scope.setFenxiPeriodEnd(new Date());
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年' + ("0" + ($scope.fenxiPeriodStart.getMonth() + 1)).slice(-2) + '月');
        }

        // Draw charts
        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryReceptionTimesOfFirstOrder($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
            $scope.tips = ''
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            $scope.tips = isRangeDate($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd) ? res.data.tips : '';

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart1 = true;
            }
            chart.clear();
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '人';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fclass')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fclass}\n${obj.fcount}人\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })
              
            chart.interaction('element-active');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart1 = true;
          $scope.hideLoading();
        });
      }

      $scope.loadData();

      $scope.$on('refresh', function(ev) {
        $scope.loadData();
      });

      $scope.itemOnLongPress = function() {
        $scope.downloadImage(chart);
      }

    });
})();

