(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('TuidanlvFenxiController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      let chart = new G2.Chart({
        container: 'xiaoshoufenxixitong-tuidanlvfenxi-chart',
        autoFit: true,
        height: 300,
      });
      $scope.$on('$destroy', function() {
        chart.clear()
        if (!chart.destroyed)
          chart.destroy()
      });
      
      $scope.loadData = () => {
        $scope.showLoading();

        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date(new Date().getFullYear(), 0, 1));
          $scope.setFenxiPeriodEnd(new Date(new Date().getFullYear() + 1, 0, 0));
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年');
        }

        // Draw charts
        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryReturnCountOfOrders($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
            $scope.tips = ''
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            const data = res.data.data;
            $scope.tips = isRangeDate($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd) ? res.data.tips : '';

            data.forEach(function(v){
              v.freturnrate *= 100;
            });

            chart.clear();
            chart.data(data);
            chart.scale({
              fmonth: {
                // range: [0.1, 0.9],
                formatter: function(val) {
                  if (val.length >= 2) {
                    return Number(val.slice(-2)) + '月';
                  } else {
                    return val;
                  }
                }
              },
              freturnrate: {
                range: [0, 0.9],
                formatter: function(val){
                  return parseFloat(val.toFixed(2)) + '%';
                },
              },
            });

            chart.tooltip({
              showTitle: false,
              showMarkers: false,
              itemTpl:
                '<li style="margin-bottom:4px;list-style-type:none;padding: 0;">' +
                '<span style="background-color:{color};" class="g2-tooltip-marker"></span>' +
                '{name}<br/>' +
                '<span style="padding-left: 16px;line-height: 16px;">退单率：{value}</span><br/>' +
                '<span style="padding-left: 16px;line-height: 16px;">退单数：{freturncount}</span><br/>' +
                '</li>',
            });
            chart.interaction('active-region');
            chart.legend(false);

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fmonth*freturnrate')
            .color('fmonth')
            .label('freturnrate', function(val){return {content: parseFloat(val.toFixed(2)) + '%', offsetY: val == 0 ? -20 : 0}})
            .tooltip('fmonth*freturnrate*freturncount', function(fmonth, freturnrate,freturncount) {
              return {
                name: fmonth, 
                value: `${parseFloat(freturnrate.toFixed(2))}%`,
                freturncount
              }
            });

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart1 = true;
          $scope.hideLoading();
        });
      }

      $scope.loadData();

      $scope.$on('refresh', function(ev) {
        $scope.loadData();
      });

      $scope.itemOnLongPress = function() {
        $scope.downloadImage(chart);
      }

    });
})();

