(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('XiaoquZhanbiFenxiController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      let chart = new G2.Chart({
        container: 'xiaoshoufenxixitong-xiaoquzhanbifenxi-chart',
        autoFit: true,
        height: 400,
        localRefresh: false,
      });
      $scope.$on('$destroy', function() {
        chart.clear()
        if (!chart.destroyed)
          chart.destroy()
      });
      
      $scope.loadData = () => {
        $scope.showLoading();

        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date());
          $scope.setFenxiPeriodEnd(new Date());
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年' + ("0" + ($scope.fenxiPeriodStart.getMonth() + 1)).slice(-2) + '月');
        }

        // Draw charts
        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCommunityOfOrders($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
            $scope.tips = ''
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            $scope.tips = isRangeDate($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd) ? res.data.tips : '';

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart1 = true;
            }

            chart.data(data);
            chart.scale({
              fcount: {
                range: [0, 0.8],
                formatter: function(val) {
                  if (Number.isInteger(val)) {
                    return val + '单';
                  } else  {
                    return '';
                  }
                },
              }
            });
            chart.coordinate().transpose();

            chart.tooltip({
              showMarkers: false
            });
            chart.interval().position('fcommunity*fcount')
            .label('fcount', function(fcount){return {content: fcount + '单'}})
            .tooltip('fcommunity*fcount', function(fclass, fcount) {
              return {
                name: '数量', value: fcount + '单'
              };
            });

            chart.interaction('active-region');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart1 = true;
          $scope.hideLoading();
        });
      }

      $scope.loadData();

      $scope.$on('refresh', function(ev) {
        $scope.loadData();
      });

      $scope.itemOnLongPress = function() {
        $scope.downloadImage(chart);
      }

    });
})();

