(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('XiaoquKedanzhiController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      $scope.pageNumber = 1;
      $scope.pageSize = 100;

      $scope.loadData = () => {
        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date(new Date().getFullYear(), 0, 1));
          $scope.setFenxiPeriodEnd(new Date(new Date().getFullYear() + 1, 0, 0));
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年');
        }
        
        fenxiService.queryCommunityDepthOfOrders($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.tips = isRangeDate($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd) ? res.data.tips : '';

            $scope.communityDepthOfOrdersList = $scope.communityDepthOfOrdersList.concat(res.data.data);
            $scope.pageTotal = 1;
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err) {
          $scope.refreshComplete();
        });
      }

      $scope.doRefresh = function () {
        $scope.showLoading();
        $scope.pageNumber = 1;
        $scope.communityDepthOfOrdersList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });
    });
})();

