(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('XiaoshouFenxiShujuController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      $scope.pageNumber = 1;
      $scope.pageSize = 100;

      $scope.loadData = () => {
        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date());
          $scope.setFenxiPeriodEnd(new Date());
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年' + ("0" + ($scope.fenxiPeriodStart.getMonth() + 1)).slice(-2) + '月');
        }
        
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCustomerOfOrders($scope.pageNumber, $scope.pageSize, descending, $scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.tips = isRangeDate($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd) ? res.data.tips : '';

            $scope.saleDataList = $scope.saleDataList.concat(res.data.data);
            $scope.pageTotal = res.data.pageTotal;
            res.data.data.forEach(saleData => {
              $scope.totalAmount += saleData.forderamount;
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.refreshComplete();
        },
        function(err) {
          $scope.refreshComplete();
        });
      }

      $scope.doRefresh = function () {
        $scope.showLoading();
        $scope.pageNumber = 1
        $scope.totalAmount = 0;
        $scope.saleDataList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.loadMore = function() {
        $scope.pageNumber += 1;
        $scope.loadData();
      }

      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });
    });
})();

