/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('XiaoshouJiluBianjiController', function($scope, $state, ionicMaterialInk, $ionicPopup, xiaoshouJiluService) {

      const agentsPurchaseId = $state.params.agentspurchaseid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.showLoading();
      var originData = {};
      var fieldArray = {
        'fdate': '年月',
        'fagentname': '经销商',
        'famount': '销售金额（元）',
      }

      xiaoshouJiluService.querySaleMain(agentsPurchaseId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          $scope.data.fdate = $scope.data.fyear + '-' + $scope.data.fmonth;
          originData = Object.assign({}, $scope.data)

          new Rolldate({
            el: '#fdate',
            format: 'YYYY-MM',
            value: $scope.data.fdate,
            confirm: function(date) {
              $scope.data.fdate = date;
              $scope.$apply($scope.data);
            },
          });
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      xiaoshouJiluService.queryAgentList()
      .then(function(res){
        if (res.data.code === 1) {
          $scope.agentList = res.data.data;
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });


      $scope.modify = function() {
        $scope.showLoading();
        var modified = ""
        for (var key in fieldArray) {
          if (originData[key] != $scope.data[key])
            modified += "," + fieldArray[key]
        }
        if (modified.substring(0, 1) == ",")
          modified = modified.substring(1)
        $scope.data.datalog = [
          {
              "ftype": "修改",
              "flog": "修改内容：" + modified, // TODO 修改内容
          }
        ],
        xiaoshouJiluService.saleInsertOrModify(agentsPurchaseId, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentSelectPanel = function() {
        $scope.selectModel = $scope.agentList;
        $scope.selectKeyField = "tagentsid";
        $scope.selectValueField = "fagentname";
        $scope.selectModelName = "tagentsid";
        $scope.selected = $scope.data.tagentsid;

        $scope.showSelectPanel();
      }

		});
})();

