(function(){

	"use strict";
	angular.module('starter.services')

	.service('xiaoshouJiluService', function (apiService, userService) {
		let self = this;

    // 销售录入列表查询
    self.querySaleList = function(fromdb, pageNumber, pageSize, sortDirection, condition, periodStart, periodEnd) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.saleinput.saleinput",
					"method": "query_saleList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {},
						"sort":"t1.changedate" + (sortDirection == ascending ? '' : ' desc'),
					}
				}
      };
      if (condition) request.data.content.where.condition = condition;
      if (periodStart) {
        request.data.content.where.begdate = periodStart.getFullYear()
          + '-' + ("0" + (periodStart.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodStart.getDate()).slice(-2);
      }
      if (periodEnd) {
        request.data.content.where.enddate = periodEnd.getFullYear()
          + '-' + ("0" + (periodEnd.getMonth() + 1)).slice(-2)
          + '-' + ("0" + periodEnd.getDate()).slice(-2);
      }

			return apiService.makeRequest(request);
    };

    // 销售录入主界面查询
    self.querySaleMain = function(agentsPurchaseId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.saleinput.saleinput",
					"method": "query_saleMain",
					"content": {
						"userid": userService.getUserId(),
						"tagents_purchaseid": agentsPurchaseId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 销售记录新增，修改
    self.saleInsertOrModify = function(agentsPurchaseId, data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.saleinput.saleinput",
					"method": "saleInsertOrModify",
					"content": {
            "userid": userService.getUserId(),
            "tagents_purchaseid": agentsPurchaseId,
						"tagentsid": data.tagentsid,
						"fyear": data.fdate ? data.fdate.substring(0, 4) : '',
            "fmonth": data.fdate ? data.fdate.substring(5, 7) : '',
            // "fyear": data.fdate.getFullYear(),
            // "fmonth": ("0" + (data.fdate.getMonth() + 1)).slice(-2),
            "famount": data.famount,
						"datalog": data.datalog
						// [// TODO 修改记录，非必填项，可以为空
            //   {
            //     "ftype": "修改", // TODO 修改类型
            //     "flog": "修改字段及内容", // TODO 修改内容
            //   }
            // ],
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 销售记录删除
    self.saleDelete = function(agentsPurchaseId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.saleinput.saleinput",
					"method": "saleDelete",
					"content": {
            "userid": userService.getUserId(),
            "tagents_purchaseid": agentsPurchaseId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 经销商选择列表查询
    self.queryAgentList = function() {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.action.saleinput.saleinput",
					"method": "query_agentList",
					"content": {
						"userid": userService.getUserId(),
					}
				}
      };

			return apiService.makeRequest(request);
    };

	})

})();
