(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('XiaoshouShujuShouyeController', function($rootScope, $scope, $location, $anchorScroll, $ionicPopup, qiyeShujuService, $timeout) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.scrollTo = function(target){
        $location.hash(target); // set the location hash
        $anchorScroll();
      };

      $scope.selectTab = function(idx){
        $scope.navIndex = idx;
        $scope.$broadcast('scroll.refreshComplete');
      }

      $scope.showLoading();

      let chartArray = []
      $scope.$on('$destroy', function() {
        chartArray.forEach(chart => {
          chart.clear()
          if (!chart.destroyed)
            chart.destroy()
        })
      });

      setTimeout(function() {
        $scope.hideChart1 = false;
        qiyeShujuService.saleAmountGrowthRateAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];

            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                data.push(v);
              }
            });

            // Draw charts
            let chart = new G2.Chart({
              container: 'xiaoshoushuju-shouye-chart-1',
              autoFit: true,
              height: 300,
            });
            
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              range: [0, 0.9],
              nice: true,
              formatter: function(val) {
                if (Number.isInteger(val)) {
                  return val + '家';
                } else  {
                  return '';
                }
              },
            });
            chart.scale('fclass', {
              tickCount: 12,
              nice: true,
            });
            chart.tooltip({
              shared: true,
              showMarkers: false,
              showTitle: false,
            });

            var colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fclass*fcount')
            .color('fclass')
            .label('fcount', function(val){return {content: val + '家', offsetY: val == 0 ? -20 : 0}})
            .tooltip('fclass*fcount', function(fclass, fcount) {
              return {
                name: fclass, value: fcount + '家'
              };
            })
            .adjust('stack');

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});

            chart.render();

            $scope.detailList5 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;
              
              if (state === 'selected') {
                const data = element.getData();

                if (stateStatus) {
                  $scope.detailList5 = data.fdata.slice(0, 10);

                  $scope.detailList5.forEach(function(item) {
                    if (item.fprovince && item.fcity && item.fcounty
                        && !isNaN(Number(item.fprovince))
                        && !isNaN(Number(item.fcity))
                        && !isNaN(Number(item.fcounty))) {
                      item.fcounty = $scope.locationList[item.fcity][item.fcounty];
                      item.fcity = $scope.locationList[item.fprovince][item.fcity];
                      item.fprovince = $scope.locationList['86'][item.fprovince];
                    }
                  })

                  $scope.$apply($scope.detailList5);
                } else {
                  $scope.detailList5 = [];
                  $scope.$apply($scope.detailList5);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }
        },
        function(err) {
          $scope.hideChart1 = true;
        });

        $scope.hideChart2 = false;
        qiyeShujuService.saleAmountAverageAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart2 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            let data = res.data.data;

            // Draw charts
            let chart = new G2.Chart({
              container: 'xiaoshoushuju-shouye-chart-2',
              autoFit: true,
              height: 300,
            });

            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              range: [0, 0.9],
              nice: true,
              formatter: function(val) {
                if (Number.isInteger(val)) {
                  return val + '家';
                } else  {
                  return '';
                }
              },
            });
            chart.scale('fclass', {
              tickCount: 12,
              nice: true,
            });
            chart.tooltip({
              shared: true,
              showMarkers: false,
              showTitle: false,
            });

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fclass*fcount')
            .color('fclass')
            .label('fcount', function(val){return {content: val + '家', offsetY: val == 0 ? -20 : 0}})
            .tooltip('fclass*fcount', function(fclass, fcount) {
              return {
                name: fclass, value: fcount + '家'
              };
            })
            .adjust('stack');

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});

            chart.render();

            $scope.detailList4 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;
              
              if (state === 'selected') {
                const data = element.getData();

                if (stateStatus) {
                  $scope.detailList4 = data.fdata.slice(0, 10);

                  $scope.detailList4.forEach(function(item) {
                    if (item.fprovince && item.fcity && item.fcounty
                        && !isNaN(Number(item.fprovince))
                        && !isNaN(Number(item.fcity))
                        && !isNaN(Number(item.fcounty))) {
                      item.fcounty = $scope.locationList[item.fcity][item.fcounty];
                      item.fcity = $scope.locationList[item.fprovince][item.fcity];
                      item.fprovince = $scope.locationList['86'][item.fprovince];
                    }
                  })

                  $scope.$apply($scope.detailList4);
                } else {
                  $scope.detailList4 = [];
                  $scope.$apply($scope.detailList4);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart2 = true;
          }
        },
        function(err) {
          $scope.hideChart2 = true;
        });

        qiyeShujuService.saleAmountAnalysis()
        .then(function(res) {
        if (res.data.code === 1) {
          $scope.saleAmountList = res.data.data.slice(0, 10);
          $scope.saleAmountList.forEach(function(item) {
            if (item.fprovince && item.fcity && item.fcounty
                && !isNaN(Number(item.fprovince))
                && !isNaN(Number(item.fcity))
                && !isNaN(Number(item.fcounty))) {
              item.fcounty = $scope.locationList[item.fcity][item.fcounty];
              item.fcity = $scope.locationList[item.fprovince][item.fcity];
              item.fprovince = $scope.locationList['86'][item.fprovince];
            }
          })
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err) {
        $scope.hideLoading();
      });
      }, 500);

      $scope.setFavButtonInvisible = () => {
        $timeout.cancel($scope.timer);
        $scope.timer = $timeout(function() {
          $scope.show1 = false;
          $scope.show2 = false;
        }, 1500);
      }

      $('.shuju-topmenu-panel').css('height', '63px');
      $('ion-content.xiaoshoushuju').css("top", "107px");

    });
})();

