(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('XiaoshouShujuController', function($rootScope, $scope, $ionicPopup, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      $scope.loadData = () => {
        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date());
          $scope.setFenxiPeriodEnd(new Date());
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年' + ("0" + ($scope.fenxiPeriodStart.getMonth() + 1)).slice(-2) + '月');
        }

        qiyeShujuService.saleAmountAnalysis($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.saleAmountList = $scope.saleAmountList.concat(res.data.data);
            $scope.saleAmountList.forEach(function(item) {
              if (item.fprovince && item.fcity && item.fcounty
                  && !isNaN(Number(item.fprovince))
                  && !isNaN(Number(item.fcity))
                  && !isNaN(Number(item.fcounty))) {
                item.fcounty = $scope.locationList[item.fcity][item.fcounty];
                item.fcity = $scope.locationList[item.fprovince][item.fcity];
                item.fprovince = $scope.locationList['86'][item.fprovince];
              }
            })
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
          $scope.$broadcast('scroll.refreshComplete');
        },
        function(err) {
          $scope.hideLoading();
          $scope.$broadcast('scroll.refreshComplete');
        });
      }

      $scope.doRefresh = function () {
        $scope.showLoading();
        $scope.saleAmountList = [];
        $scope.loadData();
      };
      $scope.doRefresh();

      $scope.$on('refresh', function(ev) {
        $scope.doRefresh();
      });
    });
})();

