(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('YuepingjunXiaoshouController', function($rootScope, $scope, $ionicPopup, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      let chart = new G2.Chart({
        container: 'xiaoshoushuju-yuepingjunxiaoshou-chart',
        autoFit: true,
        height: 300,
      });
      $scope.$on('$destroy', function() {
        chart.clear()
        if (!chart.destroyed)
          chart.destroy()
      });
      
      $scope.loadData = () => {
        $scope.showLoading();

        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date(new Date().getFullYear(), 0, 1));
          $scope.setFenxiPeriodEnd(new Date(new Date().getFullYear() + 1, 0, 0));
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年');
        }

        $scope.hideChart1 = false;
        qiyeShujuService.saleAmountAverageAnalysis($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            let data = res.data.data;

            // Draw charts
            chart.data(data);
            chart.scale('fcount', {
              range: [0, 0.9],
              nice: true,
              formatter: function(val) {
                if (Number.isInteger(val)) {
                  return val + '家';
                } else  {
                  return '';
                }
              },
            });
            chart.scale('fclass', {
              tickCount: 12,
              nice: true,
            });
            chart.tooltip({
              shared: true,
              showMarkers: false,
              showTitle: false,
            });

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fclass*fcount')
            .color('fclass')
            .label('fcount', function(val){return {content: val + '家', offsetY: val == 0 ? -20 : 0}})
            .tooltip('fclass*fcount', function(fclass, fcount) {
              return {
                name: fclass, value: fcount + '家'
              };
            })
            .adjust('stack');

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});

            chart.render();

            $scope.detailList4 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;
              
              if (state === 'selected') {
                const data = element.getData();

                if (stateStatus) {
                  $scope.detailList4 = data.fdata;

                  $scope.detailList4.forEach(function(item) {
                    if (item.fprovince && item.fcity && item.fcounty
                        && !isNaN(Number(item.fprovince))
                        && !isNaN(Number(item.fcity))
                        && !isNaN(Number(item.fcounty))) {
                      item.fcounty = $scope.locationList[item.fcity][item.fcounty];
                      item.fcity = $scope.locationList[item.fprovince][item.fcity];
                      item.fprovince = $scope.locationList['86'][item.fprovince];
                    }
                  })

                  $scope.$apply($scope.detailList4);
                } else {
                  $scope.detailList4 = [];
                  $scope.$apply($scope.detailList4);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart1 = true;
          $scope.hideLoading();
        });
      }

      $scope.loadData();

      $scope.$on('refresh', function(ev) {
        $scope.loadData();
      });

      $scope.itemOnLongPress = function() {
        $scope.downloadImage(chart);
      }


    });
})();

