/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('XinxiaoxiLiebiaoController', function($scope, $rootScope, $state, xinxiaoxiService, $ionicHistory)
  {
    $scope.dataList = [];
    $scope.showHeader();
    $scope.hideTabBar();

    $scope.pageNumber = 1;
    $scope.pageSize = 10;

    $scope.ftype = '素材';
    $scope.fromdb = $ionicHistory.forwardView() != null

    $scope.loadData = () => {
      xinxiaoxiService.queryMessage(
        $scope.fromdb,
        $scope.pageNumber, // pageNumber
        $scope.pageSize, // pageSize
        $scope.ftype, // ftype
      )
      .then(function(res){
        if (res.data.code === 1) {
          $scope.dataList = $scope.dataList.concat(res.data.data);
          if ($scope.ftype == '素材') {
            $scope.haveUnreadSucaiXiaoxi = false;
          } else {
            $scope.haveUnreadXitongXiaoxi = false;
          }
          $scope.dataList.forEach(function(v) {
            if (v.fisread == 0) {
              if ($scope.ftype == '素材') {
                $scope.haveUnreadSucaiXiaoxi = true;
              } else {
                $scope.haveUnreadXitongXiaoxi = true;
              }
            }
          });
          $scope.pageTotal = res.data.pageTotal;
        } else{
          
        }
        $scope.refreshComplete();
      },
      function(err){
        $scope.refreshComplete();
      });

      $scope.fothertype = $scope.ftype == '素材' ? '系统' : '素材';
      xinxiaoxiService.queryMessage(
        $scope.fromdb,
        1, // pageNumber
        10, // pageSize
        $scope.fothertype, // ftype
      )
      .then(function(res) {
        if (res.data.code === 1) {
          if ($scope.fothertype == '素材') {
            $scope.haveUnreadSucaiXiaoxi = false;
          } else {
            $scope.haveUnreadXitongXiaoxi = false;
          }
          res.data.data.forEach(function(v) {
            if (v.fisread == 0) {
              if ($scope.fothertype == '素材') {
                $scope.haveUnreadSucaiXiaoxi = true;
              } else {
                $scope.haveUnreadXitongXiaoxi = true;
              }
            }
          });
        } else{
          
        }
        $scope.refreshComplete();
      },
      function(err){
        $scope.refreshComplete();
      });
    }

    $scope.showLoading();

    $scope.doRefresh = function () {
      $scope.pageNumber = 1;
      $scope.dataList = [];
      $scope.loadData();
    };
    $scope.doRefresh();

    $scope.loadMore = function() {
      $scope.pageNumber += 1;
      $scope.loadData();
    };

    $scope.$on('refresh', function(ev) {
      $scope.doRefresh();
    });

    $scope.readMessage = function(messageId, fisRead, navigateToJianGuan = false) {
      if (fisRead == 0) {
        $scope.decXiaoxiCount()
        if ($scope.getXiaoxiCount() == 0)
          $("#xiaoxiCount").css('display', 'none')
        else
          $("#xiaoxiCount").text($scope.getXiaoxiCount())
      }
      xinxiaoxiService.readMessage(messageId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.dataList.forEach(function(item) {
            if (item.tmessageid == messageId) {
              item.fisread = 1;
            }
          })
        } else{
          
        }
      },
      function(err){
      });
      if (navigateToJianGuan) {
        $scope.navigate('app.tibaojianguan');
      }
    }

    $scope.showSucaiXiaoxi = function() {
      $scope.tabIndex = 0;
      $scope.ftype = '素材';

      $scope.showLoading();
      $scope.doRefresh();
    }

    $scope.showXitongXiaoxi = function() {
      $scope.tabIndex = 1;
      $scope.ftype = '系统';

      $scope.showLoading();
      $scope.doRefresh();
    }

    $scope.navigateToXiaoxiXiangqing = (item) => {
      switch (item.objectname) {
        case 'tarchives':
          $state.go('app.wuliaoxiangqing', {archivesid: item.objectid});
          break;
        case 'tarchives_ad':
          $state.go('app.sucaixiangqing', {archivesid: item.objectid});
          break;
        case 'tarchives_sc':
          $state.go('app.kechengxiangqing', {archivesid: item.objectid});
          break;
      }
    }

    $scope.tabIndex = 0;

    $scope.$on('$ionicView.beforeEnter', function (e,config) {
      config.enableBack = true;
    });
  })
})();
