(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('YixiangKehuXitongShouyeController', function($rootScope, $scope, $location, $anchorScroll, $ionicPopup, userService, fenxiService, qiyeShujuService, $timeout) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.scrollTo = function(target){
        $location.hash(target); // set the location hash
        $anchorScroll();
      };

      $scope.selectTab = function(idx){
        $scope.navIndex = idx;
        $scope.$broadcast('scroll.refreshComplete');
      }

      $scope.showLoading();

      let chartArray = []
      $scope.$on('$destroy', function() {
        chartArray.forEach(chart => {
          chart.clear()
          if (!chart.destroyed)
            chart.destroy()
        })
      });

      setTimeout(function() {
        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryChannelOfCustomers()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            $scope.tips1 = res.data.tips;

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart1 = true;
            }

            // Draw charts
            let chart = new G2.Chart({
              container: 'yixiangkehuxitong-shouye-chart-1',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '人';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7,
              // innerRadius: 0.3,
            });

            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fchannel')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fchannel}\n${obj.fcount}人\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-active');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }
        },
        function(err) {
          $scope.hideChart1 = true;
        });

        $scope.hideChart2 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryNewCustomers()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart2 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            let data = res.data.data;
            $scope.tips2 = res.data.tips;

            $scope.stackedSum = [];
            data.forEach(function(item) {
              if ($scope.stackedSum[item.fmonth]) {
                $scope.stackedSum[item.fmonth] += item.fcount;
              } else {
                $scope.stackedSum[item.fmonth] = item.fcount;
              }
            });

            // Draw charts
            let chart = new G2.Chart({
              container: 'yixiangkehuxitong-shouye-chart-2',
              autoFit: true,
              height: 300,
              padding: [50, 0, 50, 0],
            });

            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              nice: true,
              formatter: function(val) {
                return val + '人';
              },
            });
            chart.scale('fmonth', {
              tickCount: 12,
              nice: true,
              formatter: function(val) {
                if (Number.isInteger(val) && val >= data[0].fmonth && val <= data[data.length - 1].fmonth) {
                  return val + '月';
                } else  {
                  return '';
                }
              },
              min: data[0].fmonth - 0.5,
              max: data[data.length - 1].fmonth + 0.5,
            });
            chart.tooltip({
              shared: true,
              showMarkers: false,
            });

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fmonth*fcount*freception_address')
            .color('freception_address')
            .adjust('stack')
            .label('fmonth*freception_address',
              function(fmonth, freception_address) {
                if (freception_address == '卖场') {
                  return {content: $scope.stackedSum[fmonth] + '人', offsetY: $scope.stackedSum[fmonth] == 0 ? -20 : 0}
                }
              }
            );

            chart.interaction('active-region');
            chart.legend({flipPage: false});

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart2 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart2 = true;
          $scope.hideLoading();
        });
      }, 500);

      $scope.setFavButtonInvisible = () => {
        $timeout.cancel($scope.timer);
        $scope.timer = $timeout(function() {
          $scope.show1 = false;
          $scope.show2 = false;
        }, 1500);
      }

      $('.shuju-topmenu-panel').css('height', '63px');
      $('ion-content.yixiangkehuxitong').css("top", "107px");

      $scope.showTip1 = false;
      $scope.showTip2 = false;

      $scope.toggleTip1 = function() {
        $scope.showTip1 = !$scope.showTip1;
      }

      $scope.toggleTip2 = function() {
        $scope.showTip2 = !$scope.showTip2;
      }

    });
})();

