(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('XinzengYixiangKehuFenxiController', function($rootScope, $scope, $ionicPopup, userService, fenxiService, qiyeShujuService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.initFenxiPeriod();

      let chart = new G2.Chart({
        container: 'yixiangkehuxitong-xinzengyixiangkehufenxi-chart',
        autoFit: true,
        height: 300,
        padding: [50, 0, 50, 0],

      });
      $scope.$on('$destroy', function() {
        chart.clear()
        if (!chart.destroyed)
          chart.destroy()
      });
      
      $scope.loadData = () => {
        $scope.showLoading();

        if (!$scope.fenxiPeriodStart) {
          $scope.setFenxiPeriodStart(new Date(new Date().getFullYear(), 0, 1));
          $scope.setFenxiPeriodEnd(new Date(new Date().getFullYear() + 1, 0, 0));
          $scope.setFenxiPeriodString($scope.fenxiPeriodStart.getFullYear() + '年');
        }

        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryNewCustomers($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd)
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
            $scope.tips = ''
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            let data = res.data.data;
            $scope.tips = isRangeDate($scope.fenxiPeriodStart, $scope.fenxiPeriodEnd) ? res.data.tips : '';

            $scope.stackedSum = [];
            data.forEach(function(item) {
              if ($scope.stackedSum[item.fmonth]) {
                $scope.stackedSum[item.fmonth] += item.fcount;
              } else {
                $scope.stackedSum[item.fmonth] = item.fcount;
              }
            });

            // Draw charts
            chart.data(data);
            chart.scale('fcount', {
              nice: true,
              formatter: function(val) {
                return val + '人';
              },
            });
            chart.scale('fmonth', {
              tickCount: 12,
              nice: true,
              formatter: function(val) {
                if (Number.isInteger(val) && val >= data[0].fmonth && val <= data[data.length - 1].fmonth) {
                  return val + '月';
                } else  {
                  return '';
                }
              },
              min: data[0].fmonth - 0.5,
              max: data[data.length - 1].fmonth + 0.5,
            });
            chart.tooltip({
              shared: true,
              showMarkers: false,
            });

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
              .interval()
              .position('fmonth*fcount*freception_address')
              .color('freception_address')
              .adjust('stack')
              .label('fmonth*freception_address',
                function(fmonth, freception_address) {
                  if (freception_address == '卖场') {
                    return {content: $scope.stackedSum[fmonth] + '人', offsetY: $scope.stackedSum[fmonth] == 0 ? -20 : 0}
                  }
                }
              );

            chart.interaction('active-region');
            chart.legend({flipPage: false});

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart1 = true;
          $scope.hideLoading();
        });
      }

      $scope.loadData();

      $scope.$on('refresh', function(ev) {
        $scope.loadData();
      });

      $scope.itemOnLongPress = function() {
        $scope.downloadImage(chart);
      }

    });
})();

