(function(){
	"use strict";
	angular.module('starter.controllers')
    .controller('ZhifuXinzengController', function($scope, $state, userService) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.pageNumber = 1;
      $scope.pageSize = 20;

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });

      $scope.type = 1

      $scope.data = {
        faccountbalance: 0
      }

      userService.queryAccountBalance().then(res => {
        if (res.data.code == 1 && res.data.data[0]) {
          $scope.data = res.data.data[0]
        }
      })

      $scope.customAmount = 0
      $scope.charge = (type, amount) => {
        switch (type) {
          case 1:
            amount = 1000
          break;
          case 2:
            amount = 500
            break;
          case 3:
            amount = 100
            break;
          default: //custom
            if (amount <= 0){
              $scope.showToast({title: '请输入自定义金额'})
              return
            }
            break;
        }
        
        userService.createAPPWechatOrder({  token: userService.getToken(), 
                  userid: userService.getUserId(),
                  fpayamount: amount,
                } , "192.168.1.1").
        then(res => {
          if (!res.data || !res.data.data.partnerid) {
            $scope.showToast({title: '支付失败！' + reason})
            return
          }
          var params = {
            partnerid: res.data.data.partnerid, // merchant id
            prepayid: res.data.data.prepayid, // prepay id
            noncestr: res.data.data.noncestr, // nonce
            timestamp: res.data.data.timestamp, // timestamp
            sign: res.data.data.sign, // signed string
          };

          Wechat.sendPaymentRequest(params, function () {
            $scope.showToast({title: '支付成功！'})
          }, function (reason) {
            $scope.showToast({title: '支付失败！' + reason})
          });
        })
      }

		});
})();

