(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('ZhongduanDashujuShouyeController', function($rootScope, $scope, $location, $anchorScroll, $ionicPopup, userService, fenxiService, qiyeShujuService, $timeout) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.title = userService.getRole() == '企业' ? "终端大数据" : "总表";

      $scope.tips = []
      $scope.showTip = []

      let chartArray = []
      $scope.$on('$destroy', function() {
        chartArray.forEach(chart => {
          chart.clear()
          if (!chart.destroyed)
            chart.destroy()
        })
      });

      $scope.toggleTip = function(index) {
        $scope.showTip[index] = !$scope.showTip[index] && userService.getRole() == '经销商'
      }

      $scope.scrollTo = function(target){
        $location.hash(target); // set the location hash
        $anchorScroll();
      };

      $scope.selectTab = function(idx){
        $scope.navIndex = idx;
        $scope.$broadcast('scroll.refreshComplete');
      }

      $scope.showLoading();

      setTimeout(function() {
        // 终端大数据_意向客户分析_客户来源分析
        $scope.hideChart1 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryChannelOfCustomers()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            $scope.tips['kehulaiyuanfenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['kehulaiyuanfenxi'] = false

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart1 = true;
            }

            // Draw charts
            let chart = new G2.Chart({
              container: 'yixiangkehuxitong-shouye-chart-1',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '人';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fchannel')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fchannel}\n${obj.fcount}人\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-active');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }
        },
        function(err) {
          $scope.hideChart1 = true;
        });

        // 终端大数据_意向客户分析_新增意向客户分析
        $scope.hideChart2 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryNewCustomers()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart2 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            let data = res.data.data;
            $scope.tips['xinzengyixiangkehufenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['xinzengyixiangkehufenxi'] = false

            $scope.stackedSum = [];
            data.forEach(function(item) {
              if ($scope.stackedSum[item.fmonth]) {
                $scope.stackedSum[item.fmonth] += item.fcount;
              } else {
                $scope.stackedSum[item.fmonth] = item.fcount;
              }
            });

            // Draw charts
            let chart = new G2.Chart({
              container: 'yixiangkehuxitong-shouye-chart-2',
              autoFit: true,
              height: 300,
              padding: [50, 0, 50, 0],
            });
            chartArray.push(chart)

            chart.data(data);
            chart.scale('fcount', {
              nice: true,
              formatter: function(val) {
                return val + '人';
              },
            });
            chart.scale('fmonth', {
              tickCount: 12,
              nice: true,
              formatter: function(val) {
                if (Number.isInteger(val) && val >= data[0].fmonth && val <= data[data.length - 1].fmonth) {
                  return val + '月';
                } else  {
                  return '';
                }
              },
              min: data[0].fmonth - 0.5,
              max: data[data.length - 1].fmonth + 0.5,
            });
            chart.tooltip({
              shared: true,
              showMarkers: false,
            });

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fmonth*fcount*freception_address')
            .color('freception_address')
            .adjust('stack')
            .label('fmonth*freception_address',
              function(fmonth, freception_address) {
                if (freception_address == '卖场') {
                  return {content: $scope.stackedSum[fmonth] + '人', offsetY: $scope.stackedSum[fmonth] == 0 ? -20 : 0}
                }
              }
            );

            chart.interaction('active-region');
            chart.legend({flipPage: false});

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart2 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart2 = true;
          $scope.hideLoading();
        });

        // 终端大数据_销售系统分析_销售动作分析
        $scope.hideChart3 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCustomerAction()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart3 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            $scope.tips['xiaoshoudongzuofenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['xiaoshoudongzuofenxi'] = false
            // Draw charts
            const dv = new DataSet.DataView().source(res.data.data);
            var sum = 0;
            for (var ii = 0; ii < res.data.data.length; ii++){
              if (res.data.data[ii].fcustaction == '进店') {
                sum = res.data.data[ii].fcount;
              }
            }
            if (sum == 0) {
              $scope.hideChart3 = true;
            }
            dv.transform({
              type: 'map',
              callback(row) {
                row.percent = parseFloat((row.fcount / sum * 100).toFixed(2));
                return row;
              },
            });
            const data = dv.rows;
            const chart = new G2.Chart({
              container: 'xiaoshoufenxixitong-shouye-chart-1',
              autoFit: true,
              height: 300,
              padding: [0, 100, 70],
            });
            chartArray.push(chart)
            chart.data(data);
            chart.axis(false);
            chart.tooltip({
              showTitle: false,
              showMarkers: false,
              itemTpl:
                '<li style="margin-bottom:4px;list-style-type:none;padding: 0;">' +
                '<span style="background-color:{color};" class="g2-tooltip-marker"></span>' +
                '{name}<br/>' +
                '<span style="padding-left: 16px;line-height: 16px;">浏览人数：{fcount}</span><br/>' +
                '<span style="padding-left: 16px;line-height: 16px;">占比：{percent}</span><br/>' +
                '</li>',
            });
            chart
              .coordinate('rect')
              .transpose()
              .scale(1, -1);
            chart
              .interval()
              .adjust('symmetric')
              .position('fcustaction*percent')
              .shape('funnel')
              .color('fcustaction')
              .label(
                'fcustaction*fcount',
                (fcustaction, fcount) => {
                  return {
                    content: `${fcustaction} ${fcount}`,
                  };
                },
                {
                  offset: 15,
                  labelLine: {
                    style: {
                      lineWidth: 1,
                      stroke: 'rgba(0, 0, 0, 0.15)',
                    },
                  },
                }
              )
              .tooltip('fcustaction*fcount*percent', (fcustaction, fcount, percent) => {
                return {
                  name: fcustaction,
                  percent: +percent + '%',
                  fcount,
                };
              })
              .animate({
                appear: {
                  animation: 'fade-in'
                },
                update: {
                  annotation: 'fade-in'
                }
              });

            chart.interaction('element-active');
            chart.legend({flipPage: false});
            let pp = 100 / res.data.data.length

            chart.on('beforepaint', () => {
              chart.annotation().clear(true);
              const chartData = chart.getData();
              // 中间标签文本
              chartData.forEach((obj, idx) => {
                let positionY = idx * pp   + pp / 2
                chart.annotation().text({
                  top: true,
                  position: ['50%', `${positionY}%`],
                  content: obj.percent + '%', // 显示的文本内容
                  style: {
                    stroke: null,
                    fill: '#fff',
                    fontSize: 12,
                    textAlign: 'center',
                    shadowBlur: 2,
                    shadowColor: 'rgba(51, 51, 51, .45)',
                  },
                });
              });

              chart.annotation().text({
                top: true,
                content: '* 以进店数作为统计基数',
                position: ['50%', '100%'],
                style: {
                  fill: '#666666',
                  fontSize: 12,
                  fontWeight: 300,
                  textAlign: 'center',
                },
                offsetY: 25,
              });
            });

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart3 = true;
          }
        },
        function(err) {
          $scope.hideChart3 = true;
        });

        // 终端大数据_销售系统分析_销售渠道分析
        $scope.hideChart4 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryChannelOfOrders()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart4 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            $scope.tips['xiaoshouqudaofenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['xiaoshouqudaofenxi'] = false

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart4 = true;
            }
            let chart = new G2.Chart({
              container: 'xiaoshoufenxixitong-shouye-chart-2',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '人';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fchannel')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fchannel}\n${obj.fcount}人\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })              

            chart.interaction('element-active');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart4 = true;
          }
        },
        function(err) {
          $scope.hideChart4 = true;
        });

        // 终端大数据_销售系统分析_成交产品分析
        $scope.chartOption1 = 0;
        $scope.changeChartOption1 = () => {
          $scope.chartOption1 = 1 - $scope.chartOption1;
          $scope.queryProductOfOrders();
        }

        let chart = new G2.Chart({
          container: 'xiaoshoufenxixitong-shouye-chart-3',
          autoFit: true,
          height: 300,
        });
        chartArray.push(chart)

        $scope.queryProductOfOrders = function() {
          $scope.hideChart5 = false;
          (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryProductOfOrders()
          .then(function(res) {
            if (res.data.code === 1 && res.data.data.length == 0) {
              $scope.hideChart5 = true;
            } else if (res.data.code === 1 && res.data.data.length > 0) {
              const data = res.data.data;
              $scope.tips['chengjiaochanpinfenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
              $scope.showTip['chengjiaochanpinfenxi'] = false
              
              chart.clear();
              chart.data(data);
              if ($scope.chartOption1 == 0) {
                chart.scale('fqty', {
                  range: [0, 0.9],
                  formatter: function(val){
                    val = val + '件';
                    return val;
                  },
                });
              } else {
                chart.scale('famount', {
                  range: [0, 0.9],
                  formatter: function(val){
                    if (val >= 1000) {
                      val = parseFloat((val / 1000).toFixed(2)) + 'K';
                    }
                    return '￥' + val;
                  },
                });
              }

              chart.tooltip({
                showTitle: false,
                showMarkers: false
              });
              chart.interaction('active-region');
              chart.legend({flipPage: false});

              let colorMaps = [
                '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
              ];

              if ($scope.chartOption1 == 0) {
                chart
                .interval()
                .position('fprodname*fqty')
                .color('fprodname')
                .label('fqty', function(val){return {content: val + '件', offsetY: val == 0 ? -20 : 0}});
              } else {
                chart
                .interval()
                .position('fprodname*famount')
                .color('fprodname')
                .label('famount', function(val){
                  if (val >= 1000) {
                    val = parseFloat((val / 1000).toFixed(2)) + 'K';
                  }
                  return {content: '￥' + val, offsetY: val == 0 ? -20 : 0};
                });
              }

              chart.render();
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
          },
          function(err) {
          });
        }

        $scope.queryProductOfOrders();

        // 终端大数据_销售系统分析_客单值分析
        $scope.hideChart6 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryAmountOfOrders()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart6 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            const data = res.data.data;
            $scope.tips['kedanzhifenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['kedanzhifenxi'] = false
            
            const chart = new G2.Chart({
              container: 'xiaoshoufenxixitong-shouye-chart-4',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)

            chart.data(data);
            chart.scale({
              fmonth: {
                // range: [0.1, 0.9],
                formatter: function(val) {
                  if (val.length >= 2) {
                    return Number(val.slice(-2)) + '月';
                  } else {
                    return val;
                  }
                }
              },
              famount: {
                range: [0, 0.9],
                formatter: function(val){
                  if (val >= 1000) {
                    val = parseFloat((val / 1000).toFixed(2)) + 'K';
                  }
                  return '￥' + val;
                },
              },
            });

            chart.tooltip({
              showTitle: false,
            });

            chart.line().position('fmonth*famount')
            .label('famount', function(val){
              if (val >= 1000) {
                val = parseFloat((val / 1000).toFixed(2)) + 'K';
              }
              return {content: '￥' + val};
            })
            .tooltip('fmonth*famount', function(fmonth, famount) {
              if (famount >= 1000) {
                famount = parseFloat((famount / 1000).toFixed(2)) + 'K';
              } else {
                famount = parseFloat(famount.toFixed(2));
              }
              return {
                name: fmonth + ' 客单值', value: '￥' + famount
              }
            });
            chart.point().position('fmonth*famount')
            .tooltip('fmonth*famount', function(fmonth, famount) {
              if (famount >= 1000) {
                famount = parseFloat((famount / 1000).toFixed(2)) + 'K';
              } else {
                famount = parseFloat(famount.toFixed(2));
              }
              return {
                name: fmonth + ' 客单值', value: '￥' + famount
              }
            });

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart6 = true;
          }
        },
        function(err) {
          $scope.hideChart6 = true;
        });

        // 终端大数据_销售系统分析_小区占比分析
        $scope.hideChart7 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCommunityOfOrders()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart7 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            $scope.tips['xiaoquzhanbifenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['xiaoquzhanbifenxi'] = false

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            const G = G2.getEngine('canvas');

            if (sum == 0) {
              $scope.hideChart7 = true;
            }
            let chart = new G2.Chart({
              container: 'xiaoshoufenxixitong-shouye-chart-5',
              autoFit: true,
              height: 400,
              localRefresh: false,
            });
            chartArray.push(chart)

            chart.data(data);
            chart.scale({
              fcount: {
                range: [0, 0.8],
                formatter: function(val) {
                  if (Number.isInteger(val)) {
                    return val + '单';
                  } else  {
                    return '';
                  }
                },
              }
            });
            chart.coordinate().transpose();

            chart.tooltip({
              showMarkers: false
            });
            chart.interval().position('fcommunity*fcount')
            .label('fcount', function(fcount){return {content: fcount + '单'}})
            .tooltip('fcommunity*fcount', function(fclass, fcount) {
              return {
                name: '数量', value: fcount + '单'
              };
            });

            chart.interaction('active-region');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart7 = true;
          }
        },
        function(err) {
          $scope.hideChart7 = true;
        });

        // 终端大数据_销售系统分析_退单率分析
        $scope.hideChart8 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryReturnCountOfOrders()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart8 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            const data = res.data.data;
            $scope.tips['tuidanlvfenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['tuidanlvfenxi'] = false

            const chart = new G2.Chart({
              container: 'xiaoshoufenxixitong-shouye-chart-6',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)

            data.forEach(function(v){
              v.freturnrate *= 100;
            });

            chart.data(data);
            chart.scale({
              fmonth: {
                // range: [0.1, 0.9],
                formatter: function(val) {
                  if (val.length >= 2) {
                    return Number(val.slice(-2)) + '月';
                  } else {
                    return val;
                  }
                }
              },
              freturnrate: {
                range: [0, 0.9],
                formatter: function(val){
                  return parseFloat(val.toFixed(2)) + '%';
                },
              },
            });

            chart.tooltip({
              showTitle: false,
              showMarkers: false,
              itemTpl:
                '<li style="margin-bottom:4px;list-style-type:none;padding: 0;">' +
                '<span style="background-color:{color};" class="g2-tooltip-marker"></span>' +
                '{name}<br/>' +
                '<span style="padding-left: 16px;line-height: 16px;">退单率：{value}</span><br/>' +
                '<span style="padding-left: 16px;line-height: 16px;">退单数：{freturncount}</span><br/>' +
                '</li>',
            });
            chart.interaction('active-region');
            chart.legend(false);

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fmonth*freturnrate')
            .color('fmonth')
            .label('freturnrate', function(val){return {content: parseFloat(val.toFixed(2)) + '%', offsetY: val == 0 ? -20 : 0}})
            .tooltip('fmonth*freturnrate*freturncount', function(fmonth, freturnrate,freturncount) {
              return {
                name: fmonth, 
                value: `${parseFloat(freturnrate.toFixed(2))}%`,
                freturncount
              }
            });

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart8 = true;
          }
        },
        function(err) {
          $scope.hideChart8 = true;
        });

        // 终端大数据_销售系统分析_销售情况分析表
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCustomerOfOrders(1, 10, descending)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.saleDataList = res.data.data;
            // $scope.tips['kehulaiyuanfenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            // $scope.showTip['kehulaiyuanfenxi'] = false

            $scope.totalAmount = 0;
            $scope.saleDataList.forEach(saleData => {
              $scope.totalAmount += saleData.forderamount;
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideLoading();
        });

        // 终端大数据_销售系统分析_接待次数与首单成交分析
        $scope.hideChart9 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryReceptionTimesOfFirstOrder()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart9 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            $scope.tips['jiedaicishufenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['jiedaicishufenxi'] = false

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum ==  0) {
              $scope.hideChart9 = true;
            }
            let chart = new G2.Chart({
              container: 'xiaoshoufenxixitong-shouye-chart-7',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '单';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fclass')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fclass}\n${obj.fcount}单\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-active');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart9 = true;
          }
        },
        function(err) {
          $scope.hideChart9 = true;
        });

        // 终端大数据_销售分析系统_小区客单值
        if (userService.getRole() == '经销商') {
          fenxiService.queryCommunityDepthOfOrders()
          .then(function(res) {
            if (res.data.code === 1) {
              $scope.communityDepthOfOrdersList = res.data.data;
              $scope.tips['xiaoqukedanzhi']  = res.data.tips;
              $scope.showTip['xiaoqukedanzhi'] = false;
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
          },
          function(err) {
          });
        }

        // 终端大数据_事件分析_事件订单占比分析
        $scope.chartOption = 0;
        $scope.changeChartOption = () => {
          $scope.chartOption = 1 - $scope.chartOption;
          $scope.queryEventOfOrders();
        }

        let shijianfenxixitongChart = new G2.Chart({
          container: 'shijianfenxixitong-shouye-chart-1',
          autoFit: true,
          height: 300,
        });
        chartArray.push(chart)

        $scope.queryEventOfOrders = function() {
          $scope.hideChart10 = false;
          (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryEventOfOrders()
          .then(function(res) {
            if (res.data.code === 1 && res.data.data.length == 0) {
              $scope.hideChart10 = true;
            } else if (res.data.code === 1 && res.data.data.length > 0) {
              if (res.data.data.length > 0 && res.data.data[0].fsaleevent) {
                var data = [];
                $scope.tips['shijianfenxixitong']  = userService.getRole() == '经销商' ? res.data.tips : ''
                $scope.showTip['shijianfenxixitong'] = false

                var sum = 0;
                res.data.data.forEach(function(v) {
                  if (v.fcount != 0) {
                    sum += ($scope.chartOption) == 0 ? v.fcount : v.forderamount;
                    data.push(v);
                  }
                });

                if (sum == 0) {
                  $scope.hideChart10 = true;
                }

                shijianfenxixitongChart.data(data);
                shijianfenxixitongChart.clear();
                if ($scope.chartOption == 0) {
                  shijianfenxixitongChart.scale('fcount', {
                    formatter: function(val){
                      val = parseFloat(val.toFixed(2)) + '件';
                      return val;
                    },
                  });
                } else {
                  shijianfenxixitongChart.scale('forderamount', {
                    formatter: function(val){
                      if (val >= 1000) {
                        val = parseFloat((val / 1000).toFixed(2)) + 'K';
                      }
                      return '￥' + val;
                    },
                  });
                }
                shijianfenxixitongChart.coordinate('theta', {
                  radius: 0.7,
                  // innerRadius: 0.3,
                });
                
                if ($scope.chartOption == 0) {
                  shijianfenxixitongChart
                  .interval()
                  .adjust('stack')
                  .position('fcount')
                  .color('fsaleevent')
                  .label('fcount', {
                    layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                    offset: 8,
                    content: function(obj) {
                      const G = G2.getEngine('canvas');
                      const group = new G.Group({});
                      const [y0, y1] = [0, 0];
                      const inRight = y0 < y1;
                      const textAlign = inRight ? 'left' : 'right';
                      const topFontSize = 12;
                      group.addShape({
                        type: 'text',
                        attrs: {
                          x: 0,
                          y: 0,
                          text: `${obj.fsaleevent}\n${parseFloat(obj.fcount.toFixed(2))}件\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                          fill: 'rgba(0, 0, 0, 0.65)',
                          fontSize: topFontSize,
                          textAlign,
                        },
                      });
                      if (!inRight) {
                        group.translate(group.getBBox().width, 0);
                      }
                      group.translate(0, topFontSize);
                      return group;
                    },
                    labelLine: {
                      style: {
                        lineWidth: 0.5,
                      },
                    },
                  })
                } else {
                  shijianfenxixitongChart
                  .interval()
                  .adjust('stack')
                  .position('forderamount')
                  .color('fsaleevent')
                  .label('forderamount', {
                    layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                    offset: 8,
                    content: function(obj) {
                      const G = G2.getEngine('canvas');
                      const group = new G.Group({});
                      const [y0, y1] = [0, 0];
                      const inRight = y0 < y1;
                      const textAlign = inRight ? 'left' : 'right';
                      const topFontSize = 12;
                      group.addShape({
                        type: 'text',
                        attrs: {
                          x: 0,
                          y: 0,
                          text: obj.forderamount < 1000 ? `${obj.fsaleevent}\n￥${obj.forderamount}\n${parseFloat((obj.forderamount / sum * 100).toFixed(2))}%` : 
                          `${obj.fsaleevent}\n￥${parseFloat((obj.forderamount / 1000).toFixed(2))}K\n${parseFloat((obj.forderamount / sum * 100).toFixed(2))}%` ,
                          fill: 'rgba(0, 0, 0, 0.65)',
                          fontSize: topFontSize,
                          textAlign,
                        },
                      });
                      if (!inRight) {
                        group.translate(group.getBBox().width, 0);
                      }
                      group.translate(0, topFontSize);
                      return group;
                    },
                    labelLine: {
                      style: {
                        lineWidth: 0.5,
                      },
                    },
                  })
                }

                shijianfenxixitongChart.interaction('element-active');
                shijianfenxixitongChart.legend({flipPage: false});
                shijianfenxixitongChart.render();
              }
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }

            $scope.hideLoading();
          },
          function(err) {
            $scope.hideLoading();
          })
        }

        $scope.queryEventOfOrders();

        // 终端大数据_月度费用分析_月度杂项费用分析
        $scope.hideChart11 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCostNameOfMonth()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart11 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            $scope.tips['feiyongzhanbifenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['feiyongzhanbifenxi'] = false

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.famount != 0) {
                sum += v.famount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart11 = true;
            }
            let chart = new G2.Chart({
              container: 'jingyingfenxixitong-shouye-chart-1',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('famount', {
              formatter: function(val){
                val = '￥' + parseFloat(val.toFixed(2));
                return val;
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('famount')
              .color('fcostname')
              .label('famount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fcostname}\n￥${parseFloat(obj.famount.toFixed(2)) }\n${parseFloat((obj.famount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-active');
            chart.legend({flipPage: false});
            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart11 = true;
          }
        },
        function(err) {
          $scope.hideChart11 = true;
        });

        // 终端大数据_月度费用分析_月度盈亏分析
        $scope.hideChart12 = false;
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryCostAndOrdersOfMonth()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart12 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            const data = res.data.data;
            $scope.tips['yueduyingkuifenxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['yueduyingkuifenxi'] = false

            const chart = new G2.Chart({
              container: 'jingyingfenxixitong-shouye-chart-2',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)

            chart.data(data);
            chart.scale({
              fmonth: {
                formatter: function(val) {
                  if (val.length >= 2) {
                    return Number(val.slice(-2)) + '月';
                  } else {
                    return val;
                  }
                }
              },
              famount: {
                range: [0, 0.9],
                nice: true,
                formatter: function(val){
                  if (Math.abs(val) >= 1000) {
                    val = parseFloat((val / 1000).toFixed(2)) + 'K';
                  }
                  return '￥' + val;
                },
              },
            });

            chart.tooltip({
              showTitle: false,
            });

            chart.line().position('fmonth*famount')
            .label('famount', function(val){
              if (Math.abs(val) >= 1000) {
                val = parseFloat((val / 1000).toFixed(2)) + 'K';
              } else {
                val = parseFloat(val.toFixed(2));
              }
              return {content: '￥' + val}
            })
            .tooltip('fmonth*famount', function(fmonth, famount) {
              if (Math.abs(famount) >= 1000) {
                famount = parseFloat((famount / 1000).toFixed(2)) + 'K';
              } else {
                famount = parseFloat(famount.toFixed(2));
              }
              return {
                name: fmonth + ' 月度盈亏', value: '￥' + famount
              }
            });
            chart.point().position('fmonth*famount')
            .tooltip('fmonth*famount', function(fmonth, famount) {
              if (Math.abs(famount) >= 1000) {
                famount = parseFloat((famount / 1000).toFixed(2)) + 'K';
              } else {
                famount = parseFloat(famount.toFixed(2));
              }
              return {
                name: fmonth + ' 月度盈亏', value: '￥' + famount
              }
            });

            chart.render();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart12 = true;
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideChart12 = true;
          $scope.hideLoading();
        });

        // 终端大数据_客户档案分析_老客户信息查询
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryOldCustomer(1, 10)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.oldCustomerList = res.data.data;
            $scope.tips['laokehuxinxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['laokehuxinxi'] = false
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
        },
        function(err) {
        });

        // 终端大数据_客户档案分析_意向客户信息查询
        (userService.getRole() == '企业' ? qiyeShujuService : fenxiService).queryNewCustomer(1, 10)
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.newCustomerList = res.data.data;
            $scope.tips['yixiangkehuxinxi']  = userService.getRole() == '经销商' ? res.data.tips : ''
            $scope.showTip['yixiangkehuxinxi'] = false
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }

          $scope.hideLoading();
        },
        function(err) {
          $scope.hideLoading();
        });

        // 终端大数据_客户档案分析_意向客户跟进系统
        if (userService.getRole() == '经销商') {
          fenxiService.queryNewCustomerTrack()
          .then(function(res) {
            if (res.data.code === 1) {
              $scope.newCustomerTrackList = res.data.data;
              $scope.tips['yixiangkehugenjin']  = res.data.tips;
              $scope.showTip['yixiangkehugenjin'] = false;
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
          },
          function(err) {
          });
        }

        // 终端大数据_客户档案分析_老客户维护系统系统_生日提醒
        if (userService.getRole() == '经销商') {
          fenxiService.queryOldCustomerBless()
          .then(function(res) {
            if (res.data.code === 1) {
              $scope.oldCustomerBlessList = res.data.data;
              $scope.tips['laokehushengritixing']  = res.data.tips;
              $scope.showTip['laokehushengritixing'] = false;
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }
          },
          function(err) {
          });
        }

        // 终端大数据_客户档案分析_老客户维护系统系统_购买周年
        if (userService.getRole() == '经销商') {
          fenxiService.queryOldCustomerCycle()
          .then(function(res) {
            if (res.data.code === 1) {
              $scope.oldCustomerCycleList = res.data.data;
              $scope.tips['laokehugoumaizhounian']  = res.data.tips;
              $scope.showTip['laokehugoumaizhounian'] = false;
            } else {
              //$ionicPopup.alert({
              //  title: res.data.msg
              //});
            }

            $scope.hideLoading();
          },
          function(err) {
            $scope.hideLoading();
          });
        }
      }, 500);
      
      $scope.setFavButtonInvisible = () => {
        $timeout.cancel($scope.timer);
        $scope.timer = $timeout(function() {
          $scope.show1 = false;
          $scope.show2 = false;
          $scope.show3 = false;
          $scope.show4 = false;
          $scope.show5 = false;
          $scope.show6 = false;
          $scope.show7 = false;
          $scope.show8 = false;
        }, 1500);
      }

      $scope.selectedItem = 0;

      $scope.setSelectedItem = function(i) {
        $scope.selectedItem = i;
      }

      $(function() {
        $('ion-content').scroll(function() {
          if ($('div.shuju-topmenu-panel').length) {
            if ($('ion-content').scrollTop() >= 60) {
              $('div.tabs-top div.shuju-topmenu-panel').addClass('fixed-header');
							$('ion-content.zhongduandashuju').css("top", "107px");
							$('.shuju-topmenu-panel').css('height', '63px');
              $('ul:not(.wheel-scroll)').removeClass('display-flex').removeClass('flex-wrap-wrap').addClass('scrolling-wrapper');
            } else {
              $('div.tabs-top div.shuju-topmenu-panel').removeClass('fixed-header');
							$('ion-content.zhongduandashuju').css("top", "170px");
							$('.shuju-topmenu-panel').css('height', '126px');
              $('ul:not(.wheel-scroll)').removeClass('scrolling-wrapper').addClass('display-flex').addClass('flex-wrap-wrap');
            }
          }

          $("section").each(function() {
            if (isOnScreen($(this))) {
              $scope.setSelectedItem($(this).attr('panel-index'));
            }
          });
        });

        function isOnScreen(elem) {
          // if the element doesn't exist, abort
          if( elem.length == 0 ) {
            return;
          }
          var $window = $(window)
          var viewport_top = $window.scrollTop()
          var viewport_height = $window.height()
          var viewport_bottom = viewport_top + viewport_height
          var $elem = $(elem)
          var top = $elem.offset().top
          var height = $elem.height()
          var bottom = top + height

          return (top >= viewport_top && top < viewport_bottom) ||
          (bottom > viewport_top && bottom <= viewport_bottom) ||
          (height > viewport_height && top <= viewport_top && bottom >= viewport_bottom)
        }
      });

      $('ion-content.zhongduandashuju').css("top", "170px");
      $('.shuju-topmenu-panel').css('height', '126px');

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
    });
})();

