(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('ZixuanBianjiController', function($scope, $state, ionicMaterialInk, $ionicPopup, zixuanService, chuchaService, $ionicActionSheet, multimediaService, userService) {

      const workId = $state.params.workid;

			ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.showLoading();

      $scope.zixuanList = []
      zixuanService.query_optionalworkMain(workId)
      .then(function(res){
        if (res.data.code === 1) {
          $scope.data = res.data.data[0];
          res.data.data[0].workmxlist.forEach(elem => {
            elem.imageData = [
            ]
            $scope.zixuanList.push(elem)
            multimediaService.getImageList(elem.tworkmxid, 'tworkmx').then(res => {
              for (let i = 0; i < res.data.data.length; i++) {
                elem.imageData.push(res.data.data[i])
              }
            })
          });
          
          $scope.fdays = Number($scope.fdays);
          document.querySelector('#dizhi').value = $scope.getLocString($scope.data);
          setTimeout(() => {
            $scope.selectBusinessTrip($scope.data.tbusinesstripid)
          }, 100);
        } else {
          
        }
        $scope.hideLoading();
      },
      function(err){
        $scope.hideLoading();
      });

      function uploadImage(idx) {
        multimediaService.uploadPicture($scope.zixuanList[idx].imageData[$scope.zixuanList[idx].imageData.length - 1].url, 'default', $scope.zixuanList[idx].tworkmxid, 'tworkmx')
        .then(
          res => {},
          err => {
            $scope.showToast({title: err})
        })
      }

      $scope.removeImage = function(row, idx) {
        multimediaService.removeImage({ownertable: 'tworkmx', ownerid: $scope.zixuanList[row].tworkmxid, tattachmentid: $scope.zixuanList[row].imageData[idx].tattachmentid});
        $scope.zixuanList[row].imageData.splice(idx, 1)
      }
      
      $scope.addRow = function() {
        var row = {
          tworkmxid: 0,
          ftype: 'default',
          fworkname: '',
          fnotes: "",
          imageData: [],
        }
        // for (var i = 0; i < 3; i++) {
        //   row.imageData.push ({url: ''})
        // }
        $scope.zixuanList.push(row);
      }

      $scope.removeRow = function(i) {
        if ($scope.zixuanList.length == 1) {
          return;
        }
        $scope.zixuanList.splice(i, 1);
      }

      $scope.openCamera = function(rowNum) {
        multimediaService.openCamera()
          .then(function (imageURI) {
            var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            $scope.zixuanList[rowNum].imageData.push({
              url: imageURI,
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
              tattachmentid: 0,
            })
            uploadImage(rowNum)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openGallery = function(rowNum) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            $scope.zixuanList[rowNum].imageData.push({
              url: imageURI,
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
              tattachmentid: 0,
            })
            uploadImage(rowNum)
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };
      
      $scope.openFileSelector = (rowNum) => {
        fileChooser.open(function(url) {
          let extIndex = url.indexOf('com.android.externalstorage.documents/document/')
          if (extIndex != -1) {
            url = 'file:///storage/' + decodeURIComponent(url.replace('%3A', '%2F').substr(extIndex + 47))
          }
          window.FilePath.resolveNativePath(url, finalPath => {
            var fdocument = finalPath.substr(finalPath.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            $scope.zixuanList[rowNum].imageData.push({
              url: finalPath, 
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
            })
            uploadImage(rowNum)
          });
        }, function(e){
        });
      }

      $scope.actionSheet = function(rowNum) {
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: [
						{
							text: '拍照'
						},
						{
							text: '从相册选择'
						},
						{
							text: '选择文件'
						}],
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera(rowNum);
							break;
							case 1: //从相册选择
                $scope.openGallery(rowNum);
							break;
              case 2: //选择文件
                $scope.openFileSelector(rowNum)                
							break;
							default:

							break;
						}
						return true;
					}
				});
      };

      $scope.isAllImageReady = function() {
        for (var i = 0; i < $scope.zixuanList.length; i++) {
          var row = $scope.zixuanList[i]
          if (!row.fnotes)
            return false
          if (row.imageData.length == 0) {
            return false;
          }
        }
        return true;
      }

      $scope.modify = function() {
        $scope.data.fdate = getDateString(new Date());
        if (!$scope.data.tstoreid){
          $scope.showToast({title: "请选择工作门店"})
          return;
        }

        if ($scope.data.fdays <= 0){
          $scope.showToast({title: "请填写工作天数。"})
          return;
        }
        
        $scope.data.workmx = $scope.zixuanList
        for (var i = 0; i < $scope.zixuanList.length; i++){
          $scope.data.workmx[i].fnotes = $scope.zixuanList[i].fnotes
        }

        $scope.showLoading();
        $scope.data.datalog = [{
          "ftype": "修改",
          "flog": "修改内容", // TODO 修改内容
        }],
        zixuanService.optionalWorkInsertOrModify(workId, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            for (let i in res.data.data[0].workmxlist) {
              if (i < $scope.zixuanList.length && $scope.zixuanList[i].tworkmxid == 0) {
                $scope.zixuanList[i].tworkmxid = res.data.data[0].workmxlist[i].tworkmxid
                for (let ii in $scope.zixuanList[i].imageData) {
                  if ($scope.zixuanList[i].imageData[ii].url)
                    multimediaService.uploadPicture($scope.zixuanList[i].imageData[ii].url, 'default', $scope.zixuanList[i].tworkmxid, 'tworkmx')
                    .then(
                      res => {},
                      err => {
                        $scope.showToast({title: err})
                    })
                }
              }
            }
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      // Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        localStorage.setItem('businesstrip', '');
      });

      // BusinessTripSelector
      $scope.showBusinessTripSelector = function() {
        $state.go('app.selectbussinesstrip');
      }

      $scope.getBusinessTripData = function(businessTripId) {
        chuchaService.queryBusinessTripMain(businessTripId)
        .then(function(res){
          if (res.data.code === 1) {
            let businessTrip = res.data.data[0];
            $scope.data.fprovince = businessTrip.fprovince;
            $scope.data.fcity = businessTrip.fcity;
            $scope.data.fcounty = businessTrip.fcounty;
            $scope.data.tagentsid = businessTrip.tagentsid;

            $scope.agentStoreList = [];
            zixuanService.queryAgentStoreList(businessTrip.tagentsid)
            .then(function(res){
              $scope.agentStoreList = res.data.data;
              for (var i = 0; i < res.data.data.length; i++) {
                if ($scope.data.fstorename == res.data.data[i].fstorename){
                  $scope.data.tstoreid = res.data.data[i].tstoreid;
                  break;
                }
              }
            });
          }
        },
        function(err){
        });
      }

      $scope.selectBusinessTrip = function(tbusinesstripid) {
        var businessTrip = localStorage.getItem('businesstrip');
        if (!businessTrip) {
          $scope.getBusinessTripData(tbusinesstripid)
          return;
        }
        businessTrip = JSON.parse(businessTrip);
        if (businessTrip && businessTrip.tagentsid) {
          document.querySelector('#business-trip-id').value = businessTrip.tbusinesstripid;
          document.querySelector('#dizhi').value = $scope.getLocString(businessTrip);

          $scope.data.tbusinesstripid = businessTrip.tbusinesstripid;
          $scope.data.fprovince = businessTrip.fprovince;
          $scope.data.fcity = businessTrip.fcity;
          $scope.data.fcounty = businessTrip.fcounty;
          $scope.data.tagentsid = businessTrip.tagentsid;

          $scope.agentStoreList = [];
          zixuanService.queryAgentStoreList(businessTrip.tagentsid)
          .then(function(res){
            $scope.agentStoreList = res.data.data;
            for (var i = 0; i < res.data.data.length; i++) {
              if ($scope.data.fstorename == res.data.data[i].fstorename){
                $scope.data.tstoreid = res.data.data[i].tstoreid;
                break;
              }
            }
          });
        }
      }

      // get keywords
      $scope.keywords = $scope.loadKeywords();
      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentStoreSelectPanel = function() {
        $scope.selectModel = $scope.agentStoreList;
        $scope.selectKeyField = "tstoreid";
        $scope.selectValueField = "fstorename";
        $scope.selectModelName = "tstoreid";
        $scope.selected = $scope.data.tstoreid;

        $scope.showSelectPanel();
      }

		});
})();

