/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
  var app = angular.module('starter.controllers');

  app.controller('ZixuanLiebiaoController', function($scope, $rootScope, zixuanService, $ionicPopup, $ionicHistory)
  {
    $scope.dataList = [];
    $scope.hideTabBar();

    $scope.pageNumber = 1;
    $scope.pageSize = 10;
    $scope.sortDirection = descending; // 默认值为反序
    $scope.fromdb = $ionicHistory.forwardView() != null
    
    $scope.$on('$destroy', function() {
      $scope.clearKeyword()
    });

    $scope.loadData = () => {
      zixuanService.query_optionalworkList(
        $scope.fromdb,
        $scope.pageNumber, // pageNumber
        $scope.pageSize, // pageSize
        $scope.sortDirection, // sort
        $scope.keyword, // keyword
        $scope.createdate, // TODO createdate
      )
      .then(function(res){
        if (res.data.code === 1) {
          $scope.dataList = $scope.dataList.concat(res.data.data);
          $scope.pageTotal = res.data.pageTotal;
        } else{
          
        }
        $scope.refreshComplete();
      },
      function(err){
        $scope.refreshComplete();
      });
    }

    $scope.showLoading();
    
    $scope.doRefresh = function () {
      $scope.pageNumber = 1
      $scope.dataList = [];
      $scope.loadData();
    };
    $scope.doRefresh();

    $scope.loadMore = function() {
      $scope.pageNumber += 1;
      $scope.loadData();
    }

    // get keywords
    $scope.keywords = $scope.loadKeywords();

    $scope.changeSortDirection = () => {
      $scope.sortDirection = 1 - $scope.sortDirection;
      $scope.doRefresh();
    };

    $scope.$on('refresh', function(ev) {
      $scope.doRefresh();
    });

    $scope.setShowFilter(false);
    $scope.setShowSearchBar(false);
    $scope.initFenxiPeriod();

    // filter settings
    $scope.model = [];
    $scope.model.periodStart = "";
    $scope.model.periodEnd = "";
    $scope.model.province = "";
    $scope.model.city = "";
    $scope.model.county = "";
    $scope.applyFilterValue = function(v) {
      $scope.switchFilter();

      $scope.model = v;
      $scope.doRefresh();
    }
  })
})();
