(function(){

	"use strict";
	angular.module('starter.services')

	.service('zixuanService', function (apiService, userService) {
		var self = this;

    // 自选工作列表查询
		self.query_optionalworkList = function(fromdb, pageNumber, pageSize, sortDirection, condition, createdate) {
			var request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.optionalwork.optionalwork",
					"method": "query_optionalworkList",
					"content": {
						"getdatafromdbanyway": fromdb ? true : false,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {
						},
						"sort":"t1.changedate" + (sortDirection == ascending ? '' : ' desc'),
					}
				}
			};
			if (condition) {
        request.data.content.where.condition = condition;
      }
      if (createdate) {
        request.data.content.where.createdate = createdate;
      }

			return apiService.makeRequest(request);
		}

    // 自选工作主界面查询
		self.query_optionalworkMain = function(workId) {
			var request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.optionalwork.optionalwork",
					"method": "query_optionalworkMain",
					"content": {
						"userid": userService.getUserId(),
						"tworkid": workId,
					}
				}
			};

			return apiService.makeRequest(request);
    }

    // 自选工作新增，修改
    self.optionalWorkInsertOrModify = function(workId, data) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.optionalwork.optionalwork",
					"method": "optionalworkInsertOrModify",
					"content": {
            "userid": userService.getUserId(),
            "tworkid": workId,
            "tbusinesstripid": data.tbusinesstripid,
            "fdays": data.fdays,
            "tagentsid": data.tagentsid,
            "tstoreid": data.tstoreid,
            "fdate": data.fdate,
            "workmx": data.workmx,
						"datalog": data.datalog
						// [// TODO 修改记录，非必填项，可以为空
            //     {
            //         "ftype": "修改", // TODO 修改类型
            //         "flog": "修改字段及内容", // TODO 修改内容
            //     }
            // ],
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 自选工作删除
    self.optionalWorkDelete = function(workId) {
			let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.optionalwork.optionalwork",
					"method": "optionalworkDelete",
					"content": {
            "userid": userService.getUserId(),
            "tworkid": workId,
					}
				}
      };

			return apiService.makeRequest(request);
    };

    // 经销商选择列表查询
    self.queryAgentStoreList = function(agentsId) {
      let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.optionalwork.optionalwork",
					"method": "query_agentstoreList",
					"content": {
            "userid": userService.getUserId(),
            "tagentsid": agentsId,
					}
				}
      };

			return apiService.makeRequest(request);
    }

    // 出差行程列表选择查询
    self.queryBusinessTripList = function(pageNumber, pageSize, condition) {
      let request = {
				url: API_URL_V1,
				data: {
					"classname": "salerclient.mainpage.agentwork.businesstrip.businesstrip",
					"method": "query_businesstripList",
					"content": {
            "getdatafromdbanyway": true,
						"pageNumber": pageNumber,
						"pageSize": pageSize,
						"userid": userService.getUserId(),
						"where": {
              "fstatus": '待提交',
						},
					}
				}
      };

      if (condition) {
        request.data.content.where.condition = condition;
      }

			return apiService.makeRequest(request);
    }
	})

})();
