/* global angular, document, window, cordova, WALLETS, scanQR */
(function(){
	"use strict";
	angular.module('starter.controllers')
		.controller('ZixuanXinzengController', function($scope, $state, $ionicPopup, ionicMaterialInk, zixuanService, $ionicActionSheet, multimediaService, userService) {

      ionicMaterialInk.displayEffect();
      $scope.$parent.showHeader();
      $scope.$parent.hideTabBar();

      $scope.data = {
        tworkid: 0,
        tbusinesstripid: '',
        fdays: null,
        tagentsid: '',
        tstoreid: '',
        fdate: '',
        workmx: [],
      };

      $scope.zixuanList = [{
        tworkmxid: 0,
        ftype: "default",
        fworkname: "",
        fnotes: "",
        imageData: []
      }]

      $scope.showLoading();

      $scope.addRow = function() {
        var row = {
          tworkmxid: 0,
          ftype: 'default',
          fworkname: '',
          fnotes: "",
          imageData: []
        }
        // for (var i = 0; i < 3; i++) {
        //   row.imageData.push ({url: ''})
        // }
        $scope.zixuanList.push(row);
      }

      $scope.removeRow = function(i) {
        if ($scope.zixuanList.length == 1) {
          return;
        }
        $scope.zixuanList.splice(i, 1);
      }

      function uploadImages() {
        $scope.zixuanList.forEach(row => {
          row.imageData.forEach(element => {
            multimediaService.uploadPicture(element.url, 'default', row.tworkmxid, 'tworkmx')
            .then(
              res => {},
              err => {
                $scope.showToast({title: err})
            })
          });
        })        
      }

      $scope.openCamera = function(rowNum) {
        multimediaService.openCamera()
          .then(function (imageURI) {
            var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            $scope.zixuanList[rowNum].imageData.push({
              url: imageURI,
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
              tattachmentid: 0,
            })
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openGallery = function(rowNum) {
        multimediaService.getImageFromGallery()
          .then(function (imageURI) {
            var fdocument = imageURI.substr(imageURI.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            $scope.zixuanList[rowNum].imageData.push({
              url: imageURI,
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
              tattachmentid: 0,
            })
          }, function (err) {
            $scope.showToast({title: '没有选择照片！'})
          });
      };

      $scope.openFileSelector = (rowNum) => {
        fileChooser.open(function(url) {
          let extIndex = url.indexOf('com.android.externalstorage.documents/document/')
          if (extIndex != -1) {
            url = 'file:///storage/' + decodeURIComponent(url.replace('%3A', '%2F').substr(extIndex + 47))
          }
          window.FilePath.resolveNativePath(url, finalPath => {
            var fdocument = finalPath.substr(finalPath.lastIndexOf('/')+1)
            fdocument = fdocument.indexOf('?') != -1 ? fdocument.substr(0, fdocument.indexOf('?')) : fdocument
            $scope.zixuanList[rowNum].imageData.push({
              url: finalPath, 
              postfix: fdocument.substring(fdocument.lastIndexOf('.') + 1), 
              fdocument: fdocument,
              createby: userService.getUserName(),
              createdate: getDateString(new Date()),
            })
          });
        }, function(e){
        });
      }

      $scope.actionSheet = function(rowNum) {
				// Show the action sheet
				$ionicActionSheet.show({
					buttons: [
						{
							text: '拍照'
						},
						{
							text: '从相册选择'
						},
						{
							text: '选择文件'
						}],
					cancelText: '取消',
					cancel: function() {
						// add cancel code..
					},
					buttonClicked: function(index) {
						switch (index) {
							case 0: // 拍照
								$scope.openCamera(rowNum);
							break;
							case 1: //从相册选择
                $scope.openGallery(rowNum);
							break;
              case 2: //选择文件
                $scope.openFileSelector(rowNum)                
							break;
							default:
							break;
						}
						return true;
					}
				});
      };

      $scope.isAllImageReady = function() {
        for (var i = 0; i < $scope.zixuanList.length; i++) {
          var row = $scope.zixuanList[i]
          if (!row.fnotes)
            return false
          if (row.imageData.length == 0) {
            return false;
          }
        }
        return true;
      }
      
      $scope.register = function() {
        if (!$scope.data.tstoreid){
          $scope.showToast({title: "请选择工作门店"})
          return;
        }
        
        if ($scope.data.fdays <= 0){
          $scope.showToast({title: "请填写工作天数。"})
          return;
        }

        for (var i = 0; i < $scope.zixuanList.length; i++) {
          $scope.data.workmx.push({
            tworkmxid: $scope.zixuanList[i].tworkmxid,
            ftype: $scope.zixuanList[i].ftype,
            fworkname: $scope.zixuanList[i].fworkname,
            fnotes: $scope.zixuanList[i].fnotes,
          })
        }

        $scope.data.datalog = [{
          "ftype": "新增",
          "flog": "新增记录",
        }]

        $scope.showLoading();
				zixuanService.optionalWorkInsertOrModify(0, $scope.data)
        .then(function(res){
          if (res.data.code === 1) {
            $scope.showToast({title: '保存成功！'});
            for(var i = 0; i < res.data.data[0].workmxlist.length; i++) {
              $scope.zixuanList[i].tworkmxid = res.data.data[0].workmxlist[i].tworkmxid
            }
            uploadImages()
            $scope.goBack();
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
          $scope.hideLoading();
        },
        function(err){
          $scope.hideLoading();
        });
      }

      // BusinessTripSelector
      $scope.showBusinessTripSelector = function() {
        $state.go('app.selectbussinesstrip');
      }

      $scope.selectBusinessTrip = function() {
        var businessTrip = localStorage.getItem('businesstrip');
        if (!businessTrip) {
          $scope.hideLoading();
          return;
        }
        businessTrip = JSON.parse(businessTrip);
        if (businessTrip && businessTrip.tagentsid) {
          document.querySelector('#business-trip-id').value = businessTrip.tbusinesstripid;
          document.querySelector('#dizhi').value = $scope.getLocString(businessTrip);

          $scope.data.tbusinesstripid = businessTrip.tbusinesstripid;
          $scope.data.fprovince = businessTrip.fprovince;
          $scope.data.fcity = businessTrip.fcity;
          $scope.data.fcounty = businessTrip.fcounty;
          $scope.data.tagentsid = businessTrip.tagentsid;

          $scope.showLoading();
          zixuanService.queryAgentStoreList(businessTrip.tagentsid)
          .then(function(res){
            $scope.agentStoreList = res.data.data;
            $scope.hideLoading();
          },
          function(err){
            $scope.hideLoading();
          });
        }
      }

      // Cleanup the popover when we're done with it!
      $scope.$on('$destroy', function() {
        localStorage.setItem('businesstrip', '');
      });

      $scope.selectBusinessTrip();
      // get keywords
      $scope.keywords = $scope.loadKeywords();

      $scope.isShowSelectPanel = false;
      $scope.selectModel = undefined;
      $scope.selectKeyField = '';
      $scope.selectValueField = '';
      $scope.selectModelName = '';

      $scope.showSelectPanel = function() {
        $scope.isShowSelectPanel = true;
      }

      $scope.hideSelectPanel = function() {
        $scope.isShowSelectPanel = false;
      }

      $scope.selectOne = function(v) {
        if ($scope.selectKeyField) {
          $scope.data[$scope.selectModelName] = v[$scope.selectKeyField];
          $scope.data[$scope.selectValueField] = v[$scope.selectValueField];
        } else {
          $scope.data[$scope.selectModelName] = v;
        }
      }

      $scope.showAgentStoreSelectPanel = function() {
        $scope.selectModel = $scope.agentStoreList;
        $scope.selectKeyField = "tstoreid";
        $scope.selectValueField = "fstorename";
        $scope.selectModelName = "tstoreid";
        $scope.selected = $scope.data.tstoreid;

        $scope.showSelectPanel();
      }

		});
})();

