(function(){
	"use strict";

	angular.module('starter.controllers')
    .controller('ZongbiaoShouyeController', function($rootScope, $scope, $location, $anchorScroll, $ionicPopup, userService, qiyeShujuService, $timeout) {
      $scope.showHeader();
      $scope.hideTabBar();

      $scope.role = localStorage.getItem("role") == 1 ? 1 : 0; //0：经销商，1：厂家

      $scope.scrollTo = function(target){
        $location.hash(target); // set the location hash
        $anchorScroll();
      };

      $scope.selectTab = function(idx){
        $scope.navIndex = idx;
        $scope.$broadcast('scroll.refreshComplete');
      }

      $scope.showLoading();

      let chartArray = []
      $scope.$on('$destroy', function() {
        chartArray.forEach(chart => {
          chart.clear()
          if (!chart.destroyed)
            chart.destroy()
        })
      });

      qiyeShujuService.businessTripGrade()
      .then(function(res) {
        if (res.data.code === 1) {
          $scope.businessTripGradeList = res.data.data.slice(0, 10);
        } else {
          
        }
      },
      function(err) {
      });

      qiyeShujuService.businessTripGetKnowledge()
      .then(function(res) {
        if (res.data.code === 1) {
          $scope.businessTripGetKnowledgeList = res.data.data.slice(0, 10);
        } else {
          
        }
      },
      function(err) {
      });

      setTimeout(function() {
        $scope.hideChart1 = false;
        qiyeShujuService.saleAmountGrowthRateAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart1 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];
            var total = 0

            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                data.push(v);
              }
              total += v.fcount
            });

            if (total == 0) {
              $scope.hideChart1 = true;
              return
            }
            // Draw charts
            let chart = new G2.Chart({
              container: 'xiaoshoushuju-shouye-chart-1',
              autoFit: true,
              height: 300,
            });
            
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              range: [0, 0.9],
              nice: true,
              formatter: function(val) {
                if (Number.isInteger(val)) {
                  return val + '家';
                } else  {
                  return '';
                }
              },
            });
            chart.scale('fclass', {
              tickCount: 12,
              nice: true,
            });
            chart.tooltip({
              shared: true,
              showMarkers: false,
              showTitle: false,
            });

            var colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fclass*fcount')
            .color('fclass')
            .label('fcount', function(val){return {content: val + '家', offsetY: val == 0 ? -20 : 0}})
            .tooltip('fclass*fcount', function(fclass, fcount) {
              return {
                name: fclass, value: fcount + '家'
              };
            })
            .adjust('stack');

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});

            chart.render();

            $scope.detailList5 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;
              
              if (state === 'selected') {
                const data = element.getData();

                if (stateStatus) {
                  $scope.detailList5 = data.fdata.slice(0, 10);

                  $scope.detailList5.forEach(function(item) {
                    if (item.fprovince && item.fcity && item.fcounty
                        && !isNaN(Number(item.fprovince))
                        && !isNaN(Number(item.fcity))
                        && !isNaN(Number(item.fcounty))) {
                      item.fcounty = $scope.locationList[item.fcity][item.fcounty];
                      item.fcity = $scope.locationList[item.fprovince][item.fcity];
                      item.fprovince = $scope.locationList['86'][item.fprovince];
                    }
                  })

                  $scope.$apply($scope.detailList5);
                } else {
                  $scope.detailList5 = [];
                  $scope.$apply($scope.detailList5);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart1 = true;
          }
        },
        function(err) {
          $scope.hideChart1 = true;
        });

        $scope.hideChart2 = false;
        qiyeShujuService.saleAmountAverageAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart2 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            let data = res.data.data;

            // Draw charts
            let chart = new G2.Chart({
              container: 'xiaoshoushuju-shouye-chart-2',
              autoFit: true,
              height: 300,
            });

            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              range: [0, 0.9],
              nice: true,
              formatter: function(val) {
                if (Number.isInteger(val)) {
                  return val + '家';
                } else  {
                  return '';
                }
              },
            });
            chart.scale('fclass', {
              tickCount: 12,
              nice: true,
            });
            chart.tooltip({
              shared: true,
              showMarkers: false,
              showTitle: false,
            });

            let colorMaps = [
              '#FF99A6', '#FF6F75', '#FF2641', '#D0021B', '#8E0909', '#6B0004'
            ];

            chart
            .interval()
            .position('fclass*fcount')
            .color('fclass')
            .label('fcount', function(val){return {content: val + '家', offsetY: val == 0 ? -20 : 0}})
            .tooltip('fclass*fcount', function(fclass, fcount) {
              return {
                name: fclass, value: fcount + '家'
              };
            })
            .adjust('stack');

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});

            chart.render();

            $scope.detailList4 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;
              
              if (state === 'selected') {
                const data = element.getData();

                if (stateStatus) {
                  $scope.detailList4 = data.fdata.slice(0, 10);

                  $scope.detailList4.forEach(function(item) {
                    if (item.fprovince && item.fcity && item.fcounty
                        && !isNaN(Number(item.fprovince))
                        && !isNaN(Number(item.fcity))
                        && !isNaN(Number(item.fcounty))) {
                      item.fcounty = $scope.locationList[item.fcity][item.fcounty];
                      item.fcity = $scope.locationList[item.fprovince][item.fcity];
                      item.fprovince = $scope.locationList['86'][item.fprovince];
                    }
                  })

                  $scope.$apply($scope.detailList4);
                } else {
                  $scope.detailList4 = [];
                  $scope.$apply($scope.detailList4);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart2 = true;
          }
        },
        function(err) {
          $scope.hideChart2 = true;
        });

        qiyeShujuService.saleAmountAnalysis()
        .then(function(res) {
          if (res.data.code === 1) {
            $scope.saleAmountList = res.data.data.slice(0, 10);
            $scope.saleAmountList.forEach(function(item) {
              if (item.fprovince && item.fcity && item.fcounty
                  && !isNaN(Number(item.fprovince))
                  && !isNaN(Number(item.fcity))
                  && !isNaN(Number(item.fcounty))) {
                item.fcounty = $scope.locationList[item.fcity][item.fcounty];
                item.fcity = $scope.locationList[item.fprovince][item.fcity];
                item.fprovince = $scope.locationList['86'][item.fprovince];
              }
            })
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
          }
        },
        function(err) {
        });

        // 店铺数据_店铺面积占比分析
        $scope.hideChart3 = false;
        qiyeShujuService.storeAreaAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.data.length == 0) {
            $scope.hideChart3 = true;
          } else if (res.data.code === 1 && res.data.data.data.length > 0) {
            var data = [];

            var sum = 0;
            res.data.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart3 = true;
            }
            $scope.avgArea = parseFloat(res.data.data.favgarea.toFixed(2));
            let chart = new G2.Chart({
              container: 'dianpushuju-shouye-chart-1',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '家';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fclass')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fclass}\n${obj.fcount}家\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});
            chart.render();

            $scope.detailList3 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;

              if (state === 'selected') {
                const data = element.getData();
                if (stateStatus) {
                  $scope.detailList3 = data.fdata.slice(0, 10);
                  $scope.$apply($scope.detailList3);
                } else {
                  $scope.detailList3 = [];
                  $scope.$apply($scope.detailList3);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart3 = true;
          }
        },
        function(err) {
          $scope.hideChart3 = true;
        });

        // 店铺数据_改建分析
        $scope.hideChart4 = false;
        qiyeShujuService.storeRebuildAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.data.length == 0) {
            $scope.hideChart4 = true;
          } else if (res.data.code === 1 && res.data.data.data.length > 0) {
            var data = [];

            var sum = 0;
            res.data.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart4 = true;
            }
            $scope.avgIntervalTime = res.data.data.favgintervaltime;
            let chart = new G2.Chart({
              container: 'dianpushuju-shouye-chart-2',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '家';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fclass')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fclass}\n${obj.fcount}家\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});
            chart.render();

            $scope.detailList2 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;

              if (state === 'selected') {
                const data = element.getData();
                if (stateStatus) {
                  $scope.detailList2 = data.fdata.slice(0, 10);
                  $scope.$apply($scope.detailList2);
                } else {
                  $scope.detailList2 = [];
                  $scope.$apply($scope.detailList2);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart4 = true;
          }
        },
        function(err) {
          $scope.hideChart4 = true;
        });

        // 店铺数据_店铺卖场分析
        $scope.hideChart5 = false;
        qiyeShujuService.storeMarketAnalysis()
        .then(function(res) {
          if (res.data.code === 1 && res.data.data.length == 0) {
            $scope.hideChart5 = true;
          } else if (res.data.code === 1 && res.data.data.length > 0) {
            var data = [];

            var sum = 0;
            res.data.data.forEach(function(v) {
              if (v.fcount != 0) {
                sum += v.fcount;
                data.push(v);
              }
            });

            if (sum == 0) {
              $scope.hideChart5 = true;
            }
            let chart = new G2.Chart({
              container: 'dianpushuju-shouye-chart-3',
              autoFit: true,
              height: 300,
            });
            chartArray.push(chart)
            chart.data(data);
            chart.scale('fcount', {
              formatter: function(val) {
                return val + '家';
              },
            });
            chart.coordinate('theta', {
              radius: 0.7
            });
            
            chart
              .interval()
              .adjust('stack')
              .position('fcount')
              .color('fclass')
              .label('fcount', {
                layout: [{ type: 'pie-spider' }, { type: 'hide-overlap' }],
                offset: 8,
                content: function(obj) {
                  const G = G2.getEngine('canvas');
                  const group = new G.Group({});
                  const [y0, y1] = [0, 0];
                  const inRight = y0 < y1;
                  const textAlign = inRight ? 'left' : 'right';
                  const topFontSize = 12;
                  group.addShape({
                    type: 'text',
                    attrs: {
                      x: 0,
                      y: 0,
                      text: `${obj.fclass}\n${obj.fcount}家\n${parseFloat((obj.fcount / sum * 100).toFixed(2))}%`,
                      fill: 'rgba(0, 0, 0, 0.65)',
                      fontSize: topFontSize,
                      textAlign,
                    },
                  });
                  if (!inRight) {
                    group.translate(group.getBBox().width, 0);
                  }
                  group.translate(0, topFontSize);
                  return group;
                },
                labelLine: {
                  style: {
                    lineWidth: 0.5,
                  },
                },
              })

            chart.interaction('element-single-selected');
            chart.legend({flipPage: false});
            chart.render();

            $scope.detailList1 = [];

            chart.on('element:statechange', function(ev) {
              const { state, stateStatus, element } = ev.gEvent.originalEvent;

              if (state === 'selected') {
                const data = element.getData();
                if (stateStatus) {
                  $scope.detailList1 = data.fdata.slice(0, 10);
                  $scope.$apply($scope.detailList1);
                } else {
                  $scope.detailList1 = [];
                  $scope.$apply($scope.detailList1);
                }
              }
            });
          } else {
            //$ionicPopup.alert({
            // title: res.data.msg
            // });
            $scope.hideChart5 = true;
          }
        },
        function(err) {
          $scope.hideChart5 = true;
        });

        // 店铺数据_经销商档案列表
        $scope.agentList = [];
        qiyeShujuService.agentList(1, 10)
        .then(function(res) {
        if (res.data.code === 1) {
          $scope.agentList = res.data.data;
          $scope.agentList.forEach(function(item) {
            if (item.fprovince && item.fcity && item.fcounty
                && !isNaN(Number(item.fprovince))
                && !isNaN(Number(item.fcity))
                && !isNaN(Number(item.fcounty))) {
              item.fcounty = $scope.locationList[item.fcity][item.fcounty];
              item.fcity = $scope.locationList[item.fprovince][item.fcity];
              item.fprovince = $scope.locationList['86'][item.fprovince];
            }
          })
        } else {
          
        }

        $scope.hideLoading();
      },
      function(err) {
        $scope.hideLoading();
      });
      }, 500);

      $scope.selectedItem = 0;

      $scope.setSelectedItem = function(i) {
        $scope.selectedItem = i;
      }

      $(function() {
        $('ion-content').scroll(function() {
          if ($('div.shuju-topmenu-panel').length) {
            if ($('ion-content').scrollTop() >= 60) {
              $('div.tabs-top div.shuju-topmenu-panel').addClass('fixed-header');
							$('ion-content.zongbiao').css("top", "107px");
							$('.shuju-topmenu-panel').css('height', '63px');
              $('ul:not(.wheel-scroll)').removeClass('display-flex').removeClass('flex-wrap-wrap').addClass('scrolling-wrapper');
            } else {
              $('div.tabs-top div.shuju-topmenu-panel').removeClass('fixed-header');
							$('ion-content.zongbiao').css("top", "170px");
							$('.shuju-topmenu-panel').css('height', '126px');
              $('ul:not(.wheel-scroll)').removeClass('scrolling-wrapper').addClass('display-flex').addClass('flex-wrap-wrap');
            }
          }

          $("section").each(function() {
            if (isOnScreen($(this))) {
              $scope.setSelectedItem($(this).attr('panel-index'));
            }
          });
        });

        function isOnScreen(elem) {
          // if the element doesn't exist, abort
          if( elem.length == 0 ) {
            return;
          }
          var $window = $(window)
          var viewport_top = $window.scrollTop()
          var viewport_height = $window.height()
          var viewport_bottom = viewport_top + viewport_height
          var $elem = $(elem)
          var top = $elem.offset().top
          var height = $elem.height()
          var bottom = top + height

          return (top >= viewport_top && top < viewport_bottom) ||
          (bottom > viewport_top && bottom <= viewport_bottom) ||
          (height > viewport_height && top <= viewport_top && bottom >= viewport_bottom)
        }
      });

      $('ion-content.zongbiao').css("top", "170px");
      $('.shuju-topmenu-panel').css('height', '126px');

      $scope.$on('$ionicView.beforeEnter', function (e,config) {
        config.enableBack = true;
      });
    });
})();

